/* Define memory regions. */

MEMORY

{

    rom (rx) :      ORIGIN = 0x08014000, LENGTH = 32K
    EXTRAROM (rx) : ORIGIN = 0x08054000, LENGTH = 32K
    ram (rwx) : ORIGIN = 0x20002000, LENGTH = 40K

}

_estack = ORIGIN(ram)+LENGTH(ram)-0x1000;


SECTIONS
  
{
    
     .  = 0x0;          /* From 0x00000000 */


     
     .bios 0x08004200 (NOLOAD) : {
      bios.o
    }

    
     .text :
     {

          _vectors = .;

          *(.isr_vectors)      /* Vector table */
/*          *(.text*)         Program code */
          
          startup.o(.text)
          *(.text.startup)
          Interrupt.o(.text)
          stm32f10x_nvic.o(.text)
          cortexm3_macro.o(.text)
          spf.o(.text)
          


          *(.rodata*)       /* Read only data */

          /* *(.ARM.extab*) */
          /* *(.ARM.exidx*) */
          /* _etext = .;
 */
          /* _sidata = _etext;
    */
     } >rom

     .EXTRAROM : {
/*          *(.rodata*)        Read only data */
         . = ALIGN(4); 
          *(.text*)         /*Program code */
     } > EXTRAROM
     


    .ARM.extab : 
    {
        *(.ARM.extab* .gnu.linkonce.armextab.*)
    } > rom
    
    .ARM.exidx :
    {
        *(.ARM.exidx* .gnu.linkonce.armexidx.*)
    } > rom

     . = ALIGN(4); 
     _etext = .;
 
     _sidata = _etext;
    
     .  = 0x20002000;   /* From 0x20000000 */      

    
     
     .data : 
     {

         _sdata = . ;

         *(.data)        /* Data memory */

         _edata = .;

     } >ram AT > rom

  
    
    .bss : 
    {

        _sbss = .;
    *(.bss)         /* Zero-filled run time allocate data memory */

        _ebss = .;
        _end = .;

    } >ram AT > rom
  
}  

/*========== end of file ==========*/
