# 1 "Calibrat.c"
# 1 "<command-line>"
# 1 "Calibrat.c"




# 1 "inc/Interrupt.h" 1
# 9 "inc/Interrupt.h"
# 1 "FWLib/inc/stm32f10x_lib.h" 1
# 22 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_map.h" 1
# 26 "FWLib/inc/stm32f10x_map.h"
# 1 "inc/stm32f10x_conf.h" 1
# 21 "inc/stm32f10x_conf.h"
# 1 "FWLib/inc/stm32f10x_type.h" 1
# 23 "FWLib/inc/stm32f10x_type.h"
typedef signed long s32;
typedef signed short s16;
typedef signed char s8;

typedef signed long const sc32;
typedef signed short const sc16;
typedef signed char const sc8;

typedef volatile signed long vs32;
typedef volatile signed short vs16;
typedef volatile signed char vs8;

typedef volatile signed long const vsc32;
typedef volatile signed short const vsc16;
typedef volatile signed char const vsc8;

typedef unsigned long u32;
typedef unsigned short u16;
typedef unsigned char u8;

typedef unsigned long const uc32;
typedef unsigned short const uc16;
typedef unsigned char const uc8;

typedef volatile unsigned long vu32;
typedef volatile unsigned short vu16;
typedef volatile unsigned char vu8;

typedef volatile unsigned long const vuc32;
typedef volatile unsigned short const vuc16;
typedef volatile unsigned char const vuc8;

typedef enum {FALSE = 0, TRUE = !FALSE} bool;

typedef enum {RESET = 0, SET = !RESET} FlagStatus, ITStatus;

typedef enum {DISABLE = 0, ENABLE = !DISABLE} FunctionalState;


typedef enum {ERROR = 0, SUCCESS = !ERROR} ErrorStatus;
# 22 "inc/stm32f10x_conf.h" 2
# 27 "FWLib/inc/stm32f10x_map.h" 2
# 1 "FWLib/inc/stm32f10x_type.h" 1
# 28 "FWLib/inc/stm32f10x_map.h" 2
# 1 "FWLib/inc/cortexm3_macro.h" 1
# 27 "FWLib/inc/cortexm3_macro.h"
void __WFI(void);
void __WFE(void);
void __SEV(void);
void __ISB(void);
void __DSB(void);
void __DMB(void);
void __SVC(void);
u32 __MRS_CONTROL(void);
void __MSR_CONTROL(u32 Control);
u32 __MRS_PSP(void);
void __MSR_PSP(u32 TopOfProcessStack);
u32 __MRS_MSP(void);
void __MSR_MSP(u32 TopOfMainStack);
void __RESETPRIMASK(void);
void __SETPRIMASK(void);
u32 __READ_PRIMASK(void);
void __RESETFAULTMASK(void);
void __SETFAULTMASK(void);
u32 __READ_FAULTMASK(void);
void __BASEPRICONFIG(u32 NewPriority);
u32 __GetBASEPRI(void);
u16 __REV_HalfWord(u16 Data);
u32 __REV_Word(u32 Data);
# 29 "FWLib/inc/stm32f10x_map.h" 2







typedef struct
{
  vu32 SR;
  vu32 CR1;
  vu32 CR2;
  vu32 SMPR1;
  vu32 SMPR2;
  vu32 JOFR1;
  vu32 JOFR2;
  vu32 JOFR3;
  vu32 JOFR4;
  vu32 HTR;
  vu32 LTR;
  vu32 SQR1;
  vu32 SQR2;
  vu32 SQR3;
  vu32 JSQR;
  vu32 JDR1;
  vu32 JDR2;
  vu32 JDR3;
  vu32 JDR4;
  vu32 DR;
} ADC_TypeDef;


typedef struct
{
  u32 RESERVED0;
  vu16 DR1;
  u16 RESERVED1;
  vu16 DR2;
  u16 RESERVED2;
  vu16 DR3;
  u16 RESERVED3;
  vu16 DR4;
  u16 RESERVED4;
  vu16 DR5;
  u16 RESERVED5;
  vu16 DR6;
  u16 RESERVED6;
  vu16 DR7;
  u16 RESERVED7;
  vu16 DR8;
  u16 RESERVED8;
  vu16 DR9;
  u16 RESERVED9;
  vu16 DR10;
  u16 RESERVED10;
  vu16 RTCCR;
  u16 RESERVED11;
  vu16 CR;
  u16 RESERVED12;
  vu16 CSR;
  u16 RESERVED13[5];
  vu16 DR11;
  u16 RESERVED14;
  vu16 DR12;
  u16 RESERVED15;
  vu16 DR13;
  u16 RESERVED16;
  vu16 DR14;
  u16 RESERVED17;
  vu16 DR15;
  u16 RESERVED18;
  vu16 DR16;
  u16 RESERVED19;
  vu16 DR17;
  u16 RESERVED20;
  vu16 DR18;
  u16 RESERVED21;
  vu16 DR19;
  u16 RESERVED22;
  vu16 DR20;
  u16 RESERVED23;
  vu16 DR21;
  u16 RESERVED24;
  vu16 DR22;
  u16 RESERVED25;
  vu16 DR23;
  u16 RESERVED26;
  vu16 DR24;
  u16 RESERVED27;
  vu16 DR25;
  u16 RESERVED28;
  vu16 DR26;
  u16 RESERVED29;
  vu16 DR27;
  u16 RESERVED30;
  vu16 DR28;
  u16 RESERVED31;
  vu16 DR29;
  u16 RESERVED32;
  vu16 DR30;
  u16 RESERVED33;
  vu16 DR31;
  u16 RESERVED34;
  vu16 DR32;
  u16 RESERVED35;
  vu16 DR33;
  u16 RESERVED36;
  vu16 DR34;
  u16 RESERVED37;
  vu16 DR35;
  u16 RESERVED38;
  vu16 DR36;
  u16 RESERVED39;
  vu16 DR37;
  u16 RESERVED40;
  vu16 DR38;
  u16 RESERVED41;
  vu16 DR39;
  u16 RESERVED42;
  vu16 DR40;
  u16 RESERVED43;
  vu16 DR41;
  u16 RESERVED44;
  vu16 DR42;
  u16 RESERVED45;
} BKP_TypeDef;


typedef struct
{
  vu32 TIR;
  vu32 TDTR;
  vu32 TDLR;
  vu32 TDHR;
} CAN_TxMailBox_TypeDef;

typedef struct
{
  vu32 RIR;
  vu32 RDTR;
  vu32 RDLR;
  vu32 RDHR;
} CAN_FIFOMailBox_TypeDef;

typedef struct
{
  vu32 FR1;
  vu32 FR2;
} CAN_FilterRegister_TypeDef;

typedef struct
{
  vu32 MCR;
  vu32 MSR;
  vu32 TSR;
  vu32 RF0R;
  vu32 RF1R;
  vu32 IER;
  vu32 ESR;
  vu32 BTR;
  u32 RESERVED0[88];
  CAN_TxMailBox_TypeDef sTxMailBox[3];
  CAN_FIFOMailBox_TypeDef sFIFOMailBox[2];
  u32 RESERVED1[12];
  vu32 FMR;
  vu32 FM1R;
  u32 RESERVED2;
  vu32 FS1R;
  u32 RESERVED3;
  vu32 FFA1R;
  u32 RESERVED4;
  vu32 FA1R;
  u32 RESERVED5[8];
  CAN_FilterRegister_TypeDef sFilterRegister[14];
} CAN_TypeDef;


typedef struct
{
  vu32 DR;
  vu8 IDR;
  u8 RESERVED0;
  u16 RESERVED1;
  vu32 CR;
} CRC_TypeDef;



typedef struct
{
  vu32 CR;
  vu32 SWTRIGR;
  vu32 DHR12R1;
  vu32 DHR12L1;
  vu32 DHR8R1;
  vu32 DHR12R2;
  vu32 DHR12L2;
  vu32 DHR8R2;
  vu32 DHR12RD;
  vu32 DHR12LD;
  vu32 DHR8RD;
  vu32 DOR1;
  vu32 DOR2;
} DAC_TypeDef;


typedef struct
{
  vu32 IDCODE;
  vu32 CR;
}DBGMCU_TypeDef;


typedef struct
{
  vu32 CCR;
  vu32 CNDTR;
  vu32 CPAR;
  vu32 CMAR;
} DMA_Channel_TypeDef;

typedef struct
{
  vu32 ISR;
  vu32 IFCR;
} DMA_TypeDef;


typedef struct
{
  vu32 IMR;
  vu32 EMR;
  vu32 RTSR;
  vu32 FTSR;
  vu32 SWIER;
  vu32 PR;
} EXTI_TypeDef;


typedef struct
{
  vu32 ACR;
  vu32 KEYR;
  vu32 OPTKEYR;
  vu32 SR;
  vu32 CR;
  vu32 AR;
  vu32 RESERVED;
  vu32 OBR;
  vu32 WRPR;
} FLASH_TypeDef;

typedef struct
{
  vu16 RDP;
  vu16 USER;
  vu16 Data0;
  vu16 Data1;
  vu16 WRP0;
  vu16 WRP1;
  vu16 WRP2;
  vu16 WRP3;
} OB_TypeDef;


typedef struct
{
  vu32 BTCR[8];
} FSMC_Bank1_TypeDef;

typedef struct
{
  vu32 BWTR[7];
} FSMC_Bank1E_TypeDef;

typedef struct
{
  vu32 PCR2;
  vu32 SR2;
  vu32 PMEM2;
  vu32 PATT2;
  u32 RESERVED0;
  vu32 ECCR2;
} FSMC_Bank2_TypeDef;

typedef struct
{
  vu32 PCR3;
  vu32 SR3;
  vu32 PMEM3;
  vu32 PATT3;
  u32 RESERVED0;
  vu32 ECCR3;
} FSMC_Bank3_TypeDef;

typedef struct
{
  vu32 PCR4;
  vu32 SR4;
  vu32 PMEM4;
  vu32 PATT4;
  vu32 PIO4;
} FSMC_Bank4_TypeDef;


typedef struct
{
  vu32 CRL;
  vu32 CRH;
  vu32 IDR;
  vu32 ODR;
  vu32 BSRR;
  vu32 BRR;
  vu32 LCKR;
} GPIO_TypeDef;

typedef struct
{
  vu32 EVCR;
  vu32 MAPR;
  vu32 EXTICR[4];
} AFIO_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 OAR1;
  u16 RESERVED2;
  vu16 OAR2;
  u16 RESERVED3;
  vu16 DR;
  u16 RESERVED4;
  vu16 SR1;
  u16 RESERVED5;
  vu16 SR2;
  u16 RESERVED6;
  vu16 CCR;
  u16 RESERVED7;
  vu16 TRISE;
  u16 RESERVED8;
} I2C_TypeDef;


typedef struct
{
  vu32 KR;
  vu32 PR;
  vu32 RLR;
  vu32 SR;
} IWDG_TypeDef;


typedef struct
{
  vu32 ISER[2];
  u32 RESERVED0[30];
  vu32 ICER[2];
  u32 RSERVED1[30];
  vu32 ISPR[2];
  u32 RESERVED2[30];
  vu32 ICPR[2];
  u32 RESERVED3[30];
  vu32 IABR[2];
  u32 RESERVED4[62];
  vu32 IPR[15];
} NVIC_TypeDef;

typedef struct
{
  vuc32 CPUID;
  vu32 ICSR;
  vu32 VTOR;
  vu32 AIRCR;
  vu32 SCR;
  vu32 CCR;
  vu32 SHPR[3];
  vu32 SHCSR;
  vu32 CFSR;
  vu32 HFSR;
  vu32 DFSR;
  vu32 MMFAR;
  vu32 BFAR;
  vu32 AFSR;
} SCB_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CSR;
} PWR_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CFGR;
  vu32 CIR;
  vu32 APB2RSTR;
  vu32 APB1RSTR;
  vu32 AHBENR;
  vu32 APB2ENR;
  vu32 APB1ENR;
  vu32 BDCR;
  vu32 CSR;
} RCC_TypeDef;


typedef struct
{
  vu16 CRH;
  u16 RESERVED0;
  vu16 CRL;
  u16 RESERVED1;
  vu16 PRLH;
  u16 RESERVED2;
  vu16 PRLL;
  u16 RESERVED3;
  vu16 DIVH;
  u16 RESERVED4;
  vu16 DIVL;
  u16 RESERVED5;
  vu16 CNTH;
  u16 RESERVED6;
  vu16 CNTL;
  u16 RESERVED7;
  vu16 ALRH;
  u16 RESERVED8;
  vu16 ALRL;
  u16 RESERVED9;
} RTC_TypeDef;


typedef struct
{
  vu32 POWER;
  vu32 CLKCR;
  vu32 ARG;
  vu32 CMD;
  vuc32 RESPCMD;
  vuc32 RESP1;
  vuc32 RESP2;
  vuc32 RESP3;
  vuc32 RESP4;
  vu32 DTIMER;
  vu32 DLEN;
  vu32 DCTRL;
  vuc32 DCOUNT;
  vuc32 STA;
  vu32 ICR;
  vu32 MASK;
  u32 RESERVED0[2];
  vuc32 FIFOCNT;
  u32 RESERVED1[13];
  vu32 FIFO;
} SDIO_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 SR;
  u16 RESERVED2;
  vu16 DR;
  u16 RESERVED3;
  vu16 CRCPR;
  u16 RESERVED4;
  vu16 RXCRCR;
  u16 RESERVED5;
  vu16 TXCRCR;
  u16 RESERVED6;
  vu16 I2SCFGR;
  u16 RESERVED7;
  vu16 I2SPR;
  u16 RESERVED8;
} SPI_TypeDef;


typedef struct
{
  vu32 CTRL;
  vu32 LOAD;
  vu32 VAL;
  vuc32 CALIB;
} SysTick_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 SMCR;
  u16 RESERVED2;
  vu16 DIER;
  u16 RESERVED3;
  vu16 SR;
  u16 RESERVED4;
  vu16 EGR;
  u16 RESERVED5;
  vu16 CCMR1;
  u16 RESERVED6;
  vu16 CCMR2;
  u16 RESERVED7;
  vu16 CCER;
  u16 RESERVED8;
  vu16 CNT;
  u16 RESERVED9;
  vu16 PSC;
  u16 RESERVED10;
  vu16 ARR;
  u16 RESERVED11;
  vu16 RCR;
  u16 RESERVED12;
  vu16 CCR1;
  u16 RESERVED13;
  vu16 CCR2;
  u16 RESERVED14;
  vu16 CCR3;
  u16 RESERVED15;
  vu16 CCR4;
  u16 RESERVED16;
  vu16 BDTR;
  u16 RESERVED17;
  vu16 DCR;
  u16 RESERVED18;
  vu16 DMAR;
  u16 RESERVED19;
} TIM_TypeDef;


typedef struct
{
  vu16 SR;
  u16 RESERVED0;
  vu16 DR;
  u16 RESERVED1;
  vu16 BRR;
  u16 RESERVED2;
  vu16 CR1;
  u16 RESERVED3;
  vu16 CR2;
  u16 RESERVED4;
  vu16 CR3;
  u16 RESERVED5;
  vu16 GTPR;
  u16 RESERVED6;
} USART_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CFR;
  vu32 SR;
} WWDG_TypeDef;
# 23 "FWLib/inc/stm32f10x_lib.h" 2
# 49 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_dma.h" 1
# 26 "FWLib/inc/stm32f10x_dma.h"
typedef struct
{
  u32 DMA_PeripheralBaseAddr;
  u32 DMA_MemoryBaseAddr;
  u32 DMA_DIR;
  u32 DMA_BufferSize;
  u32 DMA_PeripheralInc;
  u32 DMA_MemoryInc;
  u32 DMA_PeripheralDataSize;
  u32 DMA_MemoryDataSize;
  u32 DMA_Mode;
  u32 DMA_Priority;
  u32 DMA_M2M;
}DMA_InitTypeDef;
# 284 "FWLib/inc/stm32f10x_dma.h"
void DMA_DeInit(DMA_Channel_TypeDef* DMAy_Channelx);
void DMA_Init(DMA_Channel_TypeDef* DMAy_Channelx, DMA_InitTypeDef* DMA_InitStruct);
void DMA_StructInit(DMA_InitTypeDef* DMA_InitStruct);
void DMA_Cmd(DMA_Channel_TypeDef* DMAy_Channelx, FunctionalState NewState);
void DMA_ITConfig(DMA_Channel_TypeDef* DMAy_Channelx, u32 DMA_IT, FunctionalState NewState);
u16 DMA_GetCurrDataCounter(DMA_Channel_TypeDef* DMAy_Channelx);
FlagStatus DMA_GetFlagStatus(u32 DMA_FLAG);
void DMA_ClearFlag(u32 DMA_FLAG);
ITStatus DMA_GetITStatus(u32 DMA_IT);
void DMA_ClearITPendingBit(u32 DMA_IT);
# 50 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_flash.h" 1
# 27 "FWLib/inc/stm32f10x_flash.h"
typedef enum
{
  FLASH_BUSY = 1,
  FLASH_ERROR_PG,
  FLASH_ERROR_WRP,
  FLASH_COMPLETE,
  FLASH_TIMEOUT
}FLASH_Status;
# 179 "FWLib/inc/stm32f10x_flash.h"
void FLASH_SetLatency(u32 FLASH_Latency);
void FLASH_HalfCycleAccessCmd(u32 FLASH_HalfCycleAccess);
void FLASH_PrefetchBufferCmd(u32 FLASH_PrefetchBuffer);


void FLASH_Unlock(void);
void FLASH_Lock(void);
FLASH_Status FLASH_ErasePage(u32 Page_Address);
FLASH_Status FLASH_EraseAllPages(void);
FLASH_Status FLASH_EraseOptionBytes(void);
FLASH_Status FLASH_ProgramWord(u32 Address, u32 Data);
FLASH_Status FLASH_ProgramHalfWord(u32 Address, u16 Data);
FLASH_Status FLASH_ProgramOptionByteData(u32 Address, u8 Data);
FLASH_Status FLASH_EnableWriteProtection(u32 FLASH_Pages);
FLASH_Status FLASH_ReadOutProtection(FunctionalState NewState);
FLASH_Status FLASH_UserOptionByteConfig(u16 OB_IWDG, u16 OB_STOP, u16 OB_STDBY);
u32 FLASH_GetUserOptionByte(void);
u32 FLASH_GetWriteProtectionOptionByte(void);
FlagStatus FLASH_GetReadOutProtectionStatus(void);
FlagStatus FLASH_GetPrefetchBufferStatus(void);
void FLASH_ITConfig(u16 FLASH_IT, FunctionalState NewState);
FlagStatus FLASH_GetFlagStatus(u16 FLASH_FLAG);
void FLASH_ClearFlag(u16 FLASH_FLAG);
FLASH_Status FLASH_GetStatus(void);
FLASH_Status FLASH_WaitForLastOperation(u32 Timeout);
# 58 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_fsmc.h" 1
# 26 "FWLib/inc/stm32f10x_fsmc.h"
typedef struct
{
  u32 FSMC_AddressSetupTime;
  u32 FSMC_AddressHoldTime;
  u32 FSMC_DataSetupTime;
  u32 FSMC_BusTurnAroundDuration;
  u32 FSMC_CLKDivision;
  u32 FSMC_DataLatency;
  u32 FSMC_AccessMode;
}FSMC_NORSRAMTimingInitTypeDef;


typedef struct
{
  u32 FSMC_Bank;
  u32 FSMC_DataAddressMux;
  u32 FSMC_MemoryType;
  u32 FSMC_MemoryDataWidth;
  u32 FSMC_BurstAccessMode;
  u32 FSMC_WaitSignalPolarity;
  u32 FSMC_WrapMode;
  u32 FSMC_WaitSignalActive;
  u32 FSMC_WriteOperation;
  u32 FSMC_WaitSignal;
  u32 FSMC_ExtendedMode;
  u32 FSMC_WriteBurst;

  FSMC_NORSRAMTimingInitTypeDef* FSMC_ReadWriteTimingStruct;

  FSMC_NORSRAMTimingInitTypeDef* FSMC_WriteTimingStruct;
}FSMC_NORSRAMInitTypeDef;


typedef struct
{
  u32 FSMC_SetupTime;
  u32 FSMC_WaitSetupTime;
  u32 FSMC_HoldSetupTime;
  u32 FSMC_HiZSetupTime;
}FSMC_NAND_PCCARDTimingInitTypeDef;


typedef struct
{
  u32 FSMC_Bank;
  u32 FSMC_Waitfeature;
  u32 FSMC_MemoryDataWidth;
  u32 FSMC_ECC;
  u32 FSMC_ECCPageSize;
  u32 FSMC_AddressLowMapping;
  u32 FSMC_TCLRSetupTime;
  u32 FSMC_TARSetupTime;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_CommonSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_AttributeSpaceTimingStruct;
}FSMC_NANDInitTypeDef;


typedef struct
{
  u32 FSMC_Waitfeature;
  u32 FSMC_AddressLowMapping;
  u32 FSMC_TCLRSetupTime;
  u32 FSMC_TARSetupTime;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_CommonSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_AttributeSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_IOSpaceTimingStruct;
}FSMC_PCCARDInitTypeDef;
# 323 "FWLib/inc/stm32f10x_fsmc.h"
void FSMC_NORSRAMDeInit(u32 FSMC_Bank);
void FSMC_NANDDeInit(u32 FSMC_Bank);
void FSMC_PCCARDDeInit(void);
void FSMC_NORSRAMInit(FSMC_NORSRAMInitTypeDef* FSMC_NORSRAMInitStruct);
void FSMC_NANDInit(FSMC_NANDInitTypeDef* FSMC_NANDInitStruct);
void FSMC_PCCARDInit(FSMC_PCCARDInitTypeDef* FSMC_PCCARDInitStruct);
void FSMC_NORSRAMStructInit(FSMC_NORSRAMInitTypeDef* FSMC_NORSRAMInitStruct);
void FSMC_NANDStructInit(FSMC_NANDInitTypeDef* FSMC_NANDInitStruct);
void FSMC_PCCARDStructInit(FSMC_PCCARDInitTypeDef* FSMC_PCCARDInitStruct);
void FSMC_NORSRAMCmd(u32 FSMC_Bank, FunctionalState NewState);
void FSMC_NANDCmd(u32 FSMC_Bank, FunctionalState NewState);
void FSMC_PCCARDCmd(FunctionalState NewState);
void FSMC_NANDECCCmd(u32 FSMC_Bank, FunctionalState NewState);
u32 FSMC_GetECC(u32 FSMC_Bank);
void FSMC_ITConfig(u32 FSMC_Bank, u32 FSMC_IT, FunctionalState NewState);
FlagStatus FSMC_GetFlagStatus(u32 FSMC_Bank, u32 FSMC_FLAG);
void FSMC_ClearFlag(u32 FSMC_Bank, u32 FSMC_FLAG);
ITStatus FSMC_GetITStatus(u32 FSMC_Bank, u32 FSMC_IT);
void FSMC_ClearITPendingBit(u32 FSMC_Bank, u32 FSMC_IT);
# 62 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_gpio.h" 1
# 34 "FWLib/inc/stm32f10x_gpio.h"
typedef enum
{
  GPIO_Speed_10MHz = 1,
  GPIO_Speed_2MHz,
  GPIO_Speed_50MHz
}GPIOSpeed_TypeDef;





typedef enum
{ GPIO_Mode_AIN = 0x0,
  GPIO_Mode_IN_FLOATING = 0x04,
  GPIO_Mode_IPD = 0x28,
  GPIO_Mode_IPU = 0x48,
  GPIO_Mode_Out_OD = 0x14,
  GPIO_Mode_Out_PP = 0x10,
  GPIO_Mode_AF_OD = 0x1C,
  GPIO_Mode_AF_PP = 0x18
}GPIOMode_TypeDef;







typedef struct
{
  u16 GPIO_Pin;
  GPIOSpeed_TypeDef GPIO_Speed;
  GPIOMode_TypeDef GPIO_Mode;
}GPIO_InitTypeDef;


typedef enum
{ Bit_RESET = 0,
  Bit_SET
}BitAction;
# 217 "FWLib/inc/stm32f10x_gpio.h"
void GPIO_DeInit(GPIO_TypeDef* GPIOx);
void GPIO_AFIODeInit(void);
void GPIO_Init(GPIO_TypeDef* GPIOx, GPIO_InitTypeDef* GPIO_InitStruct);
void GPIO_StructInit(GPIO_InitTypeDef* GPIO_InitStruct);
u8 GPIO_ReadInputDataBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
u16 GPIO_ReadInputData(GPIO_TypeDef* GPIOx);
u8 GPIO_ReadOutputDataBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
u16 GPIO_ReadOutputData(GPIO_TypeDef* GPIOx);
void GPIO_SetBits(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_ResetBits(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_WriteBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin, BitAction BitVal);
void GPIO_Write(GPIO_TypeDef* GPIOx, u16 PortVal);
void GPIO_PinLockConfig(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_EventOutputConfig(u8 GPIO_PortSource, u8 GPIO_PinSource);
void GPIO_EventOutputCmd(FunctionalState NewState);
void GPIO_PinRemapConfig(u32 GPIO_Remap, FunctionalState NewState);
void GPIO_EXTILineConfig(u8 GPIO_PortSource, u8 GPIO_PinSource);
# 66 "FWLib/inc/stm32f10x_lib.h" 2
# 77 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_nvic.h" 1
# 26 "FWLib/inc/stm32f10x_nvic.h"
typedef struct
{
  u8 NVIC_IRQChannel;
  u8 NVIC_IRQChannelPreemptionPriority;
  u8 NVIC_IRQChannelSubPriority;
  FunctionalState NVIC_IRQChannelCmd;
} NVIC_InitTypeDef;
# 253 "FWLib/inc/stm32f10x_nvic.h"
void NVIC_DeInit(void);
void NVIC_SCBDeInit(void);
void NVIC_PriorityGroupConfig(u32 NVIC_PriorityGroup);
void NVIC_Init(NVIC_InitTypeDef* NVIC_InitStruct);
void NVIC_StructInit(NVIC_InitTypeDef* NVIC_InitStruct);
void NVIC_SETPRIMASK(void);
void NVIC_RESETPRIMASK(void);
void NVIC_SETFAULTMASK(void);
void NVIC_RESETFAULTMASK(void);
void NVIC_BASEPRICONFIG(u32 NewPriority);
u32 NVIC_GetBASEPRI(void);
u16 NVIC_GetCurrentPendingIRQChannel(void);
ITStatus NVIC_GetIRQChannelPendingBitStatus(u8 NVIC_IRQChannel);
void NVIC_SetIRQChannelPendingBit(u8 NVIC_IRQChannel);
void NVIC_ClearIRQChannelPendingBit(u8 NVIC_IRQChannel);
u16 NVIC_GetCurrentActiveHandler(void);
ITStatus NVIC_GetIRQChannelActiveBitStatus(u8 NVIC_IRQChannel);
u32 NVIC_GetCPUID(void);
void NVIC_SetVectorTable(u32 NVIC_VectTab, u32 Offset);
void NVIC_GenerateSystemReset(void);
void NVIC_GenerateCoreReset(void);
void NVIC_SystemLPConfig(u8 LowPowerMode, FunctionalState NewState);
void NVIC_SystemHandlerConfig(u32 SystemHandler, FunctionalState NewState);
void NVIC_SystemHandlerPriorityConfig(u32 SystemHandler, u8 SystemHandlerPreemptionPriority,
                                      u8 SystemHandlerSubPriority);
ITStatus NVIC_GetSystemHandlerPendingBitStatus(u32 SystemHandler);
void NVIC_SetSystemHandlerPendingBit(u32 SystemHandler);
void NVIC_ClearSystemHandlerPendingBit(u32 SystemHandler);
ITStatus NVIC_GetSystemHandlerActiveBitStatus(u32 SystemHandler);
u32 NVIC_GetFaultHandlerSources(u32 SystemHandler);
u32 NVIC_GetFaultAddress(u32 SystemHandler);
# 78 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_rcc.h" 1
# 25 "FWLib/inc/stm32f10x_rcc.h"
typedef struct
{
  u32 SYSCLK_Frequency;
  u32 HCLK_Frequency;
  u32 PCLK1_Frequency;
  u32 PCLK2_Frequency;
  u32 ADCCLK_Frequency;
}RCC_ClocksTypeDef;
# 253 "FWLib/inc/stm32f10x_rcc.h"
void RCC_DeInit(void);
void RCC_HSEConfig(u32 RCC_HSE);
ErrorStatus RCC_WaitForHSEStartUp(void);
void RCC_AdjustHSICalibrationValue(u8 HSICalibrationValue);
void RCC_HSICmd(FunctionalState NewState);
void RCC_PLLConfig(u32 RCC_PLLSource, u32 RCC_PLLMul);
void RCC_PLLCmd(FunctionalState NewState);
void RCC_SYSCLKConfig(u32 RCC_SYSCLKSource);
u8 RCC_GetSYSCLKSource(void);
void RCC_HCLKConfig(u32 RCC_SYSCLK);
void RCC_PCLK1Config(u32 RCC_HCLK);
void RCC_PCLK2Config(u32 RCC_HCLK);
void RCC_ITConfig(u8 RCC_IT, FunctionalState NewState);
void RCC_USBCLKConfig(u32 RCC_USBCLKSource);
void RCC_ADCCLKConfig(u32 RCC_PCLK2);
void RCC_LSEConfig(u8 RCC_LSE);
void RCC_LSICmd(FunctionalState NewState);
void RCC_RTCCLKConfig(u32 RCC_RTCCLKSource);
void RCC_RTCCLKCmd(FunctionalState NewState);
void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks);
void RCC_AHBPeriphClockCmd(u32 RCC_AHBPeriph, FunctionalState NewState);
void RCC_APB2PeriphClockCmd(u32 RCC_APB2Periph, FunctionalState NewState);
void RCC_APB1PeriphClockCmd(u32 RCC_APB1Periph, FunctionalState NewState);
void RCC_APB2PeriphResetCmd(u32 RCC_APB2Periph, FunctionalState NewState);
void RCC_APB1PeriphResetCmd(u32 RCC_APB1Periph, FunctionalState NewState);
void RCC_BackupResetCmd(FunctionalState NewState);
void RCC_ClockSecuritySystemCmd(FunctionalState NewState);
void RCC_MCOConfig(u8 RCC_MCO);
FlagStatus RCC_GetFlagStatus(u8 RCC_FLAG);
void RCC_ClearFlag(void);
ITStatus RCC_GetITStatus(u8 RCC_IT);
void RCC_ClearITPendingBit(u8 RCC_IT);
# 86 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_sdio.h" 1
# 25 "FWLib/inc/stm32f10x_sdio.h"
typedef struct
{
  u8 SDIO_ClockDiv;
  u32 SDIO_ClockEdge;
  u32 SDIO_ClockBypass;
  u32 SDIO_ClockPowerSave;
  u32 SDIO_BusWide;
  u32 SDIO_HardwareFlowControl;
} SDIO_InitTypeDef;

typedef struct
{
  u32 SDIO_Argument;
  u32 SDIO_CmdIndex;
  u32 SDIO_Response;
  u32 SDIO_Wait;
  u32 SDIO_CPSM;
} SDIO_CmdInitTypeDef;

typedef struct
{
  u32 SDIO_DataTimeOut;
  u32 SDIO_DataLength;
  u32 SDIO_DataBlockSize;
  u32 SDIO_TransferDir;
  u32 SDIO_TransferMode;
  u32 SDIO_DPSM;
} SDIO_DataInitTypeDef;
# 304 "FWLib/inc/stm32f10x_sdio.h"
void SDIO_DeInit(void);
void SDIO_Init(SDIO_InitTypeDef* SDIO_InitStruct);
void SDIO_StructInit(SDIO_InitTypeDef* SDIO_InitStruct);
void SDIO_ClockCmd(FunctionalState NewState);
void SDIO_SetPowerState(u32 SDIO_PowerState);
u32 SDIO_GetPowerState(void);
void SDIO_ITConfig(u32 SDIO_IT, FunctionalState NewState);
void SDIO_DMACmd(FunctionalState NewState);
void SDIO_SendCommand(SDIO_CmdInitTypeDef *SDIO_CmdInitStruct);
void SDIO_CmdStructInit(SDIO_CmdInitTypeDef* SDIO_CmdInitStruct);
u8 SDIO_GetCommandResponse(void);
u32 SDIO_GetResponse(u32 SDIO_RESP);
void SDIO_DataConfig(SDIO_DataInitTypeDef* SDIO_DataInitStruct);
void SDIO_DataStructInit(SDIO_DataInitTypeDef* SDIO_DataInitStruct);
u32 SDIO_GetDataCounter(void);
u32 SDIO_ReadData(void);
void SDIO_WriteData(u32 Data);
u32 SDIO_GetFIFOCount(void);
void SDIO_StartSDIOReadWait(FunctionalState NewState);
void SDIO_StopSDIOReadWait(FunctionalState NewState);
void SDIO_SetSDIOReadWaitMode(u32 SDIO_ReadWaitMode);
void SDIO_SetSDIOOperation(FunctionalState NewState);
void SDIO_SendSDIOSuspendCmd(FunctionalState NewState);
void SDIO_CommandCompletionCmd(FunctionalState NewState);
void SDIO_CEATAITCmd(FunctionalState NewState);
void SDIO_SendCEATACmd(FunctionalState NewState);
FlagStatus SDIO_GetFlagStatus(u32 SDIO_FLAG);
void SDIO_ClearFlag(u32 SDIO_FLAG);
ITStatus SDIO_GetITStatus(u32 SDIO_IT);
void SDIO_ClearITPendingBit(u32 SDIO_IT);
# 94 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_spi.h" 1
# 26 "FWLib/inc/stm32f10x_spi.h"
typedef struct
{
  u16 SPI_Direction;
  u16 SPI_Mode;
  u16 SPI_DataSize;
  u16 SPI_CPOL;
  u16 SPI_CPHA;
  u16 SPI_NSS;
  u16 SPI_BaudRatePrescaler;
  u16 SPI_FirstBit;
  u16 SPI_CRCPolynomial;
}SPI_InitTypeDef;
# 175 "FWLib/inc/stm32f10x_spi.h"
void SPI_DeInit(SPI_TypeDef* SPIx);
void SPI_Init(SPI_TypeDef* SPIx, SPI_InitTypeDef* SPI_InitStruct);
void SPI_StructInit(SPI_InitTypeDef* SPI_InitStruct);
void SPI_Cmd(SPI_TypeDef* SPIx, FunctionalState NewState);
void SPI_ITConfig(SPI_TypeDef* SPIx, u8 SPI_IT, FunctionalState NewState);
void SPI_DMACmd(SPI_TypeDef* SPIx, u16 SPI_DMAReq, FunctionalState NewState);
void SPI_SendData(SPI_TypeDef* SPIx, u16 Data);
u16 SPI_ReceiveData(SPI_TypeDef* SPIx);
void SPI_NSSInternalSoftwareConfig(SPI_TypeDef* SPIx, u16 SPI_NSSInternalSoft);
void SPI_SSOutputCmd(SPI_TypeDef* SPIx, FunctionalState NewState);
void SPI_DataSizeConfig(SPI_TypeDef* SPIx, u16 SPI_DataSize);
void SPI_TransmitCRC(SPI_TypeDef* SPIx);
void SPI_CalculateCRC(SPI_TypeDef* SPIx, FunctionalState NewState);
u16 SPI_GetCRC(SPI_TypeDef* SPIx, u8 SPI_CRC);
u16 SPI_GetCRCPolynomial(SPI_TypeDef* SPIx);
void SPI_BiDirectionalLineConfig(SPI_TypeDef* SPIx, u16 SPI_Direction);
FlagStatus SPI_GetFlagStatus(SPI_TypeDef* SPIx, u16 SPI_FLAG);
void SPI_ClearFlag(SPI_TypeDef* SPIx, u16 SPI_FLAG);
ITStatus SPI_GetITStatus(SPI_TypeDef* SPIx, u8 SPI_IT);
void SPI_ClearITPendingBit(SPI_TypeDef* SPIx, u8 SPI_IT);
# 98 "FWLib/inc/stm32f10x_lib.h" 2
# 120 "FWLib/inc/stm32f10x_lib.h"
void debug(void);
# 10 "inc/Interrupt.h" 2

extern vu8 Cursor_Cnt, Key_Wait_Cnt, Key_Repeat_Cnt, Key_Buffer, Cnt_mS, Cnt_20mS;
extern vu8 Twink, Blink;
extern u8 Volume, Light;
extern vu16 Delay_Cnt, Beep_mS, Key_Status_Last, Sec_Cnt, PD_Cnt, TimedDeltaView,NotificationTimer,DelayLoopBreak;
extern vu32 Wait_Cnt;
void NMIException(void);
void HardFaultException(void);
void MemManageException(void);
void BusFaultException(void);
void UsageFaultException(void);
void DebugMonitor(void);
void SVCHandler(void);
void PendSVC(void);
void SysTickHandler(void);
void WWDG_IRQHandler(void);
void PVD_IRQHandler(void);
void TAMPER_IRQHandler(void);
void RTC_IRQHandler(void);
void FLASH_IRQHandler(void);
void RCC_IRQHandler(void);
void EXTI0_IRQHandler(void);
void EXTI1_IRQHandler(void);
void EXTI2_IRQHandler(void);
void EXTI3_IRQHandler(void);
void EXTI4_IRQHandler(void);
void DMA1_Channel1_IRQHandler(void);
void DMA1_Channel2_IRQHandler(void);
void DMA1_Channel3_IRQHandler(void);
void DMA1_Channel4_IRQHandler(void);
void DMA1_Channel5_IRQHandler(void);
void DMA1_Channel6_IRQHandler(void);
void DMA1_Channel7_IRQHandler(void);
void ADC1_2_IRQHandler(void);
void USB_HP_CAN_TX_IRQHandler(void);
void USB_LP_CAN_RX0_IRQHandler(void);
void CAN_RX1_IRQHandler(void);
void CAN_SCE_IRQHandler(void);
void EXTI9_5_IRQHandler(void);
void TIM1_BRK_IRQHandler(void);
void TIM1_UP_IRQHandler(void);
void TIM1_TRG_COM_IRQHandler(void);
void TIM1_CC_IRQHandler(void);
void TIM2_IRQHandler(void);
void TIM3_IRQHandler(void);
void TIM4_IRQHandler(void);
void I2C1_EV_IRQHandler(void);
void I2C1_ER_IRQHandler(void);
void I2C2_EV_IRQHandler(void);
void I2C2_ER_IRQHandler(void);
void SPI1_IRQHandler(void);
void SPI2_IRQHandler(void);
void USART1_IRQHandler(void);
void USART2_IRQHandler(void);
void USART3_IRQHandler(void);
void EXTI15_10_IRQHandler(void);
void RTCAlarm_IRQHandler(void);
void USBWakeUp_IRQHandler(void);
void TIM8_BRK_IRQHandler(void);
void TIM8_UP_IRQHandler(void);
void TIM8_TRG_COM_IRQHandler(void);
void TIM8_CC_IRQHandler(void);
void ADC3_IRQHandler(void);
void FSMC_IRQHandler(void);
void SDIO_IRQHandler(void);
void TIM5_IRQHandler(void);
void SPI3_IRQHandler(void);
void UART4_IRQHandler(void);
void UART5_IRQHandler(void);
void TIM6_IRQHandler(void);
void TIM7_IRQHandler(void);
void DMA2_Channel1_IRQHandler(void);
void DMA2_Channel2_IRQHandler(void);
void DMA2_Channel3_IRQHandler(void);
void DMA2_Channel4_5_IRQHandler(void);
# 6 "Calibrat.c" 2
# 1 "inc/Function.h" 1
# 26 "inc/Function.h"
u32 Power(u8 x, u8 y);
void Delayms(u16 mS);
void Int2Str(char *p, s32 n,const char *pUnit, u8 e, u8 Mode, s8 ShiftDigits);
u8 Str2Byte(char x,char y);
void u16ToDec5(char *p, u16 n);
void u8ToDec3(char *p, u8 n);
void u8ToDec2(char *p, u8 n);
void Char2Hex(char *p, u8 n);
void Shor2Hex(char *p, u16 n);
void Word2Hex(char *p, u32 n);
void s16ToDec3(char *p, s16 n);
u32 Int_sqrt(u32 n);
u8 Read_Keys(void);
void s8ToPercen(char *p, s8 n);
# 49 "inc/Function.h"
extern void fix_fft(short fr[], short fi[], short m);
# 7 "Calibrat.c" 2
# 1 "inc/Calibrat.h" 1
# 13 "inc/Calibrat.h"
extern s16 PPM_Comp;

void Calibrat(u8 Channel);
# 8 "Calibrat.c" 2
# 1 "inc/Process.h" 1
# 9 "inc/Process.h"
# 1 "inc/Draw.h" 1
# 10 "inc/Draw.h"
typedef struct
{
  s16 Value;
  u8 Flag;
} trigg;
# 83 "inc/Draw.h"
extern u8 OffsetX;
extern u8 OffsetY;


extern u16 MAX_X;
extern u8 FlagFrameMode;
extern u8 FlagMeter;
extern u8 UpdateMeter;
extern u8 TrgAuto;
extern u16 Color[16];
extern u16 LCD_Buffer1[240], LCD_Buffer2[240];
extern trigg V_Trigg[4];
u16 Get_TAB_8x11(u8 Code, u8 Row);
u8 Get_Ref_Wave(u16 i);
void Print_Clk(u16 x0, u16 y0, u16 Type, u8 Phase);
void Print_Str(u16 x0, u16 y0, u16 Color, u8 Mode, char *s);

void Print_Str2(u16 x0,u16 x1,u16 y0, u16 Type, u8 Mode, char *s,u8 LeadingBlanks,u8 TrailingBlanks);


void Draw_Row(u16 Row);
void Draw_Row_XY(u16 Row);

void Draw_Window(void);

void LoadBase3Buffer(void);
void LoadBase2Buffer(void);

void Draw_Mark(u16 m, u16 n);
void Update_Mark(void);
void Update_View_Area(void);
void Clear_Meter_Area(void);
# 10 "inc/Process.h" 2
# 65 "inc/Process.h"
typedef struct
{
  uc8 STR[8];
  uc16 PSC;
  uc16 ARR;
} A_tab ;

typedef struct
{
  uc8 STR[8];
  uc16 PSC;
  uc16 ARR;
  u16 Duty;
} D_tab ;

extern u8 discard;
extern s16 Xtend;
extern u8 BailoutFlag;

extern u8 CurDefTime;
extern u16 NSamples;
extern u16 CountUnread;
extern u8 TrackBuff [392 * 4];

extern s32 a_Avg, b_Avg, a_Ssq, b_Ssq;



extern s16 a_Max, b_Max, a_Min, b_Min;
extern s16 aT_Max, bT_Max, aT_Min, bT_Min;
extern u8 Rdiscard;

extern u16 Tcs, Tcnt;

extern u16 TaS, TbS, TcS, TdS;
extern u32 Sum[4];
extern u16 NAvg[4];
extern u16 VNAvg[2];
extern s32 VxAvg[2];
extern s32 VxSsq[2];
extern u16 PaS, PbS, PcS, PdS;
extern u16 TaN, TbN, TcN, TdN;
extern u32 PxS[4];
extern u32 TxS[4];
extern u32 TxN[4];

extern u8 FrameMode;
extern u8 FFTflag;

extern u8 Options;
extern u16 TempKp1;
extern u8 ADCoffset;
extern u8 CalFlag;
extern u16 JumpCnt;
extern s8 Kab;
extern s8 Ka1[10], Kb1[10];
extern u16 Ka2[10], Kb2[10];
extern s8 Ka3[10], Kb3[10];
extern s8 HKa1[10], HKb1[10];
extern u16 HKa2[10], HKb2[10];
extern s8 HKa3[10], HKb3[10];
extern s8 LKa1[10], LKb1[10];
extern u16 LKa2[10], LKb2[10];
extern s8 LKa3[10], LKb3[10];
extern u32 DataBuf[4096];
extern u8 ScalingOffset;
extern char Vertical[15][10];
extern s16 TrigSourceEnable;
extern u16 HiBatLevel[2];
extern u16 LoBatLevel[2];
extern u16 PrevBatLevel;
extern u16 VDiff[2];
extern u8 SumResetFlag;
extern u8 EnablePaS;
extern u8 ClearHoldFlag;
extern u8 SlowModeSkip;
extern s16 A_Posi;
extern s16 B_Posi;
extern u8 ClearLeadingEdge;


void BackGround_Reset(void);
void App_init(void);
void View_init(void);
void Update_Range(void);
void Update_Base(void);
void Update_Output(void);
void Update_Trig(u8 service);
void Process(void);
void Synchro(void);
void Send_Data(s16 Va, s16 Vb, u8 C_D, u16 n);
u16 get_bag_max_buf();
void cleardatabuf(u8 Afill, u8 Bfill, u16 n,u8 service);
void Config_init(void);
void TransferFIFO(s16 i,u8 service);
void SetOffset(u8 channel,u8 range, s16 Ypos);
void BatLevelCompensation(void);
void ResetSum(void);
void ClearMinMax(u8 Channels);
void ClearHold(u8 Channels);
void ClearTrackBuff(u8 service);



extern short fr[];
extern short fi[];

extern u8 ShowFFT;
extern u32 NFreq;
extern char NFreqStr[];
extern int imax;
extern short PeakFreq;
extern char PeakFreqStr[];
extern char FreqDivStr[];
extern char FreqT1Str[];
# 9 "Calibrat.c" 2
# 1 "inc/File.h" 1
# 28 "inc/File.h"
extern u8 FileBuff[1600];
extern u8 SaveShortBuffXpos;
extern u8 Versions;

u8 Save_Bmp(u8 FileNum);
u8 Color_Num(u16 Color);
u8 Save_Dat(u8 FileNum);
u8 Load_Dat(u8 FileNum);
u8 Save_Buf(u8 FileNum);
u8 Load_Buf(u8 FileNum);
u8 Save_Csv(u8 FileNum);
u8 Make_Filename(u8 FileNum,char* FileName);
void reset_parameter(void);
u8 Load_Param(u8 FileNum);
u8 Save_Param(u8 FileNum);
# 10 "Calibrat.c" 2
# 1 "inc/BIOS.h" 1
# 139 "inc/BIOS.h"
typedef struct
{
  u16 LCD_X;
  u16 LCD_Y;
  u16 Yp_Max;
  u16 Xp_Max;
  u16 Tg_Num;
  u16 Yv_Max;
  u16 Xt_Max;
  u16 Co_Max;
  u8 Ya_Num;
  u8 Yd_Num;
  u8 INSERT;
  u16 KpA1;
  u16 KpA2;
  u16 KpB1;
  u16 KpB2;
} G_attr ;

typedef struct
{
  char STR[8];
  s16 KA1;
  u16 KA2;
  s16 KB1;
  u16 KB2;
  u32 SCALE;
} Y_attr ;

typedef struct
{
  char STR[8];
  s16 PSC;
  u16 ARR;
  u16 CCR;
  u16 KP;
  u32 SCALE;
} X_attr ;

typedef struct
{
  char STR[8];
  u8 CHx;
  u8 CMD;
} T_attr ;

extern Y_attr *Y_Attr;
extern X_attr *X_Attr;
extern G_attr *G_Attr;
extern T_attr *T_Attr;




 void __CTR_HP(void);
 void __USB_Istr(void);
 void __USB_Init(void);

 void __LCD_Initial(void);
 void __Clear_Screen(u16 Color);
 void __Point_SCR(u16 x0, u16 y0);
 void __LCD_SetPixl(u16 Color);
 u16 __LCD_GetPixl(void);
 u16 __Get_TAB_8x14(u8 Code, u16 Row);
 void __LCD_Set_Block(u16 x1, u16 x2, u16 y1, u16 y2);

 void __LCD_Copy(uc16 *pBuffer, u16 NumPixel);
 void __LCD_Fill(u16 *pBuffer,u16 NumPixel);
 void __LCD_DMA_Ready(void);

 void __Row_Copy(uc16 *S_Buffer,u16 *T_Buffer);
 void __Row_DMA_Ready(void);

 u32 __Read_FIFO(void);
 void __Display_Str(u16 x0, u16 y0, u16 Color, u8 Mode, char *s);

 u32 __Input_Lic(u16 x0, u8 y0);
 u32 __GetDev_SN(void);

 u8 __Ident(u32 Dev_ID, u32 Proj_ID, u32 Lic_No);

 void __Set(u8 Object, u32 Value);
 u32 __Get(u8 Object);

 void __ExtFlash_PageRD(u8* pBuffer, u32 ReadAddr, u16 NumByteToRead);
 void __ExtFlash_PageWR(u8* pBuffer, u32 WriteAddr);
 u8 __ReadDiskData(u8* pBuffer, u32 ReadAddr, u16 Lenght);
 u8 __ProgDiskPage(u8* pBuffer, u32 ProgAddr);

 u8 __FLASH_Erase(u32 Address);
 u8 __FLASH_Prog(u32 Address, u16 Data);
 void __FLASH_Unlock(void);
 void __FLASH_Lock(void);

 u8 __Chk_SYS(u32 Licence);
 u8* __Chk_DFU(void);
 u8* __Chk_HDW(void);

 u8 __OpenFileWr(u8* Buffer, char* FileName, u16* Cluster, u32* pDirAddr);
 u8 __OpenFileRd(u8* Buffer, char* FileName, u16* Cluster, u32* pDirAddr);
 u8 __ReadFileSec(u8* Buffer, u16* Cluster);
 u8 __ProgFileSec(u8* Buffer, u16* Cluster);
 u8 __CloseFile(u8* Buffer, u32 Lenght, u16* Cluster, u32* pDirAddr);
# 11 "Calibrat.c" 2
# 1 "inc/Menu.h" 1
# 160 "inc/Menu.h"
typedef struct
{
  char *Str;
  u8 Track;
  u8 Item;
  uc16 XPOS1;
  uc16 XPOS2;
  uc8 YPOS;
  u8 Flag;
} meter;

typedef struct
{
  char *Str;
  u16 *Color;
  s16 Limit;
  uc8 MARK;
  u16 XPOS;
  uc8 YPOS;
  s16 Value;
  u8 Flag;
} menu;

extern menu Title[13][4];
extern meter Meter[9];
extern u8 Current, TypeA, Update,BTwink;
extern u8 Detail[14];
extern char NumStr[12];
extern u16 Result_FPS;
extern const char T_UNIT[12], S_UNIT[12], P_UNIT[12], V_UNIT[12];
extern char N_UNIT[12];
extern u8 ConfigFileNumber;
extern s16 Ga_Max;
extern s16 Gb_Max;
extern s16 Ga_Min;
extern s16 Gb_Min;
extern s16 GHa_Max;
extern s16 GHb_Max;
extern s16 GHa_Min;
extern s16 GHb_Min;
extern u8 ShiftDigits;


extern uc16 Y_COLOR[5];

void EnableMeter(void);
void DisableMeter(void);
void Display_Value(u8 i);
void Display_Title(void);
void Display_Meter(void);
void Load_Attr(void);
void Update_Battery(void);
void DisplayBigMeter(u8 MeterNum);
void MeterDefaults(void);
u32 UpScale(u32 Tmp, u16 limit);
# 12 "Calibrat.c" 2

const char VS_STR[9][12] ={"250-300mV", "!0.5-0.6V!","!1.0-1.2V!","!2.5-3.0V!",
                     "!5.0-6.0V!"," !10-12V! "," !25-30V! "," !50-60V! "};
const char V_UNIT1[8] ={'m','V','m','V','V',' ','k','V'};
const char CenterStr[5][12]= {"-<o ( )  >+","-< o( )  >+","-<  (o)  >+","-<  ( )o >+","-<  ( ) o>+"};
const char CenterStep[32]= "CENTER CAL SOURCE ON ADC STEP  ";
const char ClockEntry[5][45]= {"          COMPENSATE FOR CPU CLOCK          ","  CONNECT FREQ COUNTER TO WAVE OUT  (1MHZ)  ",
                               "   ENTER ERROR IN PPM:  +IF HIGH -IF LOW    ","LEFT TOGGLE TO CHANGE - BUTTON 2 TO CONTINUE",
                               "                  (      )                  "};

s16 PPM_Comp=0;

void ClearTop(void);




void Calibrat(u8 Channel)
{

  s8 Ma1[10], Mb1[10], Ma3[10], Mb3[10];
  u16 Ma2[10], Mb2[10], i, j;
  s16 TmpA, TmpB;
  u8 Range, k = 0, m, Step, Tmp, V_min, V_max;
  s8 Offset;
  char n[10];
  u16 BatLevel[2]={0,0};
  char PPM_Str[5];

  Key_Buffer = 0;
  __Set(20, 0);
  __Set(2, 10*(Title[11][1].Value+1));
  __Clear_Screen(0x0000);

  Delayms(1000);

  Title[5][0].Value=4;
  Title[5][1].Value=18;
  Title[5][2].Value=50;
  Update_Output();

  j=0;
  for(i=200;i>144;i-=11){
    if(i==156)i=145;
    Print_Str(16,i,0x0405,0,(char*) ClockEntry[j++]);
  }

  while(Key_Buffer){};
  while(1){
    s16ToDec3(PPM_Str, PPM_Comp);
    Print_Str(176,145,0x0405,0,PPM_Str);
    if(Key_Buffer==5) {if(PPM_Comp>-999)PPM_Comp--;}
    if(Key_Buffer==6) {if(PPM_Comp<999)PPM_Comp++;}
    if(Key_Buffer==2)break;
    Key_Buffer = 0;
  }

  Key_Buffer = 0;
  __Clear_Screen(0x0000);

  __Set(5, 0);
  __Set(32+4, 1);
  __Set(32+0, 0x20);
  Title[4][0].Value = 0;
  __Set(3, 5*(Title[12][1].Value-1));
  Beep_mS = 500;
  Range = 0;
  Step = 0;
  m = 0;

  __Set(7, X_Attr[12].PSC);
  __Set(8, X_Attr[12].ARR);

  __Set(9, 0);
  __Set(11, 0);

  for(j=0; j<220; j+=20){
    for(i=0; i<399; i++){
      __Point_SCR(i, j);
      __LCD_SetPixl(0xFFFF);
    }
  }

  for(i=0; i<399; i++){
    __Point_SCR(i, 239);
    __LCD_SetPixl(0xFFFF);
  }
  __Point_SCR( 0, 0);
  for(j= 0; j<239; j++) __LCD_SetPixl(0xFFFF);
  __Point_SCR( 44, 20);
  for(j=20; j<201; j++) __LCD_SetPixl(0xFFFF);
  __Point_SCR( 88, 20);
  for(j=20; j<201; j++) __LCD_SetPixl(0xFFFF);
  __Point_SCR(132, 20);
  for(j=20; j<201; j++) __LCD_SetPixl(0xFFFF);
  __Point_SCR(200, 20);
  for(j=20; j<201; j++) __LCD_SetPixl(0xFFFF);
  __Point_SCR(244, 20);
  for(j=20; j<201; j++) __LCD_SetPixl(0xFFFF);
  __Point_SCR(288, 20);
  for(j=20; j<201; j++) __LCD_SetPixl(0xFFFF);
  __Point_SCR(332, 20);
  for(j=20; j<201; j++) __LCD_SetPixl(0xFFFF);
  __Point_SCR(398, 0);
  for(j= 0; j<239; j++) __LCD_SetPixl(0xFFFF);

  Print_Str( 6, 185, 0x0005, 0, "CH_A");
  Print_Str( 49, 185, 0x0005, 0, "ZERO");
  Print_Str( 93, 185, 0x0005, 0, "DIFF");
  Print_Str(137, 185, 0x0005, 0, "VOLTAGE");
  Print_Str(206, 185, 0x0105, 0, "CH_B");
  Print_Str(249, 185, 0x0105, 0, "ZERO");
  Print_Str(293, 185, 0x0105, 0, "DIFF");
  Print_Str(338, 185, 0x0105, 0, "VOLTAGE");

  for(i=0; i<=G_Attr[0].Yp_Max; i++){
    Print_Str( 6, 166-(i*20), 0x0005, 0, Y_Attr[i].STR);
    Print_Str(206, 166-(i*20), 0x0105, 0, Y_Attr[i].STR);
    Ma1[i] = Ka1[i]; Ma2[i] = Ka2[i]; Ma3[i] = Ka3[i];
    Mb1[i] = Kb1[i]; Mb2[i] = Kb2[i]; Mb3[i] = Kb3[i];
  }

  while (1){
    if (__Get(5)>0) PD_Cnt = 600;
    if(PD_Cnt == 0){
      __Set(2, 0);
      __Set(20, 1);
      return;
    }
    __Set(10, Range); __Set(12, Range);
    Delayms(20);
    __Set(6, 1);
    Delayms(20);
    a_Avg = 2048; b_Avg = 2048;
    V_max=0; V_min=0;

    for(i=0; i <4096; i++){
      TransferFIFO(i,0);
      Tmp=(DataBuf[i] & 0xFF )-ADCoffset;
      if(Channel == 0){
        if(i==0)V_max=V_min=Tmp;
        if(Tmp>V_max)V_max=Tmp;
        if(Tmp<V_min)V_min=Tmp;
      }
      a_Avg+=Tmp;
      Tmp= ((DataBuf[i]>>8) & 0xFF )-ADCoffset;
      if(Channel == 1){
        if(i==0)V_max=V_min=Tmp;
        if(Tmp>V_max)V_max=Tmp;
        if(Tmp<V_min)V_min=Tmp;
      }
      b_Avg+=Tmp;
    }

    if(Step==7){
      TmpA = ((Ka1[Range]*10)+(((Ka2[Range]*10*((a_Avg/4096)-25))+ 5120)/1024));
      TmpB = ((Kb1[Range]*10)+(((Kb2[Range]*10*((b_Avg/4096)-25))+ 5120)/1024));
      if(Channel == 0){
        Offset=((V_max-(a_Avg/4096))+(V_min-(a_Avg/4096)));
      }
      if(Channel == 1){
        Offset=((V_max-(b_Avg/4096))+(V_min-(b_Avg/4096)));
      }
      if(Offset<-2)Offset=-2; if(Offset>2)Offset=2; Offset+=2;
      Print_Str( 3*8, 208, 0x0305, 0,(char*)CenterStep);
      Print_Str( 36*8, 208, 0x0405, 0,(char*)CenterStr[Offset]);
    }else{
      TmpA = Ka1[Range] +(Ka2[Range]*(a_Avg/4096)+ 512)/1024;
      TmpB = Kb1[Range] +(Kb2[Range]*(b_Avg/4096)+ 512)/1024;
    }

    if(Blink){
      Blink = 0;
      switch (Step){
      case 0:
        Range = 0;
        SetOffset(0,Range,40);
        SetOffset(1,Range,40);

        Print_Str( 2*8, 222, 0x0305, 0, "CAL W/LOW BATT (1/4 CHARGE)  THEN W/AC CHARGER");
        Print_Str( 8, 208, 0x0305, 0, "        PLEASE CONNECT");
        Print_Str(29*8, 208, 0x0305, 0, "INPUT TO ");
        Print_Str(38*8, 208, 0x0405, 0, "GND      ");
        Print_Str( 8, 6, 0x0305, 0, "   PRESS   KEY TO CONFIRM THE INPUT VOLTAGE   ");
        Print_Str(10*8, 6, 0x0405, Twink, " ");
        if(Channel == 0){
          Print_Str( 23*8, 208, 0x0005, 0, " CH_A ");
          for(i=0; i<=G_Attr[0].Yp_Max; i++){
            Ka1[i] = 0; Ka2[i] = 1024; Ka3[i] = 0;
          }
        }
        if(Channel == 1){
          Print_Str( 23*8, 208, 0x0105, 0, " CH_B ");
          for(i=0; i<=G_Attr[0].Yp_Max; i++){
            Kb1[i] = 0; Kb2[i] = 1024; Kb3[i] = 0;
          }
        }
        break;
      case 1:
        Print_Str( 8, 6, 0x0305, 0, "   AUTOMATIC CALIBRATION IN PROGRESS...       ");
        if(Channel == 0){
          s8ToPercen(n, TmpA - 40);
          Print_Str( 45, 166-(Range*20), 0x0005, 1, n);
          Ka1[Range] -= TmpA - 40;
        }
        if(Channel == 1){
          s8ToPercen(n, TmpB - 40);
          Print_Str(245, 166-(Range*20), 0x0105, 1, n);
          Kb1[Range] -= TmpB - 40;
        }
        Range++;
        if(Range > G_Attr[0].Yp_Max){
          Range = 0; Step++;
        }
        SetOffset(0,Range,40);
        SetOffset(1,Range,40);
        k = 0;
        break;
      case 2:
        k++;
        if(k >= 8) k = 0;
        if(Channel == 0){
          s8ToPercen(n, TmpA - 40);
          Print_Str( 45, 166-(Range*20), 0x0005, 0, n);
          if(TmpA - 40 != 0) Ka1[Range] -= TmpA - 40;
          else k = 0;
        }
        if(Channel == 1){
          s8ToPercen(n, TmpB - 40);
          Print_Str(245, 166-(Range*20), 0x0105, 0, n);
          if(TmpB - 40 != 0) Kb1[Range] -= TmpB - 40;
          else k = 0;
        }
        if(k == 0) Range++;
        if(Range > G_Attr[0].Yp_Max){
          Range = 0; Step++;
        }
        SetOffset(0,Range,40);
        SetOffset(1,Range,40);
        break;
      case 3:
        k++;
        SetOffset(0,Range,160);
        SetOffset(1,Range,160);
        if((Channel == 0)&&(TmpA > 140)) Step++;
        if((Channel == 1)&&(TmpB > 140)) Step++;
        if(k > 20) Step++;
        break;
      case 4:
        k = 0;
        if(Channel == 0){
          s8ToPercen(n, TmpA - 160);
          Print_Str( 89, 166-(Range*20), 0x0005, 1, n);
          Ka3[Range] -= (1024*(TmpA-160)+80)/160;
        }
        if(Channel == 1){
          s8ToPercen(n, TmpB - 160);
          Print_Str(289, 166-(Range*20), 0x0105, 1, n);
          Kb3[Range] -= (1024*(TmpB-160)+80)/160;
        }
        Range++;
        if(Range > G_Attr[0].Yp_Max){
          Range = 0; Step++;
        }
        SetOffset(0,Range,160);
        SetOffset(1,Range,160);
        break;
      case 5:
        k++;
        if(k >= 8) k = 0;
        if(Channel == 0){
          s8ToPercen(n, TmpA - 160);
          Print_Str( 89, 166-(Range*20), 0x0005, 0, n);
          if(TmpA - 160 != 0) Ka3[Range] -= (1024*(TmpA-160)+80)/160;
          else k = 0;
        }
        if(Channel == 1){
          s8ToPercen(n, TmpB - 160);
          Print_Str(289, 166-(Range*20), 0x0105, 0, n);
          if(TmpB - 160 != 0) Kb3[Range] -= (1024*(TmpB-160)+80)/160;
          else k = 0;
        }
        if(k == 0) Range++;
        if(Range > G_Attr[0].Yp_Max){
          Range = 0; Step++;
        }
        SetOffset(0,Range,160);
        SetOffset(1,Range,160);
        break;
      case 6:
        k++;
        if(k > 20) Step++;
        Range = 0;
        if(m < 2){
          SetOffset(0,Range,40);
          SetOffset(1,Range,40);
          if((Channel == 0)&&(TmpA < 50)){
            Step = 1;
            m++;
          }
          if((Channel == 1)&&(TmpB < 50)){
            Step = 1;
            m++;
          }
        } else {
          SetOffset(0,Range,25);
          SetOffset(1,Range,25);
          if((Channel == 0)&&(TmpA < 55)) Step++;
          if((Channel == 1)&&(TmpB < 55)) Step++;
        }

        if(Step==7){
          if(Channel == 0){
            BatLevel[0]=__Get(6);
            for(i=0; i<=G_Attr[0].Yp_Max; i++) Ka2[i] = Ma2[i];
          }
          if(Channel == 1){
            BatLevel[1]=__Get(6);
            for(i=0; i<=G_Attr[0].Yp_Max; i++) Kb2[i] = Mb2[i];
          }
          ClearTop();
        }
        break;
      case 7:
        Print_Str( 4*8, 222, 0x0305, 0, " INPUT ");
        Print_Str(11*8, 222, 0x0405, Twink, (char*)VS_STR[Range]);
        Print_Str(20*8, 222, 0x0305, 0, " STANDARD VOLTAGE TO ");
        Print_Str( 8, 6, 0x0305, 0, "MODIFY VOLTAGE:   ...     ");
        Print_Str(18*8, 6, 0x0405, Twink, "-");
        Print_Str(22*8, 6, 0x0405, Twink, "+");
        Print_Str(27*8, 6, 0x0305, 0, "SELECT RANGE:   ---   ");
        Print_Str(42*8, 6, 0x0405, Twink, "<");
        Print_Str(46*8, 6, 0x0405, Twink, ">");
        if(Channel == 0){
          if(TmpA > 10){
            Int2Str(n, TmpA * Y_Attr[Range].SCALE, V_UNIT, 4, 1,1);
          } else {
            Int2Str(n, 0, V_UNIT, 3, 0,0);
          }
          Print_Str( 134, 166-(Range*20), 0x0005, Twink, n);
          Print_Str(41*8, 222, 0x0005, 0, "CH_A  ");
        }
        if(Channel == 1){
          if(TmpB > 10){
            Int2Str(n, TmpB * Y_Attr[Range].SCALE, V_UNIT, 4, 1,1);
          } else {
            Int2Str(n, 0, V_UNIT, 3, 0,0);
          }
          Print_Str( 334, 166-(Range*20), 0x0105, Twink, n);
          Print_Str(41*8, 222, 0x0105, 0, "CH_B  ");
        }
        break;
      case 8:
        m = 0;
        Print_Str( 8, 6, 0x0305, 0, "    PRESS   ---  ");
        Print_Str(12*8, 6, 0x0405, Twink, "<");
        Print_Str(16*8, 6, 0x0405, Twink, ">");
        Print_Str(17*8, 6, 0x0305, 0, " TO SELECT THE NEXT OPERATION   ");
        Print_Str( 8, 216, 0x0305, 0, "  PRESS   TO ");
        Print_Str(14*8, 216, 0x0405, 0, "CONFIRM THE RE-CALIBRATION ");
        Print_Str( 9*8, 216, 0x0405, Twink, " ");
        if(Channel == 0) Print_Str(41*8, 216, 0x0005, 0, "CH_A ");
        if(Channel == 1) Print_Str(41*8, 216, 0x0105, 0, "CH_B ");
        break;
      case 9:
        Print_Str( 9*8, 216, 0x0405, Twink, " ");
        Print_Str(14*8, 216, 0x0405, 0, "SELECT THE CALIBRATION ");
        if(Channel == 0) Print_Str(37*8, 216, 0x0105, 0, "CH_B     ");
        if(Channel == 1) Print_Str(37*8, 216, 0x0005, 0, "CH_A     ");
        break;
      case 10:
        Print_Str( 9*8, 216, 0x0405, Twink, " ");
        Print_Str(14*8, 216, 0x0405, 0, "Exit WITHOUT SAVING RESULTS      ");
        break;
      case 11:
        Print_Str(8, 222, 0x0405, 0, "PRESS BUTTON 2  TO SAVE IF CALIBRATING WITH BATT");
        Print_Str(8, 208, 0x0405, 0, " PRESS BUTTON 3  IF CALIBRATING WITH AC ADAPTER ");
        break;
      case 12:
        Print_Str( 9*8, 216, 0x0405, Twink, " ");
        Print_Str(14*8, 216, 0x0405, 0, "Exit AND RESTORE SYSTEM DEFAULTS ");
        break;
      }
    }
    if(Key_Buffer){
      PD_Cnt = 600;
      if((Range <= G_Attr[0].Yp_Max)&&(Step == 7)){
        if(Channel == 0){
          Print_Str(134, 166-(Range*20), 0x0005, 0, n);
        }
        if(Channel == 1){
          Print_Str(334, 166-(Range*20), 0x0105, 0, n);
        }
      }
      switch (Key_Buffer){
      case 2:
        if(Step == 0) Step++;
        if((Step == 8)||(Step == 9)){
          ClearTop();
          if(Step == 9) Channel = 1 - Channel;
          for(i=0; i<=G_Attr[0].Yp_Max; i++){
            if(Channel == 0){
              Print_Str( 45, 166-(i*20), 0x0005, 0, "     ");
              Print_Str( 89, 166-(i*20), 0x0005, 0, "     ");
              Print_Str(134, 166-(i*20), 0x0005, 0, "       ");
            }
            if(Channel == 1){
              Print_Str(245, 166-(i*20), 0x0105, 0, "     ");
              Print_Str(289, 166-(i*20), 0x0105, 0, "     ");
              Print_Str(334, 166-(i*20), 0x0105, 0, "       ");
            }
          }
          Step = 0;;
        }
        if(Step >= 10){
          if(Step == 10){
            for(i=0; i<=G_Attr[0].Yp_Max; i++){
              Ka1[i] = Ma1[i]; Ka2[i] = Ma2[i]; Ka3[i] = Ma3[i];
              Kb1[i] = Mb1[i]; Kb2[i] = Mb2[i]; Kb3[i] = Mb3[i];
            }
            Save_Param(0);
            ClearTop();
            Print_Str( 8, 216, 0x0405, 0, "          CALIBRATION DATA NOT SAVED            ");
          }
          if(Step == 11){
     if(BatLevel[0]>0){
              LoBatLevel[0]=BatLevel[0];
         for(i=0;i<10;i++)LKa1[i]=Ka1[i];
         for(i=0;i<10;i++)LKa2[i]=Ka2[i];
         for(i=0;i<10;i++)LKa3[i]=Ka3[i];
            }
       if(BatLevel[1]>0){
              LoBatLevel[1]=BatLevel[1];
        for(i=0;i<10;i++)LKb1[i]=Kb1[i];
              for(i=0;i<10;i++)LKb2[i]=Kb2[i];
       for(i=0;i<10;i++)LKb3[i]=Kb3[i];
            }

            Save_Param(0);
            ClearTop();
            Print_Str( 8, 216, 0x0405, 0, "SAVING THE CALIBRATION DATA FROM BAT LOW CORRECT");
          }
          if(Step == 12){
            for(i=0; i<=G_Attr[0].Yp_Max; i++){
              Ka1[i] = 0; Ka2[i] = 1024; Ka3[i] = 0;
              Kb1[i] = 0; Kb2[i] = 1024; Kb3[i] = 0;
              LKa1[i] = 0; LKa2[i] = 1024; LKa3[i] = 0;
              LKb1[i] = 0; LKb2[i] = 1024; LKb3[i] = 0;
              HKa1[i] = 0; HKa2[i] = 1024; HKa3[i] = 0;
              HKb1[i] = 0; HKb2[i] = 1024; HKb3[i] = 0;
              LoBatLevel[0]=0;
              LoBatLevel[1]=0;
              HiBatLevel[0]=0;
              HiBatLevel[1]=0;
              PPM_Comp=0;
            }
            Save_Param(0);
            ClearTop();
            Print_Str( 8, 216, 0x0405, 0, "       RESTORED DEFAULT CALIBRATION DATA        ");
          }
          Delayms(1000);
          App_init();
          Config_init();
          return;
        }
        break;
      case 3:
        if(Step == 11){
   if(BatLevel[0]>0){
            HiBatLevel[0]=BatLevel[0];
       for(i=0;i<10;i++)HKa1[i]=Ka1[i];
       for(i=0;i<10;i++)HKa2[i]=Ka2[i];
       for(i=0;i<10;i++)HKa3[i]=Ka3[i];
          }
     if(BatLevel[1]>0){
            HiBatLevel[1]=BatLevel[1];
      for(i=0;i<10;i++)HKb1[i]=Kb1[i];
            for(i=0;i<10;i++)HKb2[i]=Kb2[i];
     for(i=0;i<10;i++)HKb3[i]=Kb3[i];
          }
          Save_Param(0);
          ClearTop();
          Print_Str( 8, 216, 0x0405, 0, " SAVING THE CALIBRATION DATA FROM HIGH CORRECT  ");
          Delayms(1000);
          App_init();
          Config_init();
          return;
        }

        break;
      case 9:
        if((Step == 7)&&(Range > 0)) Range--;
        if( Step >= 9) {ClearTop(); Step--;}
        if( Step == 8) Step = 12;
        break;
      case 8:
        if(Step >= 8) {ClearTop();Step++;}
        if(Step > 12) Step = 8;
        if(Step == 7) Range++;
        if(Range > G_Attr[0].Yp_Max){
          Range = 0;
          ClearTop();
          Step++;
        }
        break;
      case 5:
        if(Step == 7){
          if((Channel == 0)&&(TmpA > 35)) Ka2[Range] --;
          if((Channel == 1)&&(TmpB > 35)) Kb2[Range] --;
        }
        break;
      case 6:
        if(Step == 7){
          if((Channel == 0)&&(TmpA > 35)) Ka2[Range] ++;
          if((Channel == 1)&&(TmpB > 35)) Kb2[Range] ++;
        }
        break;
      }
      Key_Buffer = 0;
    }
  }
}

void ClearTop(void){
u8 i;
u16 j;
          for(i=201;i<239;i++){
            for (j=1;j<398;j++){
              __Point_SCR(j,i);
              __LCD_SetPixl(Color[5]);
            }
          }
}
