# 1 "Draw.c"
# 1 "<command-line>"
# 1 "Draw.c"




# 1 "inc/Process.h" 1







# 1 "FWLib/inc/stm32f10x_lib.h" 1
# 22 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_map.h" 1
# 26 "FWLib/inc/stm32f10x_map.h"
# 1 "inc/stm32f10x_conf.h" 1
# 21 "inc/stm32f10x_conf.h"
# 1 "FWLib/inc/stm32f10x_type.h" 1
# 23 "FWLib/inc/stm32f10x_type.h"
typedef signed long s32;
typedef signed short s16;
typedef signed char s8;

typedef signed long const sc32;
typedef signed short const sc16;
typedef signed char const sc8;

typedef volatile signed long vs32;
typedef volatile signed short vs16;
typedef volatile signed char vs8;

typedef volatile signed long const vsc32;
typedef volatile signed short const vsc16;
typedef volatile signed char const vsc8;

typedef unsigned long u32;
typedef unsigned short u16;
typedef unsigned char u8;

typedef unsigned long const uc32;
typedef unsigned short const uc16;
typedef unsigned char const uc8;

typedef volatile unsigned long vu32;
typedef volatile unsigned short vu16;
typedef volatile unsigned char vu8;

typedef volatile unsigned long const vuc32;
typedef volatile unsigned short const vuc16;
typedef volatile unsigned char const vuc8;

typedef enum {FALSE = 0, TRUE = !FALSE} bool;

typedef enum {RESET = 0, SET = !RESET} FlagStatus, ITStatus;

typedef enum {DISABLE = 0, ENABLE = !DISABLE} FunctionalState;


typedef enum {ERROR = 0, SUCCESS = !ERROR} ErrorStatus;
# 22 "inc/stm32f10x_conf.h" 2
# 27 "FWLib/inc/stm32f10x_map.h" 2
# 1 "FWLib/inc/stm32f10x_type.h" 1
# 28 "FWLib/inc/stm32f10x_map.h" 2
# 1 "FWLib/inc/cortexm3_macro.h" 1
# 27 "FWLib/inc/cortexm3_macro.h"
void __WFI(void);
void __WFE(void);
void __SEV(void);
void __ISB(void);
void __DSB(void);
void __DMB(void);
void __SVC(void);
u32 __MRS_CONTROL(void);
void __MSR_CONTROL(u32 Control);
u32 __MRS_PSP(void);
void __MSR_PSP(u32 TopOfProcessStack);
u32 __MRS_MSP(void);
void __MSR_MSP(u32 TopOfMainStack);
void __RESETPRIMASK(void);
void __SETPRIMASK(void);
u32 __READ_PRIMASK(void);
void __RESETFAULTMASK(void);
void __SETFAULTMASK(void);
u32 __READ_FAULTMASK(void);
void __BASEPRICONFIG(u32 NewPriority);
u32 __GetBASEPRI(void);
u16 __REV_HalfWord(u16 Data);
u32 __REV_Word(u32 Data);
# 29 "FWLib/inc/stm32f10x_map.h" 2







typedef struct
{
  vu32 SR;
  vu32 CR1;
  vu32 CR2;
  vu32 SMPR1;
  vu32 SMPR2;
  vu32 JOFR1;
  vu32 JOFR2;
  vu32 JOFR3;
  vu32 JOFR4;
  vu32 HTR;
  vu32 LTR;
  vu32 SQR1;
  vu32 SQR2;
  vu32 SQR3;
  vu32 JSQR;
  vu32 JDR1;
  vu32 JDR2;
  vu32 JDR3;
  vu32 JDR4;
  vu32 DR;
} ADC_TypeDef;


typedef struct
{
  u32 RESERVED0;
  vu16 DR1;
  u16 RESERVED1;
  vu16 DR2;
  u16 RESERVED2;
  vu16 DR3;
  u16 RESERVED3;
  vu16 DR4;
  u16 RESERVED4;
  vu16 DR5;
  u16 RESERVED5;
  vu16 DR6;
  u16 RESERVED6;
  vu16 DR7;
  u16 RESERVED7;
  vu16 DR8;
  u16 RESERVED8;
  vu16 DR9;
  u16 RESERVED9;
  vu16 DR10;
  u16 RESERVED10;
  vu16 RTCCR;
  u16 RESERVED11;
  vu16 CR;
  u16 RESERVED12;
  vu16 CSR;
  u16 RESERVED13[5];
  vu16 DR11;
  u16 RESERVED14;
  vu16 DR12;
  u16 RESERVED15;
  vu16 DR13;
  u16 RESERVED16;
  vu16 DR14;
  u16 RESERVED17;
  vu16 DR15;
  u16 RESERVED18;
  vu16 DR16;
  u16 RESERVED19;
  vu16 DR17;
  u16 RESERVED20;
  vu16 DR18;
  u16 RESERVED21;
  vu16 DR19;
  u16 RESERVED22;
  vu16 DR20;
  u16 RESERVED23;
  vu16 DR21;
  u16 RESERVED24;
  vu16 DR22;
  u16 RESERVED25;
  vu16 DR23;
  u16 RESERVED26;
  vu16 DR24;
  u16 RESERVED27;
  vu16 DR25;
  u16 RESERVED28;
  vu16 DR26;
  u16 RESERVED29;
  vu16 DR27;
  u16 RESERVED30;
  vu16 DR28;
  u16 RESERVED31;
  vu16 DR29;
  u16 RESERVED32;
  vu16 DR30;
  u16 RESERVED33;
  vu16 DR31;
  u16 RESERVED34;
  vu16 DR32;
  u16 RESERVED35;
  vu16 DR33;
  u16 RESERVED36;
  vu16 DR34;
  u16 RESERVED37;
  vu16 DR35;
  u16 RESERVED38;
  vu16 DR36;
  u16 RESERVED39;
  vu16 DR37;
  u16 RESERVED40;
  vu16 DR38;
  u16 RESERVED41;
  vu16 DR39;
  u16 RESERVED42;
  vu16 DR40;
  u16 RESERVED43;
  vu16 DR41;
  u16 RESERVED44;
  vu16 DR42;
  u16 RESERVED45;
} BKP_TypeDef;


typedef struct
{
  vu32 TIR;
  vu32 TDTR;
  vu32 TDLR;
  vu32 TDHR;
} CAN_TxMailBox_TypeDef;

typedef struct
{
  vu32 RIR;
  vu32 RDTR;
  vu32 RDLR;
  vu32 RDHR;
} CAN_FIFOMailBox_TypeDef;

typedef struct
{
  vu32 FR1;
  vu32 FR2;
} CAN_FilterRegister_TypeDef;

typedef struct
{
  vu32 MCR;
  vu32 MSR;
  vu32 TSR;
  vu32 RF0R;
  vu32 RF1R;
  vu32 IER;
  vu32 ESR;
  vu32 BTR;
  u32 RESERVED0[88];
  CAN_TxMailBox_TypeDef sTxMailBox[3];
  CAN_FIFOMailBox_TypeDef sFIFOMailBox[2];
  u32 RESERVED1[12];
  vu32 FMR;
  vu32 FM1R;
  u32 RESERVED2;
  vu32 FS1R;
  u32 RESERVED3;
  vu32 FFA1R;
  u32 RESERVED4;
  vu32 FA1R;
  u32 RESERVED5[8];
  CAN_FilterRegister_TypeDef sFilterRegister[14];
} CAN_TypeDef;


typedef struct
{
  vu32 DR;
  vu8 IDR;
  u8 RESERVED0;
  u16 RESERVED1;
  vu32 CR;
} CRC_TypeDef;



typedef struct
{
  vu32 CR;
  vu32 SWTRIGR;
  vu32 DHR12R1;
  vu32 DHR12L1;
  vu32 DHR8R1;
  vu32 DHR12R2;
  vu32 DHR12L2;
  vu32 DHR8R2;
  vu32 DHR12RD;
  vu32 DHR12LD;
  vu32 DHR8RD;
  vu32 DOR1;
  vu32 DOR2;
} DAC_TypeDef;


typedef struct
{
  vu32 IDCODE;
  vu32 CR;
}DBGMCU_TypeDef;


typedef struct
{
  vu32 CCR;
  vu32 CNDTR;
  vu32 CPAR;
  vu32 CMAR;
} DMA_Channel_TypeDef;

typedef struct
{
  vu32 ISR;
  vu32 IFCR;
} DMA_TypeDef;


typedef struct
{
  vu32 IMR;
  vu32 EMR;
  vu32 RTSR;
  vu32 FTSR;
  vu32 SWIER;
  vu32 PR;
} EXTI_TypeDef;


typedef struct
{
  vu32 ACR;
  vu32 KEYR;
  vu32 OPTKEYR;
  vu32 SR;
  vu32 CR;
  vu32 AR;
  vu32 RESERVED;
  vu32 OBR;
  vu32 WRPR;
} FLASH_TypeDef;

typedef struct
{
  vu16 RDP;
  vu16 USER;
  vu16 Data0;
  vu16 Data1;
  vu16 WRP0;
  vu16 WRP1;
  vu16 WRP2;
  vu16 WRP3;
} OB_TypeDef;


typedef struct
{
  vu32 BTCR[8];
} FSMC_Bank1_TypeDef;

typedef struct
{
  vu32 BWTR[7];
} FSMC_Bank1E_TypeDef;

typedef struct
{
  vu32 PCR2;
  vu32 SR2;
  vu32 PMEM2;
  vu32 PATT2;
  u32 RESERVED0;
  vu32 ECCR2;
} FSMC_Bank2_TypeDef;

typedef struct
{
  vu32 PCR3;
  vu32 SR3;
  vu32 PMEM3;
  vu32 PATT3;
  u32 RESERVED0;
  vu32 ECCR3;
} FSMC_Bank3_TypeDef;

typedef struct
{
  vu32 PCR4;
  vu32 SR4;
  vu32 PMEM4;
  vu32 PATT4;
  vu32 PIO4;
} FSMC_Bank4_TypeDef;


typedef struct
{
  vu32 CRL;
  vu32 CRH;
  vu32 IDR;
  vu32 ODR;
  vu32 BSRR;
  vu32 BRR;
  vu32 LCKR;
} GPIO_TypeDef;

typedef struct
{
  vu32 EVCR;
  vu32 MAPR;
  vu32 EXTICR[4];
} AFIO_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 OAR1;
  u16 RESERVED2;
  vu16 OAR2;
  u16 RESERVED3;
  vu16 DR;
  u16 RESERVED4;
  vu16 SR1;
  u16 RESERVED5;
  vu16 SR2;
  u16 RESERVED6;
  vu16 CCR;
  u16 RESERVED7;
  vu16 TRISE;
  u16 RESERVED8;
} I2C_TypeDef;


typedef struct
{
  vu32 KR;
  vu32 PR;
  vu32 RLR;
  vu32 SR;
} IWDG_TypeDef;


typedef struct
{
  vu32 ISER[2];
  u32 RESERVED0[30];
  vu32 ICER[2];
  u32 RSERVED1[30];
  vu32 ISPR[2];
  u32 RESERVED2[30];
  vu32 ICPR[2];
  u32 RESERVED3[30];
  vu32 IABR[2];
  u32 RESERVED4[62];
  vu32 IPR[15];
} NVIC_TypeDef;

typedef struct
{
  vuc32 CPUID;
  vu32 ICSR;
  vu32 VTOR;
  vu32 AIRCR;
  vu32 SCR;
  vu32 CCR;
  vu32 SHPR[3];
  vu32 SHCSR;
  vu32 CFSR;
  vu32 HFSR;
  vu32 DFSR;
  vu32 MMFAR;
  vu32 BFAR;
  vu32 AFSR;
} SCB_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CSR;
} PWR_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CFGR;
  vu32 CIR;
  vu32 APB2RSTR;
  vu32 APB1RSTR;
  vu32 AHBENR;
  vu32 APB2ENR;
  vu32 APB1ENR;
  vu32 BDCR;
  vu32 CSR;
} RCC_TypeDef;


typedef struct
{
  vu16 CRH;
  u16 RESERVED0;
  vu16 CRL;
  u16 RESERVED1;
  vu16 PRLH;
  u16 RESERVED2;
  vu16 PRLL;
  u16 RESERVED3;
  vu16 DIVH;
  u16 RESERVED4;
  vu16 DIVL;
  u16 RESERVED5;
  vu16 CNTH;
  u16 RESERVED6;
  vu16 CNTL;
  u16 RESERVED7;
  vu16 ALRH;
  u16 RESERVED8;
  vu16 ALRL;
  u16 RESERVED9;
} RTC_TypeDef;


typedef struct
{
  vu32 POWER;
  vu32 CLKCR;
  vu32 ARG;
  vu32 CMD;
  vuc32 RESPCMD;
  vuc32 RESP1;
  vuc32 RESP2;
  vuc32 RESP3;
  vuc32 RESP4;
  vu32 DTIMER;
  vu32 DLEN;
  vu32 DCTRL;
  vuc32 DCOUNT;
  vuc32 STA;
  vu32 ICR;
  vu32 MASK;
  u32 RESERVED0[2];
  vuc32 FIFOCNT;
  u32 RESERVED1[13];
  vu32 FIFO;
} SDIO_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 SR;
  u16 RESERVED2;
  vu16 DR;
  u16 RESERVED3;
  vu16 CRCPR;
  u16 RESERVED4;
  vu16 RXCRCR;
  u16 RESERVED5;
  vu16 TXCRCR;
  u16 RESERVED6;
  vu16 I2SCFGR;
  u16 RESERVED7;
  vu16 I2SPR;
  u16 RESERVED8;
} SPI_TypeDef;


typedef struct
{
  vu32 CTRL;
  vu32 LOAD;
  vu32 VAL;
  vuc32 CALIB;
} SysTick_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 SMCR;
  u16 RESERVED2;
  vu16 DIER;
  u16 RESERVED3;
  vu16 SR;
  u16 RESERVED4;
  vu16 EGR;
  u16 RESERVED5;
  vu16 CCMR1;
  u16 RESERVED6;
  vu16 CCMR2;
  u16 RESERVED7;
  vu16 CCER;
  u16 RESERVED8;
  vu16 CNT;
  u16 RESERVED9;
  vu16 PSC;
  u16 RESERVED10;
  vu16 ARR;
  u16 RESERVED11;
  vu16 RCR;
  u16 RESERVED12;
  vu16 CCR1;
  u16 RESERVED13;
  vu16 CCR2;
  u16 RESERVED14;
  vu16 CCR3;
  u16 RESERVED15;
  vu16 CCR4;
  u16 RESERVED16;
  vu16 BDTR;
  u16 RESERVED17;
  vu16 DCR;
  u16 RESERVED18;
  vu16 DMAR;
  u16 RESERVED19;
} TIM_TypeDef;


typedef struct
{
  vu16 SR;
  u16 RESERVED0;
  vu16 DR;
  u16 RESERVED1;
  vu16 BRR;
  u16 RESERVED2;
  vu16 CR1;
  u16 RESERVED3;
  vu16 CR2;
  u16 RESERVED4;
  vu16 CR3;
  u16 RESERVED5;
  vu16 GTPR;
  u16 RESERVED6;
} USART_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CFR;
  vu32 SR;
} WWDG_TypeDef;
# 23 "FWLib/inc/stm32f10x_lib.h" 2
# 49 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_dma.h" 1
# 26 "FWLib/inc/stm32f10x_dma.h"
typedef struct
{
  u32 DMA_PeripheralBaseAddr;
  u32 DMA_MemoryBaseAddr;
  u32 DMA_DIR;
  u32 DMA_BufferSize;
  u32 DMA_PeripheralInc;
  u32 DMA_MemoryInc;
  u32 DMA_PeripheralDataSize;
  u32 DMA_MemoryDataSize;
  u32 DMA_Mode;
  u32 DMA_Priority;
  u32 DMA_M2M;
}DMA_InitTypeDef;
# 284 "FWLib/inc/stm32f10x_dma.h"
void DMA_DeInit(DMA_Channel_TypeDef* DMAy_Channelx);
void DMA_Init(DMA_Channel_TypeDef* DMAy_Channelx, DMA_InitTypeDef* DMA_InitStruct);
void DMA_StructInit(DMA_InitTypeDef* DMA_InitStruct);
void DMA_Cmd(DMA_Channel_TypeDef* DMAy_Channelx, FunctionalState NewState);
void DMA_ITConfig(DMA_Channel_TypeDef* DMAy_Channelx, u32 DMA_IT, FunctionalState NewState);
u16 DMA_GetCurrDataCounter(DMA_Channel_TypeDef* DMAy_Channelx);
FlagStatus DMA_GetFlagStatus(u32 DMA_FLAG);
void DMA_ClearFlag(u32 DMA_FLAG);
ITStatus DMA_GetITStatus(u32 DMA_IT);
void DMA_ClearITPendingBit(u32 DMA_IT);
# 50 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_flash.h" 1
# 27 "FWLib/inc/stm32f10x_flash.h"
typedef enum
{
  FLASH_BUSY = 1,
  FLASH_ERROR_PG,
  FLASH_ERROR_WRP,
  FLASH_COMPLETE,
  FLASH_TIMEOUT
}FLASH_Status;
# 179 "FWLib/inc/stm32f10x_flash.h"
void FLASH_SetLatency(u32 FLASH_Latency);
void FLASH_HalfCycleAccessCmd(u32 FLASH_HalfCycleAccess);
void FLASH_PrefetchBufferCmd(u32 FLASH_PrefetchBuffer);


void FLASH_Unlock(void);
void FLASH_Lock(void);
FLASH_Status FLASH_ErasePage(u32 Page_Address);
FLASH_Status FLASH_EraseAllPages(void);
FLASH_Status FLASH_EraseOptionBytes(void);
FLASH_Status FLASH_ProgramWord(u32 Address, u32 Data);
FLASH_Status FLASH_ProgramHalfWord(u32 Address, u16 Data);
FLASH_Status FLASH_ProgramOptionByteData(u32 Address, u8 Data);
FLASH_Status FLASH_EnableWriteProtection(u32 FLASH_Pages);
FLASH_Status FLASH_ReadOutProtection(FunctionalState NewState);
FLASH_Status FLASH_UserOptionByteConfig(u16 OB_IWDG, u16 OB_STOP, u16 OB_STDBY);
u32 FLASH_GetUserOptionByte(void);
u32 FLASH_GetWriteProtectionOptionByte(void);
FlagStatus FLASH_GetReadOutProtectionStatus(void);
FlagStatus FLASH_GetPrefetchBufferStatus(void);
void FLASH_ITConfig(u16 FLASH_IT, FunctionalState NewState);
FlagStatus FLASH_GetFlagStatus(u16 FLASH_FLAG);
void FLASH_ClearFlag(u16 FLASH_FLAG);
FLASH_Status FLASH_GetStatus(void);
FLASH_Status FLASH_WaitForLastOperation(u32 Timeout);
# 58 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_fsmc.h" 1
# 26 "FWLib/inc/stm32f10x_fsmc.h"
typedef struct
{
  u32 FSMC_AddressSetupTime;
  u32 FSMC_AddressHoldTime;
  u32 FSMC_DataSetupTime;
  u32 FSMC_BusTurnAroundDuration;
  u32 FSMC_CLKDivision;
  u32 FSMC_DataLatency;
  u32 FSMC_AccessMode;
}FSMC_NORSRAMTimingInitTypeDef;


typedef struct
{
  u32 FSMC_Bank;
  u32 FSMC_DataAddressMux;
  u32 FSMC_MemoryType;
  u32 FSMC_MemoryDataWidth;
  u32 FSMC_BurstAccessMode;
  u32 FSMC_WaitSignalPolarity;
  u32 FSMC_WrapMode;
  u32 FSMC_WaitSignalActive;
  u32 FSMC_WriteOperation;
  u32 FSMC_WaitSignal;
  u32 FSMC_ExtendedMode;
  u32 FSMC_WriteBurst;

  FSMC_NORSRAMTimingInitTypeDef* FSMC_ReadWriteTimingStruct;

  FSMC_NORSRAMTimingInitTypeDef* FSMC_WriteTimingStruct;
}FSMC_NORSRAMInitTypeDef;


typedef struct
{
  u32 FSMC_SetupTime;
  u32 FSMC_WaitSetupTime;
  u32 FSMC_HoldSetupTime;
  u32 FSMC_HiZSetupTime;
}FSMC_NAND_PCCARDTimingInitTypeDef;


typedef struct
{
  u32 FSMC_Bank;
  u32 FSMC_Waitfeature;
  u32 FSMC_MemoryDataWidth;
  u32 FSMC_ECC;
  u32 FSMC_ECCPageSize;
  u32 FSMC_AddressLowMapping;
  u32 FSMC_TCLRSetupTime;
  u32 FSMC_TARSetupTime;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_CommonSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_AttributeSpaceTimingStruct;
}FSMC_NANDInitTypeDef;


typedef struct
{
  u32 FSMC_Waitfeature;
  u32 FSMC_AddressLowMapping;
  u32 FSMC_TCLRSetupTime;
  u32 FSMC_TARSetupTime;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_CommonSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_AttributeSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_IOSpaceTimingStruct;
}FSMC_PCCARDInitTypeDef;
# 323 "FWLib/inc/stm32f10x_fsmc.h"
void FSMC_NORSRAMDeInit(u32 FSMC_Bank);
void FSMC_NANDDeInit(u32 FSMC_Bank);
void FSMC_PCCARDDeInit(void);
void FSMC_NORSRAMInit(FSMC_NORSRAMInitTypeDef* FSMC_NORSRAMInitStruct);
void FSMC_NANDInit(FSMC_NANDInitTypeDef* FSMC_NANDInitStruct);
void FSMC_PCCARDInit(FSMC_PCCARDInitTypeDef* FSMC_PCCARDInitStruct);
void FSMC_NORSRAMStructInit(FSMC_NORSRAMInitTypeDef* FSMC_NORSRAMInitStruct);
void FSMC_NANDStructInit(FSMC_NANDInitTypeDef* FSMC_NANDInitStruct);
void FSMC_PCCARDStructInit(FSMC_PCCARDInitTypeDef* FSMC_PCCARDInitStruct);
void FSMC_NORSRAMCmd(u32 FSMC_Bank, FunctionalState NewState);
void FSMC_NANDCmd(u32 FSMC_Bank, FunctionalState NewState);
void FSMC_PCCARDCmd(FunctionalState NewState);
void FSMC_NANDECCCmd(u32 FSMC_Bank, FunctionalState NewState);
u32 FSMC_GetECC(u32 FSMC_Bank);
void FSMC_ITConfig(u32 FSMC_Bank, u32 FSMC_IT, FunctionalState NewState);
FlagStatus FSMC_GetFlagStatus(u32 FSMC_Bank, u32 FSMC_FLAG);
void FSMC_ClearFlag(u32 FSMC_Bank, u32 FSMC_FLAG);
ITStatus FSMC_GetITStatus(u32 FSMC_Bank, u32 FSMC_IT);
void FSMC_ClearITPendingBit(u32 FSMC_Bank, u32 FSMC_IT);
# 62 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_gpio.h" 1
# 34 "FWLib/inc/stm32f10x_gpio.h"
typedef enum
{
  GPIO_Speed_10MHz = 1,
  GPIO_Speed_2MHz,
  GPIO_Speed_50MHz
}GPIOSpeed_TypeDef;





typedef enum
{ GPIO_Mode_AIN = 0x0,
  GPIO_Mode_IN_FLOATING = 0x04,
  GPIO_Mode_IPD = 0x28,
  GPIO_Mode_IPU = 0x48,
  GPIO_Mode_Out_OD = 0x14,
  GPIO_Mode_Out_PP = 0x10,
  GPIO_Mode_AF_OD = 0x1C,
  GPIO_Mode_AF_PP = 0x18
}GPIOMode_TypeDef;







typedef struct
{
  u16 GPIO_Pin;
  GPIOSpeed_TypeDef GPIO_Speed;
  GPIOMode_TypeDef GPIO_Mode;
}GPIO_InitTypeDef;


typedef enum
{ Bit_RESET = 0,
  Bit_SET
}BitAction;
# 217 "FWLib/inc/stm32f10x_gpio.h"
void GPIO_DeInit(GPIO_TypeDef* GPIOx);
void GPIO_AFIODeInit(void);
void GPIO_Init(GPIO_TypeDef* GPIOx, GPIO_InitTypeDef* GPIO_InitStruct);
void GPIO_StructInit(GPIO_InitTypeDef* GPIO_InitStruct);
u8 GPIO_ReadInputDataBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
u16 GPIO_ReadInputData(GPIO_TypeDef* GPIOx);
u8 GPIO_ReadOutputDataBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
u16 GPIO_ReadOutputData(GPIO_TypeDef* GPIOx);
void GPIO_SetBits(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_ResetBits(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_WriteBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin, BitAction BitVal);
void GPIO_Write(GPIO_TypeDef* GPIOx, u16 PortVal);
void GPIO_PinLockConfig(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_EventOutputConfig(u8 GPIO_PortSource, u8 GPIO_PinSource);
void GPIO_EventOutputCmd(FunctionalState NewState);
void GPIO_PinRemapConfig(u32 GPIO_Remap, FunctionalState NewState);
void GPIO_EXTILineConfig(u8 GPIO_PortSource, u8 GPIO_PinSource);
# 66 "FWLib/inc/stm32f10x_lib.h" 2
# 77 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_nvic.h" 1
# 26 "FWLib/inc/stm32f10x_nvic.h"
typedef struct
{
  u8 NVIC_IRQChannel;
  u8 NVIC_IRQChannelPreemptionPriority;
  u8 NVIC_IRQChannelSubPriority;
  FunctionalState NVIC_IRQChannelCmd;
} NVIC_InitTypeDef;
# 253 "FWLib/inc/stm32f10x_nvic.h"
void NVIC_DeInit(void);
void NVIC_SCBDeInit(void);
void NVIC_PriorityGroupConfig(u32 NVIC_PriorityGroup);
void NVIC_Init(NVIC_InitTypeDef* NVIC_InitStruct);
void NVIC_StructInit(NVIC_InitTypeDef* NVIC_InitStruct);
void NVIC_SETPRIMASK(void);
void NVIC_RESETPRIMASK(void);
void NVIC_SETFAULTMASK(void);
void NVIC_RESETFAULTMASK(void);
void NVIC_BASEPRICONFIG(u32 NewPriority);
u32 NVIC_GetBASEPRI(void);
u16 NVIC_GetCurrentPendingIRQChannel(void);
ITStatus NVIC_GetIRQChannelPendingBitStatus(u8 NVIC_IRQChannel);
void NVIC_SetIRQChannelPendingBit(u8 NVIC_IRQChannel);
void NVIC_ClearIRQChannelPendingBit(u8 NVIC_IRQChannel);
u16 NVIC_GetCurrentActiveHandler(void);
ITStatus NVIC_GetIRQChannelActiveBitStatus(u8 NVIC_IRQChannel);
u32 NVIC_GetCPUID(void);
void NVIC_SetVectorTable(u32 NVIC_VectTab, u32 Offset);
void NVIC_GenerateSystemReset(void);
void NVIC_GenerateCoreReset(void);
void NVIC_SystemLPConfig(u8 LowPowerMode, FunctionalState NewState);
void NVIC_SystemHandlerConfig(u32 SystemHandler, FunctionalState NewState);
void NVIC_SystemHandlerPriorityConfig(u32 SystemHandler, u8 SystemHandlerPreemptionPriority,
                                      u8 SystemHandlerSubPriority);
ITStatus NVIC_GetSystemHandlerPendingBitStatus(u32 SystemHandler);
void NVIC_SetSystemHandlerPendingBit(u32 SystemHandler);
void NVIC_ClearSystemHandlerPendingBit(u32 SystemHandler);
ITStatus NVIC_GetSystemHandlerActiveBitStatus(u32 SystemHandler);
u32 NVIC_GetFaultHandlerSources(u32 SystemHandler);
u32 NVIC_GetFaultAddress(u32 SystemHandler);
# 78 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_rcc.h" 1
# 25 "FWLib/inc/stm32f10x_rcc.h"
typedef struct
{
  u32 SYSCLK_Frequency;
  u32 HCLK_Frequency;
  u32 PCLK1_Frequency;
  u32 PCLK2_Frequency;
  u32 ADCCLK_Frequency;
}RCC_ClocksTypeDef;
# 253 "FWLib/inc/stm32f10x_rcc.h"
void RCC_DeInit(void);
void RCC_HSEConfig(u32 RCC_HSE);
ErrorStatus RCC_WaitForHSEStartUp(void);
void RCC_AdjustHSICalibrationValue(u8 HSICalibrationValue);
void RCC_HSICmd(FunctionalState NewState);
void RCC_PLLConfig(u32 RCC_PLLSource, u32 RCC_PLLMul);
void RCC_PLLCmd(FunctionalState NewState);
void RCC_SYSCLKConfig(u32 RCC_SYSCLKSource);
u8 RCC_GetSYSCLKSource(void);
void RCC_HCLKConfig(u32 RCC_SYSCLK);
void RCC_PCLK1Config(u32 RCC_HCLK);
void RCC_PCLK2Config(u32 RCC_HCLK);
void RCC_ITConfig(u8 RCC_IT, FunctionalState NewState);
void RCC_USBCLKConfig(u32 RCC_USBCLKSource);
void RCC_ADCCLKConfig(u32 RCC_PCLK2);
void RCC_LSEConfig(u8 RCC_LSE);
void RCC_LSICmd(FunctionalState NewState);
void RCC_RTCCLKConfig(u32 RCC_RTCCLKSource);
void RCC_RTCCLKCmd(FunctionalState NewState);
void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks);
void RCC_AHBPeriphClockCmd(u32 RCC_AHBPeriph, FunctionalState NewState);
void RCC_APB2PeriphClockCmd(u32 RCC_APB2Periph, FunctionalState NewState);
void RCC_APB1PeriphClockCmd(u32 RCC_APB1Periph, FunctionalState NewState);
void RCC_APB2PeriphResetCmd(u32 RCC_APB2Periph, FunctionalState NewState);
void RCC_APB1PeriphResetCmd(u32 RCC_APB1Periph, FunctionalState NewState);
void RCC_BackupResetCmd(FunctionalState NewState);
void RCC_ClockSecuritySystemCmd(FunctionalState NewState);
void RCC_MCOConfig(u8 RCC_MCO);
FlagStatus RCC_GetFlagStatus(u8 RCC_FLAG);
void RCC_ClearFlag(void);
ITStatus RCC_GetITStatus(u8 RCC_IT);
void RCC_ClearITPendingBit(u8 RCC_IT);
# 86 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_sdio.h" 1
# 25 "FWLib/inc/stm32f10x_sdio.h"
typedef struct
{
  u8 SDIO_ClockDiv;
  u32 SDIO_ClockEdge;
  u32 SDIO_ClockBypass;
  u32 SDIO_ClockPowerSave;
  u32 SDIO_BusWide;
  u32 SDIO_HardwareFlowControl;
} SDIO_InitTypeDef;

typedef struct
{
  u32 SDIO_Argument;
  u32 SDIO_CmdIndex;
  u32 SDIO_Response;
  u32 SDIO_Wait;
  u32 SDIO_CPSM;
} SDIO_CmdInitTypeDef;

typedef struct
{
  u32 SDIO_DataTimeOut;
  u32 SDIO_DataLength;
  u32 SDIO_DataBlockSize;
  u32 SDIO_TransferDir;
  u32 SDIO_TransferMode;
  u32 SDIO_DPSM;
} SDIO_DataInitTypeDef;
# 304 "FWLib/inc/stm32f10x_sdio.h"
void SDIO_DeInit(void);
void SDIO_Init(SDIO_InitTypeDef* SDIO_InitStruct);
void SDIO_StructInit(SDIO_InitTypeDef* SDIO_InitStruct);
void SDIO_ClockCmd(FunctionalState NewState);
void SDIO_SetPowerState(u32 SDIO_PowerState);
u32 SDIO_GetPowerState(void);
void SDIO_ITConfig(u32 SDIO_IT, FunctionalState NewState);
void SDIO_DMACmd(FunctionalState NewState);
void SDIO_SendCommand(SDIO_CmdInitTypeDef *SDIO_CmdInitStruct);
void SDIO_CmdStructInit(SDIO_CmdInitTypeDef* SDIO_CmdInitStruct);
u8 SDIO_GetCommandResponse(void);
u32 SDIO_GetResponse(u32 SDIO_RESP);
void SDIO_DataConfig(SDIO_DataInitTypeDef* SDIO_DataInitStruct);
void SDIO_DataStructInit(SDIO_DataInitTypeDef* SDIO_DataInitStruct);
u32 SDIO_GetDataCounter(void);
u32 SDIO_ReadData(void);
void SDIO_WriteData(u32 Data);
u32 SDIO_GetFIFOCount(void);
void SDIO_StartSDIOReadWait(FunctionalState NewState);
void SDIO_StopSDIOReadWait(FunctionalState NewState);
void SDIO_SetSDIOReadWaitMode(u32 SDIO_ReadWaitMode);
void SDIO_SetSDIOOperation(FunctionalState NewState);
void SDIO_SendSDIOSuspendCmd(FunctionalState NewState);
void SDIO_CommandCompletionCmd(FunctionalState NewState);
void SDIO_CEATAITCmd(FunctionalState NewState);
void SDIO_SendCEATACmd(FunctionalState NewState);
FlagStatus SDIO_GetFlagStatus(u32 SDIO_FLAG);
void SDIO_ClearFlag(u32 SDIO_FLAG);
ITStatus SDIO_GetITStatus(u32 SDIO_IT);
void SDIO_ClearITPendingBit(u32 SDIO_IT);
# 94 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_spi.h" 1
# 26 "FWLib/inc/stm32f10x_spi.h"
typedef struct
{
  u16 SPI_Direction;
  u16 SPI_Mode;
  u16 SPI_DataSize;
  u16 SPI_CPOL;
  u16 SPI_CPHA;
  u16 SPI_NSS;
  u16 SPI_BaudRatePrescaler;
  u16 SPI_FirstBit;
  u16 SPI_CRCPolynomial;
}SPI_InitTypeDef;
# 175 "FWLib/inc/stm32f10x_spi.h"
void SPI_DeInit(SPI_TypeDef* SPIx);
void SPI_Init(SPI_TypeDef* SPIx, SPI_InitTypeDef* SPI_InitStruct);
void SPI_StructInit(SPI_InitTypeDef* SPI_InitStruct);
void SPI_Cmd(SPI_TypeDef* SPIx, FunctionalState NewState);
void SPI_ITConfig(SPI_TypeDef* SPIx, u8 SPI_IT, FunctionalState NewState);
void SPI_DMACmd(SPI_TypeDef* SPIx, u16 SPI_DMAReq, FunctionalState NewState);
void SPI_SendData(SPI_TypeDef* SPIx, u16 Data);
u16 SPI_ReceiveData(SPI_TypeDef* SPIx);
void SPI_NSSInternalSoftwareConfig(SPI_TypeDef* SPIx, u16 SPI_NSSInternalSoft);
void SPI_SSOutputCmd(SPI_TypeDef* SPIx, FunctionalState NewState);
void SPI_DataSizeConfig(SPI_TypeDef* SPIx, u16 SPI_DataSize);
void SPI_TransmitCRC(SPI_TypeDef* SPIx);
void SPI_CalculateCRC(SPI_TypeDef* SPIx, FunctionalState NewState);
u16 SPI_GetCRC(SPI_TypeDef* SPIx, u8 SPI_CRC);
u16 SPI_GetCRCPolynomial(SPI_TypeDef* SPIx);
void SPI_BiDirectionalLineConfig(SPI_TypeDef* SPIx, u16 SPI_Direction);
FlagStatus SPI_GetFlagStatus(SPI_TypeDef* SPIx, u16 SPI_FLAG);
void SPI_ClearFlag(SPI_TypeDef* SPIx, u16 SPI_FLAG);
ITStatus SPI_GetITStatus(SPI_TypeDef* SPIx, u8 SPI_IT);
void SPI_ClearITPendingBit(SPI_TypeDef* SPIx, u8 SPI_IT);
# 98 "FWLib/inc/stm32f10x_lib.h" 2
# 120 "FWLib/inc/stm32f10x_lib.h"
void debug(void);
# 9 "inc/Process.h" 2
# 1 "inc/Draw.h" 1
# 10 "inc/Draw.h"
typedef struct
{
  s16 Value;
  u8 Flag;
} trigg;
# 83 "inc/Draw.h"
extern u8 OffsetX;
extern u8 OffsetY;


extern u16 MAX_X;
extern u8 FlagFrameMode;
extern u8 FlagMeter;
extern u8 UpdateMeter;
extern u8 TrgAuto;
extern u16 Color[16];
extern u16 LCD_Buffer1[240], LCD_Buffer2[240];
extern trigg V_Trigg[4];
u16 Get_TAB_8x11(u8 Code, u8 Row);
u8 Get_Ref_Wave(u16 i);
void Print_Clk(u16 x0, u16 y0, u16 Type, u8 Phase);
void Print_Str(u16 x0, u16 y0, u16 Color, u8 Mode, char *s);

void Print_Str2(u16 x0,u16 x1,u16 y0, u16 Type, u8 Mode, char *s,u8 LeadingBlanks,u8 TrailingBlanks);


void Draw_Row(u16 Row);
void Draw_Row_XY(u16 Row);

void Draw_Window(void);

void LoadBase3Buffer(void);
void LoadBase2Buffer(void);

void Draw_Mark(u16 m, u16 n);
void Update_Mark(void);
void Update_View_Area(void);
void Clear_Meter_Area(void);
# 10 "inc/Process.h" 2
# 65 "inc/Process.h"
typedef struct
{
  uc8 STR[8];
  uc16 PSC;
  uc16 ARR;
} A_tab ;

typedef struct
{
  uc8 STR[8];
  uc16 PSC;
  uc16 ARR;
  u16 Duty;
} D_tab ;

extern u8 discard;
extern s16 Xtend;
extern u8 BailoutFlag;

extern u8 CurDefTime;
extern u16 NSamples;
extern u16 CountUnread;
extern u8 TrackBuff [392 * 4];

extern s32 a_Avg, b_Avg, a_Ssq, b_Ssq;



extern s16 a_Max, b_Max, a_Min, b_Min;
extern s16 aT_Max, bT_Max, aT_Min, bT_Min;
extern u8 Rdiscard;

extern u16 Tcs, Tcnt;

extern u16 TaS, TbS, TcS, TdS;
extern u32 Sum[4];
extern u16 NAvg[4];
extern u16 VNAvg[2];
extern s32 VxAvg[2];
extern s32 VxSsq[2];
extern u16 PaS, PbS, PcS, PdS;
extern u16 TaN, TbN, TcN, TdN;
extern u32 PxS[4];
extern u32 TxS[4];
extern u32 TxN[4];

extern u8 FrameMode;
extern u8 FFTflag;

extern u8 Options;
extern u16 TempKp1;
extern u8 ADCoffset;
extern u8 CalFlag;
extern u16 JumpCnt;
extern s8 Kab;
extern s8 Ka1[10], Kb1[10];
extern u16 Ka2[10], Kb2[10];
extern s8 Ka3[10], Kb3[10];
extern s8 HKa1[10], HKb1[10];
extern u16 HKa2[10], HKb2[10];
extern s8 HKa3[10], HKb3[10];
extern s8 LKa1[10], LKb1[10];
extern u16 LKa2[10], LKb2[10];
extern s8 LKa3[10], LKb3[10];
extern u32 DataBuf[4096];
extern u8 ScalingOffset;
extern char Vertical[15][10];
extern s16 TrigSourceEnable;
extern u16 HiBatLevel[2];
extern u16 LoBatLevel[2];
extern u16 PrevBatLevel;
extern u16 VDiff[2];
extern u8 SumResetFlag;
extern u8 EnablePaS;
extern u8 ClearHoldFlag;
extern u8 SlowModeSkip;
extern s16 A_Posi;
extern s16 B_Posi;
extern u8 ClearLeadingEdge;


void BackGround_Reset(void);
void App_init(void);
void View_init(void);
void Update_Range(void);
void Update_Base(void);
void Update_Output(void);
void Update_Trig(u8 service);
void Process(void);
void Synchro(void);
void Send_Data(s16 Va, s16 Vb, u8 C_D, u16 n);
u16 get_bag_max_buf();
void cleardatabuf(u8 Afill, u8 Bfill, u16 n,u8 service);
void Config_init(void);
void TransferFIFO(s16 i,u8 service);
void SetOffset(u8 channel,u8 range, s16 Ypos);
void BatLevelCompensation(void);
void ResetSum(void);
void ClearMinMax(u8 Channels);
void ClearHold(u8 Channels);
void ClearTrackBuff(u8 service);



extern short fr[];
extern short fi[];

extern u8 ShowFFT;
extern u32 NFreq;
extern char NFreqStr[];
extern int imax;
extern short PeakFreq;
extern char PeakFreqStr[];
extern char FreqDivStr[];
extern char FreqT1Str[];
# 6 "Draw.c" 2
# 1 "inc/Draw.h" 1
# 7 "Draw.c" 2
# 1 "inc/Menu.h" 1
# 160 "inc/Menu.h"
typedef struct
{
  char *Str;
  u8 Track;
  u8 Item;
  uc16 XPOS1;
  uc16 XPOS2;
  uc8 YPOS;
  u8 Flag;
} meter;

typedef struct
{
  char *Str;
  u16 *Color;
  s16 Limit;
  uc8 MARK;
  u16 XPOS;
  uc8 YPOS;
  s16 Value;
  u8 Flag;
} menu;

extern menu Title[13][4];
extern meter Meter[9];
extern u8 Current, TypeA, Update,BTwink;
extern u8 Detail[14];
extern char NumStr[12];
extern u16 Result_FPS;
extern const char T_UNIT[12], S_UNIT[12], P_UNIT[12], V_UNIT[12];
extern char N_UNIT[12];
extern u8 ConfigFileNumber;
extern s16 Ga_Max;
extern s16 Gb_Max;
extern s16 Ga_Min;
extern s16 Gb_Min;
extern s16 GHa_Max;
extern s16 GHb_Max;
extern s16 GHa_Min;
extern s16 GHb_Min;
extern u8 ShiftDigits;


extern uc16 Y_COLOR[5];

void EnableMeter(void);
void DisableMeter(void);
void Display_Value(u8 i);
void Display_Title(void);
void Display_Meter(void);
void Load_Attr(void);
void Update_Battery(void);
void DisplayBigMeter(u8 MeterNum);
void MeterDefaults(void);
u32 UpScale(u32 Tmp, u16 limit);
# 8 "Draw.c" 2
# 1 "inc/BIOS.h" 1
# 139 "inc/BIOS.h"
typedef struct
{
  u16 LCD_X;
  u16 LCD_Y;
  u16 Yp_Max;
  u16 Xp_Max;
  u16 Tg_Num;
  u16 Yv_Max;
  u16 Xt_Max;
  u16 Co_Max;
  u8 Ya_Num;
  u8 Yd_Num;
  u8 INSERT;
  u16 KpA1;
  u16 KpA2;
  u16 KpB1;
  u16 KpB2;
} G_attr ;

typedef struct
{
  char STR[8];
  s16 KA1;
  u16 KA2;
  s16 KB1;
  u16 KB2;
  u32 SCALE;
} Y_attr ;

typedef struct
{
  char STR[8];
  s16 PSC;
  u16 ARR;
  u16 CCR;
  u16 KP;
  u32 SCALE;
} X_attr ;

typedef struct
{
  char STR[8];
  u8 CHx;
  u8 CMD;
} T_attr ;

extern Y_attr *Y_Attr;
extern X_attr *X_Attr;
extern G_attr *G_Attr;
extern T_attr *T_Attr;




 void __CTR_HP(void);
 void __USB_Istr(void);
 void __USB_Init(void);

 void __LCD_Initial(void);
 void __Clear_Screen(u16 Color);
 void __Point_SCR(u16 x0, u16 y0);
 void __LCD_SetPixl(u16 Color);
 u16 __LCD_GetPixl(void);
 u16 __Get_TAB_8x14(u8 Code, u16 Row);
 void __LCD_Set_Block(u16 x1, u16 x2, u16 y1, u16 y2);

 void __LCD_Copy(uc16 *pBuffer, u16 NumPixel);
 void __LCD_Fill(u16 *pBuffer,u16 NumPixel);
 void __LCD_DMA_Ready(void);

 void __Row_Copy(uc16 *S_Buffer,u16 *T_Buffer);
 void __Row_DMA_Ready(void);

 u32 __Read_FIFO(void);
 void __Display_Str(u16 x0, u16 y0, u16 Color, u8 Mode, char *s);

 u32 __Input_Lic(u16 x0, u8 y0);
 u32 __GetDev_SN(void);

 u8 __Ident(u32 Dev_ID, u32 Proj_ID, u32 Lic_No);

 void __Set(u8 Object, u32 Value);
 u32 __Get(u8 Object);

 void __ExtFlash_PageRD(u8* pBuffer, u32 ReadAddr, u16 NumByteToRead);
 void __ExtFlash_PageWR(u8* pBuffer, u32 WriteAddr);
 u8 __ReadDiskData(u8* pBuffer, u32 ReadAddr, u16 Lenght);
 u8 __ProgDiskPage(u8* pBuffer, u32 ProgAddr);

 u8 __FLASH_Erase(u32 Address);
 u8 __FLASH_Prog(u32 Address, u16 Data);
 void __FLASH_Unlock(void);
 void __FLASH_Lock(void);

 u8 __Chk_SYS(u32 Licence);
 u8* __Chk_DFU(void);
 u8* __Chk_HDW(void);

 u8 __OpenFileWr(u8* Buffer, char* FileName, u16* Cluster, u32* pDirAddr);
 u8 __OpenFileRd(u8* Buffer, char* FileName, u16* Cluster, u32* pDirAddr);
 u8 __ReadFileSec(u8* Buffer, u16* Cluster);
 u8 __ProgFileSec(u8* Buffer, u16* Cluster);
 u8 __CloseFile(u8* Buffer, u32 Lenght, u16* Cluster, u32* pDirAddr);
# 9 "Draw.c" 2
# 1 "inc/Function.h" 1
# 26 "inc/Function.h"
u32 Power(u8 x, u8 y);
void Delayms(u16 mS);
void Int2Str(char *p, s32 n,const char *pUnit, u8 e, u8 Mode, s8 ShiftDigits);
u8 Str2Byte(char x,char y);
void u16ToDec5(char *p, u16 n);
void u8ToDec3(char *p, u8 n);
void u8ToDec2(char *p, u8 n);
void Char2Hex(char *p, u8 n);
void Shor2Hex(char *p, u16 n);
void Word2Hex(char *p, u32 n);
void s16ToDec3(char *p, s16 n);
u32 Int_sqrt(u32 n);
u8 Read_Keys(void);
void s8ToPercen(char *p, s8 n);
# 49 "inc/Function.h"
extern void fix_fft(short fr[], short fi[], short m);
# 10 "Draw.c" 2


void Print_Str_Row(u16 Row, u16* LCD_Buffer, u16 x0, u16 y0, u16 Type, u8 Mode, char *s);
void DisplayFFtValues(u16 Row,u8 buffer);
void DisplayDbScale(u16 Row, u8 buffer);
void DrawRowSpec(u16 Row);

void LoadBase3Buffer(void);
void LoadBase2Buffer(void);
void Base4(u8 buffer);
void TraceShadow(u8 start,u8 limit,u8 buffer);

u16 MAX_X;
uc16 RULE_BASE[8] ={0x020,0x040,0x080,0x040,0x020,0x010,0x008,0x010};
u8 OffsetX;
u8 OffsetY;
u16 SpecRow = 0;
s32 Tmp2;
u8 Rdiscard=0;
char DbScaleStr[3];

uc16 COLOR_INDEX=0x0503;

u16 RowMem, RowMemPeak;

uc8 Mark_TAB_1[7] ={0x00,0x00,0x42,0xFE,0x02,0x00,0x00};
uc8 Mark_TAB_2[7] ={0x00,0x46,0x8A,0x92,0x92,0x62,0x00};
uc8 Mark_TAB_3[7] ={0x00,0x44,0x82,0x92,0x92,0x6C,0x00};
uc8 Mark_TAB_4[7] ={0x00,0x18,0x28,0x4A,0xFE,0x0A,0x00};
uc8 Mark_TAB_T[7] ={0x00,0x40,0x40,0x7E,0x40,0x40,0x00};

uc8 Mark_TAB[5][7] ={{0x00,0x00,0x42,0xFE,0x02,0x00,0x00},
                      {0x00,0x46,0x8A,0x92,0x92,0x62,0x00},
                      {0x00,0x44,0x82,0x92,0x92,0x6C,0x00},
                      {0x00,0x18,0x28,0x4A,0xFE,0x0A,0x00},
                      {0x00,0x40,0x40,0x7E,0x40,0x40,0x00}};

uc16 CLK_TAB[44] =
  {0x000,0x000,0x000,0x000,0x070,0x3FF,0x070,0x000,0x000,0x000,0x000,
   0x000,0x002,0x004,0x008,0x070,0x070,0x070,0x080,0x100,0x200,0x000,
   0x020,0x020,0x020,0x020,0x070,0x070,0x070,0x020,0x020,0x020,0x020,
   0x000,0x200,0x100,0x080,0x070,0x070,0x070,0x008,0x004,0x002,0x000};

uc16 Char_TAB_8x11[744] = {

  0x000,0x000,0x000,0x780,0x040,0x020,0x020,0x020,

  0x1FC,0x1FC,0x1FC,0x1FC,0x1FC,0x1FC,0x1FC,0x000,

  0x070,0x0F8,0x1FC,0x1FC,0x1FC,0x0F8,0x070,0x000,
  0x30C,0x18C,0x0C0,0x060,0x030,0x318,0x30C,0x000,
  0x000,0x180,0x260,0x21C,0x26A,0x284,0x140,0x000,
  0x202,0x202,0x202,0x202,0x202,0x202,0x3FE,0x000,
  0x000,0x000,0x0F8,0x1FC,0x306,0x202,0x000,0x000,
  0x000,0x000,0x202,0x306,0x1FC,0x0F8,0x000,0x000,
  0x000,0x18C,0x0D8,0x070,0x070,0x0D8,0x18C,0x000,
  0x000,0x020,0x020,0x0F8,0x0F8,0x020,0x020,0x000,
  0x020,0x020,0x010,0x00F,0x000,0x000,0x000,0x000,
  0x000,0x020,0x020,0x020,0x020,0x020,0x020,0x000,
  0x000,0x000,0x300,0x300,0x000,0x000,0x000,0x000,
  0x180,0x0C0,0x060,0x030,0x018,0x00C,0x006,0x000,
  0x1FC,0x3FE,0x242,0x222,0x212,0x3FE,0x1FC,0x000,
  0x000,0x208,0x20C,0x3FE,0x3FE,0x200,0x200,0x000,
  0x304,0x386,0x2C2,0x262,0x232,0x31E,0x30C,0x000,
  0x104,0x306,0x222,0x222,0x222,0x3FE,0x1DC,0x000,
  0x060,0x070,0x058,0x24C,0x3FE,0x3FE,0x240,0x000,
  0x11E,0x21E,0x212,0x212,0x212,0x3F2,0x1E2,0x000,
  0x1F8,0x3FC,0x226,0x222,0x222,0x3E0,0x1C0,0x000,
  0x006,0x006,0x3C2,0x3E2,0x032,0x01E,0x00E,0x000,
  0x1DC,0x3FE,0x222,0x222,0x222,0x3FE,0x1DC,0x000,
  0x01C,0x23E,0x222,0x222,0x322,0x1FE,0x0FC,0x000,
  0x000,0x000,0x000,0x198,0x198,0x000,0x000,0x000,
  0x2FA,0x2FA,0x2FA,0x2FA,0x2FA,0x2FA,0x2FA,0x2FA,
  0x000,0x020,0x070,0x0D8,0x18C,0x306,0x202,0x000,
  0x090,0x090,0x090,0x090,0x090,0x090,0x000,0x000,
  0x000,0x202,0x306,0x18C,0x0D8,0x070,0x020,0x000,

  0x07F,0x008,0x0D4,0x322,0x441,0x300,0x0C0,0x000,

  0x3FE,0x020,0x3FE,0x000,0x320,0x2A0,0x260,0x000,
  0x3F0,0x3F8,0x04C,0x046,0x04C,0x3F8,0x3F0,0x000,
  0x202,0x3FE,0x3FE,0x222,0x222,0x3FE,0x1DC,0x000,
  0x0F8,0x1FC,0x306,0x202,0x202,0x306,0x18C,0x000,
  0x202,0x3FE,0x3FE,0x202,0x306,0x1FC,0x0F8,0x000,
  0x202,0x3FE,0x3FE,0x222,0x272,0x306,0x38E,0x000,
  0x202,0x3FE,0x3FE,0x222,0x072,0x006,0x00E,0x000,
  0x0F8,0x1FC,0x306,0x222,0x222,0x1E6,0x3EC,0x000,
  0x3FE,0x3FE,0x020,0x020,0x020,0x3FE,0x3FE,0x000,
  0x000,0x000,0x202,0x3FE,0x3FE,0x202,0x000,0x000,
  0x1C0,0x3C0,0x200,0x202,0x3FE,0x1FE,0x002,0x000,
  0x202,0x3FE,0x3FE,0x030,0x0F8,0x3CE,0x306,0x000,
  0x202,0x3FE,0x3FE,0x202,0x200,0x200,0x300,0x000,
  0x3FE,0x3FE,0x01C,0x038,0x01C,0x3FE,0x3FE,0x000,
  0x3FE,0x3FE,0x01C,0x038,0x070,0x3FE,0x3FE,0x000,
  0x0F8,0x1FC,0x306,0x202,0x306,0x1FC,0x0F8,0x000,
  0x202,0x3FE,0x3FE,0x222,0x022,0x03E,0x01C,0x000,
  0x1FC,0x3FE,0x202,0x282,0x302,0x3FE,0x1FC,0x000,
  0x202,0x3FE,0x3FE,0x022,0x062,0x3FE,0x39C,0x000,
  0x10C,0x31E,0x232,0x222,0x262,0x3CE,0x18C,0x000,
  0x000,0x00E,0x206,0x3FE,0x3FE,0x206,0x00E,0x000,
  0x1FE,0x3FE,0x200,0x200,0x200,0x3FE,0x1FE,0x000,
  0x07E,0x0FE,0x180,0x300,0x180,0x0FE,0x07E,0x000,
  0x0FE,0x3FE,0x380,0x1E0,0x380,0x3FE,0x0FE,0x000,
  0x306,0x3DE,0x0F8,0x020,0x0F8,0x3DE,0x306,0x000,
  0x000,0x01E,0x23E,0x3E0,0x3E0,0x23E,0x01E,0x000,
  0x38E,0x3C6,0x262,0x232,0x31E,0x38E,0x000,0x000,
  0x200,0x300,0x2C0,0x220,0x218,0x204,0x3FE,0x000,
  0x000,0x022,0x042,0x1FE,0x3FE,0x240,0x220,0x000,
  0x020,0x010,0x008,0x006,0x008,0x010,0x020,0x020,
  0x000,0x220,0x210,0x3FC,0x3FE,0x012,0x022,0x000,
  0x000,0x200,0x200,0x200,0x200,0x200,0x200,0x000,
  0x202,0x202,0x202,0x202,0x202,0x202,0x202,0x202,
  0x1C0,0x3E8,0x228,0x228,0x1F8,0x3F0,0x200,0x000,
  0x202,0x3FE,0x1FE,0x220,0x220,0x3E0,0x1C0,0x000,
  0x1E0,0x3F0,0x210,0x210,0x210,0x330,0x120,0x000,
  0x000,0x1C0,0x3E0,0x220,0x222,0x3FE,0x3FE,0x000,
  0x1E0,0x3F0,0x250,0x250,0x250,0x370,0x160,0x000,
  0x000,0x220,0x3FC,0x3FE,0x222,0x002,0x004,0x000,
  0x130,0x378,0x248,0x248,0x3F8,0x1F8,0x000,0x000,
  0x202,0x3FE,0x3FE,0x020,0x010,0x3F0,0x3E0,0x000,
  0x000,0x000,0x200,0x3F6,0x3F6,0x200,0x000,0x000,
  0x000,0x100,0x300,0x210,0x3F6,0x1F6,0x000,0x000,
  0x202,0x3FE,0x3FE,0x062,0x0F0,0x398,0x308,0x000,
  0x000,0x000,0x202,0x3FE,0x3FE,0x200,0x000,0x000,
  0x3F8,0x3F8,0x018,0x3F0,0x018,0x3F8,0x3F0,0x000,
  0x008,0x3F8,0x3F0,0x008,0x008,0x3F8,0x3F0,0x000,
  0x000,0x1F0,0x3F8,0x208,0x208,0x3F8,0x1F0,0x000,
  0x208,0x3F8,0x3F0,0x248,0x048,0x078,0x030,0x000,
  0x030,0x078,0x048,0x248,0x3F8,0x3F8,0x200,0x000,
  0x208,0x3F8,0x3F0,0x218,0x008,0x018,0x030,0x000,
  0x000,0x110,0x338,0x268,0x248,0x3D8,0x190,0x000,
  0x010,0x010,0x1F8,0x3FC,0x210,0x310,0x100,0x000,
  0x1F8,0x3F8,0x200,0x200,0x1F8,0x3F8,0x200,0x000,
  0x000,0x0F8,0x1F8,0x300,0x300,0x1F8,0x0F8,0x000,
  0x0F8,0x3F8,0x300,0x180,0x300,0x3F8,0x0F8,0x000,
  0x208,0x318,0x1B0,0x0E0,0x1B0,0x318,0x208,0x000,
  0x038,0x278,0x240,0x240,0x240,0x1F8,0x0F8,0x000,
  0x318,0x388,0x2C8,0x268,0x238,0x318,0x000,0x000,
  0x0F8,0x088,0x38E,0x022,0x2FA,0x2FA,0x2FA,0x2FA,
  0x000,0x000,0x000,0x3FE,0x3FE,0x000,0x000,0x000,
  0x2FA,0x2FA,0x2FA,0x2FA,0x2FA,0x202,0x3FE,0x000,
  0x0F8,0x088,0x38E,0x202,0x202,0x202,0x202,0x202};




const u16 colors[200] = {32768,32768,32768,32768,34816,34816,34816,36864,36864,36864,38912,38912,
 38912,40960,40960,40960,43008,43008,43008,43008,45056,45056,45056,47104,47104,47104,49152,49152,
 49152,51200,51200,51200,53248,53248,53248,55296,55296,55296,55296,57344,57344,57344,59392,59392,
 59392,61440,61440,61440,63488,63488,63488,63520,63552,63584,63616,63680,63712,63744,63776,63840,
 63872,63904,63968,64000,64032,64064,64128,64160,64192,64224,64288,64320,64352,64416,64448,64480,
 64512,64576,64608,64640,64704,64736,64768,64800,64864,64896,64928,64960,65024,65056,65088,65152,
 65184,65216,65248,65312,65344,65376,65408,65472,65504,65504,65505,65505,65506,65507,65507,65508,
 65508,65509,65510,65510,65511,65512,65512,65513,65514,65514,65515,65515,65516,65517,65517,65518,
 65519,65519,65520,65521,65521,65522,65523,65523,65524,65524,65525,65526,65526,65527,65528,65528,
 65529,65530,65530,65531,65531,65532,65533,65533,65534,65535,65535,65503,63423,63391,61279,59199,
 59167,57087,54975,54943,52863,50751,50719,48639,48607,46495,44415,44383,42303,40191,40159,38079,
 35967,35935,33855,33823,31711,29631,29599,27519,25407,25375,23295,21183,21151,19071,19039,16927,
 14847,14815,12703,10623,10591,8511,6399,6367,4287,4255,2143,63};
# 189 "Draw.c"
uc8 DbScale[201]=
{43, 37, 35, 33, 32, 31, 30, 29, 28, 27, 27, 26, 25, 25, 24, 24, 23, 23, 22, 22,
21, 21, 21, 20, 20, 20, 19, 19, 19, 19, 18, 18, 18, 17, 17, 17, 16, 16, 16, 16,
16, 15, 15, 15, 15, 14, 14, 14, 14, 14, 14, 13, 13, 13, 13, 13, 13, 12, 12, 12,
12, 12, 12, 12, 11, 11, 11, 11, 11, 11, 10, 10, 10, 10, 10, 10, 10, 9, 9, 9,
 9, 9, 9, 9, 9, 9, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 7, 7, 7,
 7, 7, 7, 7, 7, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 5, 5, 5, 5, 5,
 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3,
 3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1,
 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3, 4,
 4};
# 304 "Draw.c"
u16 Color[16] = { 0xFFE0,
                  0x07FF,
                  0xF81F,
                  0x07E0,
                  0xFFFF,
                  0x0000,
                  0x051F,
                  0xF800,
                  0xFFE0,
                  0xA534,
                  0xFFFF,
                  0x07E0,
                  0xF800,
                  0xA534,
                  0x07FF,
                  0x001F };

trigg V_Trigg[4] = {
                     { 175, 0x02 + 0x04 },
                     { 116, 0x02 },
                     { 75, 0x02 + 0x04 },
                     { 35, 0x02 + 0x04 },
                   };

u16 LCD_Buffer[2][240];
u16 Base3Buffer[240];
u16 Base2Buffer[240];

u8 Vt1=180, Vt2=128, Vt3=70, Vt4=30;




u16 Get_TAB_8x11(u8 Code, u8 Row)
{
  return Char_TAB_8x11[((Code-0x22)*8)+Row];
}
# 351 "Draw.c"
void Print_Clk(u16 x0, u16 y0, u16 Type, u8 Phase)
{
  u16 i, j, b;

  __LCD_Set_Block(x0, x0+10, y0, y0+10);
  for(i=0; i<11; ++i){
    b = CLK_TAB[Phase *11 + i];
    for(j=0; j<11; ++j){
      if((b >> j)& 0x001) __LCD_SetPixl(Color[Type >> 0x8]);
      else __LCD_SetPixl(Color[Type & 0x0F]);
    }
  }
  __LCD_Set_Block(0,399,0,239);
}



void Print_Str(u16 x0, u16 y0, u16 Type, u8 Mode, char *s)
{
  signed short i, j, b;
  __LCD_Set_Block(x0, 399, y0, y0+10);
  for (j=0; j<11;++j){
    if(Mode == 0) __LCD_SetPixl(Color[Type & 0x0F]);
    else __LCD_SetPixl(Color[Type >> 0x8]);
  }
  x0++;
  while (*s!=0) {
    for(i=0;i<8;++i){
      if((*s==0x20)||(*s==0x21)) b = 0x0000;
      else b = Get_TAB_8x11(*s, i);
      if((*s==0x21)&&(i==4)) break;
      for(j=0;j<11;++j){
        if((b << j)& 0x400) {
          if(Mode == 0) __LCD_SetPixl(Color[Type >> 0x8]);
          else __LCD_SetPixl(Color[Type & 0x0F]);
        } else {
          if(Mode == 0) __LCD_SetPixl(Color[Type & 0x0F]);
          else __LCD_SetPixl(Color[Type >> 0x8]);
        }
      }
    }
    if(*s==0x21) x0 +=4;
    else x0 += 8;
    ++s;
  }
  __LCD_Set_Block(0,399,0,239);
}





void Print_Str2(u16 x0,u16 x1,u16 y0, u16 Type, u8 Mode, char *s,u8 LeadingBlanks,u8 TrailingBlanks)
{
u8 LeadingLine=0;

 signed short i, j, b;
 u8 xm, ym;
 __LCD_Set_Block(x0, x1, y0, y0+21);

      if(LeadingBlanks>10){
        LeadingBlanks-=10;
        LeadingLine=1;
      }

      for (i=0;i<LeadingBlanks;i++){
 for (j=0;j<22;j++){
   __LCD_SetPixl(Color[5]);
 }
 x0++;
      }

    if(LeadingLine){
      for (j=0; j<44;++j){
        if(Mode == 0) __LCD_SetPixl(Color[Type & 0x0F]);
        else __LCD_SetPixl(Color[Type >> 0x8]);
      }
      x0+=2;
    }
 while (*s!=0) {
  for(i=0;i<8;++i){
   if((*s==0x20)||(*s==0x21)) b = 0x0000;
   else b = Get_TAB_8x11(*s, i);
    if((*s==0x21)&&(i==4)) break;
   for(xm=0;xm<2;++xm){
    for(j=0;j<11;++j){
     if((b << j)& 0x400) {
      if(Mode == 0) for(ym=0;ym<2;++ym) __LCD_SetPixl(Color[Type >> 0x8]);
      else for(ym=0;ym<2;++ym) __LCD_SetPixl(Color[Type & 0x0F]);
     } else {
      if(Mode == 0) for(ym=0;ym<2;++ym) __LCD_SetPixl(Color[Type & 0x0F]);
      else for(ym=0;ym<2;++ym) __LCD_SetPixl(Color[Type >> 0x8]);
     }
    }
   }
  }
  if(*s==0x21) x0 +=8;
  else x0 += 16;
  ++s;
 }

      for (i=0;i<TrailingBlanks;i++){
 for (j=0;j<22;j++){
          __LCD_SetPixl(Color[5]);
 }
 x0++;
      }

}






void Draw_Row(u16 Row)
{
  u8 i, y[8], Dot_Hide[8];
  s16 Tmp, m, n, skip;
  s16 fftx, val= 0;

 if(ClearLeadingEdge){
  if((Title[6][0].Value)!=0){
    skip=JumpCnt-4;
    skip-=Title[6][2].Value-15;
  }else skip=JumpCnt+11;
 }else skip=0x7FFF;

  if((Row > 11)&&(Row <= MAX_X)){
    m = (Row - 11 -1)* 4;
    n = (Row - 11) * 4;
    for(i = 0; i < 8; i += 2) {
      Dot_Hide[i] = 0;
      y[i] = TrackBuff[m + i/2];
      y[i+1] = TrackBuff[n + i/2];

      if(y[i] >= 0 +200) y[i] = 0 +200 -1;
      else if(y[i] <= 0 +1) y[i] = 0 +1;
      if(y[i+1] >= 0 +200) y[i+1] = 0 +200 -1;
      else if(y[i+1] <= 0 +1) y[i+1] = 0 +1;

      if(y[i] == y[i+1]){
        if((y[i] == 0 +1)||(y[i] == 200 -1)) Dot_Hide[i] = 1;
        else {
          if(y[i] >= 0 +2) y[i] -= 1;
          if(y[i+1] <= 0 +200 -2) y[i+1] += 1;
        }
      }
      if(y[i] > y[i+1]){
        Tmp = y[i+1]; y[i+1]= y[i]; y[i]= Tmp;
      }
    }
  }
  __Row_DMA_Ready();
  __Point_SCR(Row, 13);

if(Row & 1){

    __Row_Copy(Base2Buffer, LCD_Buffer[0]);

  if((Row > 11)&&(Row < MAX_X)){
    if((Title[6][1].Value>7)||(Row!=skip) ||((Title[6][1].Value>3)&&((Title[6][0].Value)!=0))){
      if((Dot_Hide[0] == 0)&&(Title[0][0].Value != 0)){
        if((y[1]-y[0])>5){
          for(i=y[0]; i<=y[1]; ++i) LCD_Buffer[1][i] |=Color[0]-0x4200;
        } else {
          for(i=y[0]; i<=y[1]; ++i) LCD_Buffer[1][i] |=Color[0];
        }
      }
      if((Dot_Hide[2] == 0)&&(Title[1][0].Value != 0)){
        if((y[3]-y[2])>5){
          for(i=y[2]; i<=y[3]; ++i) LCD_Buffer[1][i] |=Color[1]-0x0208;
        } else {
          for(i=y[2]; i<=y[3]; ++i) LCD_Buffer[1][i] |=Color[1];
        }
      }
      if((Dot_Hide[4] == 0)&&(Title[2][0].Value != 0)){
        if((y[5]-y[4])>5){
          for(i=y[4]; i<=y[5]; ++i) LCD_Buffer[1][i] |=Color[2]-0x4008;
        } else {
          for(i=y[4]; i<=y[5]; ++i) LCD_Buffer[1][i] |=Color[2];
        }
      }
      if((Dot_Hide[6] == 0)&&(Title[3][0].Value != 0)){
        if((y[7]-y[6])>5){
          for(i=y[6]; i<=y[7]; ++i) LCD_Buffer[1][i] |=Color[3]-0x0200;
        } else {
          for(i=y[6]; i<=y[7]; ++i) LCD_Buffer[1][i] |=Color[3];
        }
      }
    }


  if ((Title[6][0].Value)!=0){
      if((Title[7][0].Value == 0)&&(Title[0][0].Value != 0))
        LCD_Buffer[1][V_Trigg[0].Value] |= Color[0];
      if((Title[7][0].Value == 1)&&(Title[1][0].Value != 0))
        LCD_Buffer[1][V_Trigg[1].Value] |= Color[1];
      if((Title[7][0].Value == 2)&&(Title[2][0].Value != 0))
        LCD_Buffer[1][V_Trigg[2].Value] |= Color[2];
      if((Title[7][0].Value == 3)&&(Title[3][0].Value != 0))
        LCD_Buffer[1][V_Trigg[3].Value] |= Color[3];

      if(Title[7][0].Value == 4){
        LCD_Buffer[1][V_Trigg[0].Value] |= Color[0];
        LCD_Buffer[1][V_Trigg[1].Value] |= Color[1];
      }


      Tmp2= (((1024*100)/TempKp1)*Title[6][2].Value)/100;
      Tmp2 =(11 + 150)- Tmp2;

     if(Tmp2 > 11) {
        if((Row == Tmp2)&&((Title[6][2].Flag & 0x04)== 0)){
          for(i = 1; i < 200; i+=3) LCD_Buffer[1][i] |= Color[6];
        }
        if((Row == Tmp2-1)||(Row == Tmp2+1)){
          LCD_Buffer[1][200] = Color[6];
          LCD_Buffer[1][0] = Color[6];
        }
        if(Row == Tmp2){
          LCD_Buffer[1][200] = Color[6];
          LCD_Buffer[1][200 -1] = Color[6];
          LCD_Buffer[1][0 +1] = Color[6];
          LCD_Buffer[1][0] = Color[6];
        }
      }
  }

      Tmp = 11 + Title[10][0].Value;
      if((Row == Tmp)&&((Title[10][0].Flag & 0x04)== 0)){
        for(i = 1; i < 200; i+=3) LCD_Buffer[1][i] |= Color[4];
      }
      if((Row == Tmp-1)||(Row == Tmp+1)){
        LCD_Buffer[1][200] = Color[4];
        LCD_Buffer[1][0] = Color[4];
      }
      if(Row == Tmp){
        LCD_Buffer[1][200] = Color[4];
        LCD_Buffer[1][200 -1] = Color[4];
        LCD_Buffer[1][0 +1] = Color[4];
        LCD_Buffer[1][0] = Color[4];
      }
      Tmp = 11 + Title[10][1].Value;
      if((Row == Tmp)&&((Title[10][1].Flag & 0x04)== 0)){
        for(i = 1; i < 200; i+=3) LCD_Buffer[1][i] |= Color[4];
      }
      if((Row == Tmp-1)||(Row == Tmp+1)){
        LCD_Buffer[1][200] = Color[4];
        LCD_Buffer[1][0] = Color[4];
      }
      if(Row == Tmp){
        LCD_Buffer[1][200] = Color[4];
        LCD_Buffer[1][200 -1] = Color[4];
        LCD_Buffer[1][0 +1] = Color[4];
        LCD_Buffer[1][0] = Color[4];
      }
    }

      if((Row == 11)||(Row == MAX_X)){
        LCD_Buffer[1][Title[8][0].Value-1] |= Color[4];
        LCD_Buffer[1][Title[8][0].Value+0] |= Color[4];
        LCD_Buffer[1][Title[8][0].Value+1] |= Color[4];
        LCD_Buffer[1][Title[8][1].Value-1] |= Color[4];
        LCD_Buffer[1][Title[8][1].Value+0] |= Color[4];
        LCD_Buffer[1][Title[8][1].Value+1] |= Color[4];
      }



 if ((ShowFFT==1)&&(Row > 11)) {
                DisplayFFtValues(Row,1);
  fftx = Row - 11;
  if (fftx < (512/2)-1) {
                        val = fr[fftx];
   if (val >= 200) val = 199;
                        if(PeakFreq>198)PeakFreq=198;

                        if(fftx<245){
                          if(fr[fftx+1]>188)TraceShadow(189,fr[fftx+1]+2,1);
                          if(fr[fftx-1]>188)TraceShadow(189,fr[fftx-1]+2,1);
                        }else{
                          if(fr[fftx+1]>173)TraceShadow(174,fr[fftx+1]+2,1);
                          if(fr[fftx-1]>173)TraceShadow(174,fr[fftx-1]+2,1);
                        }
                        for(i=0 +1; i<val; i++) LCD_Buffer[1][i] = 0x07E0; if(val>173)LCD_Buffer[1][i]=0x0000;

     if ((fftx == imax - 4) || (fftx == imax + 4)) {
    for (i=PeakFreq - 1; i<PeakFreq+1; i++) {
     LCD_Buffer[1][i] = 0x001F;
     RowMem=Row;
    }
   } else if ((fftx == imax - 3) || (fftx == imax + 3)) {
    LCD_Buffer[1][PeakFreq] = 0x001F;
   } else if ((fftx == imax - 5) || (fftx == imax + 5)) {
    for (i=PeakFreq - 2; i<PeakFreq+2; i++) {
     LCD_Buffer[1][i] = 0x001F;
    }
   }

  } else {
   for (i=0 +1; i<200; i++) {
    LCD_Buffer[1][i] |= 0x0000;
   }
  }
  if(Row>167)DisplayDbScale(Row,1);
 }

    __LCD_Copy(LCD_Buffer[1], 200 +1);

} else {





    if(Row+1 == MAX_X) for(i=0;i<201;i++)LCD_Buffer[1][i]=0xA534;
    else if(Row+1 == 11);

    else if((Row+1 - 11)%30 == 0) Base4(1);
    else if((Row+1 - 11)%6 == 0) __Row_Copy(Base3Buffer, LCD_Buffer[1]);

    else __Row_Copy(Base2Buffer, LCD_Buffer[1]);

    if((Row==11 +1)||(Row==MAX_X-1)){
        LCD_Buffer[0][Title[8][0].Value] |= Color[4];
        LCD_Buffer[0][Title[8][1].Value] |= Color[4];
    }
      if((Title[8][0].Flag & 0x04)== 0)
        LCD_Buffer[0][Title[8][0].Value] |= Color[4];
      if((Title[8][1].Flag & 0x04)== 0)
        LCD_Buffer[0][Title[8][1].Value] |= Color[4];

  if((Row > 11)&&(Row < MAX_X)){
    if((Title[6][1].Value>7)||(Row!=skip) ||((Title[6][1].Value>3)&&((Title[6][0].Value)!=0))){
      if((Dot_Hide[0] == 0)&&(Title[0][0].Value != 0)){
        if((y[1]-y[0])>5){
          for(i=y[0]; i<=y[1]; ++i) LCD_Buffer[0][i] |=Color[0]-0x4200;
        } else {
          for(i=y[0]; i<=y[1]; ++i) LCD_Buffer[0][i] |=Color[0];
        }
      }
      if((Dot_Hide[2] == 0)&&(Title[1][0].Value != 0)){
        if((y[3]-y[2])>5){
          for(i=y[2]; i<=y[3]; ++i) LCD_Buffer[0][i] |=Color[1]-0x0208;
        } else {
          for(i=y[2]; i<=y[3]; ++i) LCD_Buffer[0][i] |=Color[1];
        }
      }
      if((Dot_Hide[4] == 0)&&(Title[2][0].Value != 0)){
        if((y[5]-y[4])>5){
          for(i=y[4]; i<=y[5]; ++i) LCD_Buffer[0][i] |=Color[2]-0x4008;
        } else {
          for(i=y[4]; i<=y[5]; ++i) LCD_Buffer[0][i] |=Color[2];
        }
      }
      if((Dot_Hide[6] == 0)&&(Title[3][0].Value != 0)){
        if((y[7]-y[6])>5){
          for(i=y[6]; i<=y[7]; ++i) LCD_Buffer[0][i] |=Color[3]-0x0200;
        } else {
          for(i=y[6]; i<=y[7]; ++i) LCD_Buffer[0][i] |=Color[3];
        }
      }

    }
  }


   if ((Title[6][0].Value)!=0){

      Tmp2= (((1024*100)/TempKp1)*Title[6][2].Value)/100;
      Tmp2 =(11 + 150)- Tmp2;

      if(Tmp2 > 11) {
        if((Row == Tmp2)&&((Title[6][2].Flag & 0x04)== 0)){
          for(i = 1; i < 200; i+=3) LCD_Buffer[0][i] |= Color[6];
        }
        if((Row == Tmp2-1)||(Row == Tmp2+1)){
          LCD_Buffer[0][200] = Color[6];
          LCD_Buffer[0][0] = Color[6];
        }
        if(Row == Tmp2){
          LCD_Buffer[0][200] = Color[6];
          LCD_Buffer[0][200 -1] = Color[6];
          LCD_Buffer[0][0 +1] = Color[6];
          LCD_Buffer[0][0] = Color[6];
        }
      }
   }

      Tmp = 11 + Title[10][0].Value;
      if((Row == Tmp)&&((Title[10][0].Flag & 0x04)== 0)){
        for(i = 1; i < 200; i+=3) LCD_Buffer[0][i] |= Color[4];
      }
      if((Row == Tmp-1)||(Row == Tmp+1)){
        LCD_Buffer[0][200] = Color[4];
        LCD_Buffer[0][0] = Color[4];
      }
      if(Row == Tmp){
        LCD_Buffer[0][200] = Color[4];
        LCD_Buffer[0][200 -1] = Color[4];
        LCD_Buffer[0][0 +1] = Color[4];
        LCD_Buffer[0][0] = Color[4];
      }
      Tmp = 11 + Title[10][1].Value;
      if((Row == Tmp)&&((Title[10][1].Flag & 0x04)== 0)){
        for(i = 1; i < 200; i+=3) LCD_Buffer[0][i] |= Color[4];
      }
      if((Row == Tmp-1)||(Row == Tmp+1)){
        LCD_Buffer[0][200] = Color[4];
        LCD_Buffer[0][0] = Color[4];
      }
      if(Row == Tmp){
        LCD_Buffer[0][200] = Color[4];
        LCD_Buffer[0][200 -1] = Color[4];
        LCD_Buffer[0][0 +1] = Color[4];
        LCD_Buffer[0][0] = Color[4];
      }



 if ((ShowFFT==1)&&(Row > 11)) {
                DisplayFFtValues(Row,0);
  fftx = Row - 11;
  if (fftx < 512/2){
                        val = fr[fftx];
   if (val >= 200) val = 199;
                        if(PeakFreq>198)PeakFreq=198;

                        if(fftx<245){
                          if(fr[fftx+1]>188)TraceShadow(189,fr[fftx+1]+2,0);
                          if(fr[fftx-1]>188)TraceShadow(189,fr[fftx-1]+2,0);
                        }else{
                          if(fr[fftx+1]>173)TraceShadow(174,fr[fftx+1]+2,0);
                          if(fr[fftx-1]>173)TraceShadow(174,fr[fftx-1]+2,0);
                        }
                        for(i=0 +1; i<val; i++) LCD_Buffer[0][i] = 0x07E0; if(val>173)LCD_Buffer[0][i]=0x0000;

   if ((fftx == imax - 4) || (fftx == imax + 4)) {
    for (i=PeakFreq - 1; i<PeakFreq+1; i++) {
     LCD_Buffer[0][i] = 0x001F;
     RowMem=Row;
    }
   } else if ((fftx == imax - 3) || (fftx == imax + 3)) {
    LCD_Buffer[0][PeakFreq] = 0x001F;
   } else if ((fftx == imax - 5) || (fftx == imax + 5)) {
    for (i=PeakFreq - 2; i<PeakFreq+2; i++) {
     LCD_Buffer[0][i] = 0x001F;
    }
   }

  } else {
   for (i=0 +1; i<200; i++) {
    LCD_Buffer[0][i] |= 0x0000;
   }
  }
  if(Row>167)DisplayDbScale(Row,0);
 }

    __LCD_Copy(LCD_Buffer[0], 200 +1);
  }
}
# 832 "Draw.c"
void Draw_Window(void)
{
  u16 Row;
  u16 h;
  u8 end=0,i;


  for(i=0;i<201;i++)LCD_Buffer[1][i]=0xA534;
  __Row_DMA_Ready();
  __Row_Copy(Base2Buffer, LCD_Buffer[0]);

   if (((Title[6][0].Value)==5) && (Title[0][0].Value == 0)) for (h = 0; h <= 392; ++h) TrackBuff[h*4]=105;
   if (((Title[6][0].Value)==5) && (Title[1][0].Value == 0)) for (h = 0; h <= 392; ++h) TrackBuff[(h*4)+1]=100;

  if (((Title[6][0].Value)!=5)&&(Title[3][0].Value!=11)&&(Title[3][0].Value!=10))for(Row = 11; Row <= MAX_X; ++Row){
     if (Row<(discard + 11)){
       Color[0]=0x0000;
       Color[1]=0x0000;
     }

     if (Row>(404-Rdiscard)){
       Color[0]=0x0000;
       Color[1]=0x0000;
       Color[2]=0x0000;
       Color[3]=0x0000;
     }


   if ((Title[7][0].Value<2)||(Title[7][0].Value==4))end=discard+5; else end=discard;

     if (Row<(11 +end)){
       Color[2]=0x0000;
     }

   if ((Title[3][0].Value==2)||(Title[3][0].Value==3))end=discard;

     if (Row<(11 +end)){
       Color[3]=0x0000;
     }

     if(((Title[6][0].Value)!=5)&&(!((Title[3][0].Value==11)||(Title[3][0].Value==10)))) Draw_Row(Row);
     if((Row<(discard+5+11))||(Row>(404-Rdiscard))) {
       Color[0]=0xFFE0;
       Color[1]=0x07FF;
       Color[2]=0xF81F;
       Color[3]=0x07E0;
     }
  }

  if ((Title[6][0].Value)==5)for(Row = 11; Row <= MAX_X; ++Row) Draw_Row_XY(Row);

 if(((Title[3][0].Value==11)||(Title[3][0].Value==10))&&((Title[6][0].Value)!=5)&&(Title[4][0].Value==0)){
  if (SpecRow > MAX_X) {
   SpecRow = 0;
  }
  DrawRowSpec(SpecRow);
  SpecRow++;
 }

  RowMemPeak = RowMem;

  __LCD_DMA_Ready();
  __Row_DMA_Ready();
}



void Draw_Mark(u16 m, u16 n)
{
  u16 i, j, Tmp;

  V_Trigg[2].Value=Title[2][3].Value + 10;
  V_Trigg[3].Value=Title[3][3].Value + 10;




  if(m < 4) { if((Title[m][3].Value > 200-3)||(Title[m][3].Value <3))return; }
  else { if((V_Trigg[n].Value > 200-3)||(V_Trigg[n].Value <3))return; }


  for(i = 0; i <= 10; ++i){
    if(i < 7){
      if(m < 4){
        Tmp = Mark_TAB[m][i];
        __Point_SCR(i, Title[m][3].Value +(13 -4));
      } else {
        Tmp = Mark_TAB[4][i];
        __Point_SCR(i, V_Trigg[n].Value +(13 -4));
      }
      for(j = 0; j < 8; ++j){
        if(Tmp & 1) __LCD_SetPixl(Color[5]);
        else __LCD_SetPixl(Color[n]);
        Tmp >>= 1;
      }
      __LCD_SetPixl(Color[n]);
    } else {
      if(m < 4){
        __Point_SCR(i, Title[m][3].Value +(13 -10)+ i);
        for(j=Title[m][3].Value+(13 -10)+i;j<(Title[m][3].Value+(13 +11)-i);++j)
          __LCD_SetPixl(Color[n]);
      } else {
        __Point_SCR(i, V_Trigg[n].Value +(13 -10)+ i);
        for(j=V_Trigg[n].Value+(13 -10)+i;j<(V_Trigg[n].Value+(13 +11)-i);++j)
          __LCD_SetPixl(Color[n]);
      }
    }
  }
}



void Update_Mark(void)
{
  s16 i, Tmp;
  u8 j;

  __Row_DMA_Ready();
  for(i = 0; i <= 10; ++i){


    __Point_SCR(i, 13 -2);
    for(j = 13 -2; j < (200 + 13)+3; ++j) __LCD_SetPixl(Color[5]);
  }

  if(Title[0][0].Value != 0) Draw_Mark(0, 0);
  if(Title[1][0].Value != 0) Draw_Mark(1, 1);
  if(Title[2][0].Value != 0) Draw_Mark(2, 2);
  if(Title[3][0].Value != 0) Draw_Mark(3, 3);
  if(Title[7][0].Value == 0) Draw_Mark(7, 0);
  if(Title[7][0].Value == 1) Draw_Mark(7, 1);
  if(Title[7][0].Value == 2) Draw_Mark(7, 2);
  if(Title[7][0].Value == 3) Draw_Mark(7, 3);
  if(Title[7][0].Value == 4) {
    Draw_Mark(7, 0);
    Draw_Mark(7, 1);
  }







  __Point_SCR(MAX_X+1, 13 -2);
  for(j = 13 -2; j < (200 + 13)+3; ++j) __LCD_SetPixl(Color[5]);
  __Point_SCR(MAX_X+2, 13 -2);
  for(j = 13 -2; j < (200 + 13)+3; ++j) __LCD_SetPixl(Color[5]);



  for(i = 11; i <= MAX_X+1; ++i)
  {
    __Point_SCR(i, 13 -1);
    __LCD_SetPixl(Color[5]);
    __Point_SCR(i, (200 + 13)+1);
    __LCD_SetPixl(Color[5]);
  }
  __Point_SCR(11 -1, Title[8][0].Value +(13 - 2));
  for(i = 0; i < 5; ++i) __LCD_SetPixl(Color[4]);
  __Point_SCR(11 -1, Title[8][1].Value +(13 - 2));
  for(i = 0; i < 5; ++i) __LCD_SetPixl(Color[4]);
  __Point_SCR(MAX_X+1, Title[8][0].Value +(13 - 2));
  for(i = 0; i < 5; ++i) __LCD_SetPixl(Color[4]);
  __Point_SCR(MAX_X+1, Title[8][1].Value +(13 - 2));
  for(i = 0; i < 5; ++i) __LCD_SetPixl(Color[4]);


    Tmp2= (((1024*100)/TempKp1)*Title[6][2].Value)/100;
    Tmp2 =(11 + 150)- Tmp2;

  if(Tmp2 > 11){
    for(i = Tmp2 - 2; i <= Tmp2 + 2; ++i){
      __Point_SCR(i, 13 -1);
      __LCD_SetPixl(Color[6]);
      __Point_SCR(i, (200 + 13)+1);
      __LCD_SetPixl(Color[6]);
    }
  }
  Tmp = 11 + Title[10][0].Value;
  for(i = Tmp - 2; i <= Tmp + 2; ++i){
    __Point_SCR(i, 13 -1);
    __LCD_SetPixl(Color[4]);
    __Point_SCR(i, (200 + 13)+1);
    __LCD_SetPixl(Color[4]);
  }
  Tmp = 11 + Title[10][1].Value;
  for(i = Tmp - 2; i <= Tmp + 2; ++i){
    __Point_SCR(i, 13 -1);
    __LCD_SetPixl(Color[4]);
    __Point_SCR(i, (200 + 13)+1);
    __LCD_SetPixl(Color[4]);
  }
}



void Update_View_Area(void)
{
  s16 i, j, k;
  {
    __Point_SCR(89, 0);
    for(j=0; j<12; ++j) __LCD_SetPixl(0x051F);
    __Point_SCR(90, 0);
    for(j=0; j<12; ++j) __LCD_SetPixl(0x051F);
    __Point_SCR(308, 0);
    for(j=0; j<12; ++j) __LCD_SetPixl(0x051F);
    __Point_SCR(309, 0);
    for(j=0; j<12; ++j) __LCD_SetPixl(0x051F);

    for(i=91; i<307; i+=8){
      for(j=0; j<8; ++j){
        __Point_SCR(i+j, 0);
        for(k=0; k<12; ++k){
          if((0x01 << k)& RULE_BASE[j]) __LCD_SetPixl(0x051F);
          else __LCD_SetPixl(0x0000);
        }
      }
    }
    __Point_SCR(307,0);
    for (i=0;i<12;i++) __LCD_SetPixl(0x0000);

    if ((FlagFrameMode ==1)&&((Title[6][0].Value)!=4)) {
      __Point_SCR(0 + 91 , 0);
      for(j=0;j<9;++j) __LCD_SetPixl(0xFFFF);
      __Point_SCR(15 + 91 + 200, 0);
      for(j=0;j<9;++j) __LCD_SetPixl(0xFFFF);
      for(i=0;i<216;++i){
        __Point_SCR(i + 91 , 0);
        __LCD_SetPixl(0xFFFF);
        __Point_SCR(i + 91 , 9);
        __LCD_SetPixl(0xFFFF);
      }

      if ((Options&1)>0) {
        if ((((Title[6][0].Value)==2)||((Title[6][0].Value)==3))&&(Title[6][1].Value < 10)){
          Print_Str(Title[7][3].XPOS, 0,Title[7][3].Color[Title[7][0].Value], 0,"T");
        }else{
          Print_Str(Title[7][3].XPOS, 0,0x0905, 0,"T");
        }
      }
    }
    else
    {
      __Point_SCR(0 + 91 + (Title[6][2].Value * 200)/3720, 0);
      for(j=0;j<9;++j) __LCD_SetPixl(0xFFFF);
      __Point_SCR(15 + 91 + (Title[6][2].Value * 200)/3720, 0);
      for(j=0;j<9;++j) __LCD_SetPixl(0xFFFF);
      for(i=0;i<16;++i){
        __Point_SCR(i + 91 +(Title[6][2].Value * 200)/3720, 0);
        __LCD_SetPixl(0xFFFF);
        __Point_SCR(i + 91 +(Title[6][2].Value * 200)/3720, 9);
        __LCD_SetPixl(0xFFFF);
      }
    }
    Title[6][3].Flag &= !0x02;
  }
}



void Clear_Meter_Area(void)
{
  s16 i, j;
  {
    for(j=312;j<400;++j){
      for(i=11;i<216;++i){
        __Point_SCR(j , i);
        __LCD_SetPixl(0x0000);
      }
    }
    Title[6][3].Flag &= !0x02;
  }
}




void Draw_Row_XY(u16 Row)
{
  __Row_DMA_Ready();
  __Point_SCR(Row, 13);

  u16 h;
  u16 TempY;
  u16 TempX;
  u8 i;


  if(Row & 1){

    __Row_Copy(Base2Buffer, LCD_Buffer[0]);




       if((Row == 260)||(Row+1 == MAX_X)) for(i=0;i<201;i++)LCD_Buffer[1][i]=0xA534;
    else if(Row == 11) for(i=0;i<201;i++)LCD_Buffer[1][i]=0xA534;

    else if(((Row+1 - 11)%25 == 0)&& (Row<260)) Base4(1);
    else if(((Row+1 - 11)%5 == 0)&& (Row<260)) __Row_Copy(Base3Buffer, LCD_Buffer[1]);
    else if (Row != 260) __Row_Copy(Base2Buffer, LCD_Buffer[1]);
  for(h = 0; h <= 255; ++h)
  {
     TempX=(TrackBuff[(h*4)])+OffsetX-114;
     TempY=TrackBuff[(h*4)+1]+OffsetY-100;

     if ((TempY>0) && (TempY<200) && (TempX>(51)) && (TempX<220)){

           if(TempX==Row){
             LCD_Buffer[1][TempY] |= Color[3];
        }
     }

         if (h== OffsetY)
         {
           if (Row>5)
            {
              if ((Row<((OffsetX)+5)) && (Row>((OffsetX)-5))){
              LCD_Buffer[1][h] |= Color[2];
            }
           }
         }

         if ((Row==OffsetX))
         {
           if (h>5)
            {
              if ((h<OffsetY+5) && (h>OffsetY-5)){
              LCD_Buffer[1][h] |= Color[2];
            }
           }
         }
 }

    __LCD_Copy(LCD_Buffer[1], 200 +1);
  } else {

      if((Row == 260)||(Row+1 == MAX_X)) for(i=0;i<201;i++)LCD_Buffer[0][i]=0xA534;
    else if(Row == 11) for(i=0;i<201;i++)LCD_Buffer[0][i]=0xA534;

    else if(((Row+1 - 11)%25 == 0)&& (Row<260)) Base4(0);
    else if(((Row+1 - 11)%5 == 0)&& (Row<260)) __Row_Copy(Base3Buffer, LCD_Buffer[0]);
    else if (Row != 260) __Row_Copy(Base2Buffer, LCD_Buffer[0]);


   for(h = 0; h <= 255; ++h){

     TempX=(TrackBuff[(h*4)])+OffsetX-114;
     TempY=TrackBuff[(h*4)+1]+OffsetY-100;

     if ((TempY>0) && (TempY<200) && (TempX>51) && (TempX<220)){

           if(TempX==Row){
             LCD_Buffer[0][TempY] |= Color[3];
        }
     }

   if (h== OffsetY)
         {
           if (Row>5)
            {
              if ((Row<((OffsetX)+5)) && (Row>((OffsetX)-5))){
              LCD_Buffer[0][h] |= Color[2];
            }
           }
         }

         if ((Row==OffsetX))
         {
           if (h>5)
            {
              if ((h<OffsetY+5) && (h>OffsetY-5)){
              LCD_Buffer[0][h] |= Color[2];
            }
           }
         }
  }

    __LCD_Copy(LCD_Buffer[0], 200 +1);
  }
}


void DisplayDbScale(u16 Row, u8 buffer){
u8 i;
char Nfreq[6];
char Nsuffix[3];
       for(i=0;i<5;i++)Nfreq[i]=NFreqStr[i]; Nfreq[5]=0;
       for(i=0;i<2;i++)Nsuffix[i]=NFreqStr[i+5]; Nsuffix[2]=0;





         Print_Str_Row(Row, LCD_Buffer[buffer], 269,189, COLOR_INDEX, 1, "db" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 288,189, COLOR_INDEX, 1, "+3" );

  Print_Str_Row(Row, LCD_Buffer[buffer], 296,170, COLOR_INDEX, 1, "0" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 288,145, COLOR_INDEX, 1, "-2" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 288,120, COLOR_INDEX, 1, "-4" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 288,95, COLOR_INDEX, 1, "-7" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 284,70, COLOR_INDEX, 1, "-10" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 284,45, COLOR_INDEX, 1, "-14" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 284,20, COLOR_INDEX, 1, "-20" );

  Print_Str_Row(Row, LCD_Buffer[buffer], 280, 1, COLOR_INDEX, 1, Nsuffix);
  Print_Str_Row(Row, LCD_Buffer[buffer], 268,10, COLOR_INDEX, 1, Nfreq);

}

void DisplayFFtValues(u16 Row,u8 buffer){

  if ( PeakFreq>5){

   if ( RowMemPeak < 15)RowMemPeak = 15;
   if ( RowMemPeak > 253)RowMemPeak = 253;
   if (PeakFreq+14 > 178) {
    Print_Str_Row(Row, LCD_Buffer[buffer], RowMemPeak+2, 178, COLOR_INDEX, 1, PeakFreqStr);
   } else {
    Print_Str_Row(Row, LCD_Buffer[buffer], RowMemPeak+2, PeakFreq+14, COLOR_INDEX, 1, PeakFreqStr);
   }

  }
  Print_Str_Row(Row, LCD_Buffer[buffer], 21, 189, COLOR_INDEX, 1, "Div:" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 53,189, COLOR_INDEX, 1, FreqDivStr);
  Print_Str_Row(Row, LCD_Buffer[buffer], 124,189, COLOR_INDEX, 1, "T1:" );
  Print_Str_Row(Row, LCD_Buffer[buffer], 148,189,COLOR_INDEX, 1, FreqT1Str);
  Print_Str_Row(Row, LCD_Buffer[buffer], 218,189,COLOR_INDEX, 1, "V2:");

                if(Title[8][1].Value<165)
    Print_Str_Row(Row, LCD_Buffer[buffer], 242,189,COLOR_INDEX, 1, "-");
                else if(Title[8][1].Value>175)
    Print_Str_Row(Row, LCD_Buffer[buffer], 242,189,COLOR_INDEX, 1, "+");
                else
    Print_Str_Row(Row, LCD_Buffer[buffer], 242,189,COLOR_INDEX, 1, " ");

                u8ToDec2(DbScaleStr,DbScale[Title[8][1].Value]);
  Print_Str_Row(Row, LCD_Buffer[buffer], 250,189,COLOR_INDEX, 1, DbScaleStr);

}
# 1347 "Draw.c"
void Print_Str_Row(u16 Row, u16* LCD_Buffer, u16 x0, u16 y0, u16 Type, u8 Mode, char *s)
{
 signed short i, y, b;
 u16 char_width, w = x0;

 while(*s != 0) {
  if ((*s) == 0x21) {
   char_width = 8/2;
  } else {
   char_width = 8;
  }
  if ((Row >= w) && (Row < (w + char_width))) {
   i = Row - w;
   if (i < 0) {
    b = 0x0000;
   } else {

                                if(*s==0x20) b = 0x0000; else b = Get_TAB_8x11(*s, i);
   }
   for (y = 0; y < 11; y++) {
    if((b << y)& 0x400) {
     if(Mode == 0) {
      LCD_Buffer[y0 + y] = Color[Type >> 0x8];
     } else {
      LCD_Buffer[y0 + y] = Color[Type & 0x0F];
     }
    } else {
     if(Mode == 0) {
      LCD_Buffer[y0 + y] = Color[Type & 0x0F];
     } else {
      LCD_Buffer[y0 + y] = Color[Type >> 0x8];
     }
    }
   }
   break;
  }

  w += char_width;
  s++;
 }
}

void DrawRowSpec(u16 Row){
 u8 i;
 int val= 0;
 __Row_DMA_Ready();
 __Point_SCR(Row, 13);

    if((Title[6][0].Value)!=5){
      if ((Title[3][0].Value==11) || (Title[3][0].Value==10)) {
           for (i=0 +1; i<200; i++) {
      val = fr[i-0];
     if (val >= 200) val = 199;
     LCD_Buffer[Row & 1][i] = colors[val];
             }
      }

    }
    __LCD_Copy(LCD_Buffer[Row & 1], 200 +1);

}

void Base4(u8 buffer){
u8 i;
      for(i=0;i<201;i++)LCD_Buffer[buffer][i]=0x0000;
      for(i=0;i<201;i+=5)LCD_Buffer[buffer][i]=0xA534;
}


void LoadBase3Buffer(void){
u8 i;
      for(i=0;i<201;i++)Base3Buffer[i]=0x0000;
      for(i=0;i<201;i+=25)Base3Buffer[i]=0xA534;
}

void LoadBase2Buffer(void){
u8 i;
      for(i=1;i<200;i++)Base2Buffer[i]=0x0000;
      Base2Buffer[0]=0xA534;
      Base2Buffer[200]=0xA534;
}

void TraceShadow(u8 start,u8 limit,u8 buffer){
u8 i;
  if(limit>199)limit=199;
  for(i=start;i<limit;i++)LCD_Buffer[buffer][i] = 0x0000;
}
