	/********************* (C) COPYRIGHT 2010 e-Design Co.,Ltd. ********************
 File Name : Main.c  
 Version   : DS203_APP Ver 2.5x                                  Author : bure
*******************************************************************************/
#include "Interrupt.h"
#include "Function.h"
#include "Calibrat.h"
#include "Process.h"
//#include "Ident.h"
#include "Draw.h"
#include "BIOS.h"
#include "Menu.h"
#include "File.h"

/*******************************************************************************
Version changes
APP V2.30: since this version no longer to compatible PCB_V2.6 the following version of the motherboard
           Since this version is no longer compatible SYS_V1.31 the following version
           Sleep timing was revised to 600 seconds (Main.c)
           Modify, and add a new SYS library functions (BIOS.s)
           Modify the boot information display program (Main.c)
APP V2.31: an increase of boot identify FPGA load configuration completion discriminant (Main.c)
           Increase the Licence rights management functionality Demo program example (Ident.c, Main.c),,
           Modified analog channel correction function entry and exit operations (calibrat.c)
           Increase the the 144MHz alternately sampling mode function (Process.c)
APP V2.32 from the version from the IAR 4.42 and version 5.0 can be used in parallel
           Source did not change, the increase of the folder IAR_V5_Prpject
APP V2.33 modified scan <1uS, display the refresh BUG (Process.c,)
           Modified in the calibration state, the operation message BUG (Calibrat.c)
APP V2.34 changed by channel separate calibration (Calibrat.c & Main.c,)
           Modify the calibration mode of operation (option Calibrat.c)
APP V2.35 modified in the calibration process BUG (Calibrat.c),
           Modified, <5uS scan, the suspension can not BUG (Process.c)
           To optimize the display data handler (Process.c)
           Increase of the analog channel automatic zero balance function (Main.c, Process.c, Calibrat.c)
APP V2.36 part of the calibration operation into automatic mode (Calibrat.c, Process.c, Function.c)
           Modify the boot loader to the operating parameters (Main.c)
APP V2.37 to further improve and optimize the display data handler (Process.c)
           Modify the 32-bit signed and unsigned integer conversion process rounded BUG (Function.c,)
           Increase the pulse width duty cycle of the time and frequency measurement function (Process.c, Menu.c)
APP V2.40 increase write U disk to create the file function (Main.c, and Flies.c dosfs.c)
           Modify the save file number is displayed when BUG (Menu.c)
APP V2.41 increase the file format for the BUF's read / write sample buffer data files (Main.c, Flies.c, Menu.c)
           Increased the file format for the CSV export sample buffer data files (Main.c Flies.c, Menu.c)
APP V2.42 for space-saving file system to SYS_V1.40 module (ASM.s, Flies.c, dosfs.c)
    	       Changed use "SerialNo.WPT" file is stored parameter table (Flies.c)
           Note: the APP V2.42 or later must be used in conjunction with the SYS V1.40 or later
APP V2.43 modify the adjustment of the analog channels stalls BUG (Main.c),
APP V2.44 modified to save the parameters in the calibration operation BUG (Calibrat.c),
           Increase the power load parameters, the success of Tips (Main.c)
APP V2.45 modified to read and write BUF file recovery Display the corresponding menu BUG (Files.c)
           Delete the read test information when the BUF file feedback (Main.c)
APP V2.50 rewrite based on the new FAT12 file system, file read and write procedures (Files.c, ASM.s)
           Changes to TH, TL measurements the display BUG (Menu.c,)
           Optimized with dimensionless values ??show the correlation function (Menu.c Function.c, Calibrat.c)
           Modify the pulse width trigger the BUG (Process.c)
APP V2.51 modify Vmin and Vmax, Vpp measured BUG (Process.c)
*******************************************************************************/

#define APP_VERSION       "GCCv1.7W3.1  APP(2.51+SmTech1.8+PMOS69 fixes)"
#define APP_REVISION      "         Revision(W3.1) by Wildcat           "

   
#define LINE0  "                                                  "
#define LINE2  "!PRESS    >    !#!    !$!     !]!    < O >    < O >  !"
#define LINE3  "!                                < ADJ > !< MENU > "
//#define LINE4  "                                                  "  //use line0
#define LINE5  "!SHORT> !HOLD! AUTO METERS SELECT SET TRG  !BUFFER  "
#define LINE6  "       !reset TRIG sav/ld  ITEM  CHANNEL          !"
#define LINE7  "                 !(config)!                        "
#define LINE8  "       !CH on!                                     "
#define LINE9  " LONG!> V/DIV !MAN  STAND! T-BASE MTR PGE !MENU/MTR "       
#define LINE10 "       !short TRIG   BY   !short    (w/mtrs! on)!   "
#define LINE11 "        !cut               !cut  !WAV CAL STDBY TIM!"      
#define LINE12 "                                  !(w/mtrs !off)   "
#define LINE13 "                         !METERS!                  "
#define LINE14 " HOLD!> CHART !CAL!  SAVE  CURSOR TRIGGER   !HOLD   "    
#define LINE15 "                  !config RSTRCT HOLDOFF  MIN/MAX! "
//#define LINE16 "                                                  "//use line0

typedef struct {char*ChartLine;}DisplayLine;
DisplayLine DisplayChart[16]= {{(char*)LINE0},{(char*)LINE2},{(char*)LINE3},{(char*)LINE0},{(char*)LINE5},{(char*)LINE6},
                              {(char*)LINE7},{(char*)LINE8},{(char*)LINE9},{(char*)LINE10},{(char*)LINE11},{(char*)LINE12}, 
                              {(char*)LINE13},{(char*)LINE14},{(char*)LINE15},{(char*)LINE0}};

//uc8 PROJECT_STR[20] = "Demo PROG. Ver 1.00";
u8 OldCurrent;
u8 OldDet;
u8 OldMode;
u16 OldPosi=0;
u8 FlagFrameMode;
u8 OldFrame;
u8 FlagMeter;
u8 TrgAuto;
u16 OldPosX;
u16 OldPosY;
s16 PreviousTrigSelect[4];
u8  LastSelected=0;
u8  XposFlag=0;
u8  C_Dmeter[8]={4,8,9,10,11,4,10,11};
u8  UpdateMeter=4;
u8  Timeout=1;
extern u8 _vectors[];
u8  ShortBuffXpos;
u32 Tmp;
u8  SelectiveUpdate=0;
u8  UpdateFlag=0;
u8  BTwinkState=0;
u8  SaveCurrent[2]={0,0};
u8  ChStatus[4]={0,0,0,0};
u8  ABTrigStatus=0;
u8  ChOnStatus[2]={1,1};

u8 OldMeter;
u8 TrgAutoOld;
u16 OldTrack1X;
u16 OldTrack2X;
s16 _Vt1Old;
s16 _Vt2Old;
u16 XposRef;		//Xpos compensated for interpolated ranges to show equivalent screen position
u8  UpdateCount=0;
u8 ShowFFT=0;

void UpdateBigMeters(void);
void EnableTitleMeters(u8 Service);
void ClearBigMeter1(void);
void UpdateMeterPage(void);
u8 ConfigFile(u8 service);
void FileMessage(u8 i);
u16 GetXposRef(u16 XPos);
u16 GetXpos(u16 XposRef);
u16 GetHoldoffIndPos(void);
void EnableChannel(u8 track);
void UpdateTriggerMem(void);

typedef struct {char*Message;}SelectMessage; 
u8 MessageNumber;

#define SAVESET       "       SAVE SETTINGS       "   //0
#define WAVCAL_ON     "   WAVE CALIBRATION - ON   "   //1
#define WAVCAL_OFF    "   WAVE CALIBRATION - OFF  "   //2
#define STDBYTIM_ON   "    STANDBY TIMER - ON     "   //3
#define STDBYTIM_OFF  "    STANDBY TIMER - OFF    "   //4
#define CURMETERS_ON  " CURSOR SELECT METERS - ON "   //5
#define CURMETERS_OFF " CURSOR SELECT METERS - OFF"   //6
#define TRGHLD_ON     "   TRIGGER HOLDOFF  - ON   "   //7
#define TRGHLD_OFF    "   TRIGGER HOLDOFF  - OFF  "   //8	
#define SHOWEDGE_ON   "      MIN/MAX HOLD ON      "   //9  
#define SHOWEDGE_OFF  "      MIN/MAX HOLD OFF     "   //10   
#define WAIT_RESET    "    WAITING FOR RESET...   "   //11  

//#define SHOWEDGE_ON   "      EDGE FILTER OFF      "   //9  
//#define SHOWEDGE_OFF  "      EDGE FILTER  ON      "   //10   

SelectMessage Show[12]= {{(char*)SAVESET},{(char*)WAVCAL_ON},{(char*)WAVCAL_OFF},{(char*)STDBYTIM_ON},{(char*)STDBYTIM_OFF},{
                              (char*)CURMETERS_ON},{(char*)CURMETERS_OFF},{(char*)TRGHLD_ON},{(char*)TRGHLD_OFF},{
                              (char*)SHOWEDGE_ON},{(char*)SHOWEDGE_OFF},{(char*)WAIT_RESET}};

uc16 TrigReset[27]=   {300, 150, 100, 75, 35, 15, 10, 10, 5, 3,   	//for auto trig mode, set time to reset after loosing data		
                        2,      2,   2,   2,  2,  2,  2, 2, 2, 2,    			
                        2,      2,   2,   2,  2,  2,  2 };

uc16 NoteTimer[3]=    {250, 125, 50};                			//*20ms 

/*******************************************************************************
  main : Main routine.
*******************************************************************************/
int main(void)
{ 
  s32 i;
  u16 Count_FPS = 0, Second = 0;//,Offset, Result 
  u8 j;
  u8 k;
  s16 TmpVT;
  s16 Vt1Old=0;
  s16 Vt2Old=0;
  //u16 _Vt1Old=0;	//now externs
  //u16 _Vt2Old=0;
  u16 loopcount=0;
  u8  CounterUpdate;

  NVIC_SetVectorTable(NVIC_VectTab_FLASH, (u32)&_vectors);
  
  __USB_Init();
  
  if(__Get(FPGA_OK)== 0){
    __Display_Str(6*8, 30, YEL, PRN, "      FPGA configuration error       ");
    while (1){};
  }
  
  __Display_Str(32, 50, WHT, PRN, APP_VERSION);
  __Display_Str(32, 110, WHT, PRN, APP_REVISION);
  Y_Attr = (Y_attr*)__Get(VERTICAL);     
  X_Attr = (X_attr*)__Get(HORIZONTAL);
  G_Attr = (G_attr*)__Get(GLOBAL);
  T_Attr = (T_attr*)__Get(TRIGGER);
  Load_Attr();                                 // assignment Y_Attr
  i = Load_Param(0); 
  if(i == 0)  // read the default boot parameters
    __Display_Str(6*8, 30, GRN, PRN, "     Reload parameter from disk       ");
  else       
    __Display_Str(6*8, 30, YEL, PRN, "     Parameter record not found       ");  
  
  Beep_mS = 500;
  Delayms(2000); 
  App_init();
  Key_Buffer=0;
  Config_init();
  OldMode=_Mode;
  Update=2;			//=2 initiates delayed trig loop to prevent locking up with no trigger and empty buffer
  Title[FILE][0].Value=LOAD;    //preset file menu to load config files
  Title[FILE][1].Value=0;       //config file number (0=boot file)
  Title[FILE][2].Value=CFG;
  LoadBase3Buffer();
  LoadBase2Buffer();

//-------------------------------------------------------------------------- ************** LOOP MAIN *****************
  while (1){
  
//-------------------------------------------------------------------------- Gestione Entra e Uscita da Modalit X Y
    if (_Mode!=OldMode)
    {
      if (_Mode ==X_Y ){       // entra in XY_S 
       BackGround_Reset();
        if (OldMode<5){        //4
          OldTrack1X=Title[TRACK1][POSI].Value;
          OldTrack2X=Title[TRACK2][POSI].Value;
        }
        Title[TRACK1][POSI].Value=100;			// ? gets reset below...
        Title[TRACK2][POSI].Value=100;
        OffsetX=135;
        OffsetY=100;
        OldMeter=FlagMeter;
        if (FlagMeter==0) {EnableMeter();UpdateMeterPage();}
        _Vt1Old=_Vt1;
        _Vt2Old=_Vt2;
	  Vt1Old=0;
	  Vt2Old=0;
        TrgAutoOld=TrgAuto;
        TrgAuto=2;
      }
     
      if ((_Mode<5) &&(OldMode>4)){     // esce da XY_S o XY_A
        Title[TRACK1][POSI].Value = OldTrack1X;
        Title[TRACK2][POSI].Value = OldTrack2X;
        BackGround_Reset();
        if (OldMeter==0)  DisableMeter();
        if (OldMode==X_Y){       // se era in XY_S ripristina il trigger
        _Vt1=_Vt1Old;
        _Vt2=_Vt2Old;
        TrgAuto=TrgAutoOld;
        }
      }
    }
   
    if(Title[TRIGG][SOURCE].Value !=4) OldMode=_Mode;
    if (_Mode==X_Y)  Title[TRACK1][POSI].Value=101+MIN_Y;
    if (_Mode==X_Y)  Title[TRACK2][POSI].Value=100;

    if (_4_source>11)ShowFFT=1; else ShowFFT=0;

    //-------------------------------------------------------------------------- ********* LIFE *************    
    if (((__Get(USB_POWER)>0)||(Timeout==0))&&(PD_Cnt>0)) PD_Cnt = 600;	  //don't time out into standby on external power or if timeout is disabled and not already in standby
    if(PD_Cnt == 0){               
      __Set(BACKLIGHT, 0);                    // turn off the backlight
      __Set(STANDBY, EN);                     // enter low power states
    } else {

        if((Update)&&(_Mode!=SCAN)){
          _X_posi.Value=GetXpos(XposRef);     //align interpolated time bases with the others
	}

        if (SelectiveUpdate&1){		      // restore screen after removing chart
          if (_Mode==X_Y){
            for (i=0;i<400;i++){	      // clear top line	
              __Point_SCR(i,214);
              __LCD_SetPixl(Color[SCRN]);
            }
          } 
          for (i=0;i<11;i++){		      // clear left mark area 
            __Point_SCR(i,12);
            for (j=12;j<214;j++){
              __LCD_SetPixl(Color[SCRN]);
            }                
          }  
        }  

      Synchro();                              // simultaneous display of waveform data of each track

    if ((TrgAuto>0)&&(_Mode!=SCAN)&&(_Mode!=AUTO)&&(_Mode!=SGL)){  
      if(__Get(FIFO_START)== 0){			           //check to see if not triggered w/auto trig on
        loopcount++;							
        if (loopcount>TrigReset[_T_base]){			   //after proper wait time, re-initialize trig	
          if(Title[TRIGG][SOURCE].Value==4){			   //in A&B mode, reset only non triggered ch
            if(TrigSourceEnable==0)_Vt2=_2_posi;		   //alternate channel function call at end of synchro has shifted over to
            if(TrigSourceEnable==1)_Vt1=_1_posi;		   //other ch if one ch is not triggered so need to reset alternate ch
            Update_Trig(0);
          }else{                                   
            _Vt1=_1_posi;			                   // set trig at signal zero point in hope to get device to trigger
            _Vt2=_2_posi;
            Update_Trig(1);
          }
          if (_Mode!=X_Y) Update_Mark();
          loopcount=0;
        }
      }else{								//if triggered
        if(Title[TRIGG][SOURCE].Value==4){				//in A&B mode
          if(TrigSourceEnable==0)ABTrigStatus|=1;			//ch A is triggered
          if(TrigSourceEnable==1)ABTrigStatus|=2;			//ch B is triggered
          if(ABTrigStatus==3) {loopcount=0;ABTrigStatus=0;}		//if both ch are triggered, reset count and trigger status
        }else loopcount=0;	
      }				//if get fifo start else...
    }else loopcount=0;		//if trgauto>...

      if (TimedDeltaView>0){						
        Title[T_VERNIE][2].Flag |= UPDAT; 				
        _D_V_Source.Flag |= UPDAT;            // Updat delta V 
        _Delta_V.Flag    |= UPDAT; 
        _Delta_T.Flag    |= UPDAT;            // Updat delta T 
      } 

      Count_FPS++;			
      if(Second != Sec_Cnt) {
        Second = Sec_Cnt;
        Result_FPS = Count_FPS;
        Count_FPS = 0;
        if((__Get(V_BATTERY)>(PrevBatLevel+20))||(__Get(V_BATTERY)<(PrevBatLevel-20))){	//update with greater than 20Mv change
          BatLevelCompensation(); 
          PrevBatLevel=__Get(V_BATTERY);
          SetOffset(0,_A_Range,_1_posi);				//provides update for Ka3
          SetOffset(1,_B_Range,_2_posi);
        } 
        Update_Battery();
        if (FlagMeter==1) {						// refresh the measured values ??per second
          EnablePaS=1;
          for(i=0; i<9; ++i)  Display_Value(i);
          if((__Get(FIFO_START)!=0)||(_Mode!=NORH)){			//hold reset to show meter values when in normal mode not triggered
            if(_T_base > 10)ResetSum();else SumResetFlag=1;		//in slow mode wait until frame is completed before resetting
          }
        }							
        if (FlagMeter==0)ResetSum();						//also reset vars with no meter on
      }

        if (((Cnt_20mS%16)>7)&&((Cnt_20mS%16)<16)&&(UpdateFlag==1))UpdateFlag=0;
        if (((Cnt_20mS%16)>=0)&&((Cnt_20mS%16)<8)&&(UpdateFlag==0)){    //update meters %16= 3 times/sec %24= 2 times/sec  %12= 4 times/sec
            UpdateFlag=1;						      //note that big meter highlight blink rate is tied to update speed	
          if(UpdateCount==2){
            EnablePaS=1;						//enables TH, TL and duty% to update 1/sec
            UpdateCount=0;
          }else{
            EnablePaS=0;
            UpdateCount++;
          }
            UpdateBigMeters(); 	
            if (FlagMeter==2){
              if((__Get(FIFO_START)!=0)||(_Mode!=NORH)){
                if(_T_base > 10)ResetSum();else SumResetFlag=1;
              }
            }
         }
        
      if (FlagMeter>0){
        Display_Meter();
      }
      if ((FlagMeter==2)&&(UpdateMeter==4)){			     //here this is done every loop, may want to move in above countdown
        FlagMeter=1;  		       //display value on small meter
        Display_Value(0);
        FlagMeter=2;                   //return
      } 
      Display_Title();
							    //1-Twink, INV, OR PRN
    if((Current != FILE)&&(NotificationTimer>4))Print_Str(91,0,0x0405,PRN,Show[MessageNumber].Message);           //show message
    if((Current != FILE)&&(NotificationTimer>0)&&(NotificationTimer<5)) {Update_View_Area(); NotificationTimer=0;}    //end after delay

      if(Update){                             // handle button to refresh item
	if ((SelectiveUpdate&1)&&(FlagMeter>0))EnableMeter();     
	if (TrgAuto==0)  Print_Str(365,  216, ((SCRN<<8)+Title[TRIGG][SOURCE].Value), PRN, "!Man!");
        if (TrgAuto==1)  Print_Str(365,  216, ((SCRN<<8)+Title[TRIGG][SOURCE].Value), INV, "!1/4!");
        if (TrgAuto==2)  Print_Str(365,  216, ((SCRN<<8)+Title[TRIGG][SOURCE].Value), INV, "!1/2!");
        if (TrgAuto==3)  Print_Str(365,  216, ((SCRN<<8)+Title[TRIGG][SOURCE].Value), INV, "!3/4!");
        if ((SelectiveUpdate & 0x02)==0)Update_Range();		//these 4 are exclusions, bit set prevents update
        if ((SelectiveUpdate & 0x04)==0)Update_Base();
        if ((SelectiveUpdate & 0x08)==0)Update_Output();
        if ((SelectiveUpdate & 0x10)==0){if(Title[TRIGG][SOURCE].Value==4) Update_Trig(0); else Update_Trig(1);}
        if ((_Mode!=X_Y)&&(!((_4_source==SPEC_A)||(_4_source==SPEC_B)))) Update_Mark();
        __Set(BACKLIGHT, 10*(Title[BK_LIGHT][CLASS].Value+1));

	if (SelectiveUpdate & 0x20){
          ClearHoldFlag|=1;						//transfer clear hold calls as selectiveupdate gets reset 
          if(_T_base<11)SlowModeSkip=2;				//slowmodeskip allows x frames to finish to properly update buffer
        }
	if (SelectiveUpdate & 0x40){
          ClearHoldFlag|=2;
          if(_T_base<11)SlowModeSkip=2;
        }		

	if (Current<4)Title[Current][3].Flag|= UPDAT;
        if((Current == TRIGG) && (_Det==3)){
         if ((FrameMode==0)||((Options&1)==0)||(_Mode==AUTO)||(_Mode==X_Y)||(_Mode==SGL)||(_Mode==SCAN)||(_T_base>9)) _Det=0; 
         Title[Current][_Det].Flag |= UPDAT;
        }
											
        if((Current != FILE)&&(NotificationTimer<43))   Update_View_Area();	//after 3/4 second, allow notification overwrite if button pushed														
		if (FlagMeter>0) {
			_D_V_Source.Flag |= UPDAT;            // Updat delta V 
			_Delta_V.Flag    |= UPDAT; 
			_Delta_T.Flag    |= UPDAT;            // Updat delta T 
		}else{
              if ((Current == V_VERNIE)&&(_Det == 2)) _Det=0;
            }
 
        if (FrameMode==2) SaveShortBuffXpos=XposRef;								//save trig cursor in config file  
        Update = 0;                           // Update finish
	SelectiveUpdate=0;
      }

    }//else, if power down


    if((_State.Value == HOLD)&&((__Get(FIFO_FULL)!= 0)||(__Get(FIFO_START)== 0))){
      _State.Value = 2; 
      _State.Flag |= UPDAT;
    }
   
    //--------------------------------------------------------------------------  TRIGGER AUTOMATICO 
    if  ((TrgAuto>0)&&(_Mode!=SCAN)){                                                                   

      if((Current == TRIGG) && (_Det==2)){
        if (((_Mode==NORH)||(_Mode==NORC))&&(_T_base < 10)&&(Options&1)) _Det=3; else _Det=0;
        Title[Current][_Det].Flag |= UPDAT;  
      }

      if ((Title[TRIGG][SOURCE].Value == TRACK1)||((Title[TRIGG][SOURCE].Value==4)&&(TrigSourceEnable==0))){
        TmpVT=aT_Min+Ka1[_A_Range]+((aT_Max-aT_Min)*(TrgAuto*2)/8);
        if ((TmpVT>Vt1Old +5) || (TmpVT<Vt1Old -5)){
          _Vt1=TmpVT;
          if(Title[TRIGG][SOURCE].Value==4) Update_Trig(0); else Update_Trig(1);
          if (_Mode!=X_Y) Update_Mark();
          Vt1Old=_Vt1;
        } 
      }
      if ((Title[TRIGG][SOURCE].Value == TRACK2)||((Title[TRIGG][SOURCE].Value==4)&&(TrigSourceEnable==1))){
        TmpVT=bT_Min+Kb1[_B_Range]+((bT_Max-bT_Min)*(TrgAuto*2)/8);
        if ((TmpVT>Vt2Old +5) || (TmpVT<Vt2Old -5)){
          _Vt2=TmpVT;
          if(Title[TRIGG][SOURCE].Value==4) Update_Trig(0); else Update_Trig(1);
          if (_Mode!=X_Y) Update_Mark();
          Vt2Old=_Vt2;
        } 
      }
    }
    //--------------------------------------------------------------------------  FRAME MODE
    
    if (FlagFrameMode==1){										//short buffer mode
          if (_Mode==SCAN) {
              if (_T_base>9) _X_posi.Value=150; else _X_posi.Value=0;                             
              FrameMode=1;
          } 
          else 
          {
		 if (_Mode!=SGL){
  		    Tmp= 150-(((1024 - X_Attr[Title[T_BASE][BASE].Value].KP)*150 + 512)/1024); 
		    if (_X_posi.Value>Tmp) {
			 _X_posi.Value=Tmp;  //allow xpos to shift to left of screen in short buffer mode, add this to buffer size
		       XposRef=GetXposRef(Tmp);
			 Update=1;
		    }
		    ShortBuffXpos=XposRef;	
		 }
             FrameMode=2; 	
          }
    }
    else   													//if in long buffer mode
    {														// shift trigger "splice" to left of screen
      if ((_Mode==SCAN)&&(_T_base>9)){				
          if (XposFlag==0){					//if flag set and in fast scan modes do nothing after going once in block and setting xpos to 150
            _X_posi.Value=150;									
            Update=1;										
            XposFlag=1;
          }                                                         
      }else if (XposFlag==1){			            //with flag set and all modes but scan with faster time bases            
              if (_Mode==SCAN)_X_posi.Value=0;		//don't reset xpos if not in scan mode
              XposFlag=0;					
              Update = 1;
            }else if (_Mode==SCAN){				//if flag not set, after going into above and setting flag
              if (_X_posi.Value>0){				//will drop in here as long as in scan mode with slower time base
              _X_posi.Value=0;				//make sure xpos is at zero and update if it's not after setting it to 0
              Update = 1;
            }
      }
      FrameMode=0;
    }

   //--------------------------------------------------------------------------  GESTIONE TASTI MENU	
    if(Key_Buffer) { 
      if(PD_Cnt == 0) {
	   App_init();          // exit the power saving state
         Key_Buffer=0;		// don't execute any functions when just getting device out of standby with any key press
      }

      PD_Cnt = 600;                         // 600 seconds
	  //--------------------------------------------------------------------------------------------------------------

	   for (i=0;i<4;i++){						//clear memorized trigger settings of ch if ch is turned off
 	     if (Title[i][SOURCE].Value == HIDE){			
		 if (PreviousTrigSelect[0]==i)PreviousTrigSelect[0]=0;  //PreviousTrigSelect[3] is last in, first out
         	 for (j=1;j<4;j++){										
		   if (PreviousTrigSelect[j]==i) for (k=j;k>0;k--) PreviousTrigSelect[k]=PreviousTrigSelect[k-1];
	       }
	     }
	   }
	//---------------------------------------------------------------------------------------------------------------------


      if(Key_Buffer == KEY1){

      Delay_Cnt = 1500;
    while (Delay_Cnt > 1000)
    {
       if((__Get(KEY_STATUS)& KEY1_STATUS)!=0){

        _State.Flag |= UPDAT;                          						// set the corresponding update flag
        if((Current == FILE)&&(_Curr[2].Value == BUF)) reset_parameter();

        if(_State.Value==0){									//0=run 1=hold also has 2
          _State.Value=1;  
        }else{
          _State.Value=0;
          SelectiveUpdate |=0x60;								   			
          if(_Mode!=NORH)ClearTrackBuff(1);		//REMOVING NORH CONDITION WOULD CLEAR WAVE ALONG WITH METERS...
          if((_Mode == SGL)||(_Mode==NORH)||(Options&4)||((FrameMode>0)&&(_T_base<3))||((FrameMode==0)&&(_T_base<6))){    //in run mode if frame >1 1/2 sec
            __Set(FIFO_CLR, W_PTR);
            if(Options&4) {ClearHold(3);ClearMinMax(3);}
            cleardatabuf((A_Posi+ADCoffset),(B_Posi+ADCoffset),get_bag_max_buf(),2);
            if(_T_base<11)JumpCnt=0;				
            ResetSum();
            EnablePaS=1;
         }
          if(_T_base<3){
            MessageNumber=11;		      			//wait for reset	
            NotificationTimer=NoteTimer[_T_base];              
          }
        }
        break;
      }				//if get key status
    }				//while

      while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){					// long press
	 if((__Get(KEY_STATUS)& KEY1_STATUS)!=0){

	 _Curr[_Det].Flag |= UPDAT;

	 switch (Current){	
	   case TRACK1:
             if (_Det==RANGE){
               if(_1_source==0){_1_source=ChOnStatus[0]; LastSelected=1;} else {ChOnStatus[0]=_1_source; _1_source=0;}
             }else{
               if(Title[TRACK4][SOURCE].Value<10)EnableChannel(TRACK1);		//if FFT on, do not turn channel trace on
	     }	
	     break;
	   case TRACK2:
             if (_Det==RANGE){
               if(_2_source==0){_2_source=ChOnStatus[1]; LastSelected=2;} else {ChOnStatus[1]=_2_source; _2_source=0;}
             }else{
                if(_4_source<10)EnableChannel(TRACK2);
	     }	
             break;
           default:
             if ((Title[TRACK1][SOURCE].Value != HIDE)&&(Title[TRACK2][SOURCE].Value == HIDE)){			//Cha A on B off
               Current = TRACK1;
	       LastSelected=1;
	     }else if ((Title[TRACK1][SOURCE].Value == HIDE)&&(Title[TRACK2][SOURCE].Value != HIDE)){		//Cha B on A off
               Current = TRACK2;
	       LastSelected=2;
	     }else if(_4_source<10){										//if FFT off												//both on or off
               switch (LastSelected){
	         case 0:
	         case 1:
                   Current = TRACK1;
                   EnableChannel(TRACK1);
                   break;
	         case 2:
                   Current = TRACK2;
                   EnableChannel(TRACK2);
               } 					//switch
             }else{											//FFT on, both tracks on or both off
               if(_4_source<14)Current=TRACK2;else Current=TRACK1;					//go to ch v/div but do not turn on	
             } 
           } //switch
           _Det = RANGE;

	 Title[TRACK1][SOURCE].Flag |= UPDAT;	
	 Title[TRACK2][SOURCE].Flag |= UPDAT;
         _Curr[_Det].Flag |= BLINK;
	 _Curr[_Det].Flag |= UPDAT;

         goto bypasslongpress1;
       }   				// if get key status

     }					//while delay count 0 to 1000

	  if(Delay_Cnt == 0){
             j=0; 
             for(i=204;i>38;i-=11){
                Print_Str(0,i,0x040C,PRN,DisplayChart[j++].ChartLine);
             }

	     Delayms(300);
	     Key_Buffer=0;

	    while (1) {
              if (Key_Buffer>0){
                SelectiveUpdate=1;
                break;
              } 
	    }
	  } 
       
     } 				//if key buffer
     bypasslongpress1:
      //--------------------------------------------------------------------------------------------------------------
      if(Key_Buffer== KEY2){                                                    // ===--- TASTO 2 PREMUTO ---===   
        Delay_Cnt = 3000;                                                       // Carica il temporizzatore del tasto permuto
        while (Delay_Cnt > 2500){                                                  // Se il tempo non  arrivato a 0
          if((__Get(KEY_STATUS)& KEY2_STATUS)!=0){                              // CAMBIO MODO TRIGGER
           if ((Title[TRIGG][SOURCE].Value != TRACK3)&&(Title[TRIGG][SOURCE].Value != TRACK4)){
        	_Curr[_Det].Flag |= UPDAT;
            if (TrgAuto==0){
		  TrgAuto=2;
		  Vt1Old=0;
		  Vt2Old=0;
		}else {
             TrgAuto++;					  // AUTO TRIGGER
             }          
            if (TrgAuto>3) {TrgAuto=1;}							  // short press
            Title[Current][_Det].Flag |= UPDAT;
            if ((Current == TRIGG) && (_Det==2)){ Title[Current][_Det].Flag |= UPDAT;_Det=0;}
           } 
            break;
          }//if get key
        }//while

	  while ((Delay_Cnt >0)&&(Delay_Cnt <=2500)){					// long press
          if((__Get(KEY_STATUS)& KEY2_STATUS)!=0){
           if ((Title[TRIGG][SOURCE].Value != TRACK3)&&(Title[TRIGG][SOURCE].Value != TRACK4)){
         	_Curr[_Det].Flag |= UPDAT;
		if (TrgAuto>0) TrgAuto=0;
		Current = TRIGG;
		_Det=2;
            Title[Current][_Det].Flag |= UPDAT;
           }
          break;
          }// if get key status
        } // while delay count
        if((Delay_Cnt == 0) && (Current<2) ){Calibrat(Current); goto BypassExclusions;}  // CALIBRAZIONE extra long press
      }
      //--------------------------------------------------------------------------------------------------------------     
      if(Key_Buffer== KEY3){                                                    // ===--- TASTO 3 PREMUTO --====

     if((Current!=FILE)||(_Curr[2].Value!=CFG)){
       Delay_Cnt = 1500;                                                       // Carica il temporizzatore del tasto permuto
       while (Delay_Cnt > 1000){                                                  //WAS >0           Se il tempo non  arrivato a 0
          if((__Get(KEY_STATUS)& KEY3_STATUS)!=0){ 
 
           if (FlagMeter==2) 			//if in big meters, shut off 
            {
              if (_Mode != X_Y){
                DisableMeter();
                if((_4_source==SPEC_A)||(_4_source==SPEC_B))Clear_Meter_Area();
              }else{				//toggle the 2 meters in xy mode, instead of shutting meters off
                FlagMeter=1;
                EnableMeter();
              }
              break;
           } 
            else
            {
              if (FlagMeter==1){		//if in small meters go to big meters
                if(Current > METER_3)Current=METER_3;
		if(UpdateMeter==4){
                  if(Current==METER_1)Current=METER_2;
                }else{
                  if(Current==METER_0)Current=METER_1;
                  if((Current < METER_0)&&(Current>T_VERNIE))Current=T_VERNIE;  //if not in meter item select mode
                }  
                FlagMeter=2;
              }
              TimedDeltaView=0;
              EnableMeter();			//if meters off, go to small meters
              break;       
            }
              
          } //if get key status
       } //while delay count

	    while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){					// long press

          if((__Get(KEY_STATUS)& KEY3_STATUS)!=0){

           Print_Str(119, 90, 0x0405, PRN,   "LONG PRESS - STANDBY");
           Delayms(1000);
           PD_Cnt = 0;               
           __Set(BACKLIGHT, 0);                    // turn off the backlight
           __Set(STANDBY, EN);                     // enter low power states
		
            goto bypasslongpress3;		
           }  //IF GET KEY STATUS
          }  // WHILE DELAY COUNT...
    
        if(Delay_Cnt == 0){			    //extra long press

            SaveCurrent[0]=Current;		      //save current menu item position
            SaveCurrent[1]=_Det; 
            Current=FILE;
            _Det=1;				      //select number	
            Title[FILE][0].Value=0;		      //save file
            Title[FILE][2].Value=4;		      //conf file
            _Curr[1].Value=ConfigFileNumber;            	            
            for(i=0;i<3;i++)Title[FILE][i].Flag|=UPDAT;

        } 
      }else{					      //Current = file	
        if(_Curr[2].Value==CFG){  
          if(_Curr[0].Value == SAVE){
            i=ConfigFile(SAVE);
            FileMessage(i);  
          }else{
            i=ConfigFile(LOAD);
            if(i>0)FileMessage(i);
          } 
        }
      } 

     } //if key buffer
     bypasslongpress3:

      //-------------------------------------------------------------------------------------------------------------        
                                                    // ===--- TASTO 4 PREMUTO --====
						//Key 4 short press has been swapped with center press left toggle
if(Key_Buffer== KEY4){

    Delay_Cnt = 1500;
    while (Delay_Cnt > 1000)
    {
       if((__Get(KEY_STATUS)& KEY4_STATUS)!=0){

	    _Curr[_Det].Flag |= UPDAT;
          if ((Current == TRACK3)&&(_Det == 0))_Det = 2;
            if ((Current == TRACK4)&&(_Det == 0))_Det = 2;

     	     if ((((Options&1)==0)||(_Mode==AUTO)||(_Mode==X_Y)||(_Mode==SGL)||(_Mode==SCAN)||(_T_base>9))&&(Current == TRIGG)&&(_Det==2)) _Det=3;	//skip over det3 (will go to 0)
           if ((FlagMeter!=0)||(Current != V_VERNIE)|| (_Det!=V2))
		{
			if(Current < METER_0){                         // change the Detail
			  _Curr[_Det].Flag |= UPDAT;
			  if(_Det < 3)    _Det += 1;
			  else            _Det  = 0;
			  
			  if ((Current == OUTPUT) && (Title[OUTPUT][KIND].Value==PWM) && (_Det==OUTATT)) _Det=0;
			  if ((Current == OUTPUT) && (Title[OUTPUT][KIND].Value!=PWM) && (_Det==DUTYPWM)) _Det+=1;  
			  
			  if(_Curr[_Det].MARK & NOT)                        _Det  = 0; 
			  if(_Curr[_Det].MARK & NUM2)                       _Det  = 0; 
			  if((_Curr[_Det].MARK & NUM3)&&(Current != FILE)&& (Current != OUTPUT) )  _Det  = 0;  
			  _Curr[_Det].Flag |= BLINK;
			} else {                                       // change the measurement object

                        if(Meter[Current-METER_0].Item>1){             //don't change source for VBT AND FPS (items 0 and 1) 		

			  Meter[Current-METER_0].Flag |= UPDAT;

			  if((Meter[Current-METER_0].Item>VPP)||(Meter[Current-METER_0].Item==FRQ)){
			    if(Meter[Current-METER_0].Track <=  TRACK4) 
				Meter[Current-METER_0].Track += 1;
			    if(Meter[Current-METER_0].Track > TRACK4) 
				Meter[Current-METER_0].Track  = TRACK1;
                          }else{
                            if(Meter[Current-METER_0].Track==TRACK1)
                              Meter[Current-METER_0].Track=TRACK2;
                                else Meter[Current-METER_0].Track=TRACK1;
                          }   
                        } 
		      }//if current
	      } else {
			_Curr[_Det].Flag |= UPDAT;
			_Det=V1;
		}
		break;
          }                     //if get key status
        }                      //while delay count >0

	    while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){					// long press
           if((__Get(KEY_STATUS)& KEY4_STATUS)!=0){

		_Curr[_Det].Flag |= UPDAT;

		if (Current==TRACK1)LastSelected=1;
		if (Current==TRACK2)LastSelected=2;
            Current = T_BASE;
		_Det = BASE;
            _Curr[_Det].Flag |= BLINK;
		_Curr[_Det].Flag |= UPDAT;
            goto bypasslongpress4;		
           }  //if key status
          }   //while delay cnt

        if(Delay_Cnt == 0){

          if (CurDefTime==0){
                  CurDefTime=1;
            if(Current != FILE){
                MessageNumber=5;		      //cur select meters on	
                NotificationTimer=80;                 //* 20Ms
            }
      	    Print_Str(153,216,0x0405,PRN, "X");
          }else{
            CurDefTime=0;
            if(Current != FILE){
                MessageNumber=6;		      //cur select meters off	
                NotificationTimer=80;                 //* 20Ms
            }
            Print_Str(153,216,0x0405,PRN, " ");
          }
        }   //if delay cnt
      }	  //if key buffer
       bypasslongpress4:

//----------------------------------------------------------------------------------------------------------------
      if(Key_Buffer == K_INDEX_DEC){                                            // ===--- TASTO 5 --- PREMUTO --====
	    
         if (_Mode == X_Y){
           if((Current == TRACK1)&&(_Det == POSI) && (OffsetX>45)) OffsetX=OffsetX-2;
           if((Current == TRACK2)&&(_Det == POSI) && (OffsetY>30)) OffsetY=OffsetY-2;
         }  
           if((Current == TRACK1)&&(_Det == POSI))SelectiveUpdate|=0x20;	//clear min/max hold
           if((Current == TRACK2)&&(_Det == POSI))SelectiveUpdate|=0x40;
 
        if ( ((Current == T_VERNIE)||(Current == V_VERNIE)) && (FlagMeter==0)) TimedDeltaView=150;

        if(Current < METER_0){

          for (i=0;i<4;i++){
	      if ((Current==i)&&(_Det == SOURCE)){		         			//ch selected and submenu on source
		  if (Title[i][SOURCE].Value == 1){						//about to be shut down
		    if (Title[TRIGG][SOURCE].Value ==i){				        //if trig selected
		      UpdateTriggerMem();
		      Title[TRIGG][0].Flag=UPDAT;							
	              Title[TRIGG][1].Flag=UPDAT;							
                      Title[TRIGG][2].Flag=UPDAT;							
 	              Update_Trig(1);						
		    }							  //if not selected, about to be shut down, purge # from buffer
       	            if (PreviousTrigSelect[0]==i)PreviousTrigSelect[0]=0; //clear to default (ch1) first entry if last ch memorized shut down
		    for (j=1;j<4;j++){
			if (PreviousTrigSelect[j]==i) for (k=j;k>0;k--) PreviousTrigSelect[k]=PreviousTrigSelect[k-1];
		    }
                  }  //Title[i][source]  
              }      //current=
          }          //for

          if((Current == TRIGG)&&(Detail[Current]==2)){     						        // trigger level adjustment

            if(Title[TRIGG][SOURCE].Value==4){  
              if(V_Trigg[0].Value > 0)V_Trigg[0].Value--; 		         
              if(V_Trigg[1].Value > 0)V_Trigg[1].Value--; 		         
            }else{
              if(V_Trigg[_Trigg[SOURCE].Value].Value > 0) 
                V_Trigg[_Trigg[SOURCE].Value].Value--;
            }  

          }	else  if ((Current == TRIGG)&&(_Det == 3)){								  //trigger holdoff
            if ((FrameMode==2)&&(_T_base < 10)){
              if (Title[7][3].Value>30) Title[7][3].Value-=30; else Title[7][3].Value=0;
              Title[7][3].XPOS=GetHoldoffIndPos();
              SelectiveUpdate=0x1E;										   //do not update anything
            }  
          } else if((Current == BK_LIGHT)||(Current == VOLUME)){//  adjust backlight or volume
            if(_Curr[1].Value > 0)   _Curr[1].Value--;
          } else if((Current == T_BASE)&&(_Det == XPOSI)){   							   // X_POSI adjustment
	    if (XposRef>150){
            _Curr[_Det].Value-=30;
		XposRef=GetXposRef(_Curr[_Det].Value);								
            }else {
              if (XposRef>30)XposRef-=6;else if (XposRef>0) XposRef--;
            }
              _X_View.Flag |= UPDAT;                              // refresh X_View
          } else {                                              //  for other current item
		if ((Current==TRACK1)&&(_Det==SOURCE)){
                  LastSelected=1;  //ChA is about to be turned on
                  SelectiveUpdate|=0x20;       
                }
		if ((Current==TRACK2)&&(_Det==SOURCE)){
                  LastSelected=2;  //ChB is about to be turned on
                  SelectiveUpdate|=0x40;       
                }
            if(_Curr[_Det].Value > 0){
              _Curr[_Det].Value--;
              if ((Current==TRACK1)&&(_Det==RANGE))SelectiveUpdate|=0x20;       
              if ((Current==TRACK2)&&(_Det==RANGE))SelectiveUpdate|=0x40;       
              if ((Current<2)&&(_Det==RANGE))Update_Range(); 
           } 
             else if(_Curr[_Det].MARK & CIRC) _Curr[_Det].Value =_Curr[_Det].Limit;


            if((Current == TRIGG)&&(Detail[Current]==0)){                       //trig source has just been changed
              if(Title[TRIGG][SOURCE].Value==4){				//changed to AltAB 
                if(_Mode==X_Y){
                  _Curr[_Det].Value--;
                }else{                
                  OldMode=Title[T_BASE][MODE].Value;							//save prev mode	
                  for(i=0;i<4;i++)ChStatus[i]=Title[i][SOURCE].Value;
                } 
              } 
              if((Title[TRIGG][SOURCE].Value==3)&&(_Mode!=X_Y)){				//changed from AltAB 
                Title[T_BASE][MODE].Value=OldMode;							//reset to prev mode	
                Title[T_BASE][MODE].Flag |= UPDAT;
                for(i=0;i<4;i++){
                  Title[i][SOURCE].Value=ChStatus[i];
		  Title[i][SOURCE].Flag |= UPDAT;
                }
                Title[TRACK1][RANGE].Flag |= UPDAT; Title[TRACK2][RANGE].Flag |= UPDAT;
              } 
            }


            if ((Current == T_BASE)&&(_Det == BASE)){
              if((__Get(FIFO_START)!=0)||(_Mode!=NORH))__Set(TRIGG_MODE, UNCONDITION); //temporarily setting this allows x_attr to properly update if in untriggered condition
            }
	    if((FrameMode<2)&&(Current == T_BASE)&&(_Det == BASE)){                 
              Tmp=GetXposRef(_X_posi.Value);
              if (Tmp>150) XposRef=Tmp;					//only align trig vernier when on screen when changing time bases
	    }  
          }

          if((Current == T_BASE)&&(_Det == MODE)){     // T_BASE MODE selection			//at this point mode has been changed
            if (_Mode==SCAN) {if (FrameMode>0)ShortBuffXpos=XposRef; else OldPosi=XposRef;}	//previous mode was auto
            if (_Mode==X_Y) {if (FrameMode>0)XposRef=ShortBuffXpos; else XposRef=OldPosi;}	//previous mode was scan

           Title[RUNNING][STATE].Value = RUN;         // STATE = RUNNING 
            Title[RUNNING][STATE].Flag |= UPDAT;       // refresh RUNNING STATE
          }
          if((Current == OUTPUT)&&(_Kind != PWM)){
             if (Title[OUTPUT][FRQN].Value > 13) 
            Title[OUTPUT][FRQN].Value = 13;            // upper limit of the analog signal frequency is 20KHz
           }

          if((Current == FILE)&&(_Curr[0].Value == LOAD)){ 
            if(_Curr[2].Value == BMP) _Curr[2].Value = CFG;  
            if(_Curr[2].Value == CSV) _Curr[2].Value = BUF;
          }
          if((Current == FILE)&&(_Curr[2].Value == CFG)) if(_Curr[1].Value > 9)_Curr[1].Value=9;           
          for(i=0;i<4;i++)_Curr[i].Flag |= UPDAT;
        } else {

          Meter[Current-METER_0].Flag |= UPDAT;

             if(Meter[Current-METER_0].Item >VBT)	    
               Meter[Current-METER_0].Item -= 1;          
             else                     
               Meter[Current-METER_0].Item  = TL;
 
             if((Meter[Current-METER_0].Track>1)&&(Meter[Current-METER_0].Track<4)){
               if(Meter[Current-METER_0].Item ==VPP)Meter[Current-METER_0].Item =FRQ;
               if(Meter[Current-METER_0].Item ==RMS)Meter[Current-METER_0].Item =FPS;
             }
 
             if(Meter[Current-METER_0].Item == FPS){
               SaveCurrent[0]=Current;		      
               SaveCurrent[1]=Meter[Current-METER_0].Track; 
               Meter[Current-METER_0].Track = 4;
	     } 	

             if(Meter[Current-METER_0].Item == TL){ 
               if(Current==SaveCurrent[0])
		 Meter[Current-METER_0].Track =SaveCurrent[1];
               else
                 Meter[Current-METER_0].Track = UpdateMeter;
             }

        }
      }
      //---------------------------------------------------------------------------------------------------------------------       
      if(Key_Buffer == K_INDEX_S)
	{                                              // ===--- TASTO 5 centrale PREMUTO --====
						//center press left toggle has been swapped with key 4 short press
 	    if ((Current != FILE)) {

		Delay_Cnt = 1500;
      	while (Delay_Cnt > 1000){
                                                
            if((__Get(KEY_STATUS)& K_INDEX_S_STATUS)!=0){

                  j=0;
		  for (i=0;i<4;i++){
                    if(Title[i][SOURCE].Value != HIDE)j++;
                  }
                  if(j>0){
                    if ((((_4_source==11)||(_4_source==14)||(_4_source==15))&&(_1_source!=HIDE))||
                         (((_4_source==10)||(_4_source==12)||(_4_source==13))&&(_2_source!=HIDE)))j--;
                  }

                  if (j>2){                   		//if more than 2 active channels, use as shortcut to trigg source select
	            _Curr[_Det].Flag |= UPDAT;
            	    for (i=0;i<4;i++){											
                      if (Current==i){									//================================================================
		        if (Title[i][SOURCE].Value != HIDE){
		          if (Title[TRIGG][SOURCE].Value !=i){						//if not already selected
	   		    for (j=0;j<3;j++) PreviousTrigSelect[j]=PreviousTrigSelect[(j+1)];		//lifo stack
		            PreviousTrigSelect[3]=Title[TRIGG][SOURCE].Value;				//save previous
                            Title[TRIGG][SOURCE].Value = i;						//set trig to selected track
                            if((i==3)&&((_4_source==11)||(_4_source==14)||(_4_source==15)))Title[TRIGG][SOURCE].Value=0;	//set to FFT channels
                            if((i==3)&&((_4_source==10)||(_4_source==12)||(_4_source==13)))Title[TRIGG][SOURCE].Value=1;
		            Update_Trig(1);						
                            goto BypassShortcut;        //if new source selected, do not use as shortcut
	                  }
		        }  //if turned on
	              }    //if current
                    }      //check all channels

                    Current=TRIGG;			//shortcut to trigg source select
                    _Det=SOURCE;
                    
BypassShortcut:
                    for(i=0;i<3;i++)Title[TRIGG][i].Flag=UPDAT;
		    goto bypasslongpress5;
                  }


		   if((_Mode!=X_Y)&&(Title[TRIGG][SOURCE].Value==1)&&(Title[TRACK1][SOURCE].Value!=0)&&(Title[TRACK2][SOURCE].Value!=0)&&(Title[TRACK3][SOURCE].Value==0)&&(Title[TRACK4][SOURCE].Value==0)){
                     OldMode=Title[T_BASE][MODE].Value;			//if 2 analog chs are the only ones on and trigger source = chB
                     Title[TRIGG][SOURCE].Value=4;			//cycle to include A&B mode
		     Update_Trig(1);
                   }else{						//cycle between any other 2 channels
          		for (i=0;i<4;i++){											
			    if (Title[i][SOURCE].Value != HIDE){
				 if (Title[TRIGG][SOURCE].Value !=i){						//if not already selected
                                   if(Title[TRIGG][SOURCE].Value==4){						//do not save A&B position
                                     Title[T_BASE][MODE].Value=OldMode;                     	             
                                     Title[T_BASE][MODE].Flag |= UPDAT;
                                     Update_Base(); 
                                   }else{
	   		             for (j=0;j<3;j++) PreviousTrigSelect[j]=PreviousTrigSelect[(j+1)];		//lifo stack
		                     PreviousTrigSelect[3]=Title[TRIGG][SOURCE].Value;				//save previous
                                   }  
                                   Title[TRIGG][SOURCE].Value = i;						//set trig to selected track
                                   if((i==3)&&((_4_source==11)||(_4_source==14)||(_4_source==15)))Title[TRIGG][SOURCE].Value=0;	//set to FFT channels
                                   if((i==3)&&((_4_source==10)||(_4_source==12)||(_4_source==13)))Title[TRIGG][SOURCE].Value=1;

				   Title[TRIGG][0].Flag=UPDAT;							
	     			   Title[TRIGG][1].Flag=UPDAT;							
	                           Title[TRIGG][2].Flag=UPDAT;							
				   Update_Trig(1);
				   break;	
				 }
		            }  
                        }
                   }

          break;
          }					// if keystatus
	}

	    while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){					// long press, change meter pages
          if((__Get(KEY_STATUS)& K_INDEX_S_STATUS)!=0){

 	      if (FlagMeter>0){
                SaveCurrent[0]=0;			//erase item source memory
                SaveCurrent[1]=0;
                if (UpdateMeter<4){
                 if((FlagMeter==2)&&(UpdateMeter==3)&&(Current==METER_1))Current=METER_2;
                 UpdateMeter=UpdateMeter+1;
                 if  ((_Mode==X_Y)&&(UpdateMeter>1)) UpdateMeter=4;
                }
                else{			//UpdateMeter==4, default pages for both meter types
                 if (FlagMeter==2){
                   ClearBigMeter1();
                   if((Current < METER_0)&&(Current>T_VERNIE))Current=T_VERNIE;
                   if((Current==METER_0)||(Current==METER_2))Current=METER_1;
                 } 
                 UpdateMeter=0;		
                } 
                UpdateMeterPage();

              }else{			// flagmeter=0					//toggle wave calibration

            if (CalFlag==0){
                CalFlag=1;
                if(Current != FILE){
                MessageNumber=1;		      //wave calibration on	
                NotificationTimer=80;                 //* 20Ms
                }   
               	  Print_Str(137,216,0x0405,PRN, "C");
            }else{
              CalFlag=0;
              if(Current != FILE){
                MessageNumber=2;		      //wave calibration off	
                NotificationTimer=80;                 //* 20Ms
              } 
                	  Print_Str(137,216,0x0405,PRN, "U");
            }

          }
          goto bypasslongpress5;

        }                        //if keypress
      }					// delay cnt
        
         if(Delay_Cnt == 0){		//extra long press
           if ((Options&1)==0) {
             Options|=1;
             if (((_Mode==NORH)||(_Mode==NORC))&&(_T_base < 10)){Current = TRIGG; _Det = 3;}
	     Title[Current][_Det].Flag |= UPDAT;
                MessageNumber=7;		      //trigger holdoff on	
                NotificationTimer=80;                 //* 20Ms
           }else{
             Options&=0xFE;
             if ((Current==TRIGG)&&(_Det==3)) _Det=0; 
             Title[Current][_Det].Flag |= UPDAT;
                MessageNumber=8;		      //trigger holdoff off	
                NotificationTimer=80;                 //* 20Ms
           }
         }
      }          		      // if current

        if(Current == FILE){
          Print_Str(230, 0, (SCRN<<8)+ TEXT1, PRN, " >   ");
        if(_Curr[0].Value == SAVE){
          switch (_Curr[2].Value){
          case BMP:
            i = Save_Bmp(_Curr[1].Value);
            break;
          case DAT:
            i=Save_Dat(_Curr[1].Value);
            Delayms(1000);
            break;
          case BUF:
            i=Save_Buf(_Curr[1].Value);
             break;
          case CSV:
            i=Save_Csv(_Curr[1].Value);
            break;
          case 4:        				//configuration file
            i=ConfigFile(SAVE);
          }
          if(_Curr[2].Value!=CFG)_Curr[1].Value++;	//do not increase config file number
        } else { 
          i=0;
          if(_Curr[2].Value==DAT) i = Load_Dat(_Curr[1].Value);
          if(_Curr[2].Value==BUF) i = Load_Buf(_Curr[1].Value);
          if(_Curr[2].Value==CFG){
            i=ConfigFile(LOAD);
            Current=FILE;				//stay in file menu if loading file with button 5
            for(j=0;j<3;j++)Title[FILE][j].Flag|=UPDAT;
	    if(i == 0)goto bypasslongpress5;
          }
        }
        FileMessage(i);
        }  
    }
bypasslongpress5:

      //----------------------------------------------------------------------------------------------------------------    
      if(Key_Buffer == K_INDEX_INC){                                            // ===--- TASTO 5 +++ PREMUTO --====
        
     if (_Mode == X_Y){
           if((Current == TRACK1)&&(_Det == POSI) && (OffsetX<215)) OffsetX=OffsetX+2;
           if((Current == TRACK2)&&(_Det == POSI) && (OffsetY<170)) OffsetY=OffsetY+2;
         }  

           if((Current == TRACK1)&&(_Det == POSI))SelectiveUpdate|=0x20;
           if((Current == TRACK2)&&(_Det == POSI))SelectiveUpdate|=0x40;
     
        if ( ((Current == T_VERNIE)||(Current == V_VERNIE)) && (FlagMeter==0)) TimedDeltaView=150;
        if ((TrgAuto>0)&&(Current == TRIGG) && _Det==2) _Det=0;
        if(Current < METER_0){

         for (i=0;i<4;i++){			     			      //tracks 1 through 4
           if ((Current==i)&&(_Det == SOURCE)){
             if (Title[TRIGG][SOURCE].Value ==i){			      //if trig selected

               switch (Current){					      //ch about to be shut down	
                 case TRACK1:
                 case TRACK2:
 	             if (Title[i][SOURCE].Value == 2)UpdateTriggerMem();
		     break;
                 case TRACK3:
 	             if (Title[i][SOURCE].Value == 1)UpdateTriggerMem();
		     break;
                 case TRACK4:
 	            if (Title[i][SOURCE].Value == 9)UpdateTriggerMem();
               }
	       Title[TRIGG][0].Flag=UPDAT;							
	       Title[TRIGG][1].Flag=UPDAT;							
               Title[TRIGG][2].Flag=UPDAT;
	       Update_Trig(1);						

             } //if title trig source...												//if not selected, about to be shut down, purge # from buffer

	     if (PreviousTrigSelect[0]==i)PreviousTrigSelect[0]=0;	//clear to default (ch1) first entry if last ch memorized shut down
             for (j=1;j<4;j++){										
	       if (PreviousTrigSelect[j]==i) for (k=j;k>0;k--) PreviousTrigSelect[k]=PreviousTrigSelect[k-1];
	     }  
 
           }  //if current=i
         }    //for	

          if((Current == TRIGG)&&(Detail[Current]==2)){         // trigger level adjustment

            if(Title[TRIGG][SOURCE].Value==4){
              if(V_Trigg[0].Value < 200)V_Trigg[0].Value++; 	
              if(V_Trigg[1].Value < 200)V_Trigg[1].Value++; 	
            }else{ 
              if(V_Trigg[_Trigg[SOURCE].Value].Value < 200) 
                V_Trigg[_Trigg[SOURCE].Value].Value++;
            }

          }	else  if ((Current == TRIGG)&&(_Det == 3)){								  //trigger holdoff
            if ((FrameMode==2)&&(_T_base < 10)){
              if (Title[7][3].Value<3360) Title[7][3].Value+=30;
              Title[7][3].XPOS=GetHoldoffIndPos();
              SelectiveUpdate=0x1E;										//do not update anything
            }
          } else if ((Current == BK_LIGHT)||(Current == VOLUME)){// adjust backlight or volume
            if(_Curr[1].Value < _Curr[1].Limit)   _Curr[1].Value++;
    	    } else if ((Current == T_BASE)&&(_Det == XPOSI) ){                         	 // *******>>>>>> ALT X_POSI adjustment
		if (XposRef<151) {
	          if (XposRef<30) XposRef++; else XposRef+=6;
            }else{
              if (_Curr[_Det].Value <(_Curr[_Det].Limit-30)) _Curr[_Det].Value += 30;                                            
               else if (_Curr[_Det].Value <(_Curr[_Det].Limit-6)) _Curr[_Det].Value +=6;
               else if (_Curr[_Det].Value < (_Curr[_Det].Limit)) _Curr[_Det].Value ++;
  	         XposRef=GetXposRef(_Curr[_Det].Value);						
            }
            _X_View.Flag |= UPDAT;
          }  else if ((Current == T_VERNIE) && ((_Det==T1) || (_Det==T2))){
            
                    if (FlagMeter>0){
                      if (_Curr[_Det].Value <(_Curr[_Det].Limit-95)) _Curr[_Det].Value ++;
                    }
                    else
                    {
                      if (_Curr[_Det].Value <_Curr[_Det].Limit-(MIN_X-2)) _Curr[_Det].Value ++; 
                    }
           } else {                                              // the current item for otheR

		if ((Current==TRACK1)&&(_Det==SOURCE)){
                  LastSelected=1;  //ChA is about to be turned on
                  SelectiveUpdate|=0x20;       
                }
		if ((Current==TRACK2)&&(_Det==SOURCE)){
                  LastSelected=2;  //ChB is about to be turned on
                  SelectiveUpdate|=0x40;       
                }

              if(_Curr[_Det].Value < _Curr[_Det].Limit){
                _Curr[_Det].Value++;
                if ((Current==TRACK1)&&(_Det==RANGE))SelectiveUpdate|=0x20;       
                if ((Current==TRACK2)&&(_Det==RANGE))SelectiveUpdate|=0x40;       
                if ((Current<2)&&(_Det==RANGE))Update_Range(); 
              }else if(_Curr[_Det].MARK & CIRC)_Curr[_Det].Value  = 0;

            if((Current == TRIGG)&&(Detail[Current]==0)){                       //trig source has just been changed
              if(Title[TRIGG][SOURCE].Value==4){				//changed to AltAB 
                if(_Mode==X_Y){
                  _Curr[_Det].Value=0;
                }else{
                  OldMode=Title[T_BASE][MODE].Value;							//save prev mode	
                  for(i=0;i<4;i++)ChStatus[i]=Title[i][SOURCE].Value;
                }
              } 

              if((Title[TRIGG][SOURCE].Value==0)&&(_Mode!=X_Y)){				//changed from AltAB 
                Title[T_BASE][MODE].Value=OldMode;							//reset to prev mode	
                Title[T_BASE][MODE].Flag |= UPDAT;
                for(i=0;i<4;i++){
                  Title[i][SOURCE].Value=ChStatus[i];
		  Title[i][SOURCE].Flag |= UPDAT;
                }
                Title[TRACK1][RANGE].Flag |= UPDAT; Title[TRACK2][RANGE].Flag |= UPDAT;
              } 
            }

            if ((Current == T_BASE)&&(_Det == BASE)){
              if((__Get(FIFO_START)!=0)||(_Mode!=NORH))__Set(TRIGG_MODE, UNCONDITION); //temporarily setting this allows x_attr to properly update if in untriggered condition
            }
	    if((FrameMode<2)&&(Current == T_BASE)&&(_Det == BASE)){                 
              if (XposRef>150)XposRef=GetXposRef(_X_posi.Value);
	    }  
          }
          if((Current == T_BASE)&&(_Det == MODE)){     // T_BASE MODE selection				//at this point, mode has been changes
            if (_Mode==SCAN) {if (FrameMode>0)ShortBuffXpos=XposRef; else OldPosi=XposRef;}		//previous mode was xy
            if (_Mode==AUTO) {if (FrameMode>0)XposRef=ShortBuffXpos; else XposRef=OldPosi;}		//previous mode was scan
            Title[RUNNING][STATE].Value = RUN;         // STATE = RUNNING 
            Title[RUNNING][STATE].Flag |= UPDAT;       // refresh RUNNING STATE
          }
          if((Current == OUTPUT)&&(_Kind != PWM)){
            if(Title[OUTPUT][FRQN].Value > 13) 
	        Title[OUTPUT][FRQN].Value = 13;          // upper limit of the analog signal frequency is 20KHz
          }

          if((Current == FILE)&&(_Curr[0].Value == 1)){  // only the Load Dat, Buf file
            if(_Curr[2].Value == BMP) _Curr[2].Value = DAT;  
            if(_Curr[2].Value == CSV) _Curr[2].Value = CFG;
          }
          if((Current == FILE)&&(_Curr[2].Value == CFG)) if(_Curr[1].Value > 9)_Curr[1].Value=9;           

          for(i=0;i<4;i++)_Curr[i].Flag |= UPDAT;
        } else {
				       // in meter section	

          Meter[Current-METER_0].Flag |= UPDAT;

            if(Meter[Current-METER_0].Item < TL)	    
              Meter[Current-METER_0].Item += 1;          
            else{                     
              Meter[Current-METER_0].Item  = VBT;
              SaveCurrent[0]=Current;		      
              SaveCurrent[1]=Meter[Current-METER_0].Track; 
	      Meter[Current-METER_0].Track = 4;
            }

            if(Meter[Current-METER_0].Item == VDC){ 
               if(Current==SaveCurrent[0])
		 Meter[Current-METER_0].Track =SaveCurrent[1];
               else
                 Meter[Current-METER_0].Track = UpdateMeter;
            }

            if((Meter[Current-METER_0].Track>1)&&(Meter[Current-METER_0].Track<4)){
              if(Meter[Current-METER_0].Item ==VDC)Meter[Current-METER_0].Item =FRQ; 
              if(Meter[Current-METER_0].Item ==MAX)Meter[Current-METER_0].Item =CIR; 
            }
        }
      }
      //---------------------------------------------------------------------------------------------------------------- 
      if(Key_Buffer == K_ITEM_DEC){                                             // ===--- TASTO 6 --- PREMUTO --====
        if(Current < METER_0){
          _Curr[_Det].Flag |= UPDAT;

          if(Current==T_VERNIE){Current=V_VERNIE; goto NoDec;}   //skip over file menu's regular place
          if(Current==FILE){
            if((FlagMeter==1)||((FlagMeter==2)&&(UpdateMeter==4))){Current=VOLUME;goto NoDec;}
            Current=T_VERNIE;
            goto NoDec;
          }

          if (FlagMeter>0){
            //if(Current == TRACK1)  {Current = VOLUME;}	//loop around
            if(Current == TRACK1)  {Current = TRACK1;}	//don't loop around
            else                  {Current --;}
          }
          else
          {
            //if(Current == TRACK1)  {Current = T_VERNIE;}  //loop around
            if(Current == TRACK1)  {Current = TRACK1;}	//don't loop around
            else                   {Current --;}
            if ((Current == V_VERNIE)&&(_Det == 2)) _Det=0; //if meters off							
          }
	    if (Current<4)Title[Current][3].Flag|= UPDAT;
          if(Current == RUNNING) Current --;               // Jump over Item 4
NoDec:
          _Curr[_Det].Flag |= BLINK;
          _Curr[_Det].Flag |= UPDAT;
          if (Current==FILE){
            if((_Curr[2].Value == CFG)&&(_Curr[1].Value > 9))_Curr[1].Value=9;           
            for(i=0;i<4;i++)_Curr[i].Flag |= UPDAT;  
	  }

        } else if (FlagMeter==1){			//IN METER SECTION
          Meter[Current-METER_0].Flag |= UPDAT; 
          if(Current == METER_0) Current = METER_8; else Current --;
          Meter[Current-METER_0].Flag |= BLINK;
        } else if (FlagMeter==2){
          if (UpdateMeter!=4){if(Current==METER_1)Current=METER_3; else Current--;}
          else{
            if(Current==METER_0){
              Meter[Current-METER_0].Flag &= (!UPDAT & !BLINK);             
              Current=METER_3;
            }else if(Current==METER_2){
              Meter[Current-METER_0].Flag |= UPDAT;
              Meter[Current-METER_0].Flag |= BLINK;            
              Current=METER_0;
            }else Current--;
          }
        }
      }
	  //---------------------------------------------------------------------------------------------------------------------
      if(Key_Buffer == K_ITEM_S){    // ===--- TASTO 6 centrale PREMUTO --====

     Delay_Cnt = 1500;
     while (Delay_Cnt > 1000){
       if((__Get(KEY_STATUS)& K_ITEM_S_STATUS)!=0){

          if(Current != FILE){
            if (FlagFrameMode==0){
              FlagFrameMode=1;
              SelectiveUpdate |=0x60;
              if (_Mode!=SCAN) {
		    OldPosi=XposRef;
		    XposRef=ShortBuffXpos;
                    Update=2;
              }
            }
            else
            {
              FlagFrameMode=0;
              SelectiveUpdate |=0x60;
              if (_Mode!=SCAN) {
                ShortBuffXpos=XposRef;
		   XposRef=OldPosi;	
             } 
 	       if ((Current == TRIGG) && (_Det==3)) _Det=0; Title[Current][_Det].Flag |= UPDAT;
            }
		Update_View_Area();
          }

	      break;
	 }				//if get key status
	}				//while


    while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){					// long press
     if((__Get(KEY_STATUS)& K_ITEM_S_STATUS)!=0){
 
       _Curr[_Det].Flag |= UPDAT;
        if (FlagMeter==0){
			if (((Current <= METER_8)&& (Current >= METER_0)) || (Current==BK_LIGHT) || (Current==VOLUME) ){
				Current=TRACK1 ;
			}

            if(Current != FILE){
                if (Timeout==0){
                  Timeout=1;
                MessageNumber=3;		      //standby timer on	
                NotificationTimer=80;                 //* 20Ms
                }else{
                  Timeout=0;
                MessageNumber=4;		      //standby timer off	
                NotificationTimer=80;                 //* 20Ms
                }  
             }

        } else {									//with meters on
			if(Current < METER_0) {						//shift over to meters
                          OldCurrent=Current;
			  if(UpdateMeter==4)Current = METER_0;else Current=METER_1;
			} else {							//over to main menus, track1

                              if(FlagMeter==1){
				for(CounterUpdate=0;CounterUpdate<9;++CounterUpdate){  // Udate di tutti i meter per tenterli accesi
					Meter[CounterUpdate].Flag |= UPDAT;
				}
                              }else if(FlagMeter==2){
				for(CounterUpdate=0;CounterUpdate<4;++CounterUpdate){  
					Meter[CounterUpdate].Flag |= UPDAT;
                                } 
                              }
			  Current = OldCurrent;
			}
         }
           goto bypasslongpress6;

	  }//get key
       }//delay count


       if(Delay_Cnt == 0){		//extra long press
              if ((Options&4)==0){
                  Options|=4;           //set bit 4
                  for(CounterUpdate=1;CounterUpdate<9;++CounterUpdate){    
                    Meter[CounterUpdate].Flag |= UPDAT;
                  } 

                  if(Current != FILE){
                      MessageNumber=9;		      	
                      NotificationTimer=80;                 //x 20Ms
                  }
                  Print_Str(145,216,0x0405,PRN,"H");
                  SelectiveUpdate |=0x60;
               }else{
                  Options&=0xFB;		      //clear bit 4

                  for(CounterUpdate=1;CounterUpdate<9;++CounterUpdate){    
                    Meter[CounterUpdate].Flag |= UPDAT;
                  } 
                  if(Current != FILE){
                    MessageNumber=10;		      
                    NotificationTimer=80;                 //x 20Ms
                  }
                  Print_Str(145,216,0x0405,PRN," ");  
              } 
       }
     }

bypasslongpress6:

      //---------------------------------------------------------------------------------------------------------------  
      if(Key_Buffer == K_ITEM_INC){                                             // ===--- TASTO 6 +++ PREMUTO --====
        if(Current < METER_0){
          _Curr[_Det].Flag |= UPDAT;
        
          if(Current==FILE)goto NoInc;

          if ((FlagMeter==0) && (Current == T_VERNIE))  {
                        Current=FILE;
			goto NoInc;
	  }

          if(Current == VOLUME)					
                        Current=FILE;
          else if((FlagMeter==2)&&(UpdateMeter!=4)){
            if (Current<T_VERNIE)Current++;else {Current=FILE;goto NoInc;}
            if(Current==FILE)Current++;
          }else {Current ++;if(Current==FILE)Current++;}

	  if (Current<4)Title[Current][3].Flag|= UPDAT;
          if ((FlagMeter==0)&&(Current==V_VERNIE)&&(_Det == 2)) _Det=0;

NoInc: 
          if(Current == RUNNING) Current ++;              // Jump over RUNNING
          _Curr[_Det].Flag |= BLINK;
          _Curr[_Det].Flag |= UPDAT;
          if (Current==FILE){
            if((_Curr[2].Value == CFG)&&(_Curr[1].Value > 9))_Curr[1].Value=9;           
          for(i=0;i<4;i++)_Curr[i].Flag |= UPDAT;
          }
        }else if (FlagMeter==1){					//IN METER SECTION
            Meter[Current-METER_0].Flag |= UPDAT;  
            if(Current == METER_8) Current=METER_0; else Current ++;
            Meter[Current-METER_0].Flag |= BLINK;
        }else if (FlagMeter==2){
          if(UpdateMeter!=4){if(Current==METER_3)Current=METER_1;else Current++;}  //skip over meter 0 (bat volt), not displayed w/3 big meters
          else{ 
            if(Current == METER_0){
		Meter[Current-METER_0].Flag &= (!UPDAT & !BLINK);
                Current=METER_2;
            }else if(Current==METER_3){
               Current=METER_0;
               Meter[Current-METER_0].Flag |= UPDAT;
               Meter[Current-METER_0].Flag |= BLINK;
            }else Current++;
          }          
        }
      }
      //----------------------------------------------------------------------------------------------------------------     

     MeterDefaults();	
     if((_1_source==0)&&(_2_source==0)&&(_3_source==0)&&(_4_source>9)){				//if FFT alone, set to proper ch
	if((_4_source==SPEC_A)||(_4_source==15)||(_4_source==14))Title[TRIGG][SOURCE].Value=0;
        if((_4_source==SPEC_B)|| (_4_source==13)||(_4_source==12))Title[TRIGG][SOURCE].Value=1;
        for(i=0;i<3;i++)Title[TRIGG][i].Flag=UPDAT;
        Update_Trig(1);						
     }else if (Title[TRIGG][SOURCE].Value==4){					//if trig source is a&b
        Title[T_BASE][MODE].Value=NORH;						//set normal trig mode
        Title[T_BASE][MODE].Flag |= UPDAT;
        if(Title[TRACK1][SOURCE].Value==0)Title[TRACK1][SOURCE].Value=1;	//turn both analog channels on if selecting a&b trig mode
        if(Title[TRACK2][SOURCE].Value==0)Title[TRACK2][SOURCE].Value=1;
        Title[TRACK3][SOURCE].Value=HIDE;					//shut down dig chs
        Title[TRACK4][SOURCE].Value=HIDE;
        for(i=0;i<4;i++)Title[i][SOURCE].Flag |= UPDAT;
        Title[TRACK1][RANGE].Flag |= UPDAT; Title[TRACK2][RANGE].Flag |= UPDAT;
        for(i=0;i<3;i++)Title[TRIGG][i].Flag=UPDAT;
      }							 

      if (Update!=2){
						  //full updates
        if((Current == T_BASE)&&(_Det == MODE)&&((Key_Buffer==K_INDEX_DEC)||(Key_Buffer==K_INDEX_INC)))goto BypassExclusions;
						  //note inclusions are 2 negates, eg: if current is not tbase, set bit to not update base
                                                  //update base inclusions
        if (!((Current == T_BASE)&&(_Det == BASE)&&((Key_Buffer==K_INDEX_DEC)||(Key_Buffer==K_INDEX_INC))))SelectiveUpdate|=0x04; 								
                                                  //update trigger inclusions
        if (!((((Current == TRIGG)&&((Title[TRIGG][SOURCE].Value<4)||(_Det<2)))||(Current<4)||((Current==T_VERNIE)
          &&(Title[TRIGG][SOURCE].Value<4)))&&((Key_Buffer==K_INDEX_DEC)||(Key_Buffer==K_INDEX_INC)||(Key_Buffer==K_INDEX_S))))
            SelectiveUpdate|=0x10;		
                                                  //update range inclusions
        if (!((Current<4)&&(_Det<3)&&((Key_Buffer==K_INDEX_DEC)||(Key_Buffer==K_INDEX_INC))))SelectiveUpdate|=0x02;

                                                  //shift Y positioning
BypassExclusions:

	if((Current<4)&&(_Det==3)&&((Key_Buffer==K_INDEX_DEC)||(Key_Buffer==K_INDEX_INC))){
          SetOffset(0,_A_Range,_1_posi);
          SetOffset(1,_B_Range,_2_posi);
        }  

        if((Current == T_BASE)&&(_Det == 2)&&((Key_Buffer==K_INDEX_DEC)||(Key_Buffer==K_INDEX_INC))){
          if((_Status == RUN)&&(((_Mode==NORH)&&(__Get(FIFO_START)==0))||(_T_base <8))){  //trying to shift X position with device not triggered in run mode or at very slow speeds
            _X_posi.Value=GetXpos(XposRef);     			//align interpolated time bases with the others
            _State.Value=1;						//shift to hold mode so data is not transfered		
            Process();							//update screen so x pos can be changed
            _State.Value=0;						//return to run mode
          } 
        }
                                                           //NORMH mode: if changing timebase reset meters,
        if  ((Current==T_BASE)&&(_Mode==NORH)&&(_Det == BASE)&&((Key_Buffer==K_INDEX_DEC)||(Key_Buffer==K_INDEX_INC))){
            EnablePaS=1;		//enable resetsum to reset TH, TL, duty%
            ResetSum();
        }

        Update = 1;
      }

      if(_1_source>0)ChOnStatus[0]=_1_source;
      if(_2_source>0)ChOnStatus[1]=_2_source;
      Key_Buffer=0;
    }
  }
}

u16 GetXposRef(u16 XPos){
  return (((10240000/X_Attr[Title[T_BASE][BASE].Value].KP)*XPos)+5000)/10000;
}

u16 GetXpos(u16 XposRef){
        return((((X_Attr[Title[T_BASE][BASE].Value].KP*10000)/1024)*XposRef)+5000)/10000;  //align interpolated time bases with the others
}

void MeterDefaults(void){
u8  CounterUpdate;

              if ((UpdateMeter==4)&&(FlagMeter>0)){

                Meter[0].Flag |= UPDAT;
                Meter[0].Item  =  VBT;
                Meter[0].Track = 4;  
                if(FlagMeter==1){
                  for(CounterUpdate=1;CounterUpdate<9;++CounterUpdate){    
                    Meter[CounterUpdate].Flag |= UPDAT;
                  } 
                }else if(FlagMeter==2){
                  for(CounterUpdate=1;CounterUpdate<4;++CounterUpdate){    
                    Meter[CounterUpdate].Flag |= UPDAT;
                  }
                }

                if ((_Mode==X_Y) || ( (Title[TRACK3][SOURCE].Value == HIDE) && (Title[TRACK4][SOURCE].Value == HIDE)))
                {
                  if(FlagMeter==1){              
                    Meter[1].Item  =  RMS; Meter[1].Track = 0;
                    Meter[2].Item  =  VDC; Meter[2].Track = 0;
                    Meter[3].Item  =  VPP; Meter[3].Track = 0;
                    Meter[4].Item  =  FRQ; Meter[4].Track = 0;
                    Meter[5].Item  =  RMS; Meter[5].Track = 1;
                    Meter[6].Item  =  VDC; Meter[6].Track = 1;
                    Meter[7].Item  =  VPP; Meter[7].Track = 1;
                    Meter[8].Item  =  FRQ; Meter[8].Track = 1;
                  }else{
                    Meter[2].Item  =  VDC; Meter[2].Track = 0;
                    Meter[3].Item  =  VDC; Meter[3].Track = 1;
                  }
                }  
                else  
                {
                  if(FlagMeter==1){              
                    Meter[1].Item  =  FRQ; Meter[1].Track = 0;
                    Meter[2].Item  =  VDC; Meter[2].Track = 0;
                    Meter[3].Item  =  FRQ; Meter[3].Track = 1;
                    Meter[4].Item  =  VDC; Meter[4].Track = 1;
                    Meter[5].Item  =  FRQ; Meter[5].Track = 2;
                    Meter[6].Item  =  CIR; Meter[6].Track = 2;
                    Meter[7].Item  =  FRQ; Meter[7].Track = 3;
                    Meter[8].Item  =  CIR; Meter[8].Track = 3;
                  }else{ 
                    Meter[2].Item  =  VDC; Meter[2].Track = 0;
                    Meter[3].Item  =  VDC; Meter[3].Track = 1;
                  }
                }
               }
}


void DisableMeter(void)
{
              if (((Current <= METER_8)&& (Current >= METER_0)) || (Current==BK_LIGHT) || (Current==VOLUME) ){_Curr[_Det].Flag |= UPDAT;Current=TRACK1 ;}
              FlagMeter=0;// modo no meter
              MAX_X=(386+MIN_X);
              if ((Current == V_VERNIE)&&(_Det == 2)) _Det=0;
              }
 
void EnableMeter(void)
{
  u8 CounterUpdate;
  u8 i;
  
            if (Title[T_VERNIE][T1].Value>Title[T_VERNIE][T1].Limit-95) Title[T_VERNIE][T1].Value=Title[T_VERNIE][T1].Limit-95;
            if (Title[T_VERNIE][T2].Value>Title[T_VERNIE][T2].Limit-95) Title[T_VERNIE][T2].Value=Title[T_VERNIE][T2].Limit-95;
            Clear_Meter_Area();
            if (FlagMeter==0)FlagMeter=1;
            MAX_X=(300 + MIN_X);
            Update=1;
            MeterDefaults();

        if (FlagMeter==1){
            for(CounterUpdate=0;CounterUpdate<9;++CounterUpdate){ 
              Meter[CounterUpdate].Flag |= UPDAT;
            }
            EnableTitleMeters(1); 
        }

        if (FlagMeter==1){
            Display_Meter();
            for(i=0; i<9; ++i)Display_Value(i);
        }else{
          UpdateBigMeters();
          if(UpdateMeter==4)EnableTitleMeters(1);else EnableTitleMeters(0);
        } 
}

void EnableTitleMeters(u8 Service){
            Title[V_VERNIE][2].Flag |= UPDAT; 
            Title[T_VERNIE][2].Flag |= UPDAT;
            Title[V_VERNIE][3].Flag |= UPDAT; 
            Title[T_VERNIE][3].Flag |= UPDAT;
          if(Service){
            Title[BK_LIGHT][0].Flag |= UPDAT; 
            Title[VOLUME][0].Flag |= UPDAT; 
            Title[BK_LIGHT][1].Flag |= UPDAT; 
            Title[VOLUME][1].Flag |= UPDAT; 
            Meter[0].Flag |= UPDAT;
            Meter[0].Item  =  VBT;
            Meter[0].Track = 4;          }
}

void UpdateBigMeters(void){
u8 i;
     if (FlagMeter==2){
        if(UpdateMeter==4){
          for (i=2;i<4;i++){
            if(i==(Current-METER_0)){
              BTwinkState=!BTwinkState;
              BTwink=BTwinkState;
            }else BTwink=1;
            Display_Value(i);
         }
        }else{
          for (i=1;i<4;i++){
            if(i==(Current-METER_0)){
              BTwinkState=!BTwinkState;
              BTwink=BTwinkState;
            }else BTwink=1;
            Display_Value(i);
          }
        }
      }
}

void ClearBigMeter1(void){
u8 i,j;

      __LCD_Set_Block(314,399,125,180);
      for (i=0;i<86;i++){
	for (j=0;j<56;j++){ 
           __LCD_SetPixl(Color[SCRN]);   
	}
      }
      __LCD_Set_Block(LCD_X1,LCD_X2,LCD_Y1,LCD_Y2);  		// restore the full-size window 
}

void UpdateMeterPage(void){
u8 CounterUpdate;

                if(FlagMeter==2){
                  if(UpdateMeter==4){
                     ClearBigMeter1();
                     EnableTitleMeters(1);
                  }else EnableTitleMeters(0); 
                }				

                switch (UpdateMeter){
                case 0:
                case 1:
                  if(FlagMeter==1){
                    Meter[0].Flag |= UPDAT;
                    Meter[0].Item  =  VBT;
                    Meter[0].Track = 4;
                  }

                  for(CounterUpdate=1;CounterUpdate<9;++CounterUpdate){
                    Meter[CounterUpdate].Flag |= UPDAT;
                    Meter[CounterUpdate].Item  =  CounterUpdate+1; 		
                    Meter[CounterUpdate].Track = UpdateMeter;
                  }
                  break;
                case 2:				

                  for(CounterUpdate=1;CounterUpdate<9;CounterUpdate++){
                    Meter[CounterUpdate].Flag |= UPDAT;
                    Meter[CounterUpdate].Item  = C_Dmeter[CounterUpdate-1]; 		
		    if (CounterUpdate<6)Meter[CounterUpdate].Track = 2; else Meter[CounterUpdate].Track = 3;
                  }  

                  if(FlagMeter==1){
                    Meter[0].Flag |= UPDAT;
                    Meter[0].Item  =  VBT;
                    Meter[0].Track = 4;
                  }else{
                    EnableTitleMeters(0); 
                  } 
		  break;
                case 3:

                  for(CounterUpdate=1;CounterUpdate<9;CounterUpdate++){
                    Meter[CounterUpdate].Flag |= UPDAT;
                    Meter[CounterUpdate].Item  = C_Dmeter[CounterUpdate-1]; 		
		    if (CounterUpdate<6)Meter[CounterUpdate].Track = 3; else Meter[CounterUpdate].Track = 2;
                  }  
                  if(FlagMeter==1){
                    Meter[0].Flag |= UPDAT;
                    Meter[0].Item  =  VBT;
                    Meter[0].Track = 4;
                  }else{
                    EnableTitleMeters(0); 
                  }  
                 break;
                case 4:
		  MeterDefaults();
                }				// switch
}

void Config_init(void){
  if (FlagMeter>0)MAX_X=300+MIN_X;
  else MAX_X=386+MIN_X;
  OldTrack1X=Title[TRACK1][POSI].Value;
  OldTrack2X=Title[TRACK2][POSI].Value;
  OldMeter=FlagMeter;
  _Vt1Old=_Vt1;
  _Vt2Old=_Vt2;
  ClearTrackBuff(1);
  SelectiveUpdate |=0x60;
  Options|=2;           //set bit 2, shuts off edge filter (shows sharp edges)
  TrgAutoOld=TrgAuto;
  if (FlagFrameMode>0){
    XposRef=SaveShortBuffXpos;
    OldPosi=GetXposRef(_X_posi.Value);
  }else{
    XposRef=GetXposRef(_X_posi.Value);								
    ShortBuffXpos=SaveShortBuffXpos;
  }
  Title[7][3].XPOS=GetHoldoffIndPos();
  __Set(TRIGG_MODE, UNCONDITION);	//allows arrays to update if in untriggered condition
  VDiff[0]=(HiBatLevel[0]-LoBatLevel[0]);			
  VDiff[1]=(HiBatLevel[1]-LoBatLevel[1]);			
  BatLevelCompensation();
}

u16 GetHoldoffIndPos(void){
  return (((((Title[7][3].Value)*100)/3480)*207)/100)+91;
}

u8 ConfigFile(u8 service){
u8 i;
          if(service==0){                   //save config  

            if (FrameMode==2){
              SaveShortBuffXpos=XposRef;
              _X_posi.Value=GetXpos(OldPosi);  
            } else SaveShortBuffXpos=ShortBuffXpos;

            Current=SaveCurrent[0];			//return to menu item selected before saving config
            _Det=SaveCurrent[1]; 
            i=Save_Param(Title[FILE][1].Value);
            _Curr[_Det].Flag |= UPDAT;

  	    Title[FILE][0].Value=LOAD;    		//preset file menu to load config files
            if(i==0)ConfigFileNumber=Title[FILE][1].Value;  			//file number     
            Title[FILE][2].Value=CFG;

          }else{			    //load config

            ConfigFileNumber=_Curr[1].Value;
            i = Load_Param(_Curr[1].Value);
	    if(i == 0){  
              __Set(TRIGG_MODE, UNCONDITION);         //temporarily setting this allows x_attr to properly update if in untriggered condition 
	      App_init();
              Config_init();
  	      Title[FILE][0].Value=LOAD;    		//preset file menu to load config files
              Title[FILE][1].Value=ConfigFileNumber;  			//file number     
              Title[FILE][2].Value=CFG;
              Update_View_Area();			//in case new loaded config has current=file
              Update=2;					//to update delayed trigger loop under no trigger condition & bypass selective update
            }
          }
          return i;

}


void FileMessage(u8 i){
        if       (i == OK  ) Print_Str(230, 0, (SCRN<<8)+ TEXT1, PRN, " OK  ");  
        else{ 
          if     (i == EMPT) Print_Str(230, 0, (SCRN<<8)+ TEXT1, PRN, " NONE");  
          else if(i == OVER) Print_Str(230, 0, (SCRN<<8)+ TEXT1, PRN, " FULL");  
          else               Print_Str(230, 0, (SCRN<<8)+ TEXT1, PRN, " ERR ");  
        }
        Delayms(1000);
        _Curr[1].Flag |= UPDAT; 
        _Curr[2].Flag |= UPDAT;
}

void EnableChannel(u8 track){
  if  (Title[track][SOURCE].Value == HIDE)  {Title[track][SOURCE].Value = 1;LastSelected=track+1;}
}

void UpdateTriggerMem(void){
	u8 j;
                      Title[TRIGG][SOURCE].Value = PreviousTrigSelect[3];
                      for (j=3;j>0;j--) PreviousTrigSelect[j]=PreviousTrigSelect[(j-1)];
 		      PreviousTrigSelect[0]=0;  

}
         
/*********************************  END OF FILE  ******************************/
