# 1 "Main.c"
# 1 "<command-line>"
# 1 "Main.c"




# 1 "inc/Interrupt.h" 1
# 9 "inc/Interrupt.h"
# 1 "FWLib/inc/stm32f10x_lib.h" 1
# 22 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_map.h" 1
# 26 "FWLib/inc/stm32f10x_map.h"
# 1 "inc/stm32f10x_conf.h" 1
# 21 "inc/stm32f10x_conf.h"
# 1 "FWLib/inc/stm32f10x_type.h" 1
# 23 "FWLib/inc/stm32f10x_type.h"
typedef signed long s32;
typedef signed short s16;
typedef signed char s8;

typedef signed long const sc32;
typedef signed short const sc16;
typedef signed char const sc8;

typedef volatile signed long vs32;
typedef volatile signed short vs16;
typedef volatile signed char vs8;

typedef volatile signed long const vsc32;
typedef volatile signed short const vsc16;
typedef volatile signed char const vsc8;

typedef unsigned long u32;
typedef unsigned short u16;
typedef unsigned char u8;

typedef unsigned long const uc32;
typedef unsigned short const uc16;
typedef unsigned char const uc8;

typedef volatile unsigned long vu32;
typedef volatile unsigned short vu16;
typedef volatile unsigned char vu8;

typedef volatile unsigned long const vuc32;
typedef volatile unsigned short const vuc16;
typedef volatile unsigned char const vuc8;

typedef enum {FALSE = 0, TRUE = !FALSE} bool;

typedef enum {RESET = 0, SET = !RESET} FlagStatus, ITStatus;

typedef enum {DISABLE = 0, ENABLE = !DISABLE} FunctionalState;


typedef enum {ERROR = 0, SUCCESS = !ERROR} ErrorStatus;
# 22 "inc/stm32f10x_conf.h" 2
# 27 "FWLib/inc/stm32f10x_map.h" 2
# 1 "FWLib/inc/stm32f10x_type.h" 1
# 28 "FWLib/inc/stm32f10x_map.h" 2
# 1 "FWLib/inc/cortexm3_macro.h" 1
# 27 "FWLib/inc/cortexm3_macro.h"
void __WFI(void);
void __WFE(void);
void __SEV(void);
void __ISB(void);
void __DSB(void);
void __DMB(void);
void __SVC(void);
u32 __MRS_CONTROL(void);
void __MSR_CONTROL(u32 Control);
u32 __MRS_PSP(void);
void __MSR_PSP(u32 TopOfProcessStack);
u32 __MRS_MSP(void);
void __MSR_MSP(u32 TopOfMainStack);
void __RESETPRIMASK(void);
void __SETPRIMASK(void);
u32 __READ_PRIMASK(void);
void __RESETFAULTMASK(void);
void __SETFAULTMASK(void);
u32 __READ_FAULTMASK(void);
void __BASEPRICONFIG(u32 NewPriority);
u32 __GetBASEPRI(void);
u16 __REV_HalfWord(u16 Data);
u32 __REV_Word(u32 Data);
# 29 "FWLib/inc/stm32f10x_map.h" 2







typedef struct
{
  vu32 SR;
  vu32 CR1;
  vu32 CR2;
  vu32 SMPR1;
  vu32 SMPR2;
  vu32 JOFR1;
  vu32 JOFR2;
  vu32 JOFR3;
  vu32 JOFR4;
  vu32 HTR;
  vu32 LTR;
  vu32 SQR1;
  vu32 SQR2;
  vu32 SQR3;
  vu32 JSQR;
  vu32 JDR1;
  vu32 JDR2;
  vu32 JDR3;
  vu32 JDR4;
  vu32 DR;
} ADC_TypeDef;


typedef struct
{
  u32 RESERVED0;
  vu16 DR1;
  u16 RESERVED1;
  vu16 DR2;
  u16 RESERVED2;
  vu16 DR3;
  u16 RESERVED3;
  vu16 DR4;
  u16 RESERVED4;
  vu16 DR5;
  u16 RESERVED5;
  vu16 DR6;
  u16 RESERVED6;
  vu16 DR7;
  u16 RESERVED7;
  vu16 DR8;
  u16 RESERVED8;
  vu16 DR9;
  u16 RESERVED9;
  vu16 DR10;
  u16 RESERVED10;
  vu16 RTCCR;
  u16 RESERVED11;
  vu16 CR;
  u16 RESERVED12;
  vu16 CSR;
  u16 RESERVED13[5];
  vu16 DR11;
  u16 RESERVED14;
  vu16 DR12;
  u16 RESERVED15;
  vu16 DR13;
  u16 RESERVED16;
  vu16 DR14;
  u16 RESERVED17;
  vu16 DR15;
  u16 RESERVED18;
  vu16 DR16;
  u16 RESERVED19;
  vu16 DR17;
  u16 RESERVED20;
  vu16 DR18;
  u16 RESERVED21;
  vu16 DR19;
  u16 RESERVED22;
  vu16 DR20;
  u16 RESERVED23;
  vu16 DR21;
  u16 RESERVED24;
  vu16 DR22;
  u16 RESERVED25;
  vu16 DR23;
  u16 RESERVED26;
  vu16 DR24;
  u16 RESERVED27;
  vu16 DR25;
  u16 RESERVED28;
  vu16 DR26;
  u16 RESERVED29;
  vu16 DR27;
  u16 RESERVED30;
  vu16 DR28;
  u16 RESERVED31;
  vu16 DR29;
  u16 RESERVED32;
  vu16 DR30;
  u16 RESERVED33;
  vu16 DR31;
  u16 RESERVED34;
  vu16 DR32;
  u16 RESERVED35;
  vu16 DR33;
  u16 RESERVED36;
  vu16 DR34;
  u16 RESERVED37;
  vu16 DR35;
  u16 RESERVED38;
  vu16 DR36;
  u16 RESERVED39;
  vu16 DR37;
  u16 RESERVED40;
  vu16 DR38;
  u16 RESERVED41;
  vu16 DR39;
  u16 RESERVED42;
  vu16 DR40;
  u16 RESERVED43;
  vu16 DR41;
  u16 RESERVED44;
  vu16 DR42;
  u16 RESERVED45;
} BKP_TypeDef;


typedef struct
{
  vu32 TIR;
  vu32 TDTR;
  vu32 TDLR;
  vu32 TDHR;
} CAN_TxMailBox_TypeDef;

typedef struct
{
  vu32 RIR;
  vu32 RDTR;
  vu32 RDLR;
  vu32 RDHR;
} CAN_FIFOMailBox_TypeDef;

typedef struct
{
  vu32 FR1;
  vu32 FR2;
} CAN_FilterRegister_TypeDef;

typedef struct
{
  vu32 MCR;
  vu32 MSR;
  vu32 TSR;
  vu32 RF0R;
  vu32 RF1R;
  vu32 IER;
  vu32 ESR;
  vu32 BTR;
  u32 RESERVED0[88];
  CAN_TxMailBox_TypeDef sTxMailBox[3];
  CAN_FIFOMailBox_TypeDef sFIFOMailBox[2];
  u32 RESERVED1[12];
  vu32 FMR;
  vu32 FM1R;
  u32 RESERVED2;
  vu32 FS1R;
  u32 RESERVED3;
  vu32 FFA1R;
  u32 RESERVED4;
  vu32 FA1R;
  u32 RESERVED5[8];
  CAN_FilterRegister_TypeDef sFilterRegister[14];
} CAN_TypeDef;


typedef struct
{
  vu32 DR;
  vu8 IDR;
  u8 RESERVED0;
  u16 RESERVED1;
  vu32 CR;
} CRC_TypeDef;



typedef struct
{
  vu32 CR;
  vu32 SWTRIGR;
  vu32 DHR12R1;
  vu32 DHR12L1;
  vu32 DHR8R1;
  vu32 DHR12R2;
  vu32 DHR12L2;
  vu32 DHR8R2;
  vu32 DHR12RD;
  vu32 DHR12LD;
  vu32 DHR8RD;
  vu32 DOR1;
  vu32 DOR2;
} DAC_TypeDef;


typedef struct
{
  vu32 IDCODE;
  vu32 CR;
}DBGMCU_TypeDef;


typedef struct
{
  vu32 CCR;
  vu32 CNDTR;
  vu32 CPAR;
  vu32 CMAR;
} DMA_Channel_TypeDef;

typedef struct
{
  vu32 ISR;
  vu32 IFCR;
} DMA_TypeDef;


typedef struct
{
  vu32 IMR;
  vu32 EMR;
  vu32 RTSR;
  vu32 FTSR;
  vu32 SWIER;
  vu32 PR;
} EXTI_TypeDef;


typedef struct
{
  vu32 ACR;
  vu32 KEYR;
  vu32 OPTKEYR;
  vu32 SR;
  vu32 CR;
  vu32 AR;
  vu32 RESERVED;
  vu32 OBR;
  vu32 WRPR;
} FLASH_TypeDef;

typedef struct
{
  vu16 RDP;
  vu16 USER;
  vu16 Data0;
  vu16 Data1;
  vu16 WRP0;
  vu16 WRP1;
  vu16 WRP2;
  vu16 WRP3;
} OB_TypeDef;


typedef struct
{
  vu32 BTCR[8];
} FSMC_Bank1_TypeDef;

typedef struct
{
  vu32 BWTR[7];
} FSMC_Bank1E_TypeDef;

typedef struct
{
  vu32 PCR2;
  vu32 SR2;
  vu32 PMEM2;
  vu32 PATT2;
  u32 RESERVED0;
  vu32 ECCR2;
} FSMC_Bank2_TypeDef;

typedef struct
{
  vu32 PCR3;
  vu32 SR3;
  vu32 PMEM3;
  vu32 PATT3;
  u32 RESERVED0;
  vu32 ECCR3;
} FSMC_Bank3_TypeDef;

typedef struct
{
  vu32 PCR4;
  vu32 SR4;
  vu32 PMEM4;
  vu32 PATT4;
  vu32 PIO4;
} FSMC_Bank4_TypeDef;


typedef struct
{
  vu32 CRL;
  vu32 CRH;
  vu32 IDR;
  vu32 ODR;
  vu32 BSRR;
  vu32 BRR;
  vu32 LCKR;
} GPIO_TypeDef;

typedef struct
{
  vu32 EVCR;
  vu32 MAPR;
  vu32 EXTICR[4];
} AFIO_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 OAR1;
  u16 RESERVED2;
  vu16 OAR2;
  u16 RESERVED3;
  vu16 DR;
  u16 RESERVED4;
  vu16 SR1;
  u16 RESERVED5;
  vu16 SR2;
  u16 RESERVED6;
  vu16 CCR;
  u16 RESERVED7;
  vu16 TRISE;
  u16 RESERVED8;
} I2C_TypeDef;


typedef struct
{
  vu32 KR;
  vu32 PR;
  vu32 RLR;
  vu32 SR;
} IWDG_TypeDef;


typedef struct
{
  vu32 ISER[2];
  u32 RESERVED0[30];
  vu32 ICER[2];
  u32 RSERVED1[30];
  vu32 ISPR[2];
  u32 RESERVED2[30];
  vu32 ICPR[2];
  u32 RESERVED3[30];
  vu32 IABR[2];
  u32 RESERVED4[62];
  vu32 IPR[15];
} NVIC_TypeDef;

typedef struct
{
  vuc32 CPUID;
  vu32 ICSR;
  vu32 VTOR;
  vu32 AIRCR;
  vu32 SCR;
  vu32 CCR;
  vu32 SHPR[3];
  vu32 SHCSR;
  vu32 CFSR;
  vu32 HFSR;
  vu32 DFSR;
  vu32 MMFAR;
  vu32 BFAR;
  vu32 AFSR;
} SCB_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CSR;
} PWR_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CFGR;
  vu32 CIR;
  vu32 APB2RSTR;
  vu32 APB1RSTR;
  vu32 AHBENR;
  vu32 APB2ENR;
  vu32 APB1ENR;
  vu32 BDCR;
  vu32 CSR;
} RCC_TypeDef;


typedef struct
{
  vu16 CRH;
  u16 RESERVED0;
  vu16 CRL;
  u16 RESERVED1;
  vu16 PRLH;
  u16 RESERVED2;
  vu16 PRLL;
  u16 RESERVED3;
  vu16 DIVH;
  u16 RESERVED4;
  vu16 DIVL;
  u16 RESERVED5;
  vu16 CNTH;
  u16 RESERVED6;
  vu16 CNTL;
  u16 RESERVED7;
  vu16 ALRH;
  u16 RESERVED8;
  vu16 ALRL;
  u16 RESERVED9;
} RTC_TypeDef;


typedef struct
{
  vu32 POWER;
  vu32 CLKCR;
  vu32 ARG;
  vu32 CMD;
  vuc32 RESPCMD;
  vuc32 RESP1;
  vuc32 RESP2;
  vuc32 RESP3;
  vuc32 RESP4;
  vu32 DTIMER;
  vu32 DLEN;
  vu32 DCTRL;
  vuc32 DCOUNT;
  vuc32 STA;
  vu32 ICR;
  vu32 MASK;
  u32 RESERVED0[2];
  vuc32 FIFOCNT;
  u32 RESERVED1[13];
  vu32 FIFO;
} SDIO_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 SR;
  u16 RESERVED2;
  vu16 DR;
  u16 RESERVED3;
  vu16 CRCPR;
  u16 RESERVED4;
  vu16 RXCRCR;
  u16 RESERVED5;
  vu16 TXCRCR;
  u16 RESERVED6;
  vu16 I2SCFGR;
  u16 RESERVED7;
  vu16 I2SPR;
  u16 RESERVED8;
} SPI_TypeDef;


typedef struct
{
  vu32 CTRL;
  vu32 LOAD;
  vu32 VAL;
  vuc32 CALIB;
} SysTick_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 SMCR;
  u16 RESERVED2;
  vu16 DIER;
  u16 RESERVED3;
  vu16 SR;
  u16 RESERVED4;
  vu16 EGR;
  u16 RESERVED5;
  vu16 CCMR1;
  u16 RESERVED6;
  vu16 CCMR2;
  u16 RESERVED7;
  vu16 CCER;
  u16 RESERVED8;
  vu16 CNT;
  u16 RESERVED9;
  vu16 PSC;
  u16 RESERVED10;
  vu16 ARR;
  u16 RESERVED11;
  vu16 RCR;
  u16 RESERVED12;
  vu16 CCR1;
  u16 RESERVED13;
  vu16 CCR2;
  u16 RESERVED14;
  vu16 CCR3;
  u16 RESERVED15;
  vu16 CCR4;
  u16 RESERVED16;
  vu16 BDTR;
  u16 RESERVED17;
  vu16 DCR;
  u16 RESERVED18;
  vu16 DMAR;
  u16 RESERVED19;
} TIM_TypeDef;


typedef struct
{
  vu16 SR;
  u16 RESERVED0;
  vu16 DR;
  u16 RESERVED1;
  vu16 BRR;
  u16 RESERVED2;
  vu16 CR1;
  u16 RESERVED3;
  vu16 CR2;
  u16 RESERVED4;
  vu16 CR3;
  u16 RESERVED5;
  vu16 GTPR;
  u16 RESERVED6;
} USART_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CFR;
  vu32 SR;
} WWDG_TypeDef;
# 23 "FWLib/inc/stm32f10x_lib.h" 2
# 49 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_dma.h" 1
# 26 "FWLib/inc/stm32f10x_dma.h"
typedef struct
{
  u32 DMA_PeripheralBaseAddr;
  u32 DMA_MemoryBaseAddr;
  u32 DMA_DIR;
  u32 DMA_BufferSize;
  u32 DMA_PeripheralInc;
  u32 DMA_MemoryInc;
  u32 DMA_PeripheralDataSize;
  u32 DMA_MemoryDataSize;
  u32 DMA_Mode;
  u32 DMA_Priority;
  u32 DMA_M2M;
}DMA_InitTypeDef;
# 284 "FWLib/inc/stm32f10x_dma.h"
void DMA_DeInit(DMA_Channel_TypeDef* DMAy_Channelx);
void DMA_Init(DMA_Channel_TypeDef* DMAy_Channelx, DMA_InitTypeDef* DMA_InitStruct);
void DMA_StructInit(DMA_InitTypeDef* DMA_InitStruct);
void DMA_Cmd(DMA_Channel_TypeDef* DMAy_Channelx, FunctionalState NewState);
void DMA_ITConfig(DMA_Channel_TypeDef* DMAy_Channelx, u32 DMA_IT, FunctionalState NewState);
u16 DMA_GetCurrDataCounter(DMA_Channel_TypeDef* DMAy_Channelx);
FlagStatus DMA_GetFlagStatus(u32 DMA_FLAG);
void DMA_ClearFlag(u32 DMA_FLAG);
ITStatus DMA_GetITStatus(u32 DMA_IT);
void DMA_ClearITPendingBit(u32 DMA_IT);
# 50 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_flash.h" 1
# 27 "FWLib/inc/stm32f10x_flash.h"
typedef enum
{
  FLASH_BUSY = 1,
  FLASH_ERROR_PG,
  FLASH_ERROR_WRP,
  FLASH_COMPLETE,
  FLASH_TIMEOUT
}FLASH_Status;
# 179 "FWLib/inc/stm32f10x_flash.h"
void FLASH_SetLatency(u32 FLASH_Latency);
void FLASH_HalfCycleAccessCmd(u32 FLASH_HalfCycleAccess);
void FLASH_PrefetchBufferCmd(u32 FLASH_PrefetchBuffer);


void FLASH_Unlock(void);
void FLASH_Lock(void);
FLASH_Status FLASH_ErasePage(u32 Page_Address);
FLASH_Status FLASH_EraseAllPages(void);
FLASH_Status FLASH_EraseOptionBytes(void);
FLASH_Status FLASH_ProgramWord(u32 Address, u32 Data);
FLASH_Status FLASH_ProgramHalfWord(u32 Address, u16 Data);
FLASH_Status FLASH_ProgramOptionByteData(u32 Address, u8 Data);
FLASH_Status FLASH_EnableWriteProtection(u32 FLASH_Pages);
FLASH_Status FLASH_ReadOutProtection(FunctionalState NewState);
FLASH_Status FLASH_UserOptionByteConfig(u16 OB_IWDG, u16 OB_STOP, u16 OB_STDBY);
u32 FLASH_GetUserOptionByte(void);
u32 FLASH_GetWriteProtectionOptionByte(void);
FlagStatus FLASH_GetReadOutProtectionStatus(void);
FlagStatus FLASH_GetPrefetchBufferStatus(void);
void FLASH_ITConfig(u16 FLASH_IT, FunctionalState NewState);
FlagStatus FLASH_GetFlagStatus(u16 FLASH_FLAG);
void FLASH_ClearFlag(u16 FLASH_FLAG);
FLASH_Status FLASH_GetStatus(void);
FLASH_Status FLASH_WaitForLastOperation(u32 Timeout);
# 58 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_fsmc.h" 1
# 26 "FWLib/inc/stm32f10x_fsmc.h"
typedef struct
{
  u32 FSMC_AddressSetupTime;
  u32 FSMC_AddressHoldTime;
  u32 FSMC_DataSetupTime;
  u32 FSMC_BusTurnAroundDuration;
  u32 FSMC_CLKDivision;
  u32 FSMC_DataLatency;
  u32 FSMC_AccessMode;
}FSMC_NORSRAMTimingInitTypeDef;


typedef struct
{
  u32 FSMC_Bank;
  u32 FSMC_DataAddressMux;
  u32 FSMC_MemoryType;
  u32 FSMC_MemoryDataWidth;
  u32 FSMC_BurstAccessMode;
  u32 FSMC_WaitSignalPolarity;
  u32 FSMC_WrapMode;
  u32 FSMC_WaitSignalActive;
  u32 FSMC_WriteOperation;
  u32 FSMC_WaitSignal;
  u32 FSMC_ExtendedMode;
  u32 FSMC_WriteBurst;

  FSMC_NORSRAMTimingInitTypeDef* FSMC_ReadWriteTimingStruct;

  FSMC_NORSRAMTimingInitTypeDef* FSMC_WriteTimingStruct;
}FSMC_NORSRAMInitTypeDef;


typedef struct
{
  u32 FSMC_SetupTime;
  u32 FSMC_WaitSetupTime;
  u32 FSMC_HoldSetupTime;
  u32 FSMC_HiZSetupTime;
}FSMC_NAND_PCCARDTimingInitTypeDef;


typedef struct
{
  u32 FSMC_Bank;
  u32 FSMC_Waitfeature;
  u32 FSMC_MemoryDataWidth;
  u32 FSMC_ECC;
  u32 FSMC_ECCPageSize;
  u32 FSMC_AddressLowMapping;
  u32 FSMC_TCLRSetupTime;
  u32 FSMC_TARSetupTime;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_CommonSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_AttributeSpaceTimingStruct;
}FSMC_NANDInitTypeDef;


typedef struct
{
  u32 FSMC_Waitfeature;
  u32 FSMC_AddressLowMapping;
  u32 FSMC_TCLRSetupTime;
  u32 FSMC_TARSetupTime;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_CommonSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_AttributeSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_IOSpaceTimingStruct;
}FSMC_PCCARDInitTypeDef;
# 323 "FWLib/inc/stm32f10x_fsmc.h"
void FSMC_NORSRAMDeInit(u32 FSMC_Bank);
void FSMC_NANDDeInit(u32 FSMC_Bank);
void FSMC_PCCARDDeInit(void);
void FSMC_NORSRAMInit(FSMC_NORSRAMInitTypeDef* FSMC_NORSRAMInitStruct);
void FSMC_NANDInit(FSMC_NANDInitTypeDef* FSMC_NANDInitStruct);
void FSMC_PCCARDInit(FSMC_PCCARDInitTypeDef* FSMC_PCCARDInitStruct);
void FSMC_NORSRAMStructInit(FSMC_NORSRAMInitTypeDef* FSMC_NORSRAMInitStruct);
void FSMC_NANDStructInit(FSMC_NANDInitTypeDef* FSMC_NANDInitStruct);
void FSMC_PCCARDStructInit(FSMC_PCCARDInitTypeDef* FSMC_PCCARDInitStruct);
void FSMC_NORSRAMCmd(u32 FSMC_Bank, FunctionalState NewState);
void FSMC_NANDCmd(u32 FSMC_Bank, FunctionalState NewState);
void FSMC_PCCARDCmd(FunctionalState NewState);
void FSMC_NANDECCCmd(u32 FSMC_Bank, FunctionalState NewState);
u32 FSMC_GetECC(u32 FSMC_Bank);
void FSMC_ITConfig(u32 FSMC_Bank, u32 FSMC_IT, FunctionalState NewState);
FlagStatus FSMC_GetFlagStatus(u32 FSMC_Bank, u32 FSMC_FLAG);
void FSMC_ClearFlag(u32 FSMC_Bank, u32 FSMC_FLAG);
ITStatus FSMC_GetITStatus(u32 FSMC_Bank, u32 FSMC_IT);
void FSMC_ClearITPendingBit(u32 FSMC_Bank, u32 FSMC_IT);
# 62 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_gpio.h" 1
# 34 "FWLib/inc/stm32f10x_gpio.h"
typedef enum
{
  GPIO_Speed_10MHz = 1,
  GPIO_Speed_2MHz,
  GPIO_Speed_50MHz
}GPIOSpeed_TypeDef;





typedef enum
{ GPIO_Mode_AIN = 0x0,
  GPIO_Mode_IN_FLOATING = 0x04,
  GPIO_Mode_IPD = 0x28,
  GPIO_Mode_IPU = 0x48,
  GPIO_Mode_Out_OD = 0x14,
  GPIO_Mode_Out_PP = 0x10,
  GPIO_Mode_AF_OD = 0x1C,
  GPIO_Mode_AF_PP = 0x18
}GPIOMode_TypeDef;







typedef struct
{
  u16 GPIO_Pin;
  GPIOSpeed_TypeDef GPIO_Speed;
  GPIOMode_TypeDef GPIO_Mode;
}GPIO_InitTypeDef;


typedef enum
{ Bit_RESET = 0,
  Bit_SET
}BitAction;
# 217 "FWLib/inc/stm32f10x_gpio.h"
void GPIO_DeInit(GPIO_TypeDef* GPIOx);
void GPIO_AFIODeInit(void);
void GPIO_Init(GPIO_TypeDef* GPIOx, GPIO_InitTypeDef* GPIO_InitStruct);
void GPIO_StructInit(GPIO_InitTypeDef* GPIO_InitStruct);
u8 GPIO_ReadInputDataBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
u16 GPIO_ReadInputData(GPIO_TypeDef* GPIOx);
u8 GPIO_ReadOutputDataBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
u16 GPIO_ReadOutputData(GPIO_TypeDef* GPIOx);
void GPIO_SetBits(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_ResetBits(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_WriteBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin, BitAction BitVal);
void GPIO_Write(GPIO_TypeDef* GPIOx, u16 PortVal);
void GPIO_PinLockConfig(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_EventOutputConfig(u8 GPIO_PortSource, u8 GPIO_PinSource);
void GPIO_EventOutputCmd(FunctionalState NewState);
void GPIO_PinRemapConfig(u32 GPIO_Remap, FunctionalState NewState);
void GPIO_EXTILineConfig(u8 GPIO_PortSource, u8 GPIO_PinSource);
# 66 "FWLib/inc/stm32f10x_lib.h" 2
# 77 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_nvic.h" 1
# 26 "FWLib/inc/stm32f10x_nvic.h"
typedef struct
{
  u8 NVIC_IRQChannel;
  u8 NVIC_IRQChannelPreemptionPriority;
  u8 NVIC_IRQChannelSubPriority;
  FunctionalState NVIC_IRQChannelCmd;
} NVIC_InitTypeDef;
# 253 "FWLib/inc/stm32f10x_nvic.h"
void NVIC_DeInit(void);
void NVIC_SCBDeInit(void);
void NVIC_PriorityGroupConfig(u32 NVIC_PriorityGroup);
void NVIC_Init(NVIC_InitTypeDef* NVIC_InitStruct);
void NVIC_StructInit(NVIC_InitTypeDef* NVIC_InitStruct);
void NVIC_SETPRIMASK(void);
void NVIC_RESETPRIMASK(void);
void NVIC_SETFAULTMASK(void);
void NVIC_RESETFAULTMASK(void);
void NVIC_BASEPRICONFIG(u32 NewPriority);
u32 NVIC_GetBASEPRI(void);
u16 NVIC_GetCurrentPendingIRQChannel(void);
ITStatus NVIC_GetIRQChannelPendingBitStatus(u8 NVIC_IRQChannel);
void NVIC_SetIRQChannelPendingBit(u8 NVIC_IRQChannel);
void NVIC_ClearIRQChannelPendingBit(u8 NVIC_IRQChannel);
u16 NVIC_GetCurrentActiveHandler(void);
ITStatus NVIC_GetIRQChannelActiveBitStatus(u8 NVIC_IRQChannel);
u32 NVIC_GetCPUID(void);
void NVIC_SetVectorTable(u32 NVIC_VectTab, u32 Offset);
void NVIC_GenerateSystemReset(void);
void NVIC_GenerateCoreReset(void);
void NVIC_SystemLPConfig(u8 LowPowerMode, FunctionalState NewState);
void NVIC_SystemHandlerConfig(u32 SystemHandler, FunctionalState NewState);
void NVIC_SystemHandlerPriorityConfig(u32 SystemHandler, u8 SystemHandlerPreemptionPriority,
                                      u8 SystemHandlerSubPriority);
ITStatus NVIC_GetSystemHandlerPendingBitStatus(u32 SystemHandler);
void NVIC_SetSystemHandlerPendingBit(u32 SystemHandler);
void NVIC_ClearSystemHandlerPendingBit(u32 SystemHandler);
ITStatus NVIC_GetSystemHandlerActiveBitStatus(u32 SystemHandler);
u32 NVIC_GetFaultHandlerSources(u32 SystemHandler);
u32 NVIC_GetFaultAddress(u32 SystemHandler);
# 78 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_rcc.h" 1
# 25 "FWLib/inc/stm32f10x_rcc.h"
typedef struct
{
  u32 SYSCLK_Frequency;
  u32 HCLK_Frequency;
  u32 PCLK1_Frequency;
  u32 PCLK2_Frequency;
  u32 ADCCLK_Frequency;
}RCC_ClocksTypeDef;
# 253 "FWLib/inc/stm32f10x_rcc.h"
void RCC_DeInit(void);
void RCC_HSEConfig(u32 RCC_HSE);
ErrorStatus RCC_WaitForHSEStartUp(void);
void RCC_AdjustHSICalibrationValue(u8 HSICalibrationValue);
void RCC_HSICmd(FunctionalState NewState);
void RCC_PLLConfig(u32 RCC_PLLSource, u32 RCC_PLLMul);
void RCC_PLLCmd(FunctionalState NewState);
void RCC_SYSCLKConfig(u32 RCC_SYSCLKSource);
u8 RCC_GetSYSCLKSource(void);
void RCC_HCLKConfig(u32 RCC_SYSCLK);
void RCC_PCLK1Config(u32 RCC_HCLK);
void RCC_PCLK2Config(u32 RCC_HCLK);
void RCC_ITConfig(u8 RCC_IT, FunctionalState NewState);
void RCC_USBCLKConfig(u32 RCC_USBCLKSource);
void RCC_ADCCLKConfig(u32 RCC_PCLK2);
void RCC_LSEConfig(u8 RCC_LSE);
void RCC_LSICmd(FunctionalState NewState);
void RCC_RTCCLKConfig(u32 RCC_RTCCLKSource);
void RCC_RTCCLKCmd(FunctionalState NewState);
void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks);
void RCC_AHBPeriphClockCmd(u32 RCC_AHBPeriph, FunctionalState NewState);
void RCC_APB2PeriphClockCmd(u32 RCC_APB2Periph, FunctionalState NewState);
void RCC_APB1PeriphClockCmd(u32 RCC_APB1Periph, FunctionalState NewState);
void RCC_APB2PeriphResetCmd(u32 RCC_APB2Periph, FunctionalState NewState);
void RCC_APB1PeriphResetCmd(u32 RCC_APB1Periph, FunctionalState NewState);
void RCC_BackupResetCmd(FunctionalState NewState);
void RCC_ClockSecuritySystemCmd(FunctionalState NewState);
void RCC_MCOConfig(u8 RCC_MCO);
FlagStatus RCC_GetFlagStatus(u8 RCC_FLAG);
void RCC_ClearFlag(void);
ITStatus RCC_GetITStatus(u8 RCC_IT);
void RCC_ClearITPendingBit(u8 RCC_IT);
# 86 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_sdio.h" 1
# 25 "FWLib/inc/stm32f10x_sdio.h"
typedef struct
{
  u8 SDIO_ClockDiv;
  u32 SDIO_ClockEdge;
  u32 SDIO_ClockBypass;
  u32 SDIO_ClockPowerSave;
  u32 SDIO_BusWide;
  u32 SDIO_HardwareFlowControl;
} SDIO_InitTypeDef;

typedef struct
{
  u32 SDIO_Argument;
  u32 SDIO_CmdIndex;
  u32 SDIO_Response;
  u32 SDIO_Wait;
  u32 SDIO_CPSM;
} SDIO_CmdInitTypeDef;

typedef struct
{
  u32 SDIO_DataTimeOut;
  u32 SDIO_DataLength;
  u32 SDIO_DataBlockSize;
  u32 SDIO_TransferDir;
  u32 SDIO_TransferMode;
  u32 SDIO_DPSM;
} SDIO_DataInitTypeDef;
# 304 "FWLib/inc/stm32f10x_sdio.h"
void SDIO_DeInit(void);
void SDIO_Init(SDIO_InitTypeDef* SDIO_InitStruct);
void SDIO_StructInit(SDIO_InitTypeDef* SDIO_InitStruct);
void SDIO_ClockCmd(FunctionalState NewState);
void SDIO_SetPowerState(u32 SDIO_PowerState);
u32 SDIO_GetPowerState(void);
void SDIO_ITConfig(u32 SDIO_IT, FunctionalState NewState);
void SDIO_DMACmd(FunctionalState NewState);
void SDIO_SendCommand(SDIO_CmdInitTypeDef *SDIO_CmdInitStruct);
void SDIO_CmdStructInit(SDIO_CmdInitTypeDef* SDIO_CmdInitStruct);
u8 SDIO_GetCommandResponse(void);
u32 SDIO_GetResponse(u32 SDIO_RESP);
void SDIO_DataConfig(SDIO_DataInitTypeDef* SDIO_DataInitStruct);
void SDIO_DataStructInit(SDIO_DataInitTypeDef* SDIO_DataInitStruct);
u32 SDIO_GetDataCounter(void);
u32 SDIO_ReadData(void);
void SDIO_WriteData(u32 Data);
u32 SDIO_GetFIFOCount(void);
void SDIO_StartSDIOReadWait(FunctionalState NewState);
void SDIO_StopSDIOReadWait(FunctionalState NewState);
void SDIO_SetSDIOReadWaitMode(u32 SDIO_ReadWaitMode);
void SDIO_SetSDIOOperation(FunctionalState NewState);
void SDIO_SendSDIOSuspendCmd(FunctionalState NewState);
void SDIO_CommandCompletionCmd(FunctionalState NewState);
void SDIO_CEATAITCmd(FunctionalState NewState);
void SDIO_SendCEATACmd(FunctionalState NewState);
FlagStatus SDIO_GetFlagStatus(u32 SDIO_FLAG);
void SDIO_ClearFlag(u32 SDIO_FLAG);
ITStatus SDIO_GetITStatus(u32 SDIO_IT);
void SDIO_ClearITPendingBit(u32 SDIO_IT);
# 94 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_spi.h" 1
# 26 "FWLib/inc/stm32f10x_spi.h"
typedef struct
{
  u16 SPI_Direction;
  u16 SPI_Mode;
  u16 SPI_DataSize;
  u16 SPI_CPOL;
  u16 SPI_CPHA;
  u16 SPI_NSS;
  u16 SPI_BaudRatePrescaler;
  u16 SPI_FirstBit;
  u16 SPI_CRCPolynomial;
}SPI_InitTypeDef;
# 175 "FWLib/inc/stm32f10x_spi.h"
void SPI_DeInit(SPI_TypeDef* SPIx);
void SPI_Init(SPI_TypeDef* SPIx, SPI_InitTypeDef* SPI_InitStruct);
void SPI_StructInit(SPI_InitTypeDef* SPI_InitStruct);
void SPI_Cmd(SPI_TypeDef* SPIx, FunctionalState NewState);
void SPI_ITConfig(SPI_TypeDef* SPIx, u8 SPI_IT, FunctionalState NewState);
void SPI_DMACmd(SPI_TypeDef* SPIx, u16 SPI_DMAReq, FunctionalState NewState);
void SPI_SendData(SPI_TypeDef* SPIx, u16 Data);
u16 SPI_ReceiveData(SPI_TypeDef* SPIx);
void SPI_NSSInternalSoftwareConfig(SPI_TypeDef* SPIx, u16 SPI_NSSInternalSoft);
void SPI_SSOutputCmd(SPI_TypeDef* SPIx, FunctionalState NewState);
void SPI_DataSizeConfig(SPI_TypeDef* SPIx, u16 SPI_DataSize);
void SPI_TransmitCRC(SPI_TypeDef* SPIx);
void SPI_CalculateCRC(SPI_TypeDef* SPIx, FunctionalState NewState);
u16 SPI_GetCRC(SPI_TypeDef* SPIx, u8 SPI_CRC);
u16 SPI_GetCRCPolynomial(SPI_TypeDef* SPIx);
void SPI_BiDirectionalLineConfig(SPI_TypeDef* SPIx, u16 SPI_Direction);
FlagStatus SPI_GetFlagStatus(SPI_TypeDef* SPIx, u16 SPI_FLAG);
void SPI_ClearFlag(SPI_TypeDef* SPIx, u16 SPI_FLAG);
ITStatus SPI_GetITStatus(SPI_TypeDef* SPIx, u8 SPI_IT);
void SPI_ClearITPendingBit(SPI_TypeDef* SPIx, u8 SPI_IT);
# 98 "FWLib/inc/stm32f10x_lib.h" 2
# 120 "FWLib/inc/stm32f10x_lib.h"
void debug(void);
# 10 "inc/Interrupt.h" 2

extern vu8 Cursor_Cnt, Key_Wait_Cnt, Key_Repeat_Cnt, Key_Buffer, Cnt_mS, Cnt_20mS;
extern vu8 Twink, Blink;
extern u8 Volume, Light;
extern vu16 Delay_Cnt, Beep_mS, Key_Status_Last, Sec_Cnt, PD_Cnt, TimedDeltaView,NotificationTimer,DelayLoopBreak;
extern vu32 Wait_Cnt;
void NMIException(void);
void HardFaultException(void);
void MemManageException(void);
void BusFaultException(void);
void UsageFaultException(void);
void DebugMonitor(void);
void SVCHandler(void);
void PendSVC(void);
void SysTickHandler(void);
void WWDG_IRQHandler(void);
void PVD_IRQHandler(void);
void TAMPER_IRQHandler(void);
void RTC_IRQHandler(void);
void FLASH_IRQHandler(void);
void RCC_IRQHandler(void);
void EXTI0_IRQHandler(void);
void EXTI1_IRQHandler(void);
void EXTI2_IRQHandler(void);
void EXTI3_IRQHandler(void);
void EXTI4_IRQHandler(void);
void DMA1_Channel1_IRQHandler(void);
void DMA1_Channel2_IRQHandler(void);
void DMA1_Channel3_IRQHandler(void);
void DMA1_Channel4_IRQHandler(void);
void DMA1_Channel5_IRQHandler(void);
void DMA1_Channel6_IRQHandler(void);
void DMA1_Channel7_IRQHandler(void);
void ADC1_2_IRQHandler(void);
void USB_HP_CAN_TX_IRQHandler(void);
void USB_LP_CAN_RX0_IRQHandler(void);
void CAN_RX1_IRQHandler(void);
void CAN_SCE_IRQHandler(void);
void EXTI9_5_IRQHandler(void);
void TIM1_BRK_IRQHandler(void);
void TIM1_UP_IRQHandler(void);
void TIM1_TRG_COM_IRQHandler(void);
void TIM1_CC_IRQHandler(void);
void TIM2_IRQHandler(void);
void TIM3_IRQHandler(void);
void TIM4_IRQHandler(void);
void I2C1_EV_IRQHandler(void);
void I2C1_ER_IRQHandler(void);
void I2C2_EV_IRQHandler(void);
void I2C2_ER_IRQHandler(void);
void SPI1_IRQHandler(void);
void SPI2_IRQHandler(void);
void USART1_IRQHandler(void);
void USART2_IRQHandler(void);
void USART3_IRQHandler(void);
void EXTI15_10_IRQHandler(void);
void RTCAlarm_IRQHandler(void);
void USBWakeUp_IRQHandler(void);
void TIM8_BRK_IRQHandler(void);
void TIM8_UP_IRQHandler(void);
void TIM8_TRG_COM_IRQHandler(void);
void TIM8_CC_IRQHandler(void);
void ADC3_IRQHandler(void);
void FSMC_IRQHandler(void);
void SDIO_IRQHandler(void);
void TIM5_IRQHandler(void);
void SPI3_IRQHandler(void);
void UART4_IRQHandler(void);
void UART5_IRQHandler(void);
void TIM6_IRQHandler(void);
void TIM7_IRQHandler(void);
void DMA2_Channel1_IRQHandler(void);
void DMA2_Channel2_IRQHandler(void);
void DMA2_Channel3_IRQHandler(void);
void DMA2_Channel4_5_IRQHandler(void);
# 6 "Main.c" 2
# 1 "inc/Function.h" 1
# 26 "inc/Function.h"
u32 Power(u8 x, u8 y);
void Delayms(u16 mS);
void Int2Str(char *p, s32 n,const char *pUnit, u8 e, u8 Mode, s8 ShiftDigits);
u8 Str2Byte(char x,char y);
void u16ToDec5(char *p, u16 n);
void u8ToDec3(char *p, u8 n);
void u8ToDec2(char *p, u8 n);
void Char2Hex(char *p, u8 n);
void Shor2Hex(char *p, u16 n);
void Word2Hex(char *p, u32 n);
void s16ToDec3(char *p, s16 n);
u32 Int_sqrt(u32 n);
u8 Read_Keys(void);
void s8ToPercen(char *p, s8 n);
# 49 "inc/Function.h"
extern void fix_fft(short fr[], short fi[], short m);
# 7 "Main.c" 2
# 1 "inc/Calibrat.h" 1
# 13 "inc/Calibrat.h"
extern s16 PPM_Comp;

void Calibrat(u8 Channel);
# 8 "Main.c" 2
# 1 "inc/Process.h" 1
# 9 "inc/Process.h"
# 1 "inc/Draw.h" 1
# 10 "inc/Draw.h"
typedef struct
{
  s16 Value;
  u8 Flag;
} trigg;
# 83 "inc/Draw.h"
extern u8 OffsetX;
extern u8 OffsetY;


extern u16 MAX_X;
extern u8 FlagFrameMode;
extern u8 FlagMeter;
extern u8 UpdateMeter;
extern u8 TrgAuto;
extern u16 Color[16];
extern u16 LCD_Buffer1[240], LCD_Buffer2[240];
extern trigg V_Trigg[4];
u16 Get_TAB_8x11(u8 Code, u8 Row);
u8 Get_Ref_Wave(u16 i);
void Print_Clk(u16 x0, u16 y0, u16 Type, u8 Phase);
void Print_Str(u16 x0, u16 y0, u16 Color, u8 Mode, char *s);

void Print_Str2(u16 x0,u16 x1,u16 y0, u16 Type, u8 Mode, char *s,u8 LeadingBlanks,u8 TrailingBlanks);


void Draw_Row(u16 Row);
void Draw_Row_XY(u16 Row);

void Draw_Window(void);

void LoadBase3Buffer(void);
void LoadBase2Buffer(void);

void Draw_Mark(u16 m, u16 n);
void Update_Mark(void);
void Update_View_Area(void);
void Clear_Meter_Area(void);
# 10 "inc/Process.h" 2
# 65 "inc/Process.h"
typedef struct
{
  uc8 STR[8];
  uc16 PSC;
  uc16 ARR;
} A_tab ;

typedef struct
{
  uc8 STR[8];
  uc16 PSC;
  uc16 ARR;
  u16 Duty;
} D_tab ;

extern u8 discard;
extern s16 Xtend;
extern u8 BailoutFlag;

extern u8 CurDefTime;
extern u16 NSamples;
extern u16 CountUnread;
extern u8 TrackBuff [392 * 4];

extern s32 a_Avg, b_Avg, a_Ssq, b_Ssq;



extern s16 a_Max, b_Max, a_Min, b_Min;
extern s16 aT_Max, bT_Max, aT_Min, bT_Min;
extern u8 Rdiscard;

extern u16 Tcs, Tcnt;

extern u16 TaS, TbS, TcS, TdS;
extern u32 Sum[4];
extern u16 NAvg[4];
extern u16 VNAvg[2];
extern s32 VxAvg[2];
extern s32 VxSsq[2];
extern u16 PaS, PbS, PcS, PdS;
extern u16 TaN, TbN, TcN, TdN;
extern u32 PxS[4];
extern u32 TxS[4];
extern u32 TxN[4];

extern u8 FrameMode;
extern u8 FFTflag;

extern u8 Options;
extern u16 TempKp1;
extern u8 ADCoffset;
extern u8 CalFlag;
extern u16 JumpCnt;
extern s8 Kab;
extern s8 Ka1[10], Kb1[10];
extern u16 Ka2[10], Kb2[10];
extern s8 Ka3[10], Kb3[10];
extern s8 HKa1[10], HKb1[10];
extern u16 HKa2[10], HKb2[10];
extern s8 HKa3[10], HKb3[10];
extern s8 LKa1[10], LKb1[10];
extern u16 LKa2[10], LKb2[10];
extern s8 LKa3[10], LKb3[10];
extern u32 DataBuf[4096];
extern u8 ScalingOffset;
extern char Vertical[15][10];
extern s16 TrigSourceEnable;
extern u16 HiBatLevel[2];
extern u16 LoBatLevel[2];
extern u16 PrevBatLevel;
extern u16 VDiff[2];
extern u8 SumResetFlag;
extern u8 EnablePaS;
extern u8 ClearHoldFlag;
extern u8 SlowModeSkip;
extern s16 A_Posi;
extern s16 B_Posi;
extern u8 ClearLeadingEdge;


void BackGround_Reset(void);
void App_init(void);
void View_init(void);
void Update_Range(void);
void Update_Base(void);
void Update_Output(void);
void Update_Trig(u8 service);
void Process(void);
void Synchro(void);
void Send_Data(s16 Va, s16 Vb, u8 C_D, u16 n);
u16 get_bag_max_buf();
void cleardatabuf(u8 Afill, u8 Bfill, u16 n,u8 service);
void Config_init(void);
void TransferFIFO(s16 i,u8 service);
void SetOffset(u8 channel,u8 range, s16 Ypos);
void BatLevelCompensation(void);
void ResetSum(void);
void ClearMinMax(u8 Channels);
void ClearHold(u8 Channels);
void ClearTrackBuff(u8 service);



extern short fr[];
extern short fi[];

extern u8 ShowFFT;
extern u32 NFreq;
extern char NFreqStr[];
extern int imax;
extern short PeakFreq;
extern char PeakFreqStr[];
extern char FreqDivStr[];
extern char FreqT1Str[];
# 9 "Main.c" 2

# 1 "inc/Draw.h" 1
# 11 "Main.c" 2
# 1 "inc/BIOS.h" 1
# 139 "inc/BIOS.h"
typedef struct
{
  u16 LCD_X;
  u16 LCD_Y;
  u16 Yp_Max;
  u16 Xp_Max;
  u16 Tg_Num;
  u16 Yv_Max;
  u16 Xt_Max;
  u16 Co_Max;
  u8 Ya_Num;
  u8 Yd_Num;
  u8 INSERT;
  u16 KpA1;
  u16 KpA2;
  u16 KpB1;
  u16 KpB2;
} G_attr ;

typedef struct
{
  char STR[8];
  s16 KA1;
  u16 KA2;
  s16 KB1;
  u16 KB2;
  u32 SCALE;
} Y_attr ;

typedef struct
{
  char STR[8];
  s16 PSC;
  u16 ARR;
  u16 CCR;
  u16 KP;
  u32 SCALE;
} X_attr ;

typedef struct
{
  char STR[8];
  u8 CHx;
  u8 CMD;
} T_attr ;

extern Y_attr *Y_Attr;
extern X_attr *X_Attr;
extern G_attr *G_Attr;
extern T_attr *T_Attr;




 void __CTR_HP(void);
 void __USB_Istr(void);
 void __USB_Init(void);

 void __LCD_Initial(void);
 void __Clear_Screen(u16 Color);
 void __Point_SCR(u16 x0, u16 y0);
 void __LCD_SetPixl(u16 Color);
 u16 __LCD_GetPixl(void);
 u16 __Get_TAB_8x14(u8 Code, u16 Row);
 void __LCD_Set_Block(u16 x1, u16 x2, u16 y1, u16 y2);

 void __LCD_Copy(uc16 *pBuffer, u16 NumPixel);
 void __LCD_Fill(u16 *pBuffer,u16 NumPixel);
 void __LCD_DMA_Ready(void);

 void __Row_Copy(uc16 *S_Buffer,u16 *T_Buffer);
 void __Row_DMA_Ready(void);

 u32 __Read_FIFO(void);
 void __Display_Str(u16 x0, u16 y0, u16 Color, u8 Mode, char *s);

 u32 __Input_Lic(u16 x0, u8 y0);
 u32 __GetDev_SN(void);

 u8 __Ident(u32 Dev_ID, u32 Proj_ID, u32 Lic_No);

 void __Set(u8 Object, u32 Value);
 u32 __Get(u8 Object);

 void __ExtFlash_PageRD(u8* pBuffer, u32 ReadAddr, u16 NumByteToRead);
 void __ExtFlash_PageWR(u8* pBuffer, u32 WriteAddr);
 u8 __ReadDiskData(u8* pBuffer, u32 ReadAddr, u16 Lenght);
 u8 __ProgDiskPage(u8* pBuffer, u32 ProgAddr);

 u8 __FLASH_Erase(u32 Address);
 u8 __FLASH_Prog(u32 Address, u16 Data);
 void __FLASH_Unlock(void);
 void __FLASH_Lock(void);

 u8 __Chk_SYS(u32 Licence);
 u8* __Chk_DFU(void);
 u8* __Chk_HDW(void);

 u8 __OpenFileWr(u8* Buffer, char* FileName, u16* Cluster, u32* pDirAddr);
 u8 __OpenFileRd(u8* Buffer, char* FileName, u16* Cluster, u32* pDirAddr);
 u8 __ReadFileSec(u8* Buffer, u16* Cluster);
 u8 __ProgFileSec(u8* Buffer, u16* Cluster);
 u8 __CloseFile(u8* Buffer, u32 Lenght, u16* Cluster, u32* pDirAddr);
# 12 "Main.c" 2
# 1 "inc/Menu.h" 1
# 160 "inc/Menu.h"
typedef struct
{
  char *Str;
  u8 Track;
  u8 Item;
  uc16 XPOS1;
  uc16 XPOS2;
  uc8 YPOS;
  u8 Flag;
} meter;

typedef struct
{
  char *Str;
  u16 *Color;
  s16 Limit;
  uc8 MARK;
  u16 XPOS;
  uc8 YPOS;
  s16 Value;
  u8 Flag;
} menu;

extern menu Title[13][4];
extern meter Meter[9];
extern u8 Current, TypeA, Update,BTwink;
extern u8 Detail[14];
extern char NumStr[12];
extern u16 Result_FPS;
extern const char T_UNIT[12], S_UNIT[12], P_UNIT[12], V_UNIT[12];
extern char N_UNIT[12];
extern u8 ConfigFileNumber;
extern s16 Ga_Max;
extern s16 Gb_Max;
extern s16 Ga_Min;
extern s16 Gb_Min;
extern s16 GHa_Max;
extern s16 GHb_Max;
extern s16 GHa_Min;
extern s16 GHb_Min;
extern u8 ShiftDigits;


extern uc16 Y_COLOR[5];

void EnableMeter(void);
void DisableMeter(void);
void Display_Value(u8 i);
void Display_Title(void);
void Display_Meter(void);
void Load_Attr(void);
void Update_Battery(void);
void DisplayBigMeter(u8 MeterNum);
void MeterDefaults(void);
u32 UpScale(u32 Tmp, u16 limit);
# 13 "Main.c" 2
# 1 "inc/File.h" 1
# 28 "inc/File.h"
extern u8 FileBuff[1600];
extern u8 SaveShortBuffXpos;
extern u8 Versions;

u8 Save_Bmp(u8 FileNum);
u8 Color_Num(u16 Color);
u8 Save_Dat(u8 FileNum);
u8 Load_Dat(u8 FileNum);
u8 Save_Buf(u8 FileNum);
u8 Load_Buf(u8 FileNum);
u8 Save_Csv(u8 FileNum);
u8 Make_Filename(u8 FileNum,char* FileName);
void reset_parameter(void);
u8 Load_Param(u8 FileNum);
u8 Save_Param(u8 FileNum);
# 14 "Main.c" 2
# 81 "Main.c"
typedef struct {char*ChartLine;}DisplayLine;
DisplayLine DisplayChart[16]= {{(char*)"                                                  "},{(char*)"!PRESS    >    !#!    !$!     !]!    < O >    < O >  !"},{(char*)"!                                < ADJ > !< MENU > "},{(char*)"                                                  "},{(char*)"!SHORT> !HOLD! AUTO METERS SELECT SET TRG  !BUFFER  "},{(char*)"       !reset TRIG sav/ld  ITEM  CHANNEL          !"},
                              {(char*)"                 !(config)!                        "},{(char*)"       !CH on!                                     "},{(char*)" LONG!> V/DIV !MAN  STAND! T-BASE MTR PGE !MENU/MTR "},{(char*)"       !short TRIG   BY   !short    (w/mtrs! on)!   "},{(char*)"        !cut               !cut  !WAV CAL STDBY TIM!"},{(char*)"                                  !(w/mtrs !off)   "},
                              {(char*)"                         !METERS!                  "},{(char*)" HOLD!> CHART !CAL!  SAVE  CURSOR TRIGGER   !HOLD   "},{(char*)"                  !config RSTRCT HOLDOFF  MIN/MAX! "},{(char*)"                                                  "}};


u8 OldCurrent;
u8 OldDet;
u8 OldMode;
u16 OldPosi=0;
u8 FlagFrameMode;
u8 OldFrame;
u8 FlagMeter;
u8 TrgAuto;
u16 OldPosX;
u16 OldPosY;
s16 PreviousTrigSelect[4];
u8 LastSelected=0;
u8 XposFlag=0;
u8 C_Dmeter[8]={4,8,9,10,11,4,10,11};
u8 UpdateMeter=4;
u8 Timeout=1;
extern u8 _vectors[];
u8 ShortBuffXpos;
u32 Tmp;
u8 SelectiveUpdate=0;
u8 UpdateFlag=0;
u8 BTwinkState=0;
u8 SaveCurrent[2]={0,0};
u8 ChStatus[4]={0,0,0,0};
u8 ABTrigStatus=0;
u8 ChOnStatus[2]={1,1};

u8 OldMeter;
u8 TrgAutoOld;
u16 OldTrack1X;
u16 OldTrack2X;
s16 _Vt1Old;
s16 _Vt2Old;
u16 XposRef;
u8 UpdateCount=0;
u8 ShowFFT=0;

void UpdateBigMeters(void);
void EnableTitleMeters(u8 Service);
void ClearBigMeter1(void);
void UpdateMeterPage(void);
u8 ConfigFile(u8 service);
void FileMessage(u8 i);
u16 GetXposRef(u16 XPos);
u16 GetXpos(u16 XposRef);
u16 GetHoldoffIndPos(void);
void EnableChannel(u8 track);
void UpdateTriggerMem(void);

typedef struct {char*Message;}SelectMessage;
u8 MessageNumber;
# 155 "Main.c"
SelectMessage Show[12]= {{(char*)"       SAVE SETTINGS       "},{(char*)"   WAVE CALIBRATION - ON   "},{(char*)"   WAVE CALIBRATION - OFF  "},{(char*)"    STANDBY TIMER - ON     "},{(char*)"    STANDBY TIMER - OFF    "},{
                              (char*)" CURSOR SELECT METERS - ON "},{(char*)" CURSOR SELECT METERS - OFF"},{(char*)"   TRIGGER HOLDOFF  - ON   "},{(char*)"   TRIGGER HOLDOFF  - OFF  "},{
                              (char*)"      MIN/MAX HOLD ON      "},{(char*)"      MIN/MAX HOLD OFF     "},{(char*)"    WAITING FOR RESET...   "}};

uc16 TrigReset[27]= {300, 150, 100, 75, 35, 15, 10, 10, 5, 3,
                        2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2 };

uc16 NoteTimer[3]= {250, 125, 50};




int main(void)
{
  s32 i;
  u16 Count_FPS = 0, Second = 0;
  u8 j;
  u8 k;
  s16 TmpVT;
  s16 Vt1Old=0;
  s16 Vt2Old=0;


  u16 loopcount=0;
  u8 CounterUpdate;

  NVIC_SetVectorTable(((u32)0x08000000), (u32)&_vectors);

  __USB_Init();

  if(__Get(11)== 0){
    __Display_Str(6*8, 30, 0x07FF, 0, "      FPGA configuration error       ");
    while (1){};
  }

  __Display_Str(32, 50, 0xFFFF, 0, "GCCv1.7W3.1  APP(2.51+SmTech1.8+PMOS69 fixes)");
  __Display_Str(32, 110, 0xFFFF, 0, "         Revision(W3.1) by Wildcat           ");
  Y_Attr = (Y_attr*)__Get(7);
  X_Attr = (X_attr*)__Get(8);
  G_Attr = (G_attr*)__Get(9);
  T_Attr = (T_attr*)__Get(10);
  Load_Attr();
  i = Load_Param(0);
  if(i == 0)
    __Display_Str(6*8, 30, 0x07E0, 0, "     Reload parameter from disk       ");
  else
    __Display_Str(6*8, 30, 0x07FF, 0, "     Parameter record not found       ");

  Beep_mS = 500;
  Delayms(2000);
  App_init();
  Key_Buffer=0;
  Config_init();
  OldMode=(Title[6][0].Value);
  Update=2;
  Title[9][0].Value=1;
  Title[9][1].Value=0;
  Title[9][2].Value=4;
  LoadBase3Buffer();
  LoadBase2Buffer();


  while (1){


    if ((Title[6][0].Value)!=OldMode)
    {
      if ((Title[6][0].Value) ==5 ){
       BackGround_Reset();
        if (OldMode<5){
          OldTrack1X=Title[0][3].Value;
          OldTrack2X=Title[1][3].Value;
        }
        Title[0][3].Value=100;
        Title[1][3].Value=100;
        OffsetX=135;
        OffsetY=100;
        OldMeter=FlagMeter;
        if (FlagMeter==0) {EnableMeter();UpdateMeterPage();}
        _Vt1Old=V_Trigg[0].Value;
        _Vt2Old=V_Trigg[1].Value;
   Vt1Old=0;
   Vt2Old=0;
        TrgAutoOld=TrgAuto;
        TrgAuto=2;
      }

      if (((Title[6][0].Value)<5) &&(OldMode>4)){
        Title[0][3].Value = OldTrack1X;
        Title[1][3].Value = OldTrack2X;
        BackGround_Reset();
        if (OldMeter==0) DisableMeter();
        if (OldMode==5){
        V_Trigg[0].Value=_Vt1Old;
        V_Trigg[1].Value=_Vt2Old;
        TrgAuto=TrgAutoOld;
        }
      }
    }

    if(Title[7][0].Value !=4) OldMode=(Title[6][0].Value);
    if ((Title[6][0].Value)==5) Title[0][3].Value=101+13;
    if ((Title[6][0].Value)==5) Title[1][3].Value=100;

    if (Title[3][0].Value>11)ShowFFT=1; else ShowFFT=0;


    if (((__Get(5)>0)||(Timeout==0))&&(PD_Cnt>0)) PD_Cnt = 600;
    if(PD_Cnt == 0){
      __Set(2, 0);
      __Set(20, 1);
    } else {

        if((Update)&&((Title[6][0].Value)!=0)){
          Title[6][2].Value=GetXpos(XposRef);
 }

        if (SelectiveUpdate&1){
          if ((Title[6][0].Value)==5){
            for (i=0;i<400;i++){
              __Point_SCR(i,214);
              __LCD_SetPixl(Color[5]);
            }
          }
          for (i=0;i<11;i++){
            __Point_SCR(i,12);
            for (j=12;j<214;j++){
              __LCD_SetPixl(Color[5]);
            }
          }
        }

      Synchro();

    if ((TrgAuto>0)&&((Title[6][0].Value)!=0)&&((Title[6][0].Value)!=1)&&((Title[6][0].Value)!=4)){
      if(__Get(2)== 0){
        loopcount++;
        if (loopcount>TrigReset[Title[6][1].Value]){
          if(Title[7][0].Value==4){
            if(TrigSourceEnable==0)V_Trigg[1].Value=Title[1][3].Value;
            if(TrigSourceEnable==1)V_Trigg[0].Value=Title[0][3].Value;
            Update_Trig(0);
          }else{
            V_Trigg[0].Value=Title[0][3].Value;
            V_Trigg[1].Value=Title[1][3].Value;
            Update_Trig(1);
          }
          if ((Title[6][0].Value)!=5) Update_Mark();
          loopcount=0;
        }
      }else{
        if(Title[7][0].Value==4){
          if(TrigSourceEnable==0)ABTrigStatus|=1;
          if(TrigSourceEnable==1)ABTrigStatus|=2;
          if(ABTrigStatus==3) {loopcount=0;ABTrigStatus=0;}
        }else loopcount=0;
      }
    }else loopcount=0;

      if (TimedDeltaView>0){
        Title[10][2].Flag |= 0x02;
        Title[8][2].Flag |= 0x02;
        Title[8][3].Flag |= 0x02;
        Title[10][3].Flag |= 0x02;
      }

      Count_FPS++;
      if(Second != Sec_Cnt) {
        Second = Sec_Cnt;
        Result_FPS = Count_FPS;
        Count_FPS = 0;
        if((__Get(6)>(PrevBatLevel+20))||(__Get(6)<(PrevBatLevel-20))){
          BatLevelCompensation();
          PrevBatLevel=__Get(6);
          SetOffset(0,Title[0][2].Value,Title[0][3].Value);
          SetOffset(1,Title[1][2].Value,Title[1][3].Value);
        }
        Update_Battery();
        if (FlagMeter==1) {
          EnablePaS=1;
          for(i=0; i<9; ++i) Display_Value(i);
          if((__Get(2)!=0)||((Title[6][0].Value)!=2)){
            if(Title[6][1].Value > 10)ResetSum();else SumResetFlag=1;
          }
        }
        if (FlagMeter==0)ResetSum();
      }

        if (((Cnt_20mS%16)>7)&&((Cnt_20mS%16)<16)&&(UpdateFlag==1))UpdateFlag=0;
        if (((Cnt_20mS%16)>=0)&&((Cnt_20mS%16)<8)&&(UpdateFlag==0)){
            UpdateFlag=1;
          if(UpdateCount==2){
            EnablePaS=1;
            UpdateCount=0;
          }else{
            EnablePaS=0;
            UpdateCount++;
          }
            UpdateBigMeters();
            if (FlagMeter==2){
              if((__Get(2)!=0)||((Title[6][0].Value)!=2)){
                if(Title[6][1].Value > 10)ResetSum();else SumResetFlag=1;
              }
            }
         }

      if (FlagMeter>0){
        Display_Meter();
      }
      if ((FlagMeter==2)&&(UpdateMeter==4)){
        FlagMeter=1;
        Display_Value(0);
        FlagMeter=2;
      }
      Display_Title();

    if((Current != 9)&&(NotificationTimer>4))Print_Str(91,0,0x0405,0,Show[MessageNumber].Message);
    if((Current != 9)&&(NotificationTimer>0)&&(NotificationTimer<5)) {Update_View_Area(); NotificationTimer=0;}

      if(Update){
 if ((SelectiveUpdate&1)&&(FlagMeter>0))EnableMeter();
 if (TrgAuto==0) Print_Str(365, 216, ((5<<8)+Title[7][0].Value), 0, "!Man!");
        if (TrgAuto==1) Print_Str(365, 216, ((5<<8)+Title[7][0].Value), 1, "!1/4!");
        if (TrgAuto==2) Print_Str(365, 216, ((5<<8)+Title[7][0].Value), 1, "!1/2!");
        if (TrgAuto==3) Print_Str(365, 216, ((5<<8)+Title[7][0].Value), 1, "!3/4!");
        if ((SelectiveUpdate & 0x02)==0)Update_Range();
        if ((SelectiveUpdate & 0x04)==0)Update_Base();
        if ((SelectiveUpdate & 0x08)==0)Update_Output();
        if ((SelectiveUpdate & 0x10)==0){if(Title[7][0].Value==4) Update_Trig(0); else Update_Trig(1);}
        if (((Title[6][0].Value)!=5)&&(!((Title[3][0].Value==11)||(Title[3][0].Value==10)))) Update_Mark();
        __Set(2, 10*(Title[11][1].Value+1));

 if (SelectiveUpdate & 0x20){
          ClearHoldFlag|=1;
          if(Title[6][1].Value<11)SlowModeSkip=2;
        }
 if (SelectiveUpdate & 0x40){
          ClearHoldFlag|=2;
          if(Title[6][1].Value<11)SlowModeSkip=2;
        }

 if (Current<4)Title[Current][3].Flag|= 0x02;
        if((Current == 7) && (Detail[Current]==3)){
         if ((FrameMode==0)||((Options&1)==0)||((Title[6][0].Value)==1)||((Title[6][0].Value)==5)||((Title[6][0].Value)==4)||((Title[6][0].Value)==0)||(Title[6][1].Value>9)) Detail[Current]=0;
         Title[Current][Detail[Current]].Flag |= 0x02;
        }

        if((Current != 9)&&(NotificationTimer<43)) Update_View_Area();
  if (FlagMeter>0) {
   Title[8][2].Flag |= 0x02;
   Title[8][3].Flag |= 0x02;
   Title[10][3].Flag |= 0x02;
  }else{
              if ((Current == 8)&&(Detail[Current] == 2)) Detail[Current]=0;
            }

        if (FrameMode==2) SaveShortBuffXpos=XposRef;
        Update = 0;
 SelectiveUpdate=0;
      }

    }


    if((Title[4][0].Value == 1)&&((__Get(3)!= 0)||(__Get(2)== 0))){
      Title[4][0].Value = 2;
      Title[4][0].Flag |= 0x02;
    }


    if ((TrgAuto>0)&&((Title[6][0].Value)!=0)){

      if((Current == 7) && (Detail[Current]==2)){
        if ((((Title[6][0].Value)==2)||((Title[6][0].Value)==3))&&(Title[6][1].Value < 10)&&(Options&1)) Detail[Current]=3; else Detail[Current]=0;
        Title[Current][Detail[Current]].Flag |= 0x02;
      }

      if ((Title[7][0].Value == 0)||((Title[7][0].Value==4)&&(TrigSourceEnable==0))){
        TmpVT=aT_Min+Ka1[Title[0][2].Value]+((aT_Max-aT_Min)*(TrgAuto*2)/8);
        if ((TmpVT>Vt1Old +5) || (TmpVT<Vt1Old -5)){
          V_Trigg[0].Value=TmpVT;
          if(Title[7][0].Value==4) Update_Trig(0); else Update_Trig(1);
          if ((Title[6][0].Value)!=5) Update_Mark();
          Vt1Old=V_Trigg[0].Value;
        }
      }
      if ((Title[7][0].Value == 1)||((Title[7][0].Value==4)&&(TrigSourceEnable==1))){
        TmpVT=bT_Min+Kb1[Title[1][2].Value]+((bT_Max-bT_Min)*(TrgAuto*2)/8);
        if ((TmpVT>Vt2Old +5) || (TmpVT<Vt2Old -5)){
          V_Trigg[1].Value=TmpVT;
          if(Title[7][0].Value==4) Update_Trig(0); else Update_Trig(1);
          if ((Title[6][0].Value)!=5) Update_Mark();
          Vt2Old=V_Trigg[1].Value;
        }
      }
    }


    if (FlagFrameMode==1){
          if ((Title[6][0].Value)==0) {
              if (Title[6][1].Value>9) Title[6][2].Value=150; else Title[6][2].Value=0;
              FrameMode=1;
          }
          else
          {
   if ((Title[6][0].Value)!=4){
        Tmp= 150-(((1024 - X_Attr[Title[6][1].Value].KP)*150 + 512)/1024);
      if (Title[6][2].Value>Tmp) {
    Title[6][2].Value=Tmp;
         XposRef=GetXposRef(Tmp);
    Update=1;
      }
      ShortBuffXpos=XposRef;
   }
             FrameMode=2;
          }
    }
    else
    {
      if (((Title[6][0].Value)==0)&&(Title[6][1].Value>9)){
          if (XposFlag==0){
            Title[6][2].Value=150;
            Update=1;
            XposFlag=1;
          }
      }else if (XposFlag==1){
              if ((Title[6][0].Value)==0)Title[6][2].Value=0;
              XposFlag=0;
              Update = 1;
            }else if ((Title[6][0].Value)==0){
              if (Title[6][2].Value>0){
              Title[6][2].Value=0;
              Update = 1;
            }
      }
      FrameMode=0;
    }


    if(Key_Buffer) {
      if(PD_Cnt == 0) {
    App_init();
         Key_Buffer=0;
      }

      PD_Cnt = 600;


    for (i=0;i<4;i++){
       if (Title[i][0].Value == 0){
   if (PreviousTrigSelect[0]==i)PreviousTrigSelect[0]=0;
           for (j=1;j<4;j++){
     if (PreviousTrigSelect[j]==i) for (k=j;k>0;k--) PreviousTrigSelect[k]=PreviousTrigSelect[k-1];
        }
      }
    }



      if(Key_Buffer == 1){

      Delay_Cnt = 1500;
    while (Delay_Cnt > 1000)
    {
       if((__Get(4)& 0x4000)!=0){

        Title[4][0].Flag |= 0x02;
        if((Current == 9)&&(Title[Current][2].Value == 2)) reset_parameter();

        if(Title[4][0].Value==0){
          Title[4][0].Value=1;
        }else{
          Title[4][0].Value=0;
          SelectiveUpdate |=0x60;
          if((Title[6][0].Value)!=2)ClearTrackBuff(1);
          if(((Title[6][0].Value) == 4)||((Title[6][0].Value)==2)||(Options&4)||((FrameMode>0)&&(Title[6][1].Value<3))||((FrameMode==0)&&(Title[6][1].Value<6))){
            __Set(6, 1);
            if(Options&4) {ClearHold(3);ClearMinMax(3);}
            cleardatabuf((A_Posi+ADCoffset),(B_Posi+ADCoffset),get_bag_max_buf(),2);
            if(Title[6][1].Value<11)JumpCnt=0;
            ResetSum();
            EnablePaS=1;
         }
          if(Title[6][1].Value<3){
            MessageNumber=11;
            NotificationTimer=NoteTimer[Title[6][1].Value];
          }
        }
        break;
      }
    }

      while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){
  if((__Get(4)& 0x4000)!=0){

  Title[Current][Detail[Current]].Flag |= 0x02;

  switch (Current){
    case 0:
             if (Detail[Current]==2){
               if(Title[0][0].Value==0){Title[0][0].Value=ChOnStatus[0]; LastSelected=1;} else {ChOnStatus[0]=Title[0][0].Value; Title[0][0].Value=0;}
             }else{
               if(Title[3][0].Value<10)EnableChannel(0);
      }
      break;
    case 1:
             if (Detail[Current]==2){
               if(Title[1][0].Value==0){Title[1][0].Value=ChOnStatus[1]; LastSelected=2;} else {ChOnStatus[1]=Title[1][0].Value; Title[1][0].Value=0;}
             }else{
                if(Title[3][0].Value<10)EnableChannel(1);
      }
             break;
           default:
             if ((Title[0][0].Value != 0)&&(Title[1][0].Value == 0)){
               Current = 0;
        LastSelected=1;
      }else if ((Title[0][0].Value == 0)&&(Title[1][0].Value != 0)){
               Current = 1;
        LastSelected=2;
      }else if(Title[3][0].Value<10){
               switch (LastSelected){
          case 0:
          case 1:
                   Current = 0;
                   EnableChannel(0);
                   break;
          case 2:
                   Current = 1;
                   EnableChannel(1);
               }
             }else{
               if(Title[3][0].Value<14)Current=1;else Current=0;
             }
           }
           Detail[Current] = 2;

  Title[0][0].Flag |= 0x02;
  Title[1][0].Flag |= 0x02;
         Title[Current][Detail[Current]].Flag |= 0x01;
  Title[Current][Detail[Current]].Flag |= 0x02;

         goto bypasslongpress1;
       }

     }

   if(Delay_Cnt == 0){
             j=0;
             for(i=204;i>38;i-=11){
                Print_Str(0,i,0x040C,0,DisplayChart[j++].ChartLine);
             }

      Delayms(300);
      Key_Buffer=0;

     while (1) {
              if (Key_Buffer>0){
                SelectiveUpdate=1;
                break;
              }
     }
   }

     }
     bypasslongpress1:

      if(Key_Buffer== 2){
        Delay_Cnt = 3000;
        while (Delay_Cnt > 2500){
          if((__Get(4)& 0x2000)!=0){
           if ((Title[7][0].Value != 2)&&(Title[7][0].Value != 3)){
         Title[Current][Detail[Current]].Flag |= 0x02;
            if (TrgAuto==0){
    TrgAuto=2;
    Vt1Old=0;
    Vt2Old=0;
  }else {
             TrgAuto++;
             }
            if (TrgAuto>3) {TrgAuto=1;}
            Title[Current][Detail[Current]].Flag |= 0x02;
            if ((Current == 7) && (Detail[Current]==2)){ Title[Current][Detail[Current]].Flag |= 0x02;Detail[Current]=0;}
           }
            break;
          }
        }

   while ((Delay_Cnt >0)&&(Delay_Cnt <=2500)){
          if((__Get(4)& 0x2000)!=0){
           if ((Title[7][0].Value != 2)&&(Title[7][0].Value != 3)){
          Title[Current][Detail[Current]].Flag |= 0x02;
  if (TrgAuto>0) TrgAuto=0;
  Current = 7;
  Detail[Current]=2;
            Title[Current][Detail[Current]].Flag |= 0x02;
           }
          break;
          }
        }
        if((Delay_Cnt == 0) && (Current<2) ){Calibrat(Current); goto BypassExclusions;}
      }

      if(Key_Buffer== 3){

     if((Current!=9)||(Title[Current][2].Value!=4)){
       Delay_Cnt = 1500;
       while (Delay_Cnt > 1000){
          if((__Get(4)& 0x0100)!=0){

           if (FlagMeter==2)
            {
              if ((Title[6][0].Value) != 5){
                DisableMeter();
                if((Title[3][0].Value==11)||(Title[3][0].Value==10))Clear_Meter_Area();
              }else{
                FlagMeter=1;
                EnableMeter();
              }
              break;
           }
            else
            {
              if (FlagMeter==1){
                if(Current > 16)Current=16;
  if(UpdateMeter==4){
                  if(Current==14)Current=15;
                }else{
                  if(Current==13)Current=14;
                  if((Current < 13)&&(Current>10))Current=10;
                }
                FlagMeter=2;
              }
              TimedDeltaView=0;
              EnableMeter();
              break;
            }

          }
       }

     while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){

          if((__Get(4)& 0x0100)!=0){

           Print_Str(119, 90, 0x0405, 0, "LONG PRESS - STANDBY");
           Delayms(1000);
           PD_Cnt = 0;
           __Set(2, 0);
           __Set(20, 1);

            goto bypasslongpress3;
           }
          }

        if(Delay_Cnt == 0){

            SaveCurrent[0]=Current;
            SaveCurrent[1]=Detail[Current];
            Current=9;
            Detail[Current]=1;
            Title[9][0].Value=0;
            Title[9][2].Value=4;
            Title[Current][1].Value=ConfigFileNumber;
            for(i=0;i<3;i++)Title[9][i].Flag|=0x02;

        }
      }else{
        if(Title[Current][2].Value==4){
          if(Title[Current][0].Value == 0){
            i=ConfigFile(0);
            FileMessage(i);
          }else{
            i=ConfigFile(1);
            if(i>0)FileMessage(i);
          }
        }
      }

     }
     bypasslongpress3:




if(Key_Buffer== 4){

    Delay_Cnt = 1500;
    while (Delay_Cnt > 1000)
    {
       if((__Get(4)& 0x0200)!=0){

     Title[Current][Detail[Current]].Flag |= 0x02;
          if ((Current == 2)&&(Detail[Current] == 0))Detail[Current] = 2;
            if ((Current == 3)&&(Detail[Current] == 0))Detail[Current] = 2;

           if ((((Options&1)==0)||((Title[6][0].Value)==1)||((Title[6][0].Value)==5)||((Title[6][0].Value)==4)||((Title[6][0].Value)==0)||(Title[6][1].Value>9))&&(Current == 7)&&(Detail[Current]==2)) Detail[Current]=3;
           if ((FlagMeter!=0)||(Current != 8)|| (Detail[Current]!=1))
  {
   if(Current < 13){
     Title[Current][Detail[Current]].Flag |= 0x02;
     if(Detail[Current] < 3) Detail[Current] += 1;
     else Detail[Current] = 0;

     if ((Current == 5) && (Title[5][0].Value==4) && (Detail[Current]==3)) Detail[Current]=0;
     if ((Current == 5) && (Title[5][0].Value!=4) && (Detail[Current]==2)) Detail[Current]+=1;

     if(Title[Current][Detail[Current]].MARK & 0x80) Detail[Current] = 0;
     if(Title[Current][Detail[Current]].MARK & 0x01) Detail[Current] = 0;
     if((Title[Current][Detail[Current]].MARK & 0x02)&&(Current != 9)&& (Current != 5) ) Detail[Current] = 0;
     Title[Current][Detail[Current]].Flag |= 0x01;
   } else {

                        if(Meter[Current-13].Item>1){

     Meter[Current-13].Flag |= 0x02;

     if((Meter[Current-13].Item>7)||(Meter[Current-13].Item==4)){
       if(Meter[Current-13].Track <= 3)
    Meter[Current-13].Track += 1;
       if(Meter[Current-13].Track > 3)
    Meter[Current-13].Track = 0;
                          }else{
                            if(Meter[Current-13].Track==0)
                              Meter[Current-13].Track=1;
                                else Meter[Current-13].Track=0;
                          }
                        }
        }
       } else {
   Title[Current][Detail[Current]].Flag |= 0x02;
   Detail[Current]=0;
  }
  break;
          }
        }

     while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){
           if((__Get(4)& 0x0200)!=0){

  Title[Current][Detail[Current]].Flag |= 0x02;

  if (Current==0)LastSelected=1;
  if (Current==1)LastSelected=2;
            Current = 6;
  Detail[Current] = 1;
            Title[Current][Detail[Current]].Flag |= 0x01;
  Title[Current][Detail[Current]].Flag |= 0x02;
            goto bypasslongpress4;
           }
          }

        if(Delay_Cnt == 0){

          if (CurDefTime==0){
                  CurDefTime=1;
            if(Current != 9){
                MessageNumber=5;
                NotificationTimer=80;
            }
           Print_Str(153,216,0x0405,0, "X");
          }else{
            CurDefTime=0;
            if(Current != 9){
                MessageNumber=6;
                NotificationTimer=80;
            }
            Print_Str(153,216,0x0405,0, " ");
          }
        }
      }
       bypasslongpress4:


      if(Key_Buffer == 5){

         if ((Title[6][0].Value) == 5){
           if((Current == 0)&&(Detail[Current] == 3) && (OffsetX>45)) OffsetX=OffsetX-2;
           if((Current == 1)&&(Detail[Current] == 3) && (OffsetY>30)) OffsetY=OffsetY-2;
         }
           if((Current == 0)&&(Detail[Current] == 3))SelectiveUpdate|=0x20;
           if((Current == 1)&&(Detail[Current] == 3))SelectiveUpdate|=0x40;

        if ( ((Current == 10)||(Current == 8)) && (FlagMeter==0)) TimedDeltaView=150;

        if(Current < 13){

          for (i=0;i<4;i++){
       if ((Current==i)&&(Detail[Current] == 0)){
    if (Title[i][0].Value == 1){
      if (Title[7][0].Value ==i){
        UpdateTriggerMem();
        Title[7][0].Flag=0x02;
               Title[7][1].Flag=0x02;
                      Title[7][2].Flag=0x02;
                Update_Trig(1);
      }
                    if (PreviousTrigSelect[0]==i)PreviousTrigSelect[0]=0;
      for (j=1;j<4;j++){
   if (PreviousTrigSelect[j]==i) for (k=j;k>0;k--) PreviousTrigSelect[k]=PreviousTrigSelect[k-1];
      }
                  }
              }
          }

          if((Current == 7)&&(Detail[Current]==2)){

            if(Title[7][0].Value==4){
              if(V_Trigg[0].Value > 0)V_Trigg[0].Value--;
              if(V_Trigg[1].Value > 0)V_Trigg[1].Value--;
            }else{
              if(V_Trigg[Title[7][0].Value].Value > 0)
                V_Trigg[Title[7][0].Value].Value--;
            }

          } else if ((Current == 7)&&(Detail[Current] == 3)){
            if ((FrameMode==2)&&(Title[6][1].Value < 10)){
              if (Title[7][3].Value>30) Title[7][3].Value-=30; else Title[7][3].Value=0;
              Title[7][3].XPOS=GetHoldoffIndPos();
              SelectiveUpdate=0x1E;
            }
          } else if((Current == 11)||(Current == 12)){
            if(Title[Current][1].Value > 0) Title[Current][1].Value--;
          } else if((Current == 6)&&(Detail[Current] == 2)){
     if (XposRef>150){
            Title[Current][Detail[Current]].Value-=30;
  XposRef=GetXposRef(Title[Current][Detail[Current]].Value);
            }else {
              if (XposRef>30)XposRef-=6;else if (XposRef>0) XposRef--;
            }
              Title[6][3].Flag |= 0x02;
          } else {
  if ((Current==0)&&(Detail[Current]==0)){
                  LastSelected=1;
                  SelectiveUpdate|=0x20;
                }
  if ((Current==1)&&(Detail[Current]==0)){
                  LastSelected=2;
                  SelectiveUpdate|=0x40;
                }
            if(Title[Current][Detail[Current]].Value > 0){
              Title[Current][Detail[Current]].Value--;
              if ((Current==0)&&(Detail[Current]==2))SelectiveUpdate|=0x20;
              if ((Current==1)&&(Detail[Current]==2))SelectiveUpdate|=0x40;
              if ((Current<2)&&(Detail[Current]==2))Update_Range();
           }
             else if(Title[Current][Detail[Current]].MARK & 0x10) Title[Current][Detail[Current]].Value =Title[Current][Detail[Current]].Limit;


            if((Current == 7)&&(Detail[Current]==0)){
              if(Title[7][0].Value==4){
                if((Title[6][0].Value)==5){
                  Title[Current][Detail[Current]].Value--;
                }else{
                  OldMode=Title[6][0].Value;
                  for(i=0;i<4;i++)ChStatus[i]=Title[i][0].Value;
                }
              }
              if((Title[7][0].Value==3)&&((Title[6][0].Value)!=5)){
                Title[6][0].Value=OldMode;
                Title[6][0].Flag |= 0x02;
                for(i=0;i<4;i++){
                  Title[i][0].Value=ChStatus[i];
    Title[i][0].Flag |= 0x02;
                }
                Title[0][2].Flag |= 0x02; Title[1][2].Flag |= 0x02;
              }
            }


            if ((Current == 6)&&(Detail[Current] == 1)){
              if((__Get(2)!=0)||((Title[6][0].Value)!=2))__Set(32+0, 0x20);
            }
     if((FrameMode<2)&&(Current == 6)&&(Detail[Current] == 1)){
              Tmp=GetXposRef(Title[6][2].Value);
              if (Tmp>150) XposRef=Tmp;
     }
          }

          if((Current == 6)&&(Detail[Current] == 0)){
            if ((Title[6][0].Value)==0) {if (FrameMode>0)ShortBuffXpos=XposRef; else OldPosi=XposRef;}
            if ((Title[6][0].Value)==5) {if (FrameMode>0)XposRef=ShortBuffXpos; else XposRef=OldPosi;}

           Title[4][0].Value = 0;
            Title[4][0].Flag |= 0x02;
          }
          if((Current == 5)&&(Title[5][0].Value != 4)){
             if (Title[5][1].Value > 13)
            Title[5][1].Value = 13;
           }

          if((Current == 9)&&(Title[Current][0].Value == 1)){
            if(Title[Current][2].Value == 0) Title[Current][2].Value = 4;
            if(Title[Current][2].Value == 3) Title[Current][2].Value = 2;
          }
          if((Current == 9)&&(Title[Current][2].Value == 4)) if(Title[Current][1].Value > 9)Title[Current][1].Value=9;
          for(i=0;i<4;i++)Title[Current][i].Flag |= 0x02;
        } else {

          Meter[Current-13].Flag |= 0x02;

             if(Meter[Current-13].Item >0)
               Meter[Current-13].Item -= 1;
             else
               Meter[Current-13].Item = 11;

             if((Meter[Current-13].Track>1)&&(Meter[Current-13].Track<4)){
               if(Meter[Current-13].Item ==7)Meter[Current-13].Item =4;
               if(Meter[Current-13].Item ==3)Meter[Current-13].Item =1;
             }

             if(Meter[Current-13].Item == 1){
               SaveCurrent[0]=Current;
               SaveCurrent[1]=Meter[Current-13].Track;
               Meter[Current-13].Track = 4;
      }

             if(Meter[Current-13].Item == 11){
               if(Current==SaveCurrent[0])
   Meter[Current-13].Track =SaveCurrent[1];
               else
                 Meter[Current-13].Track = UpdateMeter;
             }

        }
      }

      if(Key_Buffer == 7)
 {

      if ((Current != 9)) {

  Delay_Cnt = 1500;
       while (Delay_Cnt > 1000){

            if((__Get(4)& 0x1000)!=0){

                  j=0;
    for (i=0;i<4;i++){
                    if(Title[i][0].Value != 0)j++;
                  }
                  if(j>0){
                    if ((((Title[3][0].Value==11)||(Title[3][0].Value==14)||(Title[3][0].Value==15))&&(Title[0][0].Value!=0))||
                         (((Title[3][0].Value==10)||(Title[3][0].Value==12)||(Title[3][0].Value==13))&&(Title[1][0].Value!=0)))j--;
                  }

                  if (j>2){
             Title[Current][Detail[Current]].Flag |= 0x02;
                 for (i=0;i<4;i++){
                      if (Current==i){
          if (Title[i][0].Value != 0){
            if (Title[7][0].Value !=i){
          for (j=0;j<3;j++) PreviousTrigSelect[j]=PreviousTrigSelect[(j+1)];
              PreviousTrigSelect[3]=Title[7][0].Value;
                            Title[7][0].Value = i;
                            if((i==3)&&((Title[3][0].Value==11)||(Title[3][0].Value==14)||(Title[3][0].Value==15)))Title[7][0].Value=0;
                            if((i==3)&&((Title[3][0].Value==10)||(Title[3][0].Value==12)||(Title[3][0].Value==13)))Title[7][0].Value=1;
              Update_Trig(1);
                            goto BypassShortcut;
                   }
          }
               }
                    }

                    Current=7;
                    Detail[Current]=0;

BypassShortcut:
                    for(i=0;i<3;i++)Title[7][i].Flag=0x02;
      goto bypasslongpress5;
                  }


     if(((Title[6][0].Value)!=5)&&(Title[7][0].Value==1)&&(Title[0][0].Value!=0)&&(Title[1][0].Value!=0)&&(Title[2][0].Value==0)&&(Title[3][0].Value==0)){
                     OldMode=Title[6][0].Value;
                     Title[7][0].Value=4;
       Update_Trig(1);
                   }else{
            for (i=0;i<4;i++){
       if (Title[i][0].Value != 0){
     if (Title[7][0].Value !=i){
                                   if(Title[7][0].Value==4){
                                     Title[6][0].Value=OldMode;
                                     Title[6][0].Flag |= 0x02;
                                     Update_Base();
                                   }else{
                   for (j=0;j<3;j++) PreviousTrigSelect[j]=PreviousTrigSelect[(j+1)];
                       PreviousTrigSelect[3]=Title[7][0].Value;
                                   }
                                   Title[7][0].Value = i;
                                   if((i==3)&&((Title[3][0].Value==11)||(Title[3][0].Value==14)||(Title[3][0].Value==15)))Title[7][0].Value=0;
                                   if((i==3)&&((Title[3][0].Value==10)||(Title[3][0].Value==12)||(Title[3][0].Value==13)))Title[7][0].Value=1;

       Title[7][0].Flag=0x02;
            Title[7][1].Flag=0x02;
                            Title[7][2].Flag=0x02;
       Update_Trig(1);
       break;
     }
              }
                        }
                   }

          break;
          }
 }

     while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){
          if((__Get(4)& 0x1000)!=0){

        if (FlagMeter>0){
                SaveCurrent[0]=0;
                SaveCurrent[1]=0;
                if (UpdateMeter<4){
                 if((FlagMeter==2)&&(UpdateMeter==3)&&(Current==14))Current=15;
                 UpdateMeter=UpdateMeter+1;
                 if (((Title[6][0].Value)==5)&&(UpdateMeter>1)) UpdateMeter=4;
                }
                else{
                 if (FlagMeter==2){
                   ClearBigMeter1();
                   if((Current < 13)&&(Current>10))Current=10;
                   if((Current==13)||(Current==15))Current=14;
                 }
                 UpdateMeter=0;
                }
                UpdateMeterPage();

              }else{

            if (CalFlag==0){
                CalFlag=1;
                if(Current != 9){
                MessageNumber=1;
                NotificationTimer=80;
                }
                  Print_Str(137,216,0x0405,0, "C");
            }else{
              CalFlag=0;
              if(Current != 9){
                MessageNumber=2;
                NotificationTimer=80;
              }
                   Print_Str(137,216,0x0405,0, "U");
            }

          }
          goto bypasslongpress5;

        }
      }

         if(Delay_Cnt == 0){
           if ((Options&1)==0) {
             Options|=1;
             if ((((Title[6][0].Value)==2)||((Title[6][0].Value)==3))&&(Title[6][1].Value < 10)){Current = 7; Detail[Current] = 3;}
      Title[Current][Detail[Current]].Flag |= 0x02;
                MessageNumber=7;
                NotificationTimer=80;
           }else{
             Options&=0xFE;
             if ((Current==7)&&(Detail[Current]==3)) Detail[Current]=0;
             Title[Current][Detail[Current]].Flag |= 0x02;
                MessageNumber=8;
                NotificationTimer=80;
           }
         }
      }

        if(Current == 9){
          Print_Str(230, 0, (5<<8)+ 10, 0, " >   ");
        if(Title[Current][0].Value == 0){
          switch (Title[Current][2].Value){
          case 0:
            i = Save_Bmp(Title[Current][1].Value);
            break;
          case 1:
            i=Save_Dat(Title[Current][1].Value);
            Delayms(1000);
            break;
          case 2:
            i=Save_Buf(Title[Current][1].Value);
             break;
          case 3:
            i=Save_Csv(Title[Current][1].Value);
            break;
          case 4:
            i=ConfigFile(0);
          }
          if(Title[Current][2].Value!=4)Title[Current][1].Value++;
        } else {
          i=0;
          if(Title[Current][2].Value==1) i = Load_Dat(Title[Current][1].Value);
          if(Title[Current][2].Value==2) i = Load_Buf(Title[Current][1].Value);
          if(Title[Current][2].Value==4){
            i=ConfigFile(1);
            Current=9;
            for(j=0;j<3;j++)Title[9][j].Flag|=0x02;
     if(i == 0)goto bypasslongpress5;
          }
        }
        FileMessage(i);
        }
    }
bypasslongpress5:


      if(Key_Buffer == 6){

     if ((Title[6][0].Value) == 5){
           if((Current == 0)&&(Detail[Current] == 3) && (OffsetX<215)) OffsetX=OffsetX+2;
           if((Current == 1)&&(Detail[Current] == 3) && (OffsetY<170)) OffsetY=OffsetY+2;
         }

           if((Current == 0)&&(Detail[Current] == 3))SelectiveUpdate|=0x20;
           if((Current == 1)&&(Detail[Current] == 3))SelectiveUpdate|=0x40;

        if ( ((Current == 10)||(Current == 8)) && (FlagMeter==0)) TimedDeltaView=150;
        if ((TrgAuto>0)&&(Current == 7) && Detail[Current]==2) Detail[Current]=0;
        if(Current < 13){

         for (i=0;i<4;i++){
           if ((Current==i)&&(Detail[Current] == 0)){
             if (Title[7][0].Value ==i){

               switch (Current){
                 case 0:
                 case 1:
               if (Title[i][0].Value == 2)UpdateTriggerMem();
       break;
                 case 2:
               if (Title[i][0].Value == 1)UpdateTriggerMem();
       break;
                 case 3:
              if (Title[i][0].Value == 9)UpdateTriggerMem();
               }
        Title[7][0].Flag=0x02;
        Title[7][1].Flag=0x02;
               Title[7][2].Flag=0x02;
        Update_Trig(1);

             }

      if (PreviousTrigSelect[0]==i)PreviousTrigSelect[0]=0;
             for (j=1;j<4;j++){
        if (PreviousTrigSelect[j]==i) for (k=j;k>0;k--) PreviousTrigSelect[k]=PreviousTrigSelect[k-1];
      }

           }
         }

          if((Current == 7)&&(Detail[Current]==2)){

            if(Title[7][0].Value==4){
              if(V_Trigg[0].Value < 200)V_Trigg[0].Value++;
              if(V_Trigg[1].Value < 200)V_Trigg[1].Value++;
            }else{
              if(V_Trigg[Title[7][0].Value].Value < 200)
                V_Trigg[Title[7][0].Value].Value++;
            }

          } else if ((Current == 7)&&(Detail[Current] == 3)){
            if ((FrameMode==2)&&(Title[6][1].Value < 10)){
              if (Title[7][3].Value<3360) Title[7][3].Value+=30;
              Title[7][3].XPOS=GetHoldoffIndPos();
              SelectiveUpdate=0x1E;
            }
          } else if ((Current == 11)||(Current == 12)){
            if(Title[Current][1].Value < Title[Current][1].Limit) Title[Current][1].Value++;
         } else if ((Current == 6)&&(Detail[Current] == 2) ){
  if (XposRef<151) {
           if (XposRef<30) XposRef++; else XposRef+=6;
            }else{
              if (Title[Current][Detail[Current]].Value <(Title[Current][Detail[Current]].Limit-30)) Title[Current][Detail[Current]].Value += 30;
               else if (Title[Current][Detail[Current]].Value <(Title[Current][Detail[Current]].Limit-6)) Title[Current][Detail[Current]].Value +=6;
               else if (Title[Current][Detail[Current]].Value < (Title[Current][Detail[Current]].Limit)) Title[Current][Detail[Current]].Value ++;
            XposRef=GetXposRef(Title[Current][Detail[Current]].Value);
            }
            Title[6][3].Flag |= 0x02;
          } else if ((Current == 10) && ((Detail[Current]==0) || (Detail[Current]==1))){

                    if (FlagMeter>0){
                      if (Title[Current][Detail[Current]].Value <(Title[Current][Detail[Current]].Limit-95)) Title[Current][Detail[Current]].Value ++;
                    }
                    else
                    {
                      if (Title[Current][Detail[Current]].Value <Title[Current][Detail[Current]].Limit-(11 -2)) Title[Current][Detail[Current]].Value ++;
                    }
           } else {

  if ((Current==0)&&(Detail[Current]==0)){
                  LastSelected=1;
                  SelectiveUpdate|=0x20;
                }
  if ((Current==1)&&(Detail[Current]==0)){
                  LastSelected=2;
                  SelectiveUpdate|=0x40;
                }

              if(Title[Current][Detail[Current]].Value < Title[Current][Detail[Current]].Limit){
                Title[Current][Detail[Current]].Value++;
                if ((Current==0)&&(Detail[Current]==2))SelectiveUpdate|=0x20;
                if ((Current==1)&&(Detail[Current]==2))SelectiveUpdate|=0x40;
                if ((Current<2)&&(Detail[Current]==2))Update_Range();
              }else if(Title[Current][Detail[Current]].MARK & 0x10)Title[Current][Detail[Current]].Value = 0;

            if((Current == 7)&&(Detail[Current]==0)){
              if(Title[7][0].Value==4){
                if((Title[6][0].Value)==5){
                  Title[Current][Detail[Current]].Value=0;
                }else{
                  OldMode=Title[6][0].Value;
                  for(i=0;i<4;i++)ChStatus[i]=Title[i][0].Value;
                }
              }

              if((Title[7][0].Value==0)&&((Title[6][0].Value)!=5)){
                Title[6][0].Value=OldMode;
                Title[6][0].Flag |= 0x02;
                for(i=0;i<4;i++){
                  Title[i][0].Value=ChStatus[i];
    Title[i][0].Flag |= 0x02;
                }
                Title[0][2].Flag |= 0x02; Title[1][2].Flag |= 0x02;
              }
            }

            if ((Current == 6)&&(Detail[Current] == 1)){
              if((__Get(2)!=0)||((Title[6][0].Value)!=2))__Set(32+0, 0x20);
            }
     if((FrameMode<2)&&(Current == 6)&&(Detail[Current] == 1)){
              if (XposRef>150)XposRef=GetXposRef(Title[6][2].Value);
     }
          }
          if((Current == 6)&&(Detail[Current] == 0)){
            if ((Title[6][0].Value)==0) {if (FrameMode>0)ShortBuffXpos=XposRef; else OldPosi=XposRef;}
            if ((Title[6][0].Value)==1) {if (FrameMode>0)XposRef=ShortBuffXpos; else XposRef=OldPosi;}
            Title[4][0].Value = 0;
            Title[4][0].Flag |= 0x02;
          }
          if((Current == 5)&&(Title[5][0].Value != 4)){
            if(Title[5][1].Value > 13)
         Title[5][1].Value = 13;
          }

          if((Current == 9)&&(Title[Current][0].Value == 1)){
            if(Title[Current][2].Value == 0) Title[Current][2].Value = 1;
            if(Title[Current][2].Value == 3) Title[Current][2].Value = 4;
          }
          if((Current == 9)&&(Title[Current][2].Value == 4)) if(Title[Current][1].Value > 9)Title[Current][1].Value=9;

          for(i=0;i<4;i++)Title[Current][i].Flag |= 0x02;
        } else {


          Meter[Current-13].Flag |= 0x02;

            if(Meter[Current-13].Item < 11)
              Meter[Current-13].Item += 1;
            else{
              Meter[Current-13].Item = 0;
              SaveCurrent[0]=Current;
              SaveCurrent[1]=Meter[Current-13].Track;
       Meter[Current-13].Track = 4;
            }

            if(Meter[Current-13].Item == 2){
               if(Current==SaveCurrent[0])
   Meter[Current-13].Track =SaveCurrent[1];
               else
                 Meter[Current-13].Track = UpdateMeter;
            }

            if((Meter[Current-13].Track>1)&&(Meter[Current-13].Track<4)){
              if(Meter[Current-13].Item ==2)Meter[Current-13].Item =4;
              if(Meter[Current-13].Item ==5)Meter[Current-13].Item =8;
            }
        }
      }

      if(Key_Buffer == 9){
        if(Current < 13){
          Title[Current][Detail[Current]].Flag |= 0x02;

          if(Current==10){Current=8; goto NoDec;}
          if(Current==9){
            if((FlagMeter==1)||((FlagMeter==2)&&(UpdateMeter==4))){Current=12;goto NoDec;}
            Current=10;
            goto NoDec;
          }

          if (FlagMeter>0){

            if(Current == 0) {Current = 0;}
            else {Current --;}
          }
          else
          {

            if(Current == 0) {Current = 0;}
            else {Current --;}
            if ((Current == 8)&&(Detail[Current] == 2)) Detail[Current]=0;
          }
     if (Current<4)Title[Current][3].Flag|= 0x02;
          if(Current == 4) Current --;
NoDec:
          Title[Current][Detail[Current]].Flag |= 0x01;
          Title[Current][Detail[Current]].Flag |= 0x02;
          if (Current==9){
            if((Title[Current][2].Value == 4)&&(Title[Current][1].Value > 9))Title[Current][1].Value=9;
            for(i=0;i<4;i++)Title[Current][i].Flag |= 0x02;
   }

        } else if (FlagMeter==1){
          Meter[Current-13].Flag |= 0x02;
          if(Current == 13) Current = 21; else Current --;
          Meter[Current-13].Flag |= 0x01;
        } else if (FlagMeter==2){
          if (UpdateMeter!=4){if(Current==14)Current=16; else Current--;}
          else{
            if(Current==13){
              Meter[Current-13].Flag &= (!0x02 & !0x01);
              Current=16;
            }else if(Current==15){
              Meter[Current-13].Flag |= 0x02;
              Meter[Current-13].Flag |= 0x01;
              Current=13;
            }else Current--;
          }
        }
      }

      if(Key_Buffer == 10){

     Delay_Cnt = 1500;
     while (Delay_Cnt > 1000){
       if((__Get(4)& 0x0040)!=0){

          if(Current != 9){
            if (FlagFrameMode==0){
              FlagFrameMode=1;
              SelectiveUpdate |=0x60;
              if ((Title[6][0].Value)!=0) {
      OldPosi=XposRef;
      XposRef=ShortBuffXpos;
                    Update=2;
              }
            }
            else
            {
              FlagFrameMode=0;
              SelectiveUpdate |=0x60;
              if ((Title[6][0].Value)!=0) {
                ShortBuffXpos=XposRef;
     XposRef=OldPosi;
             }
         if ((Current == 7) && (Detail[Current]==3)) Detail[Current]=0; Title[Current][Detail[Current]].Flag |= 0x02;
            }
  Update_View_Area();
          }

       break;
  }
 }


    while ((Delay_Cnt >0)&&(Delay_Cnt <=1000)){
     if((__Get(4)& 0x0040)!=0){

       Title[Current][Detail[Current]].Flag |= 0x02;
        if (FlagMeter==0){
   if (((Current <= 21)&& (Current >= 13)) || (Current==11) || (Current==12) ){
    Current=0 ;
   }

            if(Current != 9){
                if (Timeout==0){
                  Timeout=1;
                MessageNumber=3;
                NotificationTimer=80;
                }else{
                  Timeout=0;
                MessageNumber=4;
                NotificationTimer=80;
                }
             }

        } else {
   if(Current < 13) {
                          OldCurrent=Current;
     if(UpdateMeter==4)Current = 13;else Current=14;
   } else {

                              if(FlagMeter==1){
    for(CounterUpdate=0;CounterUpdate<9;++CounterUpdate){
     Meter[CounterUpdate].Flag |= 0x02;
    }
                              }else if(FlagMeter==2){
    for(CounterUpdate=0;CounterUpdate<4;++CounterUpdate){
     Meter[CounterUpdate].Flag |= 0x02;
                                }
                              }
     Current = OldCurrent;
   }
         }
           goto bypasslongpress6;

   }
       }


       if(Delay_Cnt == 0){
              if ((Options&4)==0){
                  Options|=4;
                  for(CounterUpdate=1;CounterUpdate<9;++CounterUpdate){
                    Meter[CounterUpdate].Flag |= 0x02;
                  }

                  if(Current != 9){
                      MessageNumber=9;
                      NotificationTimer=80;
                  }
                  Print_Str(145,216,0x0405,0,"H");
                  SelectiveUpdate |=0x60;
               }else{
                  Options&=0xFB;

                  for(CounterUpdate=1;CounterUpdate<9;++CounterUpdate){
                    Meter[CounterUpdate].Flag |= 0x02;
                  }
                  if(Current != 9){
                    MessageNumber=10;
                    NotificationTimer=80;
                  }
                  Print_Str(145,216,0x0405,0," ");
              }
       }
     }

bypasslongpress6:


      if(Key_Buffer == 8){
        if(Current < 13){
          Title[Current][Detail[Current]].Flag |= 0x02;

          if(Current==9)goto NoInc;

          if ((FlagMeter==0) && (Current == 10)) {
                        Current=9;
   goto NoInc;
   }

          if(Current == 12)
                        Current=9;
          else if((FlagMeter==2)&&(UpdateMeter!=4)){
            if (Current<10)Current++;else {Current=9;goto NoInc;}
            if(Current==9)Current++;
          }else {Current ++;if(Current==9)Current++;}

   if (Current<4)Title[Current][3].Flag|= 0x02;
          if ((FlagMeter==0)&&(Current==8)&&(Detail[Current] == 2)) Detail[Current]=0;

NoInc:
          if(Current == 4) Current ++;
          Title[Current][Detail[Current]].Flag |= 0x01;
          Title[Current][Detail[Current]].Flag |= 0x02;
          if (Current==9){
            if((Title[Current][2].Value == 4)&&(Title[Current][1].Value > 9))Title[Current][1].Value=9;
          for(i=0;i<4;i++)Title[Current][i].Flag |= 0x02;
          }
        }else if (FlagMeter==1){
            Meter[Current-13].Flag |= 0x02;
            if(Current == 21) Current=13; else Current ++;
            Meter[Current-13].Flag |= 0x01;
        }else if (FlagMeter==2){
          if(UpdateMeter!=4){if(Current==16)Current=14;else Current++;}
          else{
            if(Current == 13){
  Meter[Current-13].Flag &= (!0x02 & !0x01);
                Current=15;
            }else if(Current==16){
               Current=13;
               Meter[Current-13].Flag |= 0x02;
               Meter[Current-13].Flag |= 0x01;
            }else Current++;
          }
        }
      }


     MeterDefaults();
     if((Title[0][0].Value==0)&&(Title[1][0].Value==0)&&(Title[2][0].Value==0)&&(Title[3][0].Value>9)){
 if((Title[3][0].Value==11)||(Title[3][0].Value==15)||(Title[3][0].Value==14))Title[7][0].Value=0;
        if((Title[3][0].Value==10)|| (Title[3][0].Value==13)||(Title[3][0].Value==12))Title[7][0].Value=1;
        for(i=0;i<3;i++)Title[7][i].Flag=0x02;
        Update_Trig(1);
     }else if (Title[7][0].Value==4){
        Title[6][0].Value=2;
        Title[6][0].Flag |= 0x02;
        if(Title[0][0].Value==0)Title[0][0].Value=1;
        if(Title[1][0].Value==0)Title[1][0].Value=1;
        Title[2][0].Value=0;
        Title[3][0].Value=0;
        for(i=0;i<4;i++)Title[i][0].Flag |= 0x02;
        Title[0][2].Flag |= 0x02; Title[1][2].Flag |= 0x02;
        for(i=0;i<3;i++)Title[7][i].Flag=0x02;
      }

      if (Update!=2){

        if((Current == 6)&&(Detail[Current] == 0)&&((Key_Buffer==5)||(Key_Buffer==6)))goto BypassExclusions;


        if (!((Current == 6)&&(Detail[Current] == 1)&&((Key_Buffer==5)||(Key_Buffer==6))))SelectiveUpdate|=0x04;

        if (!((((Current == 7)&&((Title[7][0].Value<4)||(Detail[Current]<2)))||(Current<4)||((Current==10)
          &&(Title[7][0].Value<4)))&&((Key_Buffer==5)||(Key_Buffer==6)||(Key_Buffer==7))))
            SelectiveUpdate|=0x10;

        if (!((Current<4)&&(Detail[Current]<3)&&((Key_Buffer==5)||(Key_Buffer==6))))SelectiveUpdate|=0x02;


BypassExclusions:

 if((Current<4)&&(Detail[Current]==3)&&((Key_Buffer==5)||(Key_Buffer==6))){
          SetOffset(0,Title[0][2].Value,Title[0][3].Value);
          SetOffset(1,Title[1][2].Value,Title[1][3].Value);
        }

        if((Current == 6)&&(Detail[Current] == 2)&&((Key_Buffer==5)||(Key_Buffer==6))){
          if((Title[4][0].Value == 0)&&((((Title[6][0].Value)==2)&&(__Get(2)==0))||(Title[6][1].Value <8))){
            Title[6][2].Value=GetXpos(XposRef);
            Title[4][0].Value=1;
            Process();
            Title[4][0].Value=0;
          }
        }

        if ((Current==6)&&((Title[6][0].Value)==2)&&(Detail[Current] == 1)&&((Key_Buffer==5)||(Key_Buffer==6))){
            EnablePaS=1;
            ResetSum();
        }

        Update = 1;
      }

      if(Title[0][0].Value>0)ChOnStatus[0]=Title[0][0].Value;
      if(Title[1][0].Value>0)ChOnStatus[1]=Title[1][0].Value;
      Key_Buffer=0;
    }
  }
}

u16 GetXposRef(u16 XPos){
  return (((10240000/X_Attr[Title[6][1].Value].KP)*XPos)+5000)/10000;
}

u16 GetXpos(u16 XposRef){
        return((((X_Attr[Title[6][1].Value].KP*10000)/1024)*XposRef)+5000)/10000;
}

void MeterDefaults(void){
u8 CounterUpdate;

              if ((UpdateMeter==4)&&(FlagMeter>0)){

                Meter[0].Flag |= 0x02;
                Meter[0].Item = 0;
                Meter[0].Track = 4;
                if(FlagMeter==1){
                  for(CounterUpdate=1;CounterUpdate<9;++CounterUpdate){
                    Meter[CounterUpdate].Flag |= 0x02;
                  }
                }else if(FlagMeter==2){
                  for(CounterUpdate=1;CounterUpdate<4;++CounterUpdate){
                    Meter[CounterUpdate].Flag |= 0x02;
                  }
                }

                if (((Title[6][0].Value)==5) || ( (Title[2][0].Value == 0) && (Title[3][0].Value == 0)))
                {
                  if(FlagMeter==1){
                    Meter[1].Item = 3; Meter[1].Track = 0;
                    Meter[2].Item = 2; Meter[2].Track = 0;
                    Meter[3].Item = 7; Meter[3].Track = 0;
                    Meter[4].Item = 4; Meter[4].Track = 0;
                    Meter[5].Item = 3; Meter[5].Track = 1;
                    Meter[6].Item = 2; Meter[6].Track = 1;
                    Meter[7].Item = 7; Meter[7].Track = 1;
                    Meter[8].Item = 4; Meter[8].Track = 1;
                  }else{
                    Meter[2].Item = 2; Meter[2].Track = 0;
                    Meter[3].Item = 2; Meter[3].Track = 1;
                  }
                }
                else
                {
                  if(FlagMeter==1){
                    Meter[1].Item = 4; Meter[1].Track = 0;
                    Meter[2].Item = 2; Meter[2].Track = 0;
                    Meter[3].Item = 4; Meter[3].Track = 1;
                    Meter[4].Item = 2; Meter[4].Track = 1;
                    Meter[5].Item = 4; Meter[5].Track = 2;
                    Meter[6].Item = 8; Meter[6].Track = 2;
                    Meter[7].Item = 4; Meter[7].Track = 3;
                    Meter[8].Item = 8; Meter[8].Track = 3;
                  }else{
                    Meter[2].Item = 2; Meter[2].Track = 0;
                    Meter[3].Item = 2; Meter[3].Track = 1;
                  }
                }
               }
}


void DisableMeter(void)
{
              if (((Current <= 21)&& (Current >= 13)) || (Current==11) || (Current==12) ){Title[Current][Detail[Current]].Flag |= 0x02;Current=0 ;}
              FlagMeter=0;
              MAX_X=(386+11);
              if ((Current == 8)&&(Detail[Current] == 2)) Detail[Current]=0;
              }

void EnableMeter(void)
{
  u8 CounterUpdate;
  u8 i;

            if (Title[10][0].Value>Title[10][0].Limit-95) Title[10][0].Value=Title[10][0].Limit-95;
            if (Title[10][1].Value>Title[10][1].Limit-95) Title[10][1].Value=Title[10][1].Limit-95;
            Clear_Meter_Area();
            if (FlagMeter==0)FlagMeter=1;
            MAX_X=(300 + 11);
            Update=1;
            MeterDefaults();

        if (FlagMeter==1){
            for(CounterUpdate=0;CounterUpdate<9;++CounterUpdate){
              Meter[CounterUpdate].Flag |= 0x02;
            }
            EnableTitleMeters(1);
        }

        if (FlagMeter==1){
            Display_Meter();
            for(i=0; i<9; ++i)Display_Value(i);
        }else{
          UpdateBigMeters();
          if(UpdateMeter==4)EnableTitleMeters(1);else EnableTitleMeters(0);
        }
}

void EnableTitleMeters(u8 Service){
            Title[8][2].Flag |= 0x02;
            Title[10][2].Flag |= 0x02;
            Title[8][3].Flag |= 0x02;
            Title[10][3].Flag |= 0x02;
          if(Service){
            Title[11][0].Flag |= 0x02;
            Title[12][0].Flag |= 0x02;
            Title[11][1].Flag |= 0x02;
            Title[12][1].Flag |= 0x02;
            Meter[0].Flag |= 0x02;
            Meter[0].Item = 0;
            Meter[0].Track = 4; }
}

void UpdateBigMeters(void){
u8 i;
     if (FlagMeter==2){
        if(UpdateMeter==4){
          for (i=2;i<4;i++){
            if(i==(Current-13)){
              BTwinkState=!BTwinkState;
              BTwink=BTwinkState;
            }else BTwink=1;
            Display_Value(i);
         }
        }else{
          for (i=1;i<4;i++){
            if(i==(Current-13)){
              BTwinkState=!BTwinkState;
              BTwink=BTwinkState;
            }else BTwink=1;
            Display_Value(i);
          }
        }
      }
}

void ClearBigMeter1(void){
u8 i,j;

      __LCD_Set_Block(314,399,125,180);
      for (i=0;i<86;i++){
 for (j=0;j<56;j++){
           __LCD_SetPixl(Color[5]);
 }
      }
      __LCD_Set_Block(0,399,0,239);
}

void UpdateMeterPage(void){
u8 CounterUpdate;

                if(FlagMeter==2){
                  if(UpdateMeter==4){
                     ClearBigMeter1();
                     EnableTitleMeters(1);
                  }else EnableTitleMeters(0);
                }

                switch (UpdateMeter){
                case 0:
                case 1:
                  if(FlagMeter==1){
                    Meter[0].Flag |= 0x02;
                    Meter[0].Item = 0;
                    Meter[0].Track = 4;
                  }

                  for(CounterUpdate=1;CounterUpdate<9;++CounterUpdate){
                    Meter[CounterUpdate].Flag |= 0x02;
                    Meter[CounterUpdate].Item = CounterUpdate+1;
                    Meter[CounterUpdate].Track = UpdateMeter;
                  }
                  break;
                case 2:

                  for(CounterUpdate=1;CounterUpdate<9;CounterUpdate++){
                    Meter[CounterUpdate].Flag |= 0x02;
                    Meter[CounterUpdate].Item = C_Dmeter[CounterUpdate-1];
      if (CounterUpdate<6)Meter[CounterUpdate].Track = 2; else Meter[CounterUpdate].Track = 3;
                  }

                  if(FlagMeter==1){
                    Meter[0].Flag |= 0x02;
                    Meter[0].Item = 0;
                    Meter[0].Track = 4;
                  }else{
                    EnableTitleMeters(0);
                  }
    break;
                case 3:

                  for(CounterUpdate=1;CounterUpdate<9;CounterUpdate++){
                    Meter[CounterUpdate].Flag |= 0x02;
                    Meter[CounterUpdate].Item = C_Dmeter[CounterUpdate-1];
      if (CounterUpdate<6)Meter[CounterUpdate].Track = 3; else Meter[CounterUpdate].Track = 2;
                  }
                  if(FlagMeter==1){
                    Meter[0].Flag |= 0x02;
                    Meter[0].Item = 0;
                    Meter[0].Track = 4;
                  }else{
                    EnableTitleMeters(0);
                  }
                 break;
                case 4:
    MeterDefaults();
                }
}

void Config_init(void){
  if (FlagMeter>0)MAX_X=300+11;
  else MAX_X=386+11;
  OldTrack1X=Title[0][3].Value;
  OldTrack2X=Title[1][3].Value;
  OldMeter=FlagMeter;
  _Vt1Old=V_Trigg[0].Value;
  _Vt2Old=V_Trigg[1].Value;
  ClearTrackBuff(1);
  SelectiveUpdate |=0x60;
  Options|=2;
  TrgAutoOld=TrgAuto;
  if (FlagFrameMode>0){
    XposRef=SaveShortBuffXpos;
    OldPosi=GetXposRef(Title[6][2].Value);
  }else{
    XposRef=GetXposRef(Title[6][2].Value);
    ShortBuffXpos=SaveShortBuffXpos;
  }
  Title[7][3].XPOS=GetHoldoffIndPos();
  __Set(32+0, 0x20);
  VDiff[0]=(HiBatLevel[0]-LoBatLevel[0]);
  VDiff[1]=(HiBatLevel[1]-LoBatLevel[1]);
  BatLevelCompensation();
}

u16 GetHoldoffIndPos(void){
  return (((((Title[7][3].Value)*100)/3480)*207)/100)+91;
}

u8 ConfigFile(u8 service){
u8 i;
          if(service==0){

            if (FrameMode==2){
              SaveShortBuffXpos=XposRef;
              Title[6][2].Value=GetXpos(OldPosi);
            } else SaveShortBuffXpos=ShortBuffXpos;

            Current=SaveCurrent[0];
            Detail[Current]=SaveCurrent[1];
            i=Save_Param(Title[9][1].Value);
            Title[Current][Detail[Current]].Flag |= 0x02;

       Title[9][0].Value=1;
            if(i==0)ConfigFileNumber=Title[9][1].Value;
            Title[9][2].Value=4;

          }else{

            ConfigFileNumber=Title[Current][1].Value;
            i = Load_Param(Title[Current][1].Value);
     if(i == 0){
              __Set(32+0, 0x20);
       App_init();
              Config_init();
         Title[9][0].Value=1;
              Title[9][1].Value=ConfigFileNumber;
              Title[9][2].Value=4;
              Update_View_Area();
              Update=2;
            }
          }
          return i;

}


void FileMessage(u8 i){
        if (i == 0 ) Print_Str(230, 0, (5<<8)+ 10, 0, " OK  ");
        else{
          if (i == 4) Print_Str(230, 0, (5<<8)+ 10, 0, " NONE");
          else if(i == 3) Print_Str(230, 0, (5<<8)+ 10, 0, " FULL");
          else Print_Str(230, 0, (5<<8)+ 10, 0, " ERR ");
        }
        Delayms(1000);
        Title[Current][1].Flag |= 0x02;
        Title[Current][2].Flag |= 0x02;
}

void EnableChannel(u8 track){
  if (Title[track][0].Value == 0) {Title[track][0].Value = 1;LastSelected=track+1;}
}

void UpdateTriggerMem(void){
 u8 j;
                      Title[7][0].Value = PreviousTrigSelect[3];
                      for (j=3;j>0;j--) PreviousTrigSelect[j]=PreviousTrigSelect[(j-1)];
         PreviousTrigSelect[0]=0;

}
