/********************* (C) COPYRIGHT 2010 e-Design Co.,Ltd. ********************
 File Name : Menu.c  
 Version   : DS203_APP Ver 2.5x                                  Author : bure
*******************************************************************************/
#include <string.h>
#include "Interrupt.h"
#include "Function.h"
#include "Process.h"
#include "Menu.h"
#include "Draw.h"
#include "BIOS.h"
#include "Calibrat.h"

u16 Result_FPS;
u8 Cnt_InCharge;
u8 Cnt_Charged;
u8 Cnt_Batt;
u8 FlagInCharge;
u16 NSamples;
u8 MinTresh=1;				//adjust this as the least significant amount to be displayed in V meters
u8 BTwink=0; 
u8  ConfigFileNumber=0;
s16 Ga_Max;
s16 Gb_Max;
s16 Ga_Min;
s16 Gb_Min;
s16 GHa_Max;
s16 GHb_Max;
s16 GHa_Min;
s16 GHb_Min;
u8  ShiftDigits;

u32 TimeScaleCorrection(u32 Tmp, u8 Polarity, u16 Kp);
void CalculateTimeMeters(u32 Tmp, u32 m, u32 n, u16 Kp);
u32 Period(u8 Ch,u32 k);
u32 ClockAdjust(u32 Value);

const char a_xy[8]="CH!A=!X";		
const char b_xy[8]="CH!B=!Y";
const char ax10_xy[7]="X10A=X";
const char bx10_xy[7]="X10B=Y";
const char a[8]="!CH(A)!";		
const char b[8]="!CH(B)!";
const char ax10[7]="x10(A)";
const char bx10[7]="x10(B)";

const char T_UNIT[12] ={'n','s', 0 ,'u','s', 0 ,'m','s', 0 ,'s',' ', 0 };
const char D_UNIT[12] ={'u','s', 0 ,'u','s', 0 ,'m','s', 0 ,'s',' ', 0 };     //special for delta T, will not work right with "n" as 1st ch  	
const char V_UNIT[12] ={'m','V', 0 ,'m','V', 0 ,'V',' ', 0 ,'?',' ', 0 };     // ? = special"kv"character 
      char N_UNIT[12] ={ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 };           	
const char S_UNIT[12] ={'/','s','e','c', 0 ,'/','s','e','c', 0 , 0 , 0 };
const char P_UNIT[12] ={'%',' ', 0 ,'%',' ', 0 ,'%',' ', 0 , 0 , 0 , 0 };
const char F_UNIT[12] ={'H','z', 0 ,'K','@', 0 ,'M','@', 0 ,'G','@', 0 };	//Used at high sweep rates so display works right
const char F_UNITSUB[12]={'H','z', 0 ,'H','z', 0 ,'k','@', 0 ,'M','@', 0 };   //added to keep original FREQ display working right at low sweep rates 

const char STATESTR[3][10] = {"!RUN!", "HOLD", "HOLD"};                  	// Running state str

uc16 S_Inv[3]       = {(SCRN<<8)+TEXT2, (SCRN<<8)+X_POSI, (SCRN<<8)+NOTE1};         // Running state Color

const char BATT_STR[5][10] = {"~``'", "~``}", "~`;}", "~;;}", "{;;}"};   // Battery Status Str
uc16 B_COLOR[5]     = {(NOTE1<<8)+SCRN, (SIDE <<8)+SCRN,
                       (TEXT2<<8)+SCRN, (TEXT2<<8)+SCRN,
                       (TEXT2<<8)+SCRN};                          // Battery Status Color

char CH_A_STR[4][10]  = {" !OFF! ", "!CH(A)!", "x10(A)"};
char CH_B_STR[4][10]  = {" !OFF! ", "!CH(B)!", "x10(B)"};
const char CH_C_STR[2][10]  = {" !OFF! ", "!CH(C)!"};

//const char CH_D_STR[10][10] = {" !OFF! ", "!CH(D)!", "!(A+B)!", "!(A-B)!",  
//                     "!(C&D)!", "!(C|D)!", ".DAT_A",  ".DAT_B",
//                        ".DAT_C",  ".DAT_D"};                      // Track source Str 

const char CH_D_STR[16][10] = {	" !OFF! ", "!CH(D)!", "!(A+B)!", "!(A-B)!",  
							"!(C&D)!", "!(C|D)!", "!REC_A!",  "!REC_B!",
							"!REC_C!","!REC_D!","SPEC_B","SPEC_A","hFFT_B","sFFT_B","hFFT_A","sFFT_A"};                      // Track source Str

const char NO_RANGE[1]      = "";//" -- ";                       
const char NO_DEF[1]        = "";//"--";                       

const char  YCOUPLE[3][10]  = {"DC", "AC", "!-!"};                        // Track Couple Str                    
char  Vertical[15][10];                                             // Track Range Str
const char  YPOSISTR[5]    = {"YPOS"};                                    // Track Position Str 
uc16 Y_INV[5]       = {(SCRN<<8)+TR_1, (SCRN<<8)+TR_2,
                       (SCRN<<8)+TR_3, (SCRN<<8)+TR_4,
                       (SCRN<<8)+VERNIE};                          // Track Color 1
uc16 Y_COLOR[5]     = {(TR_1<<8)+SCRN, (TR_2<<8)+SCRN,
                       (TR_3<<8)+SCRN, (TR_4<<8)+SCRN,
                       (VERNIE<<8)+SCRN};                          // Track Color 2

const char MODESTR[10][10]  = {"TrOFF","!AUTO!", "NORML","NorCL","SINGL"," X_Y "};        // Sync Mode Str

char BaseStr[30][10];                                           // Time Base b Str
const char  XPOSISTR[5]    = {"XPOS"};
uc16 XCOLOR[2]      = {(SCRN<<8)+X_POSI, (X_POSI<<8)+SCRN};        // Time Base Color

const char FO_TYPE[5][10]  = {"!SINUS!",  "TRIANG",  "! SAW !",  "SQUARE", "! PWM !"}; // Output Kind Str  "Kd=  %"

const char FO_STR[23][10]  = {"! 1Hz !",  "! 2Hz !",  "! 5Hz !",
                        " 10Hz ",  " 20Hz ",  " 50Hz ",   "!100Hz!",
                       "!200Hz!", "!500Hz!", " 1kHz ",   " 2kHz ",
                       " 5kHz ",  "!10kHz!", "!25kHz!",  "!50kHz!",
                       "100kHz",  "200kHz",  "500kHz",   " 1MHz ",
                       " 2MHz ",  " 4MHz ",  " 6MHz ",   " 8MHz "}; // Output Frequency Str

//uc16 O_COLOR[2]     = {(SCRN<<8)+TEXT3, (TEXT3<<8)+SCRN};         // Output Frequency Color BLUE
uc16 O_COLOR[2]     = {(SCRN<<8)+NOTE1, (NOTE1<<8)+SCRN};         // Output Frequency Color  RED


const char  TRIGSTR[8][10] = {"TR A ", "TR B ", "TR C ", "TR D ", " A&B "};      // Trigger source Str

const char  TR_TYPE[8][10] = {":!\\!", ":!^!", "<Vt", ">Vt",     // Trigger Type Str
                       "L<[",   "L>[",  "H<[", "H>["};     // Seems clearer to state, for example: "low pulse less in width
                     //"<TL",   ">TL",  "<TH", ">TH"};	   // than delta T1-T2" as "L<Delta" rather than "<TL"
const char  VT_STR[4]  =  "LEV";                                 
const char  DELAY_STR[2] = "T";				   // Trigg holdoff indicator	
                          
const char  VERNIE1[5]     = {"!V1!"};          // V1 Vernie Str
const char  VERNIE2[5]     = {"!V2!"};          // V2 Vernie Str
const char  VERNIE3[5]     = {"!T1!"};          // T1 Vernie Str
const char  VERNIE4[5]     = {"!T2!"};          // T2 Vernie Str
uc16 V_INV[1]       = {(SCRN<<8)+VERNIE};
uc16 V_COLOR[1]     = {(VERNIE<<8)+SCRN};                         // Y Vernie Color
uc16 T_INV[1]       = {(SCRN<<8)+VERNIE};
uc16 T_COLOR[1]        = {(VERNIE<<8)+SCRN};                         // X Vernie Color
const char  F_FUNC[2][10]  = {"Save File", "Load File"};                 // File Function Str

//char  F_EXT[8][10]   = {".BMP ", ".DAT ", ".BUF ",".CSV ", " OK! ",
//                         " ERR!",".HEX", ".BIN"};                  // File Ext Name Str
const char  F_EXT[5][10]   = {".BMP ", ".DAT ", ".BUF ",".CSV ", ".CFG "};

uc16 F_INV[1]       = {(SCRN<<8)+TEXT1};                          //  File Color
const char  DELTA_V[2][10] = {"[V:", "[V:"};
const char  DELTA_T[4]     = "[T:";
const char  METER[12][5]   = {"Vbt", "FPS", "Vdc", "RMS", "Frq",  "Max", 
                       "Min", "Vpp", "Per", "Dut", "!TH!", "!TL!"};

u8   Detail[14];
char NumStr[12];
u8   Current = 0, TypeA = 0, Update = 1;
const char BL_Str[5]="B.L", Vol_Str[5]="Vol";

char  x10[8][6]   = {"0.5V", " 1V ", " 2V ", " 5V ", "!10V!", "!20V!", "!50V!", "100V"};

menu Title[13][4]=   
{
  //     Item_String,   m_Color,   Limit, Mark, xPos, yPos, Value, Flag 
  {//============================ Title Track1 Group ===========================
    {(char*)CH_A_STR,(u16*)Y_INV,     3-1, CIRC,   35,  228,     1, UPDAT}, //  Track source   2
    {(char*)YCOUPLE, (u16*)Y_COLOR,   2-1, CIRC,   35,  216,     0, UPDAT}, //  Track Couple        
    {(char*)Vertical,(u16*)Y_COLOR,   9-1,    0,   51,  216,     5, UPDAT}, //  Track Range 
    {(char*)YPOSISTR,(u16*)Y_INV,     200,  FIX,    0,    0,   150, UPDAT}, //  Adj. Track Position 160
  },
  {//============================ Title Track2 Group ===========================
    {(char*)CH_B_STR,(u16*)Y_INV+1,   3-1, CIRC,   86,  228,     1, UPDAT}, //  Track source   2
    {(char*)YCOUPLE, (u16*)Y_COLOR+1, 2-1, CIRC,   86,  216,     1, UPDAT}, //  Track Couple        
    {(char*)Vertical,(u16*)Y_COLOR+1, 9-1,    0,  102,  216,     1, UPDAT}, //  Track Range
    {(char*)YPOSISTR,(u16*)Y_INV+1,   200,  FIX,    0,    0,   100, UPDAT}, //  Adj. Track Position
  },
  {//============================ Title Track3 Group ===========================
    {(char*)CH_C_STR,(u16*)Y_INV+2,   2-1, CIRC,  137,  228,     1, UPDAT}, //  Track source
    {(char*)NO_DEF , (u16*)Y_COLOR+2, 1-1, CIRC,  137,  216,     0, HID}, //  Track Couple        
    {(char*)NO_RANGE,(u16*)Y_COLOR+2, 1-1,    0,  153,  216,     0, HID}, //  Track Range
    {(char*)YPOSISTR,(u16*)Y_INV+2, 200-1,  FIX,    0,    0,    60, UPDAT}, //  Adj. Track Position
  },
  {//============================ Title Track4 Group ===========================
    {(char*)CH_D_STR,(u16*)Y_INV+3,  16-1, CIRC,  188,  228,     1, UPDAT}, //  Track source
    {(char*)NO_DEF , (u16*)Y_COLOR+3, 1-1, CIRC,  188,  216,     0, UPDAT}, //  Track Couple        
    {(char*)NO_RANGE,(u16*)Y_COLOR+3, 1-1,    0,  204,  216,     0, UPDAT}, //  Track Range
    {(char*)YPOSISTR,(u16*)Y_INV+3, 200-1,  FIX,    0,    0,    20, UPDAT}, //  Adj. Track Position
  },
  {//================== Running State & Battery Status Group ===================
    {(char*)STATESTR,(u16*)S_Inv,     3-1,    0,    0,  228,     0, UPDAT}, //  Running state
    {(char*)BATT_STR,(u16*)B_COLOR,   5-1,    0,    0,  216,     0, UPDAT}, //  Battery status
    {(char*)BATT_STR,(u16*)B_COLOR,   5-1,  NOT,    0,    0,     0,   HID}, 
    {(char*)BATT_STR,(u16*)B_COLOR,   5-1,  NOT,    0,    0,     0,   HID},
  },
  {//======================= Title Output Signal Group =========================
    {(char*)FO_TYPE, (u16*)O_COLOR,   5-1, CIRC,  239,  228,     3, UPDAT}, //  Output Wave Kind    282 228       
    {(char*)FO_STR,  (u16*)O_COLOR+1,23-1,    0,  239,  216,    13, UPDAT}, //  Output Frequency    282 216      
    {(char*)NumStr,  (u16*)O_COLOR,   100, NUM3,  212,  216,    50, UPDAT}, //  Duty value      282,202
    {(char*)NumStr,  (u16*)O_COLOR,   100, NUM3,  196,  216,    50, UPDAT}, //  Attenuazione    251,202         
  },
  {//========================= Title Time Base Group ===========================
    {(char*)MODESTR, (u16*)XCOLOR,    6-1, CIRC,  290,  228,     0, UPDAT}, //  Sync Mode    5 numero modi  239  228
    {(char*)BaseStr, (u16*)XCOLOR+1, 27-1,    0,  290,  216,    17, UPDAT}, //  Time Base Range             239 216
    {(char*)XPOSISTR,(u16*)XCOLOR,   3695,  FIX,  366,    0,     0, UPDAT}, //  Adj. X position  3795
    {(char*)XPOSISTR,(u16*)XCOLOR,   3695,  NOT,   80,    0,     0, UPDAT}, //  View window rule  3795
  },           
  {//=====================;===== Title Trigger Group ====;======================
    {(char*)TRIGSTR, (u16*)Y_INV,     5-1, CIRC,  333,  228,     1, UPDAT}, //  Trigger source         
    {(char*)TR_TYPE, (u16*)Y_INV,     8-1, CIRC,  373,  228,     0, UPDAT}, //  Trigger Kine         
    {(char*)VT_STR,  (u16*)Y_COLOR,   200,  FIX,  333,  216,     0, UPDAT}, //  Adj. Trigger threshold     
  //{(char*)VT_STR,  (u16*)Y_COLOR,     0,  NOT,  357,  216,     0,   HID}, //  Number position     
    {(char*)DELAY_STR,(u16*)Y_COLOR, 3400,  FIX,  92,    0,      0, UPDAT}, //  Trigger holdoff value     
  },
  {//============================ Title Y Vernie Group =========================
    {(char*)VERNIE1, (u16*)V_INV,   201-1,  FIX,   35,    0,   180, UPDAT}, //  V1 Vernie         
    {(char*)VERNIE2, (u16*)V_INV,   201-1,  FIX,   62,    0,    40, UPDAT}, //  V2 Vernie     
    {(char*)DELTA_V, (u16*)Y_INV,     2-1, CIRC,  314,  197,     0, UPDAT}, //  Measure Track    
    {(char*)NumStr,  (u16*)Y_COLOR,   240, NUM3,  342,  197,    70, UPDAT}, //  Delta V value    
  },
  {//============================= Title File Group ============================
    {(char*)F_FUNC,  (u16*)F_INV,     2-1, CIRC,  134,    0,     0,     0}, //  File function    
    {(char*)NumStr,  (u16*)F_INV,   256-1, NUM3,  206,    0,     0,     1}, //  File number     
  //{(char*)F_EXT,   (u16*)F_INV,     4-1, CIRC,  230,    0,     0,     0}, //  Ext. name     0
    {(char*)F_EXT,   (u16*)F_INV,     5-1, CIRC,  230,    0,     0,     0}, //  Ext. name     
    {(char*)F_EXT,   (u16*)F_INV,       0,  NOT,    0,    0,     0,   HID}, //  
  },
  {//============================ Title X Vernie Group =========================
    {(char*)VERNIE3, (u16*)T_INV,     395,  FIX,  312,    0,    80, UPDAT}, //  T1 Vernie     300     
    {(char*)VERNIE4, (u16*)T_INV,     395,  FIX,  339,    0,   280, UPDAT}, //  T2 Vernie     300   
    {(char*)DELTA_T, (u16*)T_INV,       0,  NOT,  314,  182,     0, UPDAT}, //  Delta T Str     
    {(char*)NumStr,  (u16*)T_COLOR,   400, NUM3,  342,  182,    80, UPDAT}, //  Delta T value 300   
  },
  {//=========================== Title BackLight Group =========================
    {(char*)BL_Str,  (u16*)V_INV,     1-1,  FIX,  314,  167,     0,   HID}, //  BackLight    
    {(char*)NumStr,  (u16*)V_COLOR,  10-1, NUM2,  342,  167,     5,   HID}, //  Class     
    {(char*)NumStr,  (u16*)V_INV,       0,  NOT,    0,    0,     0,   HID},     
    {(char*)NumStr,  (u16*)V_INV,       0,  NOT,    0,    0,     0,   HID},  
  },
  {//============================ Title Volume Group ===========================
    {(char*)Vol_Str, (u16*)V_INV,     1-1,  FIX,  314,  152,     0,   HID}, //  Volume        
    {(char*)NumStr,  (u16*)V_COLOR,  10-1, NUM2,  342,  152,     5,   HID}, //  Class     was 11-1, causing display error
    {(char*)NumStr,  (u16*)V_INV,       0,  NOT,    0,    0,     0,   HID},    
    {(char*)NumStr,  (u16*)V_INV,       0,  NOT,    0,    0,     0,   HID},    
  },
};
      //.str
meter Meter[9] = //.track   .item                         .flag
{ {(char*)METER,      4,    VBT,     314,    342,   137,  UPDAT}, //  Meter #0
  {(char*)METER,      4,    FPS,     314,    342,   122,  UPDAT}, //  Meter #1
  {(char*)METER, TRACK4,    FRQ,     314,    342,   107,  UPDAT}, //  Meter #2
  {(char*)METER, TRACK3,    CIR,     314,    342,    92,  UPDAT}, //  Meter #3
  {(char*)METER, TRACK3,    DUT,     314,    342,    77,  UPDAT}, //  Meter #4
  {(char*)METER, TRACK2,    TH,      314,    342,    62,  UPDAT}, //  Meter #5
  {(char*)METER, TRACK2,    TL,      314,    342,    47,  UPDAT}, //  Meter #6
  {(char*)METER, TRACK1,    VPP,     314,    342,    32,  UPDAT}, //  Meter #7
  {(char*)METER, TRACK1,    VDC,     314,    342,    17,  UPDAT}, //  Meter #8
};

void Display_Meter(void)                  // refresh measurements display
{
  u8  i;
  u8  MeterLimit=9;

  if(FlagMeter==2){
    MeterLimit=1;
    if(UpdateMeter!=4)MeterLimit=0;
  }

  for(i=0; i<MeterLimit;i++){        
    if(Meter[i].Flag & UPDAT){            //-----the name of the measurements show the need to refresh

      Meter[i].Flag &= (!UPDAT & !BLINK);       // Clr Update & Blink flag

      if(((Options&4)==4)&&((Meter[i].Item==MIN)||(Meter[i].Item==MAX))){
        Print_Str
          (Meter[i].XPOS1, Meter[i].YPOS,        // coordinates to be displayed
           Y_INV[4],                    	 // white for hold mode
           PRN,                                  // print (no flash)
           Meter[i].Str +(Meter[i].Item * 5));   // need to display the project name
      }else{
        Print_Str
          (Meter[i].XPOS1, Meter[i].YPOS,        // coordinates to be displayed
           Y_INV[Meter[i].Track],                // need to display color (belongs channel)
           PRN,                                  // print (no flash)
           Meter[i].Str +(Meter[i].Item * 5));   // need to display the project name
      } 

    } 
  }
  if((Current >= METER_0)&&(Current <(MeterLimit+METER_0))){  
    if(Blink){                            //----- the name of the display required flashing measurements
      i = Current - METER_0;
      Blink = 0;                               // Clr Blink Ctrl flag

      if(((Options&4)==4)&&((Meter[i].Item==MIN)||(Meter[i].Item==MAX))){
        Print_Str(
          Meter[i].XPOS1, Meter[i].YPOS,         // flashing coordinates
          Y_INV[4],                              // white for hold mode
          Twink,                                 // flashing
          Meter[i].Str +(Meter[i].Item *5));     // flashing the project name
      }else{
        Print_Str(
          Meter[i].XPOS1, Meter[i].YPOS,         // flashing coordinates
          Y_INV[Meter[i].Track],                 // flashing colors (belongs channel)
          Twink,                                 // flashing
          Meter[i].Str +(Meter[i].Item *5));     // flashing the project name
      } 

    }
  }
}


void Display_Value(u8 i)
{
  s32 Tmp = 0;
  s32 Tmp2= 0;
  u32 UTmp=0;
  u16 Kp;
  u32 k, n, m;
  u8  j;
 
  switch (TempKp1){		//add 1 or 2 digits of resolution to interpolation factors
  case 983:
    Kp=9830;
    break;
  case 819:
    Kp=8192;
    break;
  case 614:
    Kp=6144;
    break;
  case 492:
    Kp=4915;			//actual correct value here is 49152, compensated for in TimeScaleCorrection
    break;
  case 246:
    Kp=24576;
    break;
  default:
    Kp=1024;
  }
  
  k = _T_Range; m = 1;  n = 1;
  if(k < 9)  m = Power(10, (11-k)/3); //9 //11
  else       n = Power(10, (k- 9)/3);  //9
  k = X_Attr[(k%3)+9].SCALE;
  ShiftDigits=0;
  
if(FFTflag)goto CalculateFFTvalues;
  switch (Meter[i].Item){  
  case VBT://--------------- calculation and display of battery voltage ---------------
    Int2Str(NumStr, __Get(V_BATTERY)*1000, V_UNIT, 3, SIGN,0);
    break;
  case FPS://--------------- calculates and displays the frame count ---------------
    Int2Str(NumStr, Result_FPS & 0x7F, S_UNIT, 2, STD,0);
    break;  
  case VPP:
    if(Meter[i].Track == TRACK1){
		if  ((_1_source == HIDE)&&(_4_source!=14)&&(_4_source!=15)) Tmp=0;
		else {
			Tmp=Ga_Max+Ka1[_A_Range]-_1_posi;				
	                Tmp=Ka2[_A_Range]*Tmp;
                        if (Tmp>0)Tmp+=512; else Tmp-=512;	// Flip bias down when calculating negative values	
			Tmp2=Ga_Min+Ka1[_A_Range]-_1_posi;	// otherwise neg values end up 1 LSB short after adding +1/2 LSB (+512/1024)
		        Tmp2=Ka2[_A_Range]*Tmp2; 
                        if (Tmp2>0)Tmp2+=512; else Tmp2-=512;	 	        
			Tmp=(Tmp/1024)-(Tmp2/1024);
			if(Tmp <= MinTresh) Tmp = 0;						
			Tmp *= Y_Attr[_A_Range].SCALE;
			if  (_1_source == CH_X10) Tmp=Tmp*10;
		}
    }
    if(Meter[i].Track == TRACK2){
		if  ((_2_source == HIDE)&&(_4_source!=12)&&(_4_source!=13)) Tmp=0;
		else {
			Tmp=Gb_Max+Kb1[_B_Range]-_2_posi;
	                Tmp=Kb2[_B_Range]*Tmp; 
                        if (Tmp>0)Tmp+=512; else Tmp-=512;	 	    	
			Tmp2=Gb_Min+Kb1[_B_Range]-_2_posi;
	                Tmp2=Kb2[_B_Range]*Tmp2; 
                        if (Tmp2>0)Tmp2+=512; else Tmp2-=512;	 	        
			Tmp=(Tmp/1024)-(Tmp2/1024);
			if(Tmp <= MinTresh) Tmp = 0;						
			Tmp *= Y_Attr[_B_Range].SCALE;
			if  (_2_source == CH_X10) Tmp=Tmp*10;
		}
    }

    Int2Str(NumStr, Tmp, V_UNIT, 3, SIGN,0);
    break;
  case VDC:
    if(Meter[i].Track == TRACK1){
		if  ((_1_source == HIDE)&&(_4_source!=14)&&(_4_source!=15)) Tmp=0;
		else {
			Tmp=((VxAvg[0]/NSamples)+Ka1[_A_Range]-_1_posi);
	                Tmp=Ka2[_A_Range]*Tmp;   // Add signal level correction factor based on signal zero level rather than bottom of screen, prevents offsets from corrupting value 
                        if (Tmp>0)Tmp+=512; else Tmp-=512;	 	        	
                        Tmp/=1024;
			if((Tmp >= -MinTresh)&&(Tmp <= MinTresh)) Tmp = 0;
			Tmp *= Y_Attr[_A_Range].SCALE;
			if  (_1_source == CH_X10) Tmp=Tmp*10;
		}
    }
    if(Meter[i].Track == TRACK2){
		if  ((_2_source == HIDE)&&(_4_source!=12)&&(_4_source!=13)) Tmp=0;
		else {
			Tmp=((VxAvg[1]/NSamples)+Kb1[_B_Range]-_2_posi);
	                Tmp=Kb2[_B_Range]*Tmp; 
                        if (Tmp>0)Tmp+=512; else Tmp-=512;	 	        	
                        Tmp/=1024;
			if((Tmp >= -MinTresh)&&(Tmp <= MinTresh)) Tmp = 0;
			Tmp *= Y_Attr[_B_Range].SCALE;
			if  (_2_source == CH_X10) Tmp=Tmp*10;
		}
    }
    Int2Str(NumStr, Tmp, V_UNIT, 3, SIGN,0);
    break;
  case RMS:
    if(Meter[i].Track == TRACK1){
		if  ((_1_source == HIDE)&&(_4_source!=14)&&(_4_source!=15)) Tmp=0;
		else {
			Tmp = (Ka2[_A_Range]*Int_sqrt(VxSsq[0]/NSamples)+ 512)/1024;     // adding Ka1 here causes error in calc, already factored in in Process...
			if(Tmp <= MinTresh) Tmp = 0;										
			Tmp *= Y_Attr[_A_Range].SCALE;
			if  (_1_source == CH_X10) Tmp=Tmp*10;
		}
    }
    if(Meter[i].Track == TRACK2){
		if  ((_2_source == HIDE)&&(_4_source!=12)&&(_4_source!=13)) Tmp=0;
		else {
			Tmp = (Kb2[_B_Range]*Int_sqrt(VxSsq[1]/NSamples)+ 512)/1024; 			
			if(Tmp <= MinTresh) Tmp = 0;										
			Tmp *= Y_Attr[_B_Range].SCALE;
			if  (_2_source == CH_X10) Tmp=Tmp*10;
		}
    }
    Int2Str(NumStr, Tmp, V_UNIT, 3, SIGN,0); //unsign
    break;
 case MAX:
    if(Meter[i].Track == TRACK1){
		if  ((_1_source == HIDE)&&(_4_source!=14)&&(_4_source!=15)) Tmp=0;
		else {
			Tmp=GHa_Max+Ka1[_A_Range]-_1_posi;
	                Tmp=Ka2[_A_Range]*Tmp; 
                        if (Tmp>0)Tmp+=512; else Tmp-=512;	 	        	
                        Tmp/=1024;
			if((Tmp >= -MinTresh)&&(Tmp <= MinTresh)) Tmp = 0;
			Tmp *= Y_Attr[_A_Range].SCALE;
			if  (_1_source == CH_X10) Tmp=Tmp*10;
		}
	}
    if(Meter[i].Track == TRACK2){
		if  ((_2_source == HIDE)&&(_4_source!=12)&&(_4_source!=13)) Tmp=0;
		else {
			Tmp=GHb_Max+Kb1[_B_Range]-_2_posi;
         	        Tmp=Kb2[_B_Range]*Tmp; 
                        if (Tmp>0)Tmp+=512; else Tmp-=512;	 	        	
                        Tmp/=1024;
			if((Tmp >= -MinTresh)&&(Tmp <= MinTresh)) Tmp = 0;
			Tmp *= Y_Attr[_B_Range].SCALE;
			if  (_2_source == CH_X10) Tmp=Tmp*10;
		}
    }
	
    Int2Str(NumStr, Tmp, V_UNIT, 3, SIGN,0);
    break;
  case MIN:
    if(Meter[i].Track == TRACK1){
		if  ((_1_source == HIDE)&&(_4_source!=14)&&(_4_source!=15)) Tmp=0;
		else {
			Tmp=GHa_Min+Ka1[_A_Range]-_1_posi;
	            	Tmp=Ka2[_A_Range]*Tmp; 
                        if (Tmp>0)Tmp+=512; else Tmp-=512;	 	        	
                        Tmp/=1024;
			if((Tmp >= -MinTresh)&&(Tmp <= MinTresh)) Tmp = 0;
			Tmp *= Y_Attr[_A_Range].SCALE;
			if  (_1_source == CH_X10) Tmp=Tmp*10;
		}
    }
    if(Meter[i].Track == TRACK2){
		if  ((_2_source == HIDE)&&(_4_source!=12)&&(_4_source!=13)) Tmp=0;
		else {
			Tmp=GHb_Min+Kb1[_B_Range]-_2_posi;
	            	Tmp=Kb2[_B_Range]*Tmp; 
                        if (Tmp>0)Tmp+=512; else Tmp-=512;	 	        	
                        Tmp/=1024;
			if((Tmp >= -MinTresh)&&(Tmp <= MinTresh)) Tmp = 0;
			Tmp *= Y_Attr[_B_Range].SCALE;
			if  (_2_source == CH_X10) Tmp=Tmp*10;
		}
    }
    Int2Str(NumStr, Tmp, V_UNIT, 3, SIGN,0);
    break;

  // Lines commented out in rest of function reflect fix to eliminate meter values showing up on wrong channels if they are shut off           

  case FRQ:
  //if(((Meter[i].Track == TRACK1)&&(_1_source != HIDE))||(_4_source==14)||(_4_source==15))UTmp=Sum[0];   //use averaged sum of all FIFO transfers
  //if(((Meter[i].Track == TRACK2)&&(_2_source != HIDE))||(_4_source==12)||(_4_source==13))UTmp=Sum[1];          
    if((Meter[i].Track == TRACK1)&&((_1_source != HIDE)||(_4_source==14)||(_4_source==15)))UTmp=Sum[0];   //use averaged sum of all FIFO transfers
    if((Meter[i].Track == TRACK2)&&((_2_source != HIDE)||(_4_source==12)||(_4_source==13)))UTmp=Sum[1];          
    if((Meter[i].Track == TRACK3)&&(_3_source == CH_C))UTmp=Sum[2];         
    if((Meter[i].Track == TRACK4)&&((_4_source == CH_D)||(_4_source == C_and_D)||(_4_source == C_or_D)))UTmp=Sum[3];
    UTmp=UpScale(UTmp,1);
CalculateFFTvalues:
    if(FFTflag)UTmp=500000000;
    UTmp=ClockAdjust(UTmp);

    if(n < 10){							
      UTmp=(1000*((UTmp+(k/2))/k))/m;
      if(FFTflag){NFreq=UTmp;for(j=0;j<12;j++)N_UNIT[j]=F_UNITSUB[j];} else Int2Str(NumStr,UTmp, F_UNITSUB , 4, UNSIGN, ShiftDigits);
    }
    else{       
      if(FFTflag){NFreq=UTmp;for(j=0;j<12;j++)N_UNIT[j]=F_UNIT[j];}
      if(Kp==1024){
        UTmp=n*((UTmp+(k/2))/k);
        if(FFTflag)NFreq=UTmp;else Int2Str(NumStr,UTmp, F_UNIT, 4, UNSIGN, ShiftDigits);
      } 
      else{                          //for interpolated ranges, adjust to prevent truncation errors in scaling to be further multiplied
        UTmp=TimeScaleCorrection(UTmp,0,Kp);
        if(Kp==24576){
            UTmp=((Kp*((((n/10)*((UTmp+(k/2))/k))+512)/1024))+5)/10;  	  //Kp here X100 * n/10=  /10
        }else{
            UTmp=((Kp*(((n*((UTmp+(k/2))/k))+512)/1024))+5)/10;	 	  //Kp X10 so need to /10
        }
        if(UTmp>0x7FFFFFFF){						  //scale down if beyond s32 range
          Tmp=(UTmp/10);
          ShiftDigits--;
        }else Tmp=UTmp;
        if(FFTflag)NFreq=Tmp;else Int2Str(NumStr,Tmp, F_UNIT, 4, UNSIGN, ShiftDigits);
      }
    } 
if(FFTflag)return;
    break;  
  case CIR:
  //if(((Meter[i].Track == TRACK1)&&(_1_source != HIDE))||(_4_source==14)||(_4_source==15))UTmp=Period(0,k);  //derive period from averaged frequency parameters 
  //if(((Meter[i].Track == TRACK2)&&(_2_source != HIDE))||(_4_source==12)||(_4_source==13))UTmp=Period(1,k);
    if((Meter[i].Track == TRACK1)&&((_1_source != HIDE)||(_4_source==14)||(_4_source==15)))UTmp=Period(0,k);  //derive period from averaged frequency parameters 
    if((Meter[i].Track == TRACK2)&&((_2_source != HIDE)||(_4_source==12)||(_4_source==13)))UTmp=Period(1,k);
    if((Meter[i].Track == TRACK3)&&(_3_source == CH_C))UTmp=Period(2,k);
    if((Meter[i].Track == TRACK4)&&((_4_source == CH_D)||(_4_source == C_and_D)||(_4_source == C_or_D)))UTmp=Period(3,k);
    CalculateTimeMeters(UTmp,m,n,Kp);
    break;
  case DUT:
if(EnablePaS){							//only update these once per second
  //if(((Meter[i].Track == TRACK1)&&(_1_source != HIDE))||(_4_source==14)||(_4_source==15))
    if((Meter[i].Track == TRACK1)&&((_1_source != HIDE)||(_4_source==14)||(_4_source==15)))
      Tmp = ((10000*PxS[0])/TxS[0])*10;
  //if(((Meter[i].Track == TRACK2)&&(_2_source != HIDE))||(_4_source==12)||(_4_source==13))
    if((Meter[i].Track == TRACK2)&&((_2_source != HIDE)||(_4_source==12)||(_4_source==13)))
      Tmp = ((10000*PxS[1])/TxS[1])*10;
    if((Meter[i].Track == TRACK3)&&(_3_source == CH_C))
      Tmp = ((10000*PxS[2])/TxS[2])*10;
    if((Meter[i].Track == TRACK4)&&((_4_source == CH_D)||(_4_source == C_and_D)||(_4_source == C_or_D)))
      Tmp = ((10000*PxS[3])/TxS[3])*10;
    Int2Str(NumStr, Tmp, P_UNIT, 4, UNSIGN,0);
}
    break;
  case TL:
if(EnablePaS){
  //if(((Meter[i].Track == TRACK1)&&(_1_source != HIDE))||(_4_source==14)||(_4_source==15))
    if((Meter[i].Track == TRACK1)&&((_1_source != HIDE)||(_4_source==14)||(_4_source==15)))
      UTmp=(UpScale(k*(TxS[0]-PxS[0]),1)+(TxN[0]/2))/TxN[0];
  //if(((Meter[i].Track == TRACK2)&&(_2_source != HIDE))||(_4_source==12)||(_4_source==13))
    if((Meter[i].Track == TRACK2)&&((_2_source != HIDE)||(_4_source==12)||(_4_source==13)))
      UTmp=(UpScale(k*(TxS[1]-PxS[1]),1)+(TxN[1]/2))/TxN[1];
    if((Meter[i].Track == TRACK3)&&(_3_source == CH_C))
      UTmp=(UpScale(k*(TxS[2]-PxS[2]),1)+(TxN[2]/2))/TxN[2];
    if((Meter[i].Track == TRACK4)&&((_4_source == CH_D)||(_4_source == C_and_D)||(_4_source == C_or_D)))
      UTmp=(UpScale(k*(TxS[3]-PxS[3]),1)+(TxN[3]/2))/TxN[3];
    CalculateTimeMeters(UTmp,m,n,Kp);
}
    break;
  case TH:
if(EnablePaS){
  //if(((Meter[i].Track == TRACK1)&&(_1_source != HIDE))||(_4_source==14)||(_4_source==15))
    if((Meter[i].Track == TRACK1)&&((_1_source != HIDE)||(_4_source==14)||(_4_source==15)))
      UTmp=(UpScale(k *PxS[0],1)+(TxN[0]/2))/TxN[0];
  //if(((Meter[i].Track == TRACK2)&&(_2_source != HIDE))||(_4_source==12)||(_4_source==13))
    if((Meter[i].Track == TRACK2)&&((_2_source != HIDE)||(_4_source==12)||(_4_source==13)))
      UTmp=(UpScale(k *PxS[1],1)+(TxN[1]/2))/TxN[1];
    if((Meter[i].Track == TRACK3)&&(_3_source == CH_C))
      UTmp=(UpScale(k *PxS[2],1)+(TxN[2]/2))/TxN[2];
    if((Meter[i].Track == TRACK4)&&((_4_source == CH_D)||(_4_source == C_and_D)||(_4_source == C_or_D)))
      UTmp=(UpScale(k *PxS[3],1)+(TxN[3]/2))/TxN[3];
    CalculateTimeMeters(UTmp,m,n,Kp);
}
    break;


  }
  if (FlagMeter==1){
    Print_Str(
    Meter[i].XPOS2, Meter[i].YPOS,
    Y_COLOR[Meter[i].Track], 
    PRN,
    NumStr);                              // display the measured values
  }else if (FlagMeter==2){		  // display measured values and meter title in big meters
    DisplayBigMeter(i);
  }  
  
}

void Display_Title(void)			
{
  u16  i, j;
  s32  k, n, m;
  u8 z;
  char *p;
  char Zero[2];
  Zero[1]=0;
  u8 ShiftLeft=0;

if(TimedDeltaView>0)ShiftLeft=2; else ShiftLeft=0;	//move it away from right edge to clear border 

if (_Mode==X_Y){					//replace menu title for chA and chB to show X_Y mode
  p=(char *)CH_A_STR;
  p+=10;
  for (i=0;i<7;i++)*p++=a_xy[i];
  p+=3;
  for (i=0;i<6;i++)*p++=ax10_xy[i];
  p=(char *)CH_B_STR;
  p+=10;
  for (i=0;i<7;i++)*p++=b_xy[i];
  p+=3;
  for (i=0;i<6;i++)*p++=bx10_xy[i];
 }else{						//show regular title
  p=(char *)CH_A_STR;
  p+=10;
  for (i=0;i<7;i++)*p++=a[i];
  p+=3;
  for (i=0;i<6;i++)*p++=ax10[i];
  p=(char *)CH_B_STR;
  p+=10;
  for (i=0;i<7;i++)*p++=b[i];
  p+=3;
  for (i=0;i<6;i++)*p++=bx10[i];
}


      if ((Current == OUTPUT)&&((_Det==DUTYPWM) || (_Det==OUTATT))){ z=Twink; }else { z=INV;}
     
      if  (Title[OUTPUT][KIND].Value == PWM)
	{
        u8ToDec3(Title[OUTPUT][DUTYPWM].Str, Title[OUTPUT][DUTYPWM].Value);
        Print_Str(172,  216, (Title[OUTPUT][DUTYPWM].Color[0]), z, "Dut% "); //225,202[Title[OUTPUT][PWM].Value]
        Print_Str(Title[OUTPUT][DUTYPWM].XPOS, Title[OUTPUT][DUTYPWM].YPOS,
                  (Title[OUTPUT][DUTYPWM].Color[0]),z,Title[OUTPUT][DUTYPWM].Str);
      }  
      else
      {
        Print_Str(172,  216, (Title[OUTPUT][DUTYPWM].Color[0]), z, "Vo ");//230,202
        Int2Str(NumStr, (Title[OUTPUT][OUTATT].Value*28000), V_UNIT, 2, UNSIGN,0);     //26000 
        Print_Str(Title[OUTPUT][OUTATT].XPOS, Title[OUTPUT][OUTATT].YPOS,
                  (Title[OUTPUT][OUTATT].Color[0]),z,NumStr);
      }


        if (CalFlag==0){
          Print_Str(137,216,0x0405,PRN,"U");
        }else{
          Print_Str(137,216,0x0405,PRN,"C");
        }
        
        if (CurDefTime==0){
          Print_Str(153,216,0x0405,PRN," ");
        }else{
          Print_Str(153,216,0x0405,PRN,"X");
        }

        if(Options&4){
          Print_Str(145,216,0x0405,PRN,"H");
        }else{
          Print_Str(145,216,0x0405,PRN," ");
        }

        p=(char*)Zero;
        *p='0'+ConfigFileNumber;  
        Print_Str(161,216,0x0405,PRN,Zero);

   

  for(i = TRACK1; i <= VOLUME; ++i){
    for(j = 0; j < 4; ++j){
      if(Title[i][j].Flag & UPDAT){   // need to refresh the Item
        Title[i][j].Flag &= ~UPDAT;   // Clr Update flag 
        if((i == BATTERY)||(i == TRIGG)){
          if(Title[i][j].MARK & FIX){                  // ---- Under fix mode

         if (!((i==TRIGG)&&(j==3)&&((NotificationTimer>0)||(Current==FILE)))){	// "T" delay 
            Print_Str( 								//notifications are displayed
              Title[i][j].XPOS, Title[i][j].YPOS,
              Title[i][j].Color[Title[i][0].Value],    // Color variable 
              PRN, 
              Title[i][j].Str                          // String fixed
            );                    
         }

          } else if(!(Title[i][j].MARK & NOT)){        // ---- Under other mode
	            Print_Str(
              Title[i][j].XPOS, Title[i][j].YPOS,
              Title[i][j].Color[Title[i][0].Value],    // Color variable 
              PRN, 
              Title[i][j].Str +(Title[i][j].Value * 10)// String variable
            ); 
          }
        } else {
          if(Title[i][j].MARK & FIX){                  // ---- Under fix mode
              Print_Str(
                Title[i][j].XPOS, Title[i][j].YPOS,
                Title[i][j].Color[0],                    // Color fixed 
                PRN, 
                Title[i][j].Str                          // String fixed
		    	    // battery and volume meter titles - not flashing
               );
          } else if(Title[i][j].MARK & NUM3){          // ---- Under NUM3 mode
            if(i == V_VERNIE){
              if  (Title[_Meas_V_Track][SOURCE].Value ==2) 
                  {Int2Str(NumStr,(_V1_Vernie-_V2_Vernie)*_Meas_V_Scale*10, V_UNIT, 3, SIGN,0);}
                else
                  {Int2Str(NumStr,(_V1_Vernie-_V2_Vernie)*_Meas_V_Scale, V_UNIT, 3, SIGN,0);
                }
              Print_Str(
                //Title[i][j].XPOS, Title[i][j].YPOS,			//shift left when calling with no meters to clear right edge
                (Title[i][j].XPOS-ShiftLeft), Title[i][j].YPOS,
                Title[i][j].Color[_Meas_V_Track],      // Color fixed  
                PRN, 
                NumStr                                // String for numerical
				//Delta V value
              );
            }
            if(i == T_VERNIE){				
              m = 1;  n = 1;
              k = _T_Range;
              if(k < 9)  m = Power(10, (11-k)/3);
              else       n = Power(10, (k- 9)/3);
              k = X_Attr[(k%3)+9].SCALE *(_T2 - _T1);
		  if (_T_Range<3)k/=1000;				//special case for very long interval so won't overload
              if(k > 0){
                if(k <=  0x7FFFFFFF/m)  k = (m * k)/n;
                else                    k = 0x80000000;
              } else {
                if((-k)> 0x7FFFFFFF/m)  k = (m * k)/n;
                else                    k = 0x80000000;
              }
              Int2Str(NumStr, k, D_UNIT, 3, SIGN,0);
              Print_Str(
                //Title[i][j].XPOS, Title[i][j].YPOS,
                (Title[i][j].XPOS-ShiftLeft), Title[i][j].YPOS,		//shift left when calling with no meters to clear right edge
                Title[i][j].Color[0],                  // Color fixed  
                PRN, 
                NumStr                                // String for numerical
              );
            }
            if(i==FILE){
               u8ToDec3(Title[FILE][1].Str, Title[FILE][1].Value);
               Print_Str(
                Title[FILE][1].XPOS, Title[FILE][1].YPOS,
                Title[FILE][1].Color[0],                  // Color fixed  
                PRN, 
                Title[FILE][1].Str                        // String for numerical
              );
            }
          } else if(Title[i][j].MARK == NUM2){ 
                NumStr[0]=' ';
            if(i == BK_LIGHT){                        // backlight percentage
              if(Title[i][j].Value == 9){
                Int2Str(NumStr, 100, P_UNIT, 3, STD,0);
                } else Int2Str(NumStr, 10*(Title[i][j].Value+1), P_UNIT, 2, STD,0);
            } else {                                  // volume percentage
              if(Title[i][j].Value == 9){							//was 10, changed so volume ind works properly
                Int2Str(NumStr, 100, P_UNIT, 3, STD,0);
              } else Int2Str(NumStr, 10*(Title[i][j].Value+1), P_UNIT, 2, STD,0);
            }
            Print_Str(
              Title[i][j].XPOS, Title[i][j].YPOS,
              Title[i][j].Color[0],                  // Color fixed  
              PRN, 
              NumStr                        // String for numerical
			  //Battery and volume values
            );
          } else if(Title[i][j].MARK != NOT){
          
            if(i == V_VERNIE){
              Print_Str(
                Title[i][j].XPOS, Title[i][j].YPOS,
                Title[i][j].Color[_Meas_V_Track],         // Color variable 
                PRN, 
                Title[i][j].Str +(Title[i][j].Value * 10) // String variable
				//Delta V meter title
              ); 
            } else {
				if (i<=1 && j==2 && Title[i][0].Value==2){
				
				Print_Str(
					Title[i][j].XPOS, Title[i][j].YPOS,
					Title[i][j].Color[0],                    // Color fixed 
					PRN, 
					x10[Title[i][j].Value]// String variable
					//ChA or ChB x10 value - not flasing
				  );
				  
				} else {
				  Print_Str(
					Title[i][j].XPOS, Title[i][j].YPOS,
					Title[i][j].Color[0],                    // Color fixed 
					PRN, 
					Title[i][j].Str +(Title[i][j].Value *10)// String variable
					//Upper menu titles and values - not flashing
				  );

				}
            }
          } else if(i == T_VERNIE){
            Print_Str(
              Title[i][j].XPOS, Title[i][j].YPOS,
              Title[i][j].Color[0],                    // Color fixed 
              PRN, 
              Title[i][j].Str                          // String variable
            ); 
          }
        }
      } else if((Current == i)&&(Detail[i] == j)&&(Blink)){ // current cursor position Item
        Blink = 0;
        if((i == BATTERY)||(i == TRIGG)){
          if((Title[i][j].MARK & FIX)){      // ---- Under fix mode
            if (j==3) {						//show delayed trigger "T" on view area
              if ((FrameMode==2)&&((Options&1)>0)&&(NotificationTimer==0)) {
                //Print_Str((((((Title[7][3].Value/30)*100)/116)*207)/100)+91, Title[i][j].YPOS,
                Print_Str(Title[i][j].XPOS, Title[i][j].YPOS,
                Title[i][j].Color[Title[i][0].Value],    // Color variable 
                Twink, 
                Title[i][j].Str);                          // String fixed
              }
            }else{
              Print_Str( 
                Title[i][j].XPOS, Title[i][j].YPOS,
                Title[i][j].Color[Title[i][0].Value],    // Color variable 
                Twink, 
                Title[i][j].Str                          // String fixed
              ); 
            } 
          } else {                                // ---- Under other mode
            Print_Str(
              Title[i][j].XPOS, Title[i][j].YPOS,
              Title[i][j].Color[Title[i][0].Value],    // Color variable 
              Twink, 
              Title[i][j].Str +(Title[i][j].Value * 10)// String variable
            ); 
          }
        } else {
          if(Title[i][j].MARK & FIX){             // ---- Under fix mode
            Print_Str(
              Title[i][j].XPOS, Title[i][j].YPOS,
              Title[i][j].Color[0],                    // Color fixed 
              Twink, 
              Title[i][j].Str                          // String fixed
            );
     } else if(Title[i][j].MARK != NUM3){
            if(i == V_VERNIE)
            Print_Str(
                Title[i][j].XPOS, Title[i][j].YPOS,
                Title[i][j].Color[_Meas_V_Track],        // Color variable
                Twink, 
                Title[i][j].Str +(Title[i][j].Value * 10)// String variable
				// Delta V meter title - flashing
            ); else {
                        if (i<=1 && j==2 && Title[i][0].Value==2)
				Print_Str(
					Title[i][j].XPOS, Title[i][j].YPOS,
					Title[i][j].Color[0],                    // Color fixed 
					Twink, 
					x10[Title[i][j].Value]// String variable
					//ChA or ChB x10 value - flashing
				); 
			else
				Print_Str(
					Title[i][j].XPOS, Title[i][j].YPOS,
					Title[i][j].Color[0],                    // Color fixed 
					Twink, 
					Title[i][j].Str +(Title[i][j].Value * 10)// String variable
					//Upper menu titles and values - flashing
				); 
			}
                   }
            if((i == FILE)&&(Title[i][j].MARK & NUM3)){
              u8ToDec3(Title[i][1].Str, Title[i][1].Value);
              Print_Str(
                Title[i][1].XPOS, Title[i][1].YPOS,
                Title[i][1].Color[0],                  // Color fixed  
                Twink, 
                Title[i][1].Str                        // String for numerical
              );
            }
        }

      }		//if UPDAT (?)
    }		//for j
  }		//for i
}		//function

/*******************************************************************************
 Load_Attr:   load the hardware properties
*******************************************************************************/
void Load_Attr(void)
{
  u16 i;
  
  for(i=0; i<G_Attr[0].Yp_Max+1; ++i) 
    strcpy(&Vertical[i][0], Y_Attr[i].STR);

  Title[TRACK1][RANGE].Limit = G_Attr[0].Yp_Max;
  Title[TRACK2][RANGE].Limit = G_Attr[0].Yp_Max;
  Title[TRACK3][RANGE].Limit = 0;
  Title[TRACK4][RANGE].Limit = 0;
  
  for(i=0; i<G_Attr[0].Xp_Max+6; ++i) 
    strcpy(&BaseStr[i][0], X_Attr[i].STR);
  Title[T_BASE][BASE].Limit = G_Attr[0].Xp_Max;
  
}
/*******************************************************************************
 Update_Battery:  refresh the battery indicator
*******************************************************************************/
void Update_Battery(void)
{
  u16 Vb, Level;
  
  Vb = __Get(V_BATTERY);
  if (Cnt_InCharge>0) Cnt_InCharge--;
  if (Cnt_Charged>0) Cnt_Charged--;
  Cnt_Batt++;
  if (Cnt_Batt>4) Cnt_Batt=1;
  
  if (__Get(CHARGE)==1){
    Cnt_Charged=4;
     if (Cnt_InCharge==0)FlagInCharge=1;
 }
    else
  {  
    Cnt_InCharge=4;  
    if (Cnt_Charged==0)FlagInCharge=0;
   
  }
  
  
  if (FlagInCharge==1){        //batteria in carica
    Level = Cnt_Batt ;
  }
  else
  {
    Level =0;	//3000,3500,3900,4100 (or)    3200,3600,3900,4100 (mod)     3400,3600,3800,3990 >Batt seemed to die off very fast after going from 1/2 to 1/4...
    //if(Vb > 3000 ) Level +=1;
    if(Vb > 3400 ) Level +=1;
    //if(Vb > 3500 ) Level +=1;
    if(Vb > 3600 ) Level +=1;
    if(Vb > 3800 ) Level +=1;
    if(Vb > 3990 ) Level +=1; 
     
  }  
  if (Level>4) Level=4;
    Print_Str(
    Title[4][1].XPOS, Title[4][1].YPOS,
    Title[4][1].Color[Level], 
    PRN,
    (Title[4][1].Str + Level*10) 
  );    
}


void DisplayBigMeter(u8 MeterNum){

  u8   j;
  u8   BigMeterYpos1=0;
  u8   BigMeterYpos2=0;
  char BigMeterStr1[7];			//values
  char BigMeterStr2[4];			//suffix
  char BigMeterStr3[5];			//items
  BigMeterStr1[5]=0;			//termination nulls
  BigMeterStr2[2]=0;
  BigMeterStr3[3]=0;
  char RefStr[10]=" DCmV?k!S";		//reference matching characters	

  switch (MeterNum){			//meter positions
    case 1:  
      BigMeterYpos1=154;
      BigMeterYpos2=129;
    break;
    case 2:
      BigMeterYpos1=97;
      BigMeterYpos2=72;  
    break;               //32
    case 3:
      BigMeterYpos1=40;  //25
      BigMeterYpos2=15;
  }

  switch (Meter[MeterNum].Item){       //format string 1, values
    case VBT:
    case VDC...RMS:
    case MAX...VPP:
      if((NumStr[5]==RefStr[3])||(NumStr[5]==RefStr[4])){	//look for "m" or "V" for all volt meters	
        for (j=0;j<5;j++)BigMeterStr1[j]=NumStr[j];		
      }else{							//if "KV" or ending of number, strip leading zero and replace with sign
        BigMeterStr1[0]=NumStr[0];				//puts "-" or "+" sign before number, instead of leading "0" in 0.0
        for (j=1;j<5;j++)BigMeterStr1[j]=NumStr[j+1];           //ie:   +.124  rather than 0.124 for some ranges so all of number fits
      }
      break;
    case FRQ:
    case CIR...TL:
      for (j=0;j<5;j++)BigMeterStr1[j]=NumStr[j];
      break;
    case FPS:
      BigMeterStr1[0]=RefStr[7];
      for (j=1;j<5;j++)BigMeterStr1[j]=NumStr[j];
      BigMeterStr1[5]=RefStr[7];
      BigMeterStr1[6]=0; 
  }


  switch (Meter[MeterNum].Item){       //format string 2, suffix
    case VBT: 
    case VDC...RMS:
    case MAX...VPP:
      if(NumStr[5]==RefStr[3]){					//"m", so copy 2 ("mV")
        for (j=0;j<2;j++)BigMeterStr2[j]=NumStr[j+5];
      }else if((NumStr[5]==RefStr[4])||(NumStr[6]==RefStr[4])){ //"V"
        BigMeterStr2[0]=RefStr[7];				//"!"
        BigMeterStr2[1]=RefStr[4];
        BigMeterStr2[2]=RefStr[7];
        BigMeterStr2[3]=0;
      }else{
        BigMeterStr2[0]=RefStr[6];				//"kV" character
        BigMeterStr2[1]=RefStr[4];
      }
      break;
    case FRQ:
        for (j=0;j<2;j++)BigMeterStr2[j]=NumStr[j+5];		//HZ, etc
        break; 
    case CIR:
    case TH:
    case TL:
      if(NumStr[5]==RefStr[8]){					//"S"
        BigMeterStr2[0]=RefStr[7];				//"!"
        BigMeterStr2[1]=RefStr[8];
        BigMeterStr2[2]=RefStr[7];
        BigMeterStr2[3]=0;
      }else for (j=0;j<2;j++)BigMeterStr2[j]=NumStr[j+5];	//"uS" etc
      break; 
   case DUT:
        BigMeterStr2[0]=RefStr[7];				//"!"
        BigMeterStr2[1]=NumStr[5];
        BigMeterStr2[2]=RefStr[7];
        BigMeterStr2[3]=0;
      break;
   case FPS:
      for(j=0;j<2;j++)BigMeterStr2[j]=RefStr[0];
 }


 switch (Meter[MeterNum].Item){       //format string3, items
    case VBT...DUT:
      for (j=0;j<3;j++)BigMeterStr3[j]=METER[Meter[MeterNum].Item][j];
      break; 
    case TH...TL:
      for (j=0;j<4;j++)BigMeterStr3[j]=METER[Meter[MeterNum].Item][j];	//"!TH!,!TL!"
      BigMeterStr3[4]=0;						//termination null moved to 5th place to allow for the 2 half spaces
  }


  if((Meter[MeterNum].Item<9)||(EnablePaS)){                            //only update TH,TL,%duty values once per second
    Print_Str2(			     //display values	                //these generate much "bobbling" @3/sec due to uncompensated
    314,LCD_X2,BigMeterYpos1,	     //x and y positions		//quantization errors from PxS starting and stopping at every wave		  
    Y_COLOR[Meter[MeterNum].Track], 					//also extends averaging numbers if available (at the faster TB's)
    PRN,
    BigMeterStr1,
    3,3);			    //leading, trailing blanks  	

    Print_Str2(			    //display suffix	
    313,347,BigMeterYpos2,				  
    Y_COLOR[Meter[MeterNum].Track], 
    PRN,			      			    	
    BigMeterStr2,
    2,0);
  }



    if(((Meter[MeterNum].Item==MIN)||(Meter[MeterNum].Item==MAX))&&((Options&4)==4)){
      Print_Str2(			    //display items in white for hold mode	
      346,LCD_X2,BigMeterYpos2,				  
      Y_COLOR[4], 
      BTwink,			      			    	
      BigMeterStr3,
      12,1);	 			    //>10 leading blanks=leading line + (-10) leading blanks				
    }else{
      Print_Str2(			    //display items in normal color	
      346,LCD_X2,BigMeterYpos2,				  
      Y_COLOR[Meter[MeterNum].Track], 
      BTwink,			      			    	
      BigMeterStr3,
      12,1);
    }

    __LCD_Set_Block(LCD_X1,LCD_X2,LCD_Y1,LCD_Y2);  		// restore the full-size window
 
}

u32 TimeScaleCorrection(u32 Tmp, u8 Polarity, u16 Kp){
                                    //Compensates for truncation of "k" scaling values in interpolated ranges
                                    //Prevents these errors to be further multiplied by IP scaling factors                          
                                    //Uses modified (X10, X100) Kp IP scaling factors as reference  
        switch (Kp){
          case 9830:						//2uS/div, k returns 50ppm off (eg: (6667-6666.6666666)/6667)*1e6 = 50)     
            if(Polarity==0)Tmp+=(Tmp/20000); else Tmp-=(Tmp/20000); 
            break;  
          case 24576:						
          case 8192:						        // 1/.1 uS/div, k returns 10ppm off
            if(Polarity==0)Tmp-=(Tmp/100000); else Tmp+=(Tmp/100000);   // k here equals 33333 in which error is neg as opposed to other
            break;  							// k values
          case 6144:                                     	        // .5uS/div, k returns 20ppm off
            if(Polarity==0)Tmp+=(Tmp/50000); else Tmp-=(Tmp/50000); 
            break;  
          case 4915:						//.2uS/div, k returns 50ppm off, + kp returns 41ppm off = 91ppm off) 
            if(Polarity==0)Tmp+=(Tmp/10989); else Tmp-=(Tmp/10989); 
        }
        return Tmp;
}


u32 UpScale(u32 Tmp, u16 limit){

    if(Tmp>4290){			//up scale,increases resolution with low number of waves counted when dividing with integer math
      while(Tmp<429000000){             //specially in large buffer mode. Makes sure the maximum number of digits of precision can
        Tmp*=10;                        //be considered under all conditions by making #'s as high as possible with 
        ShiftDigits++;                  //u32 variable minus some headroom for following adjustments.
      }					//ShiftDigits compensates for this in Int2Str
    }else ShiftDigits=0;

    while(limit>1){					//scale back down if limit is called for
      if(ShiftDigits>0)ShiftDigits--; else break;
      Tmp/=10;
      limit/=10;
    }
    return Tmp;
}

void CalculateTimeMeters(u32 Tmp, u32 m, u32 n, u16 Kp){
s32 STmp;

    if(n<10){
      while((m>1)&&(ShiftDigits>0)){			//remove any up scaling in the lower ranges
        m/=10;
        ShiftDigits--;
      }    
      if(Tmp <= 0x7FFFFFFF/m) Tmp*=m;
      else                    Tmp = 0x80000000;
    }else{
      Tmp=UpScale(Tmp,1);				//up scale after dividing by TxN, so significant digits are not lost
      if(Kp==1024){
        Tmp=((Tmp+(n/2))/n);
      }else{
        Tmp=TimeScaleCorrection(Tmp,1,Kp);		//add Kp IP scaled correction
        Tmp=((Tmp+(n/2))/n);				//sets range, with k factor selecting ranges within each decade
        Tmp=UpScale(Tmp,10);				//up scale after dividing by n, so significant digits are not lost, restrict by X10 to leave room for IP scaling
        if(Kp==24576){					//IP scaling                               
          Tmp=(102400*((Tmp+(Kp/2))/Kp));		//special case .1uS/div with Kp X 100
        }else Tmp=(10240*((Tmp+(Kp/2))/Kp));            //rest of IP ranges, Kp X 10
      } 
    }

        if(Tmp>0x7FFFFFFF){				//convert to signed var for Int2Str				 
          STmp=(Tmp/10);
          ShiftDigits--;
        }else STmp=Tmp;

    Int2Str(NumStr, STmp, T_UNIT, 4, UNSIGN, ShiftDigits);
}

u32 Period(u8 Ch,u32 k){ 
u32 Tmp;
      Tmp=UpScale(Sum[Ch],1);
      Tmp=ClockAdjust(Tmp);
      ShiftDigits=-ShiftDigits;				//upscaled denominator so works backwards, invert shift    
      return(UpScale(((k*100000)/(Tmp/100000)),1)/10);    //scales by e10 (100000*100000) for best resolution in all cases,
}							// div/10 to bring down to original freq scaling of 1e9

u32 ClockAdjust(u32 Value){
    if((PPM_Comp>0)&&(PPM_Comp<1000)){			//do not use if out of range, indicating a read error
      return Value+=(Value/(1000000/PPM_Comp));
    }else if((PPM_Comp<0)&&(PPM_Comp>-1000)){
      return Value-=(Value/(1000000/-PPM_Comp));	//change PPM_Comp to + so works correctly with unsigned var	
    }else return Value;				 
}



/******************************** END OF FILE *********************************/
