# 1 "Process.c"
# 1 "<command-line>"
# 1 "Process.c"




# 1 "inc/Interrupt.h" 1
# 9 "inc/Interrupt.h"
# 1 "FWLib/inc/stm32f10x_lib.h" 1
# 22 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_map.h" 1
# 26 "FWLib/inc/stm32f10x_map.h"
# 1 "inc/stm32f10x_conf.h" 1
# 21 "inc/stm32f10x_conf.h"
# 1 "FWLib/inc/stm32f10x_type.h" 1
# 23 "FWLib/inc/stm32f10x_type.h"
typedef signed long s32;
typedef signed short s16;
typedef signed char s8;

typedef signed long const sc32;
typedef signed short const sc16;
typedef signed char const sc8;

typedef volatile signed long vs32;
typedef volatile signed short vs16;
typedef volatile signed char vs8;

typedef volatile signed long const vsc32;
typedef volatile signed short const vsc16;
typedef volatile signed char const vsc8;

typedef unsigned long u32;
typedef unsigned short u16;
typedef unsigned char u8;

typedef unsigned long const uc32;
typedef unsigned short const uc16;
typedef unsigned char const uc8;

typedef volatile unsigned long vu32;
typedef volatile unsigned short vu16;
typedef volatile unsigned char vu8;

typedef volatile unsigned long const vuc32;
typedef volatile unsigned short const vuc16;
typedef volatile unsigned char const vuc8;

typedef enum {FALSE = 0, TRUE = !FALSE} bool;

typedef enum {RESET = 0, SET = !RESET} FlagStatus, ITStatus;

typedef enum {DISABLE = 0, ENABLE = !DISABLE} FunctionalState;


typedef enum {ERROR = 0, SUCCESS = !ERROR} ErrorStatus;
# 22 "inc/stm32f10x_conf.h" 2
# 27 "FWLib/inc/stm32f10x_map.h" 2
# 1 "FWLib/inc/stm32f10x_type.h" 1
# 28 "FWLib/inc/stm32f10x_map.h" 2
# 1 "FWLib/inc/cortexm3_macro.h" 1
# 27 "FWLib/inc/cortexm3_macro.h"
void __WFI(void);
void __WFE(void);
void __SEV(void);
void __ISB(void);
void __DSB(void);
void __DMB(void);
void __SVC(void);
u32 __MRS_CONTROL(void);
void __MSR_CONTROL(u32 Control);
u32 __MRS_PSP(void);
void __MSR_PSP(u32 TopOfProcessStack);
u32 __MRS_MSP(void);
void __MSR_MSP(u32 TopOfMainStack);
void __RESETPRIMASK(void);
void __SETPRIMASK(void);
u32 __READ_PRIMASK(void);
void __RESETFAULTMASK(void);
void __SETFAULTMASK(void);
u32 __READ_FAULTMASK(void);
void __BASEPRICONFIG(u32 NewPriority);
u32 __GetBASEPRI(void);
u16 __REV_HalfWord(u16 Data);
u32 __REV_Word(u32 Data);
# 29 "FWLib/inc/stm32f10x_map.h" 2







typedef struct
{
  vu32 SR;
  vu32 CR1;
  vu32 CR2;
  vu32 SMPR1;
  vu32 SMPR2;
  vu32 JOFR1;
  vu32 JOFR2;
  vu32 JOFR3;
  vu32 JOFR4;
  vu32 HTR;
  vu32 LTR;
  vu32 SQR1;
  vu32 SQR2;
  vu32 SQR3;
  vu32 JSQR;
  vu32 JDR1;
  vu32 JDR2;
  vu32 JDR3;
  vu32 JDR4;
  vu32 DR;
} ADC_TypeDef;


typedef struct
{
  u32 RESERVED0;
  vu16 DR1;
  u16 RESERVED1;
  vu16 DR2;
  u16 RESERVED2;
  vu16 DR3;
  u16 RESERVED3;
  vu16 DR4;
  u16 RESERVED4;
  vu16 DR5;
  u16 RESERVED5;
  vu16 DR6;
  u16 RESERVED6;
  vu16 DR7;
  u16 RESERVED7;
  vu16 DR8;
  u16 RESERVED8;
  vu16 DR9;
  u16 RESERVED9;
  vu16 DR10;
  u16 RESERVED10;
  vu16 RTCCR;
  u16 RESERVED11;
  vu16 CR;
  u16 RESERVED12;
  vu16 CSR;
  u16 RESERVED13[5];
  vu16 DR11;
  u16 RESERVED14;
  vu16 DR12;
  u16 RESERVED15;
  vu16 DR13;
  u16 RESERVED16;
  vu16 DR14;
  u16 RESERVED17;
  vu16 DR15;
  u16 RESERVED18;
  vu16 DR16;
  u16 RESERVED19;
  vu16 DR17;
  u16 RESERVED20;
  vu16 DR18;
  u16 RESERVED21;
  vu16 DR19;
  u16 RESERVED22;
  vu16 DR20;
  u16 RESERVED23;
  vu16 DR21;
  u16 RESERVED24;
  vu16 DR22;
  u16 RESERVED25;
  vu16 DR23;
  u16 RESERVED26;
  vu16 DR24;
  u16 RESERVED27;
  vu16 DR25;
  u16 RESERVED28;
  vu16 DR26;
  u16 RESERVED29;
  vu16 DR27;
  u16 RESERVED30;
  vu16 DR28;
  u16 RESERVED31;
  vu16 DR29;
  u16 RESERVED32;
  vu16 DR30;
  u16 RESERVED33;
  vu16 DR31;
  u16 RESERVED34;
  vu16 DR32;
  u16 RESERVED35;
  vu16 DR33;
  u16 RESERVED36;
  vu16 DR34;
  u16 RESERVED37;
  vu16 DR35;
  u16 RESERVED38;
  vu16 DR36;
  u16 RESERVED39;
  vu16 DR37;
  u16 RESERVED40;
  vu16 DR38;
  u16 RESERVED41;
  vu16 DR39;
  u16 RESERVED42;
  vu16 DR40;
  u16 RESERVED43;
  vu16 DR41;
  u16 RESERVED44;
  vu16 DR42;
  u16 RESERVED45;
} BKP_TypeDef;


typedef struct
{
  vu32 TIR;
  vu32 TDTR;
  vu32 TDLR;
  vu32 TDHR;
} CAN_TxMailBox_TypeDef;

typedef struct
{
  vu32 RIR;
  vu32 RDTR;
  vu32 RDLR;
  vu32 RDHR;
} CAN_FIFOMailBox_TypeDef;

typedef struct
{
  vu32 FR1;
  vu32 FR2;
} CAN_FilterRegister_TypeDef;

typedef struct
{
  vu32 MCR;
  vu32 MSR;
  vu32 TSR;
  vu32 RF0R;
  vu32 RF1R;
  vu32 IER;
  vu32 ESR;
  vu32 BTR;
  u32 RESERVED0[88];
  CAN_TxMailBox_TypeDef sTxMailBox[3];
  CAN_FIFOMailBox_TypeDef sFIFOMailBox[2];
  u32 RESERVED1[12];
  vu32 FMR;
  vu32 FM1R;
  u32 RESERVED2;
  vu32 FS1R;
  u32 RESERVED3;
  vu32 FFA1R;
  u32 RESERVED4;
  vu32 FA1R;
  u32 RESERVED5[8];
  CAN_FilterRegister_TypeDef sFilterRegister[14];
} CAN_TypeDef;


typedef struct
{
  vu32 DR;
  vu8 IDR;
  u8 RESERVED0;
  u16 RESERVED1;
  vu32 CR;
} CRC_TypeDef;



typedef struct
{
  vu32 CR;
  vu32 SWTRIGR;
  vu32 DHR12R1;
  vu32 DHR12L1;
  vu32 DHR8R1;
  vu32 DHR12R2;
  vu32 DHR12L2;
  vu32 DHR8R2;
  vu32 DHR12RD;
  vu32 DHR12LD;
  vu32 DHR8RD;
  vu32 DOR1;
  vu32 DOR2;
} DAC_TypeDef;


typedef struct
{
  vu32 IDCODE;
  vu32 CR;
}DBGMCU_TypeDef;


typedef struct
{
  vu32 CCR;
  vu32 CNDTR;
  vu32 CPAR;
  vu32 CMAR;
} DMA_Channel_TypeDef;

typedef struct
{
  vu32 ISR;
  vu32 IFCR;
} DMA_TypeDef;


typedef struct
{
  vu32 IMR;
  vu32 EMR;
  vu32 RTSR;
  vu32 FTSR;
  vu32 SWIER;
  vu32 PR;
} EXTI_TypeDef;


typedef struct
{
  vu32 ACR;
  vu32 KEYR;
  vu32 OPTKEYR;
  vu32 SR;
  vu32 CR;
  vu32 AR;
  vu32 RESERVED;
  vu32 OBR;
  vu32 WRPR;
} FLASH_TypeDef;

typedef struct
{
  vu16 RDP;
  vu16 USER;
  vu16 Data0;
  vu16 Data1;
  vu16 WRP0;
  vu16 WRP1;
  vu16 WRP2;
  vu16 WRP3;
} OB_TypeDef;


typedef struct
{
  vu32 BTCR[8];
} FSMC_Bank1_TypeDef;

typedef struct
{
  vu32 BWTR[7];
} FSMC_Bank1E_TypeDef;

typedef struct
{
  vu32 PCR2;
  vu32 SR2;
  vu32 PMEM2;
  vu32 PATT2;
  u32 RESERVED0;
  vu32 ECCR2;
} FSMC_Bank2_TypeDef;

typedef struct
{
  vu32 PCR3;
  vu32 SR3;
  vu32 PMEM3;
  vu32 PATT3;
  u32 RESERVED0;
  vu32 ECCR3;
} FSMC_Bank3_TypeDef;

typedef struct
{
  vu32 PCR4;
  vu32 SR4;
  vu32 PMEM4;
  vu32 PATT4;
  vu32 PIO4;
} FSMC_Bank4_TypeDef;


typedef struct
{
  vu32 CRL;
  vu32 CRH;
  vu32 IDR;
  vu32 ODR;
  vu32 BSRR;
  vu32 BRR;
  vu32 LCKR;
} GPIO_TypeDef;

typedef struct
{
  vu32 EVCR;
  vu32 MAPR;
  vu32 EXTICR[4];
} AFIO_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 OAR1;
  u16 RESERVED2;
  vu16 OAR2;
  u16 RESERVED3;
  vu16 DR;
  u16 RESERVED4;
  vu16 SR1;
  u16 RESERVED5;
  vu16 SR2;
  u16 RESERVED6;
  vu16 CCR;
  u16 RESERVED7;
  vu16 TRISE;
  u16 RESERVED8;
} I2C_TypeDef;


typedef struct
{
  vu32 KR;
  vu32 PR;
  vu32 RLR;
  vu32 SR;
} IWDG_TypeDef;


typedef struct
{
  vu32 ISER[2];
  u32 RESERVED0[30];
  vu32 ICER[2];
  u32 RSERVED1[30];
  vu32 ISPR[2];
  u32 RESERVED2[30];
  vu32 ICPR[2];
  u32 RESERVED3[30];
  vu32 IABR[2];
  u32 RESERVED4[62];
  vu32 IPR[15];
} NVIC_TypeDef;

typedef struct
{
  vuc32 CPUID;
  vu32 ICSR;
  vu32 VTOR;
  vu32 AIRCR;
  vu32 SCR;
  vu32 CCR;
  vu32 SHPR[3];
  vu32 SHCSR;
  vu32 CFSR;
  vu32 HFSR;
  vu32 DFSR;
  vu32 MMFAR;
  vu32 BFAR;
  vu32 AFSR;
} SCB_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CSR;
} PWR_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CFGR;
  vu32 CIR;
  vu32 APB2RSTR;
  vu32 APB1RSTR;
  vu32 AHBENR;
  vu32 APB2ENR;
  vu32 APB1ENR;
  vu32 BDCR;
  vu32 CSR;
} RCC_TypeDef;


typedef struct
{
  vu16 CRH;
  u16 RESERVED0;
  vu16 CRL;
  u16 RESERVED1;
  vu16 PRLH;
  u16 RESERVED2;
  vu16 PRLL;
  u16 RESERVED3;
  vu16 DIVH;
  u16 RESERVED4;
  vu16 DIVL;
  u16 RESERVED5;
  vu16 CNTH;
  u16 RESERVED6;
  vu16 CNTL;
  u16 RESERVED7;
  vu16 ALRH;
  u16 RESERVED8;
  vu16 ALRL;
  u16 RESERVED9;
} RTC_TypeDef;


typedef struct
{
  vu32 POWER;
  vu32 CLKCR;
  vu32 ARG;
  vu32 CMD;
  vuc32 RESPCMD;
  vuc32 RESP1;
  vuc32 RESP2;
  vuc32 RESP3;
  vuc32 RESP4;
  vu32 DTIMER;
  vu32 DLEN;
  vu32 DCTRL;
  vuc32 DCOUNT;
  vuc32 STA;
  vu32 ICR;
  vu32 MASK;
  u32 RESERVED0[2];
  vuc32 FIFOCNT;
  u32 RESERVED1[13];
  vu32 FIFO;
} SDIO_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 SR;
  u16 RESERVED2;
  vu16 DR;
  u16 RESERVED3;
  vu16 CRCPR;
  u16 RESERVED4;
  vu16 RXCRCR;
  u16 RESERVED5;
  vu16 TXCRCR;
  u16 RESERVED6;
  vu16 I2SCFGR;
  u16 RESERVED7;
  vu16 I2SPR;
  u16 RESERVED8;
} SPI_TypeDef;


typedef struct
{
  vu32 CTRL;
  vu32 LOAD;
  vu32 VAL;
  vuc32 CALIB;
} SysTick_TypeDef;


typedef struct
{
  vu16 CR1;
  u16 RESERVED0;
  vu16 CR2;
  u16 RESERVED1;
  vu16 SMCR;
  u16 RESERVED2;
  vu16 DIER;
  u16 RESERVED3;
  vu16 SR;
  u16 RESERVED4;
  vu16 EGR;
  u16 RESERVED5;
  vu16 CCMR1;
  u16 RESERVED6;
  vu16 CCMR2;
  u16 RESERVED7;
  vu16 CCER;
  u16 RESERVED8;
  vu16 CNT;
  u16 RESERVED9;
  vu16 PSC;
  u16 RESERVED10;
  vu16 ARR;
  u16 RESERVED11;
  vu16 RCR;
  u16 RESERVED12;
  vu16 CCR1;
  u16 RESERVED13;
  vu16 CCR2;
  u16 RESERVED14;
  vu16 CCR3;
  u16 RESERVED15;
  vu16 CCR4;
  u16 RESERVED16;
  vu16 BDTR;
  u16 RESERVED17;
  vu16 DCR;
  u16 RESERVED18;
  vu16 DMAR;
  u16 RESERVED19;
} TIM_TypeDef;


typedef struct
{
  vu16 SR;
  u16 RESERVED0;
  vu16 DR;
  u16 RESERVED1;
  vu16 BRR;
  u16 RESERVED2;
  vu16 CR1;
  u16 RESERVED3;
  vu16 CR2;
  u16 RESERVED4;
  vu16 CR3;
  u16 RESERVED5;
  vu16 GTPR;
  u16 RESERVED6;
} USART_TypeDef;


typedef struct
{
  vu32 CR;
  vu32 CFR;
  vu32 SR;
} WWDG_TypeDef;
# 23 "FWLib/inc/stm32f10x_lib.h" 2
# 49 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_dma.h" 1
# 26 "FWLib/inc/stm32f10x_dma.h"
typedef struct
{
  u32 DMA_PeripheralBaseAddr;
  u32 DMA_MemoryBaseAddr;
  u32 DMA_DIR;
  u32 DMA_BufferSize;
  u32 DMA_PeripheralInc;
  u32 DMA_MemoryInc;
  u32 DMA_PeripheralDataSize;
  u32 DMA_MemoryDataSize;
  u32 DMA_Mode;
  u32 DMA_Priority;
  u32 DMA_M2M;
}DMA_InitTypeDef;
# 284 "FWLib/inc/stm32f10x_dma.h"
void DMA_DeInit(DMA_Channel_TypeDef* DMAy_Channelx);
void DMA_Init(DMA_Channel_TypeDef* DMAy_Channelx, DMA_InitTypeDef* DMA_InitStruct);
void DMA_StructInit(DMA_InitTypeDef* DMA_InitStruct);
void DMA_Cmd(DMA_Channel_TypeDef* DMAy_Channelx, FunctionalState NewState);
void DMA_ITConfig(DMA_Channel_TypeDef* DMAy_Channelx, u32 DMA_IT, FunctionalState NewState);
u16 DMA_GetCurrDataCounter(DMA_Channel_TypeDef* DMAy_Channelx);
FlagStatus DMA_GetFlagStatus(u32 DMA_FLAG);
void DMA_ClearFlag(u32 DMA_FLAG);
ITStatus DMA_GetITStatus(u32 DMA_IT);
void DMA_ClearITPendingBit(u32 DMA_IT);
# 50 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_flash.h" 1
# 27 "FWLib/inc/stm32f10x_flash.h"
typedef enum
{
  FLASH_BUSY = 1,
  FLASH_ERROR_PG,
  FLASH_ERROR_WRP,
  FLASH_COMPLETE,
  FLASH_TIMEOUT
}FLASH_Status;
# 179 "FWLib/inc/stm32f10x_flash.h"
void FLASH_SetLatency(u32 FLASH_Latency);
void FLASH_HalfCycleAccessCmd(u32 FLASH_HalfCycleAccess);
void FLASH_PrefetchBufferCmd(u32 FLASH_PrefetchBuffer);


void FLASH_Unlock(void);
void FLASH_Lock(void);
FLASH_Status FLASH_ErasePage(u32 Page_Address);
FLASH_Status FLASH_EraseAllPages(void);
FLASH_Status FLASH_EraseOptionBytes(void);
FLASH_Status FLASH_ProgramWord(u32 Address, u32 Data);
FLASH_Status FLASH_ProgramHalfWord(u32 Address, u16 Data);
FLASH_Status FLASH_ProgramOptionByteData(u32 Address, u8 Data);
FLASH_Status FLASH_EnableWriteProtection(u32 FLASH_Pages);
FLASH_Status FLASH_ReadOutProtection(FunctionalState NewState);
FLASH_Status FLASH_UserOptionByteConfig(u16 OB_IWDG, u16 OB_STOP, u16 OB_STDBY);
u32 FLASH_GetUserOptionByte(void);
u32 FLASH_GetWriteProtectionOptionByte(void);
FlagStatus FLASH_GetReadOutProtectionStatus(void);
FlagStatus FLASH_GetPrefetchBufferStatus(void);
void FLASH_ITConfig(u16 FLASH_IT, FunctionalState NewState);
FlagStatus FLASH_GetFlagStatus(u16 FLASH_FLAG);
void FLASH_ClearFlag(u16 FLASH_FLAG);
FLASH_Status FLASH_GetStatus(void);
FLASH_Status FLASH_WaitForLastOperation(u32 Timeout);
# 58 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_fsmc.h" 1
# 26 "FWLib/inc/stm32f10x_fsmc.h"
typedef struct
{
  u32 FSMC_AddressSetupTime;
  u32 FSMC_AddressHoldTime;
  u32 FSMC_DataSetupTime;
  u32 FSMC_BusTurnAroundDuration;
  u32 FSMC_CLKDivision;
  u32 FSMC_DataLatency;
  u32 FSMC_AccessMode;
}FSMC_NORSRAMTimingInitTypeDef;


typedef struct
{
  u32 FSMC_Bank;
  u32 FSMC_DataAddressMux;
  u32 FSMC_MemoryType;
  u32 FSMC_MemoryDataWidth;
  u32 FSMC_BurstAccessMode;
  u32 FSMC_WaitSignalPolarity;
  u32 FSMC_WrapMode;
  u32 FSMC_WaitSignalActive;
  u32 FSMC_WriteOperation;
  u32 FSMC_WaitSignal;
  u32 FSMC_ExtendedMode;
  u32 FSMC_WriteBurst;

  FSMC_NORSRAMTimingInitTypeDef* FSMC_ReadWriteTimingStruct;

  FSMC_NORSRAMTimingInitTypeDef* FSMC_WriteTimingStruct;
}FSMC_NORSRAMInitTypeDef;


typedef struct
{
  u32 FSMC_SetupTime;
  u32 FSMC_WaitSetupTime;
  u32 FSMC_HoldSetupTime;
  u32 FSMC_HiZSetupTime;
}FSMC_NAND_PCCARDTimingInitTypeDef;


typedef struct
{
  u32 FSMC_Bank;
  u32 FSMC_Waitfeature;
  u32 FSMC_MemoryDataWidth;
  u32 FSMC_ECC;
  u32 FSMC_ECCPageSize;
  u32 FSMC_AddressLowMapping;
  u32 FSMC_TCLRSetupTime;
  u32 FSMC_TARSetupTime;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_CommonSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_AttributeSpaceTimingStruct;
}FSMC_NANDInitTypeDef;


typedef struct
{
  u32 FSMC_Waitfeature;
  u32 FSMC_AddressLowMapping;
  u32 FSMC_TCLRSetupTime;
  u32 FSMC_TARSetupTime;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_CommonSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_AttributeSpaceTimingStruct;

  FSMC_NAND_PCCARDTimingInitTypeDef* FSMC_IOSpaceTimingStruct;
}FSMC_PCCARDInitTypeDef;
# 323 "FWLib/inc/stm32f10x_fsmc.h"
void FSMC_NORSRAMDeInit(u32 FSMC_Bank);
void FSMC_NANDDeInit(u32 FSMC_Bank);
void FSMC_PCCARDDeInit(void);
void FSMC_NORSRAMInit(FSMC_NORSRAMInitTypeDef* FSMC_NORSRAMInitStruct);
void FSMC_NANDInit(FSMC_NANDInitTypeDef* FSMC_NANDInitStruct);
void FSMC_PCCARDInit(FSMC_PCCARDInitTypeDef* FSMC_PCCARDInitStruct);
void FSMC_NORSRAMStructInit(FSMC_NORSRAMInitTypeDef* FSMC_NORSRAMInitStruct);
void FSMC_NANDStructInit(FSMC_NANDInitTypeDef* FSMC_NANDInitStruct);
void FSMC_PCCARDStructInit(FSMC_PCCARDInitTypeDef* FSMC_PCCARDInitStruct);
void FSMC_NORSRAMCmd(u32 FSMC_Bank, FunctionalState NewState);
void FSMC_NANDCmd(u32 FSMC_Bank, FunctionalState NewState);
void FSMC_PCCARDCmd(FunctionalState NewState);
void FSMC_NANDECCCmd(u32 FSMC_Bank, FunctionalState NewState);
u32 FSMC_GetECC(u32 FSMC_Bank);
void FSMC_ITConfig(u32 FSMC_Bank, u32 FSMC_IT, FunctionalState NewState);
FlagStatus FSMC_GetFlagStatus(u32 FSMC_Bank, u32 FSMC_FLAG);
void FSMC_ClearFlag(u32 FSMC_Bank, u32 FSMC_FLAG);
ITStatus FSMC_GetITStatus(u32 FSMC_Bank, u32 FSMC_IT);
void FSMC_ClearITPendingBit(u32 FSMC_Bank, u32 FSMC_IT);
# 62 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_gpio.h" 1
# 34 "FWLib/inc/stm32f10x_gpio.h"
typedef enum
{
  GPIO_Speed_10MHz = 1,
  GPIO_Speed_2MHz,
  GPIO_Speed_50MHz
}GPIOSpeed_TypeDef;





typedef enum
{ GPIO_Mode_AIN = 0x0,
  GPIO_Mode_IN_FLOATING = 0x04,
  GPIO_Mode_IPD = 0x28,
  GPIO_Mode_IPU = 0x48,
  GPIO_Mode_Out_OD = 0x14,
  GPIO_Mode_Out_PP = 0x10,
  GPIO_Mode_AF_OD = 0x1C,
  GPIO_Mode_AF_PP = 0x18
}GPIOMode_TypeDef;







typedef struct
{
  u16 GPIO_Pin;
  GPIOSpeed_TypeDef GPIO_Speed;
  GPIOMode_TypeDef GPIO_Mode;
}GPIO_InitTypeDef;


typedef enum
{ Bit_RESET = 0,
  Bit_SET
}BitAction;
# 217 "FWLib/inc/stm32f10x_gpio.h"
void GPIO_DeInit(GPIO_TypeDef* GPIOx);
void GPIO_AFIODeInit(void);
void GPIO_Init(GPIO_TypeDef* GPIOx, GPIO_InitTypeDef* GPIO_InitStruct);
void GPIO_StructInit(GPIO_InitTypeDef* GPIO_InitStruct);
u8 GPIO_ReadInputDataBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
u16 GPIO_ReadInputData(GPIO_TypeDef* GPIOx);
u8 GPIO_ReadOutputDataBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
u16 GPIO_ReadOutputData(GPIO_TypeDef* GPIOx);
void GPIO_SetBits(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_ResetBits(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_WriteBit(GPIO_TypeDef* GPIOx, u16 GPIO_Pin, BitAction BitVal);
void GPIO_Write(GPIO_TypeDef* GPIOx, u16 PortVal);
void GPIO_PinLockConfig(GPIO_TypeDef* GPIOx, u16 GPIO_Pin);
void GPIO_EventOutputConfig(u8 GPIO_PortSource, u8 GPIO_PinSource);
void GPIO_EventOutputCmd(FunctionalState NewState);
void GPIO_PinRemapConfig(u32 GPIO_Remap, FunctionalState NewState);
void GPIO_EXTILineConfig(u8 GPIO_PortSource, u8 GPIO_PinSource);
# 66 "FWLib/inc/stm32f10x_lib.h" 2
# 77 "FWLib/inc/stm32f10x_lib.h"
# 1 "FWLib/inc/stm32f10x_nvic.h" 1
# 26 "FWLib/inc/stm32f10x_nvic.h"
typedef struct
{
  u8 NVIC_IRQChannel;
  u8 NVIC_IRQChannelPreemptionPriority;
  u8 NVIC_IRQChannelSubPriority;
  FunctionalState NVIC_IRQChannelCmd;
} NVIC_InitTypeDef;
# 253 "FWLib/inc/stm32f10x_nvic.h"
void NVIC_DeInit(void);
void NVIC_SCBDeInit(void);
void NVIC_PriorityGroupConfig(u32 NVIC_PriorityGroup);
void NVIC_Init(NVIC_InitTypeDef* NVIC_InitStruct);
void NVIC_StructInit(NVIC_InitTypeDef* NVIC_InitStruct);
void NVIC_SETPRIMASK(void);
void NVIC_RESETPRIMASK(void);
void NVIC_SETFAULTMASK(void);
void NVIC_RESETFAULTMASK(void);
void NVIC_BASEPRICONFIG(u32 NewPriority);
u32 NVIC_GetBASEPRI(void);
u16 NVIC_GetCurrentPendingIRQChannel(void);
ITStatus NVIC_GetIRQChannelPendingBitStatus(u8 NVIC_IRQChannel);
void NVIC_SetIRQChannelPendingBit(u8 NVIC_IRQChannel);
void NVIC_ClearIRQChannelPendingBit(u8 NVIC_IRQChannel);
u16 NVIC_GetCurrentActiveHandler(void);
ITStatus NVIC_GetIRQChannelActiveBitStatus(u8 NVIC_IRQChannel);
u32 NVIC_GetCPUID(void);
void NVIC_SetVectorTable(u32 NVIC_VectTab, u32 Offset);
void NVIC_GenerateSystemReset(void);
void NVIC_GenerateCoreReset(void);
void NVIC_SystemLPConfig(u8 LowPowerMode, FunctionalState NewState);
void NVIC_SystemHandlerConfig(u32 SystemHandler, FunctionalState NewState);
void NVIC_SystemHandlerPriorityConfig(u32 SystemHandler, u8 SystemHandlerPreemptionPriority,
                                      u8 SystemHandlerSubPriority);
ITStatus NVIC_GetSystemHandlerPendingBitStatus(u32 SystemHandler);
void NVIC_SetSystemHandlerPendingBit(u32 SystemHandler);
void NVIC_ClearSystemHandlerPendingBit(u32 SystemHandler);
ITStatus NVIC_GetSystemHandlerActiveBitStatus(u32 SystemHandler);
u32 NVIC_GetFaultHandlerSources(u32 SystemHandler);
u32 NVIC_GetFaultAddress(u32 SystemHandler);
# 78 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_rcc.h" 1
# 25 "FWLib/inc/stm32f10x_rcc.h"
typedef struct
{
  u32 SYSCLK_Frequency;
  u32 HCLK_Frequency;
  u32 PCLK1_Frequency;
  u32 PCLK2_Frequency;
  u32 ADCCLK_Frequency;
}RCC_ClocksTypeDef;
# 253 "FWLib/inc/stm32f10x_rcc.h"
void RCC_DeInit(void);
void RCC_HSEConfig(u32 RCC_HSE);
ErrorStatus RCC_WaitForHSEStartUp(void);
void RCC_AdjustHSICalibrationValue(u8 HSICalibrationValue);
void RCC_HSICmd(FunctionalState NewState);
void RCC_PLLConfig(u32 RCC_PLLSource, u32 RCC_PLLMul);
void RCC_PLLCmd(FunctionalState NewState);
void RCC_SYSCLKConfig(u32 RCC_SYSCLKSource);
u8 RCC_GetSYSCLKSource(void);
void RCC_HCLKConfig(u32 RCC_SYSCLK);
void RCC_PCLK1Config(u32 RCC_HCLK);
void RCC_PCLK2Config(u32 RCC_HCLK);
void RCC_ITConfig(u8 RCC_IT, FunctionalState NewState);
void RCC_USBCLKConfig(u32 RCC_USBCLKSource);
void RCC_ADCCLKConfig(u32 RCC_PCLK2);
void RCC_LSEConfig(u8 RCC_LSE);
void RCC_LSICmd(FunctionalState NewState);
void RCC_RTCCLKConfig(u32 RCC_RTCCLKSource);
void RCC_RTCCLKCmd(FunctionalState NewState);
void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks);
void RCC_AHBPeriphClockCmd(u32 RCC_AHBPeriph, FunctionalState NewState);
void RCC_APB2PeriphClockCmd(u32 RCC_APB2Periph, FunctionalState NewState);
void RCC_APB1PeriphClockCmd(u32 RCC_APB1Periph, FunctionalState NewState);
void RCC_APB2PeriphResetCmd(u32 RCC_APB2Periph, FunctionalState NewState);
void RCC_APB1PeriphResetCmd(u32 RCC_APB1Periph, FunctionalState NewState);
void RCC_BackupResetCmd(FunctionalState NewState);
void RCC_ClockSecuritySystemCmd(FunctionalState NewState);
void RCC_MCOConfig(u8 RCC_MCO);
FlagStatus RCC_GetFlagStatus(u8 RCC_FLAG);
void RCC_ClearFlag(void);
ITStatus RCC_GetITStatus(u8 RCC_IT);
void RCC_ClearITPendingBit(u8 RCC_IT);
# 86 "FWLib/inc/stm32f10x_lib.h" 2







# 1 "FWLib/inc/stm32f10x_sdio.h" 1
# 25 "FWLib/inc/stm32f10x_sdio.h"
typedef struct
{
  u8 SDIO_ClockDiv;
  u32 SDIO_ClockEdge;
  u32 SDIO_ClockBypass;
  u32 SDIO_ClockPowerSave;
  u32 SDIO_BusWide;
  u32 SDIO_HardwareFlowControl;
} SDIO_InitTypeDef;

typedef struct
{
  u32 SDIO_Argument;
  u32 SDIO_CmdIndex;
  u32 SDIO_Response;
  u32 SDIO_Wait;
  u32 SDIO_CPSM;
} SDIO_CmdInitTypeDef;

typedef struct
{
  u32 SDIO_DataTimeOut;
  u32 SDIO_DataLength;
  u32 SDIO_DataBlockSize;
  u32 SDIO_TransferDir;
  u32 SDIO_TransferMode;
  u32 SDIO_DPSM;
} SDIO_DataInitTypeDef;
# 304 "FWLib/inc/stm32f10x_sdio.h"
void SDIO_DeInit(void);
void SDIO_Init(SDIO_InitTypeDef* SDIO_InitStruct);
void SDIO_StructInit(SDIO_InitTypeDef* SDIO_InitStruct);
void SDIO_ClockCmd(FunctionalState NewState);
void SDIO_SetPowerState(u32 SDIO_PowerState);
u32 SDIO_GetPowerState(void);
void SDIO_ITConfig(u32 SDIO_IT, FunctionalState NewState);
void SDIO_DMACmd(FunctionalState NewState);
void SDIO_SendCommand(SDIO_CmdInitTypeDef *SDIO_CmdInitStruct);
void SDIO_CmdStructInit(SDIO_CmdInitTypeDef* SDIO_CmdInitStruct);
u8 SDIO_GetCommandResponse(void);
u32 SDIO_GetResponse(u32 SDIO_RESP);
void SDIO_DataConfig(SDIO_DataInitTypeDef* SDIO_DataInitStruct);
void SDIO_DataStructInit(SDIO_DataInitTypeDef* SDIO_DataInitStruct);
u32 SDIO_GetDataCounter(void);
u32 SDIO_ReadData(void);
void SDIO_WriteData(u32 Data);
u32 SDIO_GetFIFOCount(void);
void SDIO_StartSDIOReadWait(FunctionalState NewState);
void SDIO_StopSDIOReadWait(FunctionalState NewState);
void SDIO_SetSDIOReadWaitMode(u32 SDIO_ReadWaitMode);
void SDIO_SetSDIOOperation(FunctionalState NewState);
void SDIO_SendSDIOSuspendCmd(FunctionalState NewState);
void SDIO_CommandCompletionCmd(FunctionalState NewState);
void SDIO_CEATAITCmd(FunctionalState NewState);
void SDIO_SendCEATACmd(FunctionalState NewState);
FlagStatus SDIO_GetFlagStatus(u32 SDIO_FLAG);
void SDIO_ClearFlag(u32 SDIO_FLAG);
ITStatus SDIO_GetITStatus(u32 SDIO_IT);
void SDIO_ClearITPendingBit(u32 SDIO_IT);
# 94 "FWLib/inc/stm32f10x_lib.h" 2



# 1 "FWLib/inc/stm32f10x_spi.h" 1
# 26 "FWLib/inc/stm32f10x_spi.h"
typedef struct
{
  u16 SPI_Direction;
  u16 SPI_Mode;
  u16 SPI_DataSize;
  u16 SPI_CPOL;
  u16 SPI_CPHA;
  u16 SPI_NSS;
  u16 SPI_BaudRatePrescaler;
  u16 SPI_FirstBit;
  u16 SPI_CRCPolynomial;
}SPI_InitTypeDef;
# 175 "FWLib/inc/stm32f10x_spi.h"
void SPI_DeInit(SPI_TypeDef* SPIx);
void SPI_Init(SPI_TypeDef* SPIx, SPI_InitTypeDef* SPI_InitStruct);
void SPI_StructInit(SPI_InitTypeDef* SPI_InitStruct);
void SPI_Cmd(SPI_TypeDef* SPIx, FunctionalState NewState);
void SPI_ITConfig(SPI_TypeDef* SPIx, u8 SPI_IT, FunctionalState NewState);
void SPI_DMACmd(SPI_TypeDef* SPIx, u16 SPI_DMAReq, FunctionalState NewState);
void SPI_SendData(SPI_TypeDef* SPIx, u16 Data);
u16 SPI_ReceiveData(SPI_TypeDef* SPIx);
void SPI_NSSInternalSoftwareConfig(SPI_TypeDef* SPIx, u16 SPI_NSSInternalSoft);
void SPI_SSOutputCmd(SPI_TypeDef* SPIx, FunctionalState NewState);
void SPI_DataSizeConfig(SPI_TypeDef* SPIx, u16 SPI_DataSize);
void SPI_TransmitCRC(SPI_TypeDef* SPIx);
void SPI_CalculateCRC(SPI_TypeDef* SPIx, FunctionalState NewState);
u16 SPI_GetCRC(SPI_TypeDef* SPIx, u8 SPI_CRC);
u16 SPI_GetCRCPolynomial(SPI_TypeDef* SPIx);
void SPI_BiDirectionalLineConfig(SPI_TypeDef* SPIx, u16 SPI_Direction);
FlagStatus SPI_GetFlagStatus(SPI_TypeDef* SPIx, u16 SPI_FLAG);
void SPI_ClearFlag(SPI_TypeDef* SPIx, u16 SPI_FLAG);
ITStatus SPI_GetITStatus(SPI_TypeDef* SPIx, u8 SPI_IT);
void SPI_ClearITPendingBit(SPI_TypeDef* SPIx, u8 SPI_IT);
# 98 "FWLib/inc/stm32f10x_lib.h" 2
# 120 "FWLib/inc/stm32f10x_lib.h"
void debug(void);
# 10 "inc/Interrupt.h" 2

extern vu8 Cursor_Cnt, Key_Wait_Cnt, Key_Repeat_Cnt, Key_Buffer, Cnt_mS, Cnt_20mS;
extern vu8 Twink, Blink;
extern u8 Volume, Light;
extern vu16 Delay_Cnt, Beep_mS, Key_Status_Last, Sec_Cnt, PD_Cnt, TimedDeltaView,NotificationTimer,DelayLoopBreak;
extern vu32 Wait_Cnt;
void NMIException(void);
void HardFaultException(void);
void MemManageException(void);
void BusFaultException(void);
void UsageFaultException(void);
void DebugMonitor(void);
void SVCHandler(void);
void PendSVC(void);
void SysTickHandler(void);
void WWDG_IRQHandler(void);
void PVD_IRQHandler(void);
void TAMPER_IRQHandler(void);
void RTC_IRQHandler(void);
void FLASH_IRQHandler(void);
void RCC_IRQHandler(void);
void EXTI0_IRQHandler(void);
void EXTI1_IRQHandler(void);
void EXTI2_IRQHandler(void);
void EXTI3_IRQHandler(void);
void EXTI4_IRQHandler(void);
void DMA1_Channel1_IRQHandler(void);
void DMA1_Channel2_IRQHandler(void);
void DMA1_Channel3_IRQHandler(void);
void DMA1_Channel4_IRQHandler(void);
void DMA1_Channel5_IRQHandler(void);
void DMA1_Channel6_IRQHandler(void);
void DMA1_Channel7_IRQHandler(void);
void ADC1_2_IRQHandler(void);
void USB_HP_CAN_TX_IRQHandler(void);
void USB_LP_CAN_RX0_IRQHandler(void);
void CAN_RX1_IRQHandler(void);
void CAN_SCE_IRQHandler(void);
void EXTI9_5_IRQHandler(void);
void TIM1_BRK_IRQHandler(void);
void TIM1_UP_IRQHandler(void);
void TIM1_TRG_COM_IRQHandler(void);
void TIM1_CC_IRQHandler(void);
void TIM2_IRQHandler(void);
void TIM3_IRQHandler(void);
void TIM4_IRQHandler(void);
void I2C1_EV_IRQHandler(void);
void I2C1_ER_IRQHandler(void);
void I2C2_EV_IRQHandler(void);
void I2C2_ER_IRQHandler(void);
void SPI1_IRQHandler(void);
void SPI2_IRQHandler(void);
void USART1_IRQHandler(void);
void USART2_IRQHandler(void);
void USART3_IRQHandler(void);
void EXTI15_10_IRQHandler(void);
void RTCAlarm_IRQHandler(void);
void USBWakeUp_IRQHandler(void);
void TIM8_BRK_IRQHandler(void);
void TIM8_UP_IRQHandler(void);
void TIM8_TRG_COM_IRQHandler(void);
void TIM8_CC_IRQHandler(void);
void ADC3_IRQHandler(void);
void FSMC_IRQHandler(void);
void SDIO_IRQHandler(void);
void TIM5_IRQHandler(void);
void SPI3_IRQHandler(void);
void UART4_IRQHandler(void);
void UART5_IRQHandler(void);
void TIM6_IRQHandler(void);
void TIM7_IRQHandler(void);
void DMA2_Channel1_IRQHandler(void);
void DMA2_Channel2_IRQHandler(void);
void DMA2_Channel3_IRQHandler(void);
void DMA2_Channel4_5_IRQHandler(void);
# 6 "Process.c" 2
# 1 "inc/Function.h" 1
# 26 "inc/Function.h"
u32 Power(u8 x, u8 y);
void Delayms(u16 mS);
void Int2Str(char *p, s32 n,const char *pUnit, u8 e, u8 Mode, s8 ShiftDigits);
u8 Str2Byte(char x,char y);
void u16ToDec5(char *p, u16 n);
void u8ToDec3(char *p, u8 n);
void u8ToDec2(char *p, u8 n);
void Char2Hex(char *p, u8 n);
void Shor2Hex(char *p, u16 n);
void Word2Hex(char *p, u32 n);
void s16ToDec3(char *p, s16 n);
u32 Int_sqrt(u32 n);
u8 Read_Keys(void);
void s8ToPercen(char *p, s8 n);
# 49 "inc/Function.h"
extern void fix_fft(short fr[], short fi[], short m);
# 7 "Process.c" 2
# 1 "inc/Process.h" 1
# 9 "inc/Process.h"
# 1 "inc/Draw.h" 1
# 10 "inc/Draw.h"
typedef struct
{
  s16 Value;
  u8 Flag;
} trigg;
# 83 "inc/Draw.h"
extern u8 OffsetX;
extern u8 OffsetY;


extern u16 MAX_X;
extern u8 FlagFrameMode;
extern u8 FlagMeter;
extern u8 UpdateMeter;
extern u8 TrgAuto;
extern u16 Color[16];
extern u16 LCD_Buffer1[240], LCD_Buffer2[240];
extern trigg V_Trigg[4];
u16 Get_TAB_8x11(u8 Code, u8 Row);
u8 Get_Ref_Wave(u16 i);
void Print_Clk(u16 x0, u16 y0, u16 Type, u8 Phase);
void Print_Str(u16 x0, u16 y0, u16 Color, u8 Mode, char *s);

void Print_Str2(u16 x0,u16 x1,u16 y0, u16 Type, u8 Mode, char *s,u8 LeadingBlanks,u8 TrailingBlanks);


void Draw_Row(u16 Row);
void Draw_Row_XY(u16 Row);

void Draw_Window(void);

void LoadBase3Buffer(void);
void LoadBase2Buffer(void);

void Draw_Mark(u16 m, u16 n);
void Update_Mark(void);
void Update_View_Area(void);
void Clear_Meter_Area(void);
# 10 "inc/Process.h" 2
# 65 "inc/Process.h"
typedef struct
{
  uc8 STR[8];
  uc16 PSC;
  uc16 ARR;
} A_tab ;

typedef struct
{
  uc8 STR[8];
  uc16 PSC;
  uc16 ARR;
  u16 Duty;
} D_tab ;

extern u8 discard;
extern s16 Xtend;
extern u8 BailoutFlag;

extern u8 CurDefTime;
extern u16 NSamples;
extern u16 CountUnread;
extern u8 TrackBuff [392 * 4];

extern s32 a_Avg, b_Avg, a_Ssq, b_Ssq;



extern s16 a_Max, b_Max, a_Min, b_Min;
extern s16 aT_Max, bT_Max, aT_Min, bT_Min;
extern u8 Rdiscard;

extern u16 Tcs, Tcnt;

extern u16 TaS, TbS, TcS, TdS;
extern u32 Sum[4];
extern u16 NAvg[4];
extern u16 VNAvg[2];
extern s32 VxAvg[2];
extern s32 VxSsq[2];
extern u16 PaS, PbS, PcS, PdS;
extern u16 TaN, TbN, TcN, TdN;
extern u32 PxS[4];
extern u32 TxS[4];
extern u32 TxN[4];

extern u8 FrameMode;
extern u8 FFTflag;

extern u8 Options;
extern u16 TempKp1;
extern u8 ADCoffset;
extern u8 CalFlag;
extern u16 JumpCnt;
extern s8 Kab;
extern s8 Ka1[10], Kb1[10];
extern u16 Ka2[10], Kb2[10];
extern s8 Ka3[10], Kb3[10];
extern s8 HKa1[10], HKb1[10];
extern u16 HKa2[10], HKb2[10];
extern s8 HKa3[10], HKb3[10];
extern s8 LKa1[10], LKb1[10];
extern u16 LKa2[10], LKb2[10];
extern s8 LKa3[10], LKb3[10];
extern u32 DataBuf[4096];
extern u8 ScalingOffset;
extern char Vertical[15][10];
extern s16 TrigSourceEnable;
extern u16 HiBatLevel[2];
extern u16 LoBatLevel[2];
extern u16 PrevBatLevel;
extern u16 VDiff[2];
extern u8 SumResetFlag;
extern u8 EnablePaS;
extern u8 ClearHoldFlag;
extern u8 SlowModeSkip;
extern s16 A_Posi;
extern s16 B_Posi;
extern u8 ClearLeadingEdge;


void BackGround_Reset(void);
void App_init(void);
void View_init(void);
void Update_Range(void);
void Update_Base(void);
void Update_Output(void);
void Update_Trig(u8 service);
void Process(void);
void Synchro(void);
void Send_Data(s16 Va, s16 Vb, u8 C_D, u16 n);
u16 get_bag_max_buf();
void cleardatabuf(u8 Afill, u8 Bfill, u16 n,u8 service);
void Config_init(void);
void TransferFIFO(s16 i,u8 service);
void SetOffset(u8 channel,u8 range, s16 Ypos);
void BatLevelCompensation(void);
void ResetSum(void);
void ClearMinMax(u8 Channels);
void ClearHold(u8 Channels);
void ClearTrackBuff(u8 service);



extern short fr[];
extern short fi[];

extern u8 ShowFFT;
extern u32 NFreq;
extern char NFreqStr[];
extern int imax;
extern short PeakFreq;
extern char PeakFreqStr[];
extern char FreqDivStr[];
extern char FreqT1Str[];
# 8 "Process.c" 2
# 1 "inc/Draw.h" 1
# 9 "Process.c" 2
# 1 "inc/Menu.h" 1
# 160 "inc/Menu.h"
typedef struct
{
  char *Str;
  u8 Track;
  u8 Item;
  uc16 XPOS1;
  uc16 XPOS2;
  uc8 YPOS;
  u8 Flag;
} meter;

typedef struct
{
  char *Str;
  u16 *Color;
  s16 Limit;
  uc8 MARK;
  u16 XPOS;
  uc8 YPOS;
  s16 Value;
  u8 Flag;
} menu;

extern menu Title[13][4];
extern meter Meter[9];
extern u8 Current, TypeA, Update,BTwink;
extern u8 Detail[14];
extern char NumStr[12];
extern u16 Result_FPS;
extern const char T_UNIT[12], S_UNIT[12], P_UNIT[12], V_UNIT[12];
extern char N_UNIT[12];
extern u8 ConfigFileNumber;
extern s16 Ga_Max;
extern s16 Gb_Max;
extern s16 Ga_Min;
extern s16 Gb_Min;
extern s16 GHa_Max;
extern s16 GHb_Max;
extern s16 GHa_Min;
extern s16 GHb_Min;
extern u8 ShiftDigits;


extern uc16 Y_COLOR[5];

void EnableMeter(void);
void DisableMeter(void);
void Display_Value(u8 i);
void Display_Title(void);
void Display_Meter(void);
void Load_Attr(void);
void Update_Battery(void);
void DisplayBigMeter(u8 MeterNum);
void MeterDefaults(void);
u32 UpScale(u32 Tmp, u16 limit);
# 10 "Process.c" 2
# 1 "inc/BIOS.h" 1
# 139 "inc/BIOS.h"
typedef struct
{
  u16 LCD_X;
  u16 LCD_Y;
  u16 Yp_Max;
  u16 Xp_Max;
  u16 Tg_Num;
  u16 Yv_Max;
  u16 Xt_Max;
  u16 Co_Max;
  u8 Ya_Num;
  u8 Yd_Num;
  u8 INSERT;
  u16 KpA1;
  u16 KpA2;
  u16 KpB1;
  u16 KpB2;
} G_attr ;

typedef struct
{
  char STR[8];
  s16 KA1;
  u16 KA2;
  s16 KB1;
  u16 KB2;
  u32 SCALE;
} Y_attr ;

typedef struct
{
  char STR[8];
  s16 PSC;
  u16 ARR;
  u16 CCR;
  u16 KP;
  u32 SCALE;
} X_attr ;

typedef struct
{
  char STR[8];
  u8 CHx;
  u8 CMD;
} T_attr ;

extern Y_attr *Y_Attr;
extern X_attr *X_Attr;
extern G_attr *G_Attr;
extern T_attr *T_Attr;




 void __CTR_HP(void);
 void __USB_Istr(void);
 void __USB_Init(void);

 void __LCD_Initial(void);
 void __Clear_Screen(u16 Color);
 void __Point_SCR(u16 x0, u16 y0);
 void __LCD_SetPixl(u16 Color);
 u16 __LCD_GetPixl(void);
 u16 __Get_TAB_8x14(u8 Code, u16 Row);
 void __LCD_Set_Block(u16 x1, u16 x2, u16 y1, u16 y2);

 void __LCD_Copy(uc16 *pBuffer, u16 NumPixel);
 void __LCD_Fill(u16 *pBuffer,u16 NumPixel);
 void __LCD_DMA_Ready(void);

 void __Row_Copy(uc16 *S_Buffer,u16 *T_Buffer);
 void __Row_DMA_Ready(void);

 u32 __Read_FIFO(void);
 void __Display_Str(u16 x0, u16 y0, u16 Color, u8 Mode, char *s);

 u32 __Input_Lic(u16 x0, u8 y0);
 u32 __GetDev_SN(void);

 u8 __Ident(u32 Dev_ID, u32 Proj_ID, u32 Lic_No);

 void __Set(u8 Object, u32 Value);
 u32 __Get(u8 Object);

 void __ExtFlash_PageRD(u8* pBuffer, u32 ReadAddr, u16 NumByteToRead);
 void __ExtFlash_PageWR(u8* pBuffer, u32 WriteAddr);
 u8 __ReadDiskData(u8* pBuffer, u32 ReadAddr, u16 Lenght);
 u8 __ProgDiskPage(u8* pBuffer, u32 ProgAddr);

 u8 __FLASH_Erase(u32 Address);
 u8 __FLASH_Prog(u32 Address, u16 Data);
 void __FLASH_Unlock(void);
 void __FLASH_Lock(void);

 u8 __Chk_SYS(u32 Licence);
 u8* __Chk_DFU(void);
 u8* __Chk_HDW(void);

 u8 __OpenFileWr(u8* Buffer, char* FileName, u16* Cluster, u32* pDirAddr);
 u8 __OpenFileRd(u8* Buffer, char* FileName, u16* Cluster, u32* pDirAddr);
 u8 __ReadFileSec(u8* Buffer, u16* Cluster);
 u8 __ProgFileSec(u8* Buffer, u16* Cluster);
 u8 __CloseFile(u8* Buffer, u32 Lenght, u16* Cluster, u32* pDirAddr);
# 11 "Process.c" 2
# 1 "inc/File.h" 1
# 28 "inc/File.h"
extern u8 FileBuff[1600];
extern u8 SaveShortBuffXpos;
extern u8 Versions;

u8 Save_Bmp(u8 FileNum);
u8 Color_Num(u16 Color);
u8 Save_Dat(u8 FileNum);
u8 Load_Dat(u8 FileNum);
u8 Save_Buf(u8 FileNum);
u8 Load_Buf(u8 FileNum);
u8 Save_Csv(u8 FileNum);
u8 Make_Filename(u8 FileNum,char* FileName);
void reset_parameter(void);
u8 Load_Param(u8 FileNum);
u8 Save_Param(u8 FileNum);
# 12 "Process.c" 2


short fr[512];
short fi[512];
u32 NFreq;
char NFreqStr[12];
int imax;
short PeakFreq;
char PeakFreqStr[12];
char FreqDivStr[12];
char FreqT1Str[12];


u32 Sum[4]={0,0,0,0};
u16 NAvg[4]={0,0,0,0};
u16 VNAvg[2]={0,0};
s32 VxAvg[2]={0,0};
s32 VxSsq[2]={0,0};
u32 PxS[4]={0,0,0,0};
u32 TxS[4]={0,0,0,0};
u32 TxN[4]={0,0,0,0};

u16 TaS, TbS, TcS, TdS;
u16 PaS, PbS, PcS, PdS;
u16 TaN, TbN, TcN, TdN;
s16 a_Mid_H, a_Mid_L;
s16 b_Mid_H, b_Mid_L;

s32 a_Avg, b_Avg, a_Ssq, b_Ssq;
s16 a_Max, b_Max, a_Min, b_Min;
s16 aT_Max, bT_Max, aT_Min, bT_Min;

s16 Posi_412,Posi_41_2, Posi_41, Posi_42, Posi_4_2, Posi_4F1, Posi_4F2, Posi_4F3, Posi_4F4;
s16 c_Max, d_Max, A_Posi, B_Posi;
u8 Full=1, BailoutFlag=0;
u16 JumpCnt,CountUnread;
u8 FrameMode;
u8 HoldOnNext =0;
u16 bag_max_buf = 4096;
u8 freerun=0;
u8 exitflag=0;
u8 entryflag=0;
u8 ADCoffset=54;
u16 TempKp1=1024;
u8 CalFlag;
u8 CurDefTime=0;
u8 Options;
u8 HoldResetFlag=0;
s16 Xtend;
u8 discard=0;
s16 TrigSourceEnable=1;
u32 ReverseBitMask;
u32 BitMask;
u16 AltHoldoff=0;
s8 OldShift=0;
u8 ScalingOffset=40;


u16 QStart[2]={0,0};
u16 QEnd[2]={0,0};
u8 LastA_Mid=0;
u8 LastB_Mid=0;
u8 FirstA_Mid=0;
u8 FirstB_Mid=0;
u8 SumResetFlag=0;
u32 UTmp;
u8 EnablePaS=1;
u8 ClearHoldFlag=0;
u8 SlowModeSkip=0;
u8 ClearLeadingEdge=0;
u8 FFTflag=0;
u8 Normal=100;

void Beeper(u16 ms);
void AlternateChannel(void);
void SetOffset(u8 channel,u8 range, s16 Ypos);
void BatLevelCompensation(void);
s8 InterpolateS8(u8 Ch, s8 L8,s8 H8);
u16 InterpolateU16(u8 Ch, u16 L16,u16 H16);
s16 QParam(u8 Ch, u16 Position,u8 service);
s32 QError(u8 Ch, u16 Start, u16 End, u32 Utmp);
void Average(u8 Ch);
void RunAvg(u8 Ch);
s32 VRunAvg(u8 Ch, s32 Value, s32 Sum);

uc16 Wait[27]= {1000, 500, 200, 100, 65, 30, 20, 10, 5, 3,
                       2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2 };

uc16 shortwait[27]= {300, 150, 100, 75, 35, 15, 10, 10, 5, 3,
                        2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
                        2, 2, 2, 2, 2, 2, 2 };

uc16 TrigDelayLoop[10]= {2,4,10,20,40,100,200,400,1000,2000};

uc16 AltDelay[21]= {1000, 500, 300, 150, 75, 30, 15, 8, 4, 2};

Y_attr *Y_Attr;
X_attr *X_Attr;
G_attr *G_Attr;
T_attr *T_Attr;

u32 DataBuf[4096];
u8 TrackBuff [392 * 4];

uc8 Exp[201]={ 1, 2, 4, 6, 8, 10, 12, 14, 16, 18, 19, 21, 23, 25, 27, 29, 31, 33, 34, 36,
   38, 40, 42, 43, 45, 47, 49, 50, 52, 54, 55, 57, 59, 61, 62, 64, 65, 67, 69, 70,
   72, 74, 75, 77, 78, 80, 81, 83, 84, 86, 87, 89, 90, 92, 93, 95, 96, 98, 99,101,
  102,103,105,106,107,109,110,111,113,114,115,117,118,119,120,122,123,124,125,127,
  128,129,130,131,133,134,135,136,137,138,139,140,141,143,144,145,146,147,148,149,
  150,151,152,153,154,155,156,156,157,158,159,160,161,162,163,164,164,165,166,167,
  168,168,169,170,171,171,172,173,174,174,175,176,176,177,178,178,179,180,180,181,
  182,182,183,183,184,184,185,185,186,186,187,187,188,188,189,189,190,190,191,191,
  191,192,192,192,193,193,194,194,194,194,195,195,195,196,196,196,196,197,197,197,
  197,197,198,198,198,198,198,198,198,198,199,199,199,199,199,199,199,199,199,199,
                200};


uc8 Hamming[512]=
  {12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13,
  14, 14, 14, 14, 15, 15, 15, 15, 16, 16, 16, 16, 17, 17, 17, 18, 18, 19, 19, 19,
  20, 20, 21, 21, 21, 22, 22, 23, 23, 24, 24, 25, 25, 26, 26, 27, 27, 28, 28, 29,
  30, 30, 31, 31, 32, 32, 33, 34, 34, 35, 36, 36, 37, 38, 38, 39, 40, 40, 41, 42,
  42, 43, 44, 45, 45, 46, 47, 47, 48, 49, 50, 51, 51, 52, 53, 54, 54, 55, 56, 57,
  58, 58, 59, 60, 61, 62, 62, 63, 64, 65, 66, 67, 67, 68, 69, 70, 71, 72, 72, 73,
  74, 75, 76, 77, 78, 78, 79, 80, 81, 82, 83, 84, 84, 85, 86, 87, 88, 89, 89, 90,
  91, 92, 93, 94, 94, 95, 96, 97, 98, 99, 99,100,101,102,103,104,104,105,106,107,
 107,108,109,110,111,111,112,113,114,114,115,116,117,117,118,119,119,120,121,122,
 122,123,124,124,125,126,126,127,127,128,129,129,130,131,131,132,132,133,133,134,
 134,135,136,136,137,137,138,138,139,139,139,140,140,141,141,142,142,142,143,143,
 144,144,144,145,145,145,145,146,146,146,147,147,147,147,148,148,148,148,148,149,
 149,149,149,149,149,149,150,150,150,150,150,150,150,150,150,150,150,150,150,150,
 150,150,150,150,150,150,149,149,149,149,149,149,149,148,148,148,148,148,147,147,
 147,147,146,146,146,145,145,145,145,144,144,144,143,143,142,142,142,141,141,140,
 140,139,139,139,138,138,137,137,136,136,135,134,134,133,133,132,132,131,131,130,
 129,129,128,127,127,126,126,125,124,124,123,122,122,121,120,119,119,118,117,117,
 116,115,114,114,113,112,111,111,110,109,108,107,107,106,105,104,104,103,102,101,
 100, 99, 99, 98, 97, 96, 95, 94, 94, 93, 92, 91, 90, 89, 89, 88, 87, 86, 85, 84,
  84, 83, 82, 81, 80, 79, 78, 78, 77, 76, 75, 74, 73, 72, 72, 71, 70, 69, 68, 67,
  67, 66, 65, 64, 63, 62, 62, 61, 60, 59, 58, 58, 57, 56, 55, 54, 54, 53, 52, 51,
  51, 50, 49, 48, 47, 47, 46, 45, 45, 44, 43, 42, 42, 41, 40, 40, 39, 38, 38, 37,
  36, 36, 35, 34, 34, 33, 32, 32, 31, 31, 30, 30, 29, 28, 28, 27, 27, 26, 26, 25,
  25, 24, 24, 23, 23, 22, 22, 21, 21, 21, 20, 20, 19, 19, 19, 18, 18, 17, 17, 17,
  16, 16, 16, 16, 15, 15, 15, 15, 14, 14, 14, 14, 13, 13, 13, 13, 13, 13, 12, 12,
  12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12};

s8 Ka1[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
s8 Kb1[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
u16 Ka2[10] ={1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024};
u16 Kb2[10] ={1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024};
s8 Ka3[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
s8 Kb3[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

s8 HKa1[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
s8 HKb1[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
u16 HKa2[10] ={1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024};
u16 HKb2[10] ={1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024};
s8 HKa3[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
s8 HKb3[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

s8 LKa1[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
s8 LKb1[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
u16 LKa2[10] ={1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024};
u16 LKb2[10] ={1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024};
s8 LKa3[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
s8 LKb3[10] ={ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

u16 HiBatLevel[2]={0,0};
u16 LoBatLevel[2]={0,0};
u16 PrevBatLevel=0;
u16 VDiff[2]={0,0};

D_tab D_Tab[23] ={

  {" !1Hz! ", 1800-1, 40000-1, 50},
  {" !2Hz! ", 1800-1, 20000-1, 50},
  {" !5Hz! ", 1800-1, 8000-1, 50},
  {" 10Hz ", 180-1, 40000-1, 50},
  {" 20Hz ", 180-1, 20000-1, 50},
  {" 50Hz ", 180-1, 8000-1, 50},
  {"!100Hz!", 180-1, 4000-1, 50},
  {"!200Hz!", 180-1, 2000-1, 50},
  {"!500Hz!", 180-1, 800-1, 50},
  {" 1KHz ", 180-1, 400-1, 50},
  {" 2KHz ", 180-1, 200-1, 50},
  {" 5KHz ", 18-1, 800-1, 50},
  {"!10KHz!", 18-1, 400-1, 50},

  {"!25KHz!", 1-1, 2880-1, 50},
  {"!50KHz!", 1-1, 1440-1, 50},
  {"100KHz", 1-1, 720-1, 50},
  {"200KHz", 1-1, 360-1, 50},
  {"500KHz", 1-1, 144-1, 50},
  {" 1MHz ", 1-1, 72-1, 50},
  {" 2MHz ", 1-1, 36-1, 50},
  {" 4MHz ", 1-1, 18-1, 50},
  {" 6MHz ", 1-1, 12-1, 50},
  {" 8MHz ", 1-1, 9-1, 50}};

A_tab A_Tab[15] ={



  {"! 1Hz !", 10-1, 50000-1},
  {"! 2Hz !", 10-1, 25000-1},
  {"! 5Hz !", 10-1, 10000-1},
  {" 10Hz ", 10-1, 5000-1},
  {" 20Hz ", 10-1, 2500-1},
  {" 50Hz ", 10-1, 1000-1},
  {"!100Hz!", 10-1, 500-1},
  {"!200Hz!", 10-1, 250-1},
  {"!500Hz!", 10-1, 100-1},
  {" 1KHz ", 10-1, 50-1},
  {" 2KHz ", 10-1, 25-1},
  {" 5KHz ", 10-1, 10-1},
  {"!10KHz!", 10-1, 5-1},
  {"!25KHz!", 10-1, 2-1},
  {"!40KHz!", 10-1, 2-1}};


u16 ATT_DATA[72];

uc16 SIN_DATA[72] =
{2048,2226,2404,2578,2748,2914,3072,3223,3364,3496,3617,3726,3822,
3904,3972,4026,4065,4088,4095,4088,4065,4026,3972,3904,3822,3726,3617,
3496,3364,3223,3072,2914,2748,2578,2404,2226,2048,1870,1692,1518,1348,
1182,1024,873,732,600,479,370,274,192,124,70,31,8,0,8,31,70,124,192,274,
370,479,600,732,873,1024,1182,1348,1518,1692,1870,};

uc16 TRG_DATA[72] =
  {0,114,228,342,456,570,684,798,912,1026,1140,1254,1368,1482,1596,1710,1824,1938,2052,
2166,2280,2394,2508,2622,2736,2850,2964,3078,3192,3306,3420,3534,3648,3762,3876,3990,4095,
3990,3876,3762,3648,3534,3420,3306,3192,3078,2964,2850,2736,2622,2508,2394,2280,2166,2052,
1938,1824,1710,1596,1482,1368,1254,1140,1026,912,798,684,570,456,342,228,114};

uc16 SAW_DATA[72] =
  {0,
57,112,168,224,280,336,392,448,504,560,616,672,728,784,840,896,952,1008,1064,1120,1176,1232,
1288,1344,1400,1456,1512,1568,1624,1680,1736,1792,1848,1904,1960,2016,2072,2128,2184,2240,2296,
2352,2408,2464,2520,2576,2632,2688,2744,2800,2856,2912,2968,3024,3080,3136,3192,3248,3304,3360,
3416,3472,3528,3584,3640,3696,3752,3808,3864,3920,3976};

uc16 DIGI_DATA[2] =
  {0,4095};

void BackGround_Reset(void)
{
  u16 i, j;
  u8 TitleLimit=13;
  if ((FlagMeter==2)&&(UpdateMeter!=4))TitleLimit=11;

  __Clear_Screen(0x0000);
  for(i=0; i<TitleLimit; i++) for(j=0; j<4; j++) Title[i][j].Flag |= 0x02;
  for(i=0; i<9; i++) Meter[i].Flag |= 0x02;
  if(Current != 9) {
    Title[9][0].Flag &= !0x02;
    Title[9][1].Flag &= !0x02;
    Title[9][3].Flag &= !0x02;
  }
   Update = 1;
}




void App_init(void)
{
  __Set(32+4, 1 );
  __Set(20, 0);
  Delayms(20);
  __Set(6, 1);
  BackGround_Reset();
  PD_Cnt = 600;
}
# 305 "Process.c"
void Update_Range(void)
{
  __Set(32+4, 1);
  __Set(5, 0);

  __Set(9, Title[0][1].Value);
  __Set(10, Title[0][2].Value);
  SetOffset(0,Title[0][2].Value,Title[0][3].Value);
  __Set(11, Title[1][1].Value);
  __Set(12, Title[1][2].Value);
  SetOffset(1,Title[1][2].Value,Title[1][3].Value);
}



void Update_Base(void)
{
  u16 i;

  __Set(32+4, 1);
  i = Title[6][1].Value;
  __Set(7, X_Attr[i].PSC);
  __Set(8, X_Attr[i].ARR);
  Wait_Cnt = Wait[Title[6][1].Value];
  if(Title[4][0].Value == 0) __Set(6, 1);
}



void Update_Output(void)
{

  u8 att;

  if(Title[5][0].Value == 0){
    for(att=0; att <72; att++){

     ATT_DATA[att]=(((Title[5][3].Value*(SIN_DATA[att]-2048))/100)+2048);}
     ((DMA_Channel_TypeDef *) ((((u32)0x40000000) + 0x20000) + 0x0444))->CCR &= ~((u16)0x0001);

      __Set(15, 72);
      __Set(14, (u32)ATT_DATA);
    ((DMA_Channel_TypeDef *) ((((u32)0x40000000) + 0x20000) + 0x0444))->CCR |= ((u16)0x0001);
      __Set(13, A_Tab[Title[5][1].Value].ARR);

  }
  if(Title[5][0].Value == 2){
   for(att=0; att <72; att++){

     ATT_DATA[att]=(((Title[5][3].Value*(SAW_DATA[att]-2048))/100)+2048);}
     ((DMA_Channel_TypeDef *) ((((u32)0x40000000) + 0x20000) + 0x0444))->CCR &= ~((u16)0x0001);

      __Set(15, 72);
      __Set(14, (u32)ATT_DATA);
     ((DMA_Channel_TypeDef *) ((((u32)0x40000000) + 0x20000) + 0x0444))->CCR |= ((u16)0x0001);
      __Set(13, A_Tab[Title[5][1].Value].ARR);
  }
  if(Title[5][0].Value == 1){
    for(att=0; att <72; att++){

     ATT_DATA[att]=(((Title[5][3].Value*(TRG_DATA[att]-2048))/100)+2048);}
     ((DMA_Channel_TypeDef *) ((((u32)0x40000000) + 0x20000) + 0x0444))->CCR &= ~((u16)0x0001);

      __Set(15, 72);
      __Set(14, (u32)ATT_DATA);
    ((DMA_Channel_TypeDef *) ((((u32)0x40000000) + 0x20000) + 0x0444))->CCR |= ((u16)0x0001);
      __Set(13, A_Tab[Title[5][1].Value].ARR);
  }

  if(Title[5][0].Value == 3){
    for(att=0; att <72; att++){
       ATT_DATA[att]=(((Title[5][3].Value*(DIGI_DATA[(att/36)]-2048))/100)+2048);
    }

     ((DMA_Channel_TypeDef *) ((((u32)0x40000000) + 0x20000) + 0x0444))->CCR &= ~((u16)0x0001);

      __Set(15, 72);
      __Set(14, (u32)ATT_DATA);
    ((DMA_Channel_TypeDef *) ((((u32)0x40000000) + 0x20000) + 0x0444))->CCR |= ((u16)0x0001);
      __Set(13, A_Tab[Title[5][1].Value].ARR);
  }

  if(Title[5][0].Value == 4){
    __Set(16, D_Tab[Title[5][1].Value].PSC);
    __Set(17, D_Tab[Title[5][1].Value].ARR);
    __Set(18, ((D_Tab[Title[5][1].Value].ARR+1)*(100-Title[5][2].Value))/100);
  }
}



void Update_Trig(u8 service)
{

  if(Title[10][0].Value > Title[10][1].Value) __Set(32+2, ((((TempKp1*Title[10][0].Value)+512)/1024)-(((TempKp1*Title[10][1].Value)+512)/1024)));
  else __Set(32+2, ((((TempKp1*Title[10][1].Value)+512)/1024)-(((TempKp1*Title[10][0].Value)+512)/1024)));


 if(service){
  __Set(32+0, (Title[7][0].Value<< 3)+Title[7][1].Value);
  if(Title[7][0].Value == 0){
  __Set(32+1, ((((V_Trigg[0].Value-Ka1[Title[0][2].Value]-Title[0][3].Value)*1024)/Ka2[Title[0][2].Value])&0xFF)+ADCoffset+Title[0][3].Value);
  }
  if(Title[7][0].Value == 1){
  __Set(32+1, ((((V_Trigg[1].Value-Kb1[Title[1][2].Value]-Title[1][3].Value)*1024)/Kb2[Title[1][2].Value])&0xFF)+ADCoffset+Title[1][3].Value);
  }

 }else{
  __Set(32+0, (TrigSourceEnable<< 3)+Title[7][1].Value);
  if(TrigSourceEnable == 0){
  __Set(32+1, ((((V_Trigg[0].Value-Ka1[Title[0][2].Value]-Title[0][3].Value)*1024)/Ka2[Title[0][2].Value])&0xFF)+ADCoffset+Title[0][3].Value);
  }
  if(TrigSourceEnable == 1){
  __Set(32+1, ((((V_Trigg[1].Value-Kb1[Title[1][2].Value]-Title[1][3].Value)*1024)/Kb2[Title[1][2].Value])&0xFF)+ADCoffset+Title[1][3].Value);
  }

 }

}



void Process(void)
{
  s16 i, j = 0, k, V[8] = {0},a,b, n = 0;
  s32 Tmp;
  u8 Ch[4], C_D=0;
  s8 Sa = 2, Sb = 2, Sc = 2, Sd = 2;
  u16 Ta, Tb, Tc, Td;
  u16 Pa, Pb, Pc, Pd;
  u8 jj;
  s16 h;
  s16 start;
  u16 finish;
  s8 Shift=0;
  u8 TriggerPosition=150;
  u8 DTriggerPosition=150;
  u8 TimeCalcHyst=2;
  s16 AWavCenter;
  s16 BWavCenter;
  s16 X,Y;
  u16 LeftSkirt=0;

  Ta = Tb = Tc = Td = 0;
  Pa = Pb = Pc = Pd = 0;

  TaS = 0; TbS = 0; TcS = 0; TdS = 0;
  PaS = 0; PbS = 0; PcS = 0; PdS = 0;
  TaN = 0;
  TbN = 0; TcN = 0; TdN = 0;

  Posi_412 = Title[3][3].Value - Title[0][3].Value - Title[1][3].Value;
  Posi_41_2 = Title[3][3].Value - Title[0][3].Value + Title[1][3].Value;
  Posi_41 = Title[3][3].Value - Title[0][3].Value;
  Posi_42 = Title[3][3].Value - Title[1][3].Value;
  Posi_4_2 = Title[3][3].Value + Title[1][3].Value;
  Posi_4F1 = Title[3][3].Value - FileBuff[ 399];
  Posi_4F2 = Title[3][3].Value - FileBuff[ 799];
  Posi_4F3 = Title[3][3].Value - FileBuff[ 1199];
  Posi_4F4 = Title[3][3].Value - FileBuff[1599];

  A_Posi = Title[0][3].Value-Ka1[Title[0][2].Value];
  B_Posi = Title[1][3].Value-Kb1[Title[1][2].Value];



  a_Max=-0x7FFF;a_Min=0x7FFF;
  b_Max=-0x7FFF;b_Min=0x7FFF;

  aT_Max = A_Posi; bT_Max = B_Posi;
  aT_Min = A_Posi; bT_Min = B_Posi;

  if((Title[2][3].Value + 20)>= 0 +200) c_Max = 0 +200 -1;
  else c_Max = Title[2][3].Value + 20;
  if((Title[3][3].Value + 20)>= 0 +200) d_Max = 0 +200 -1;
  else d_Max = Title[3][3].Value + 20;


     if (((((Title[6][0].Value)==2)||((Title[6][0].Value)==3))&&(Title[6][1].Value < 10)&&(Options&1))||(Title[3][0].Value>9)){
       Xtend=150;
     }else{
       Xtend=Title[6][2].Value;
       if (FlagMeter>0) Xtend-=86;
     }

      if(Title[7][1].Value>3)TriggerPosition=149;else TriggerPosition=150;

      switch (Title[6][1].Value){
        case 17:
   DTriggerPosition=149;
          break;
        case 18:
   DTriggerPosition=148;
          break;
        case 19:
          if(Title[7][1].Value>3)DTriggerPosition=147;else DTriggerPosition=148;
          break;
        case 20:
          if(Title[7][1].Value>3)DTriggerPosition=146;else DTriggerPosition=147;
          break;
        case 21:
          if(Title[7][1].Value>3)DTriggerPosition=145;else DTriggerPosition=146;
      }

    if(Title[4][0].Value==0)TempKp1=X_Attr[Title[6][1].Value].KP;
    k =((1024 - TempKp1)*TriggerPosition + 512)/1024 + Title[6][2].Value;

    start=(((((TempKp1*1000)/1024)*Title[10][0].Value)+500)/1000)+k-((1024/TempKp1)/4);
    if((Title[6][1].Value==20)&&(Title[7][0].Value<2))start--;
    if(Title[6][1].Value==19)start--;
    if((Title[6][1].Value==18)&&(Title[7][1].Value>3))start--;
    finish=(((((TempKp1*1000)/1024)*Title[10][1].Value)+500)/1000)+k;

    if ((Title[7][0].Value>1)&&(Title[7][0].Value<4)){start+=5;finish+=5;}

    bag_max_buf = get_bag_max_buf();

    if(Title[10][0].Value==0)start=0;
    if(FlagMeter){
      if(Title[10][1].Value==300)finish=bag_max_buf;
    }else{
      if(Title[10][1].Value==386)finish=bag_max_buf;
    }

    if (CurDefTime==0){
      NSamples=(bag_max_buf-4);
      a_Avg=NSamples/2;
      b_Avg=NSamples/2;
    }else{
       if (finish>start){
         NSamples=(finish-start);
         if (NSamples>1){
     NSamples--;
            a_Avg=NSamples/2;
            b_Avg=NSamples/2;
         }else{
          a_Avg=A_Posi;
          b_Avg=B_Posi;
         }
       }else{
        NSamples=1;
        a_Avg=A_Posi;
        b_Avg=B_Posi;
       }
    }
    a_Ssq=b_Ssq=NSamples/2;
    if((Title[3][0].Value==15)||(Title[3][0].Value==13))Normal=100; else Normal=85;

    if ((exitflag==1)&&(JumpCnt!=0)) exitflag=0;

    for(i=0; i <bag_max_buf; i++){
      if(((Title[6][1].Value > 10)||(freerun==1)||(((Title[6][0].Value)==5)&&(Title[6][1].Value>9)))&&(Title[4][0].Value == 0)){
           if(Title[7][0].Value==4) TransferFIFO(i,1); else TransferFIFO(i,0);
      }
      else if((__Get(1)==0)&&(i == JumpCnt)&&(Title[4][0].Value == 0))
   {
            JumpCnt++;
            if(Title[7][0].Value==4) TransferFIFO(i,1); else TransferFIFO(i,0);
   }

      Ch[0] = (DataBuf[i] & 0xFF );
 V[0]=(Ch[0]-ADCoffset);
 if (Ch[0]<ADCoffset) Ch[0]=ADCoffset;
 Ch[0]-=ADCoffset;

      Ch[1] = ((DataBuf[i] >> 8) & 0xFF);
 V[1]=(Ch[1]-ADCoffset);
 if (Ch[1]<ADCoffset) Ch[1]=ADCoffset;
 Ch[1]-=ADCoffset;

   if(i == 4) {
       aT_Max = V[0];
  aT_Min = aT_Max;
  bT_Max = V[1];
  bT_Min = bT_Max;
   }else{
    if(V[0] > aT_Max) aT_Max = V[0];
  if(V[0] < aT_Min) aT_Min = V[0];
  if(V[1] < bT_Min) bT_Min = V[1];
  if(V[1] > bT_Max) bT_Max = V[1];
   }



           if (i < 512){
  if ((Title[3][0].Value==11)|| (Title[3][0].Value==15)||(Title[3][0].Value==14))
                    fr[i]=(((Ch[0]*Hamming[i])+(Hamming[i]>>1))/Normal)<<2;

  if ((Title[3][0].Value==10)|| (Title[3][0].Value==13)||(Title[3][0].Value==12))
                    fr[i]=(((Ch[1]*Hamming[i])+(Hamming[i]>>1))/Normal)<<2;
            }




      if (i>5) {C_D = DataBuf[i-6] >>16;}else C_D=0;


      if (((CurDefTime==0)&&(i>3)&&(i<bag_max_buf))||((i>start)&&(i<finish))){

        a_Avg += V[0];
        Tmp = V[0]- A_Posi;
        a_Ssq +=(Tmp * Tmp);

        b_Avg += V[1];
        Tmp = V[1]- B_Posi;
        b_Ssq +=(Tmp * Tmp);

   if((i == 4)||((CurDefTime>0)&&(i==(start+1)))) {
         a_Max = V[0];
  a_Min = a_Max;
  b_Max = V[1];
  b_Min = b_Max;
   }else{
    if(V[0] > a_Max) a_Max = V[0];
  if(V[0] < a_Min) a_Min = V[0];
  if(V[1] < b_Min) b_Min = V[1];
  if(V[1] > b_Max) b_Max = V[1];
   }
      }

     if ((CurDefTime==0)||((i>start-1)&&(i<(finish+1)))){

      if((i>3)&&(i<(bag_max_buf-3))){

       if((CurDefTime==0)||(i<finish)){

        if(Ch[0] > a_Mid_H){
          if (Sa<2){
            if(Sa == 0){
    TaS = i;
                  LastA_Mid=a_Mid_H;
              if(Ta==0){
                  Ta=i;
                  QStart[0]=i;
                  FirstA_Mid=a_Mid_H;
    }else{
      TaN++;
      PaS += Pa;
              }
  }
            Sa = 1;
          }
        } else {
          if(Ch[0] < a_Mid_L){
            if(Sa == 2){
    Sa=0;
    PaS=0;
            }
       if(Sa == 1){
                  Sa = 0;
    Pa = i-TaS;
            }
          }
        }

       if(Ch[1] > b_Mid_H){
          if (Sb<2){
            if(Sb == 0){
    TbS = i;
                  LastB_Mid=b_Mid_H;
              if(Tb==0){
                  Tb=i;
                  QStart[1]=i;
                  FirstB_Mid=b_Mid_H;
    }else{
      TbN++;
      PbS += Pb;
              }
  }
            Sb = 1;
          }
        } else {
          if(Ch[1] < b_Mid_L){
            if(Sb == 2){
    Sb=0;
    PbS=0;
            }
       if(Sb == 1){
              Sb = 0;
    Pb = i-TbS;
            }
          }
        }
       }

    if((i>10)&&((CurDefTime==0)||(i>start))){

       if(C_D & 1){
          if (Sc<2){
            if(Sc == 0){
    TcS = i;
              if(Tc==0){
                Tc=i;
    }else{
      TcN++;
      PcS += Pc;
              }
  }
            Sc = 1;
          }
        } else {
            if(Sc == 2){
    Sc=0;
    PcS=0;
            }
       if(Sc == 1){
              Sc = 0;
    Pc = i-TcS;
            }
   }

       if(C_D & 2){
          if (Sd<2){
            if(Sd == 0){
    TdS = i;
              if(Td==0){
                Td=i;
    }else{
      TdN++;
      PdS += Pd;
              }
  }
            Sd = 1;
          }
        } else {
            if(Sd == 2){
    Sd=0;
    PdS=0;
            }
       if(Sd == 1){
              Sd = 0;
    Pd = i-TdS;
            }
        }

      }
    }
  }


      if((i==TriggerPosition)&&(Title[6][1].Value > 16)&&((Title[6][0].Value)!=0)&&(__Get(2)!=0)){
        if((Title[7][1].Value==1)||(Title[7][1].Value==3)||(Title[7][1].Value==4)||(Title[7][1].Value==5)){
          if ((Title[7][0].Value==0)||((Title[7][0].Value==4)&&(TrigSourceEnable==0))){
            b=(Ka1[Title[0][2].Value]+A_Posi+(Ka2[Title[0][2].Value]*(V[0]-A_Posi)+ 512)/1024)-V_Trigg[0].Value;
     a=V_Trigg[0].Value-(Ka1[Title[0][2].Value]+A_Posi+(Ka2[Title[0][2].Value]*(((DataBuf[TriggerPosition-1]& 0xFF)-ADCoffset)-A_Posi)+ 512)/1024);
          }else if((Title[7][0].Value==1)||((Title[7][0].Value==4)&&(TrigSourceEnable==1))){
            b=(Kb1[Title[1][2].Value]+B_Posi+(Kb2[Title[1][2].Value]*(V[1]-B_Posi)+ 512)/1024)-V_Trigg[1].Value;
     a=V_Trigg[1].Value-(Kb1[Title[1][2].Value]+B_Posi+(Kb2[Title[1][2].Value]*((((DataBuf[TriggerPosition-1]>>8)&0xFF)-ADCoffset)-B_Posi)+ 512)/1024);
          }else goto bypasscalculate;
        }else{
          if ((Title[7][0].Value==0)||((Title[7][0].Value==4)&&(TrigSourceEnable==0))){
            b=V_Trigg[0].Value-(Ka1[Title[0][2].Value]+A_Posi+(Ka2[Title[0][2].Value]*(V[0]-A_Posi)+ 512)/1024);
     a=(Ka1[Title[0][2].Value]+A_Posi+(Ka2[Title[0][2].Value]*(((DataBuf[TriggerPosition-1]& 0xFF)-ADCoffset)-A_Posi)+ 512)/1024)-V_Trigg[0].Value;
          }else if((Title[7][0].Value==1)||((Title[7][0].Value==4)&&(TrigSourceEnable==1))){
            b=V_Trigg[1].Value-(Kb1[Title[1][2].Value]+B_Posi+(Kb2[Title[1][2].Value]*(V[1]-B_Posi)+ 512)/1024);
     a=(Kb1[Title[1][2].Value]+B_Posi+(Kb2[Title[1][2].Value]*((((DataBuf[TriggerPosition-1]>>8)&0xFF)-ADCoffset)-B_Posi)+ 512)/1024)-V_Trigg[1].Value;
          }else goto bypasscalculate;
        }
        Shift=-((((b*102400)/((a+b)*TempKp1))+50)/100);
      }
bypasscalculate:

     if ((i==155)&&(Title[6][1].Value > 16)&&((Title[6][0].Value)!=0)&&(__Get(2)!=0)){
        if((Title[7][1].Value==1)||(Title[7][1].Value==3)||(Title[7][1].Value==4)||(Title[7][1].Value==5)){
          if (Title[7][0].Value==2){
            for (jj=DTriggerPosition;jj<155;jj++){
       if (((DataBuf[jj]>>16)&1)==1){Shift=((jj-DTriggerPosition)*1024)/TempKp1;break;}
            }
          }else if(Title[7][0].Value==3){
            for (jj=DTriggerPosition;jj<155;jj++){
       if (((DataBuf[jj]>>16)&2)==2){Shift=((jj-DTriggerPosition)*1024)/TempKp1;break;}
            }
          }
        }else{
          if (Title[7][0].Value==2){
            for (jj=DTriggerPosition;jj<155;jj++){
       if (((DataBuf[jj]>>16)&1)==0){Shift=((jj-DTriggerPosition)*1024)/TempKp1;break;}
            }
          }else if(Title[7][0].Value==3){
            for (jj=DTriggerPosition;jj<155;jj++){
       if (((DataBuf[jj]>>16)&2)==0){Shift=((jj-DTriggerPosition)*1024)/TempKp1;break;}
            }
          }
        }
      }

      if(i >= k){

   if (CalFlag>0) {
          Tmp=Ka2[Title[0][2].Value]*(V[0]-A_Posi) ;
          if (Tmp>0)Tmp+=512; else Tmp-=512;
          V[0] = Ka1[Title[0][2].Value]+A_Posi+(Tmp/1024);
          Tmp=Kb2[Title[1][2].Value]*(V[1]-B_Posi);
          if (Tmp>0)Tmp+=512; else Tmp-=512;
          V[1] = Kb1[Title[1][2].Value]+B_Posi+(Tmp/1024);
   }else{
          V[0] = Ka1[Title[0][2].Value]+V[0];
          V[1] = Kb1[Title[1][2].Value]+V[1];
        }

        while(j > 0 ){
          if ((Options&2)&&(Title[6][1].Value<17)) {
            Send_Data( V[2],V[3],C_D,n++);
          }else{
            Send_Data( V[2]+((V[0]-V[2])*(1024 - j))/1024,
                       V[3]+((V[1]-V[3])*(1024 - j))/1024,
                       C_D,
                       n++);
          }
          j -= TempKp1;
          if(n >= 392){ k = 8192; break;}
        }

        j += 1024;
        V[2] = V[0]; V[3] = V[1];

      }

    }

    if ((exitflag==1)&&(JumpCnt<(393+Xtend))) exitflag=0;

    if ((FrameMode!=0) && (Title[6][1].Value>11) && ((Title[6][0].Value)==0)) __Set(6, 1);

        if(Options&4){
          if((Title[6][0].Value)!=5){

                      if(Title[8][0].Value<200){
   h=a_Max-A_Posi;
                 h = (((Ka2[Title[0][2].Value]*h)+512)/1024);
                        h=h+Title[0][3].Value;
                        if((h>Title[8][0].Value)&&(Title[0][0].Value!=0)&&(Title[8][2].Value==0)) Beeper(500);

   h=b_Max-B_Posi;
                 h = (((Kb2[Title[1][2].Value]*h)+512)/1024);
                        h=h+Title[1][3].Value;
                        if((h>Title[8][0].Value)&&(Title[1][0].Value!=0)&&(Title[8][2].Value==1))Beeper(500);
                      }

                      if(Title[8][1].Value>0){
   h=a_Min-A_Posi;
                 h = (((Ka2[Title[0][2].Value]*h)+512)/1024);
                        h=h+Title[0][3].Value;
                        if((h<Title[8][1].Value)&&(Title[0][0].Value!=0)&&(Title[8][2].Value==0))Beeper(500);

   h=b_Min-B_Posi;
                 h = (((Kb2[Title[1][2].Value]*h)+512)/1024);
                        h=h+Title[1][3].Value;
                        if((h<Title[8][1].Value)&&(Title[1][0].Value!=0)&&(Title[8][2].Value==1))Beeper(500);
                      }
          }

        }

   AWavCenter=(a_Max + a_Min)/2;
        BWavCenter=(b_Max + b_Min)/2;

 if(CurDefTime>0){
     h=AWavCenter;
          Tmp=h;
          h=(((Ka2[Title[0][2].Value]*(h-A_Posi))+512)/1024)+Title[0][3].Value;
          if(Title[8][0].Value<h){
            AWavCenter-=(((1024*(h-Title[8][0].Value))+((512*Ka2[Title[0][2].Value])/1024))/Ka2[Title[0][2].Value]);
            if(Title[8][1].Value>Title[8][0].Value){
              Tmp+=(((1024*(Title[8][1].Value-h))+((512*Ka2[Title[0][2].Value])/1024))/Ka2[Title[0][2].Value]);
              AWavCenter=Tmp;
            }
          }else if(Title[8][1].Value>h){
            AWavCenter+=(((1024*(Title[8][1].Value-h))+((512*Ka2[Title[0][2].Value])/1024))/Ka2[Title[0][2].Value]);
          }
     h=BWavCenter;
          Tmp=h;
          h=(((Kb2[Title[1][2].Value]*(h-B_Posi))+512)/1024)+Title[1][3].Value;
          if(Title[8][0].Value<h){
            BWavCenter-=(((1024*(h-Title[8][0].Value))+((512*Kb2[Title[1][2].Value])/1024))/Kb2[Title[1][2].Value]);
            if(Title[8][1].Value>Title[8][0].Value){
              Tmp+=(((1024*(Title[8][1].Value-h))+((512*Kb2[Title[1][2].Value])/1024))/Kb2[Title[1][2].Value]);
              BWavCenter=Tmp;
            }
          }else if(Title[8][1].Value>h){
            BWavCenter+=(((1024*(Title[8][1].Value-h))+((512*Kb2[Title[1][2].Value])/1024))/Kb2[Title[1][2].Value]);
          }
        }
        a_Mid_H = TimeCalcHyst +AWavCenter;
        a_Mid_L = a_Mid_H - (2*TimeCalcHyst);
        b_Mid_H = TimeCalcHyst +BWavCenter;
        b_Mid_L = b_Mid_H - (2*TimeCalcHyst);

        QEnd[0]=TaS;
        QEnd[1]=TbS;

       TaS -= Ta; TbS -= Tb; TcS -= Tc; TdS -= Td;

  if((Title[4][0].Value == 0)&&(Options&4)&&(ClearHoldFlag>0)){
    if((Title[6][1].Value > 10)||((Title[6][1].Value < 11)&&((JumpCnt==get_bag_max_buf())||(freerun==1)))){
     if(SlowModeSkip==0){
      if(Title[7][0].Value<4){
        ClearMinMax(ClearHoldFlag);
        ClearHold(ClearHoldFlag);
        ClearHoldFlag=0;
      }else{
         if((TrigSourceEnable==0)&&(ClearHoldFlag&1)){
           ClearMinMax(1);
           ClearHold(1);
           ClearHoldFlag--;
         }
         if((TrigSourceEnable==1)&&(ClearHoldFlag&2)){
           ClearMinMax(2);
           ClearHold(2);
           ClearHoldFlag&=0xFD;
         }
      }
     }else if(SlowModeSkip>0) SlowModeSkip--;
    }
  }

    if(JumpCnt==get_bag_max_buf())ClearLeadingEdge=0;
    if((SumResetFlag==1)&&((JumpCnt==get_bag_max_buf())||(freerun==1)||(Title[4][0].Value!= 0))){
      EnablePaS=1;
      ResetSum();
      SumResetFlag=0;
    }

        if(a_Max>Ga_Max)Ga_Max=a_Max;
        if(b_Max>Gb_Max)Gb_Max=b_Max;
        if(a_Min<Ga_Min)Ga_Min=a_Min;
        if(b_Min<Gb_Min)Gb_Min=b_Min;

        if((Options&4)==4){
          if(a_Max>GHa_Max)GHa_Max=a_Max;else if(HoldResetFlag&1)GHa_Max=a_Max;
          if(b_Max>GHb_Max)GHb_Max=b_Max;else if(HoldResetFlag&2)GHb_Max=b_Max;
          if(a_Min<GHa_Min)GHa_Min=a_Min;else if(HoldResetFlag&1)GHa_Min=a_Min;
          if(b_Min<GHb_Min)GHb_Min=b_Min;else if(HoldResetFlag&2)GHb_Min=b_Min;
          HoldResetFlag=0;
        }else{
          GHa_Max=Ga_Max;
          GHb_Max=Gb_Max;
          GHa_Min=Ga_Min;
          GHb_Min=Gb_Min;
        }


    if((Title[0][0].Value != 0)||(Title[3][0].Value==14)||(Title[3][0].Value==15)){
           UTmp= (1000000000/TaS)*TaN;
           UTmp-=QError(0,QStart[0],QEnd[0],UTmp);
    Average(0);
    }
    if((Title[1][0].Value != 0)||(Title[3][0].Value==12)||(Title[3][0].Value==13)){
           UTmp= (1000000000/TbS)*TbN;
           UTmp-=QError(1,QStart[1],QEnd[1],UTmp);
    Average(1);
    }
    if(Title[2][0].Value == 1){
           UTmp= (1000000000/TcS)*TcN;
    Average(2);
    }
    if((Title[3][0].Value == 1)||(Title[3][0].Value == 4)||(Title[3][0].Value == 5)){
           UTmp = (1000000000/TdS)*TdN;
    Average(3);
    }

   if ((Title[7][0].Value>1)&&(Title[7][0].Value<4)){
     for(h=0; h<=(392 -5); h++){
        TrackBuff[h*4] = TrackBuff[(h+5)*4];
        TrackBuff[h*4+1] = TrackBuff[(h+5)*4+1];
        TrackBuff[h*4+2] = TrackBuff[(h+5)*4+2];
        TrackBuff[h*4+3] = TrackBuff[(h+5)*4+3];
     }
   }


if (Title[6][1].Value > 16){

  if(Title[7][0].Value==4){

    if(TrigSourceEnable==0){

     if (Shift<0){
      for(h=392;h>=-Shift; h--){
        TrackBuff[h*4] = TrackBuff[(h+Shift)*4];
      }
     }
     if (OldShift<0){
      for(h=392;h>=-OldShift; h--){
        TrackBuff[h*4+1] = TrackBuff[(h+OldShift)*4+1];
      }
     }

    }else if(TrigSourceEnable==1){

     if (Shift<0){
      for(h=392;h>=-Shift; h--){
        TrackBuff[h*4+1] = TrackBuff[(h+Shift)*4+1];
      }
     }
     if (OldShift<0){
      for(h=392;h>=-OldShift; h--){
        TrackBuff[h*4] = TrackBuff[(h+OldShift)*4];
      }
     }

    }

    Tmp=Shift;
    if(OldShift<Shift)Shift=OldShift;
    OldShift=Tmp;

  }else{

    if (Shift>0){
      for(h=0; h<=(392 -Shift); h++){
        TrackBuff[h*4] = TrackBuff[(h+Shift)*4];
        TrackBuff[h*4+1] = TrackBuff[(h+Shift)*4+1];
        TrackBuff[h*4+2] = TrackBuff[(h+Shift)*4+2];
        TrackBuff[h*4+3] = TrackBuff[(h+Shift)*4+3];
      }
    }else if (Shift<0){
      for(h=392;h>=-Shift; h--){
        TrackBuff[h*4] = TrackBuff[(h+Shift)*4];
        TrackBuff[h*4+1] = TrackBuff[(h+Shift)*4+1];
        TrackBuff[h*4+2] = TrackBuff[(h+Shift)*4+2];
        TrackBuff[h*4+3] = TrackBuff[(h+Shift)*4+3];
      }
    }


  }

}


   if (Title[6][1].Value < 17){
     if (Title[6][1].Value > 10){
       discard=4;
     }else discard=1;
   }else if (Shift<0){
     discard=-Shift;
   }else discard=0;
   if ((Title[6][0].Value)==4) discard=4;


   if (Shift>0)Rdiscard=Shift;else Rdiscard=0;
   if (Title[6][1].Value>16)Rdiscard+=7;else Rdiscard=0;

   for(jj=0; jj<discard; jj++){
    TrackBuff[jj*4] = TrackBuff[discard*4];
    TrackBuff[jj*4+1] = TrackBuff[discard*4+1];
   }
   if ((Title[7][0].Value<2)||(Title[7][0].Value==4))Tmp=6; else Tmp=0;

   for(jj=0; jj<(discard+Tmp); jj++){
    TrackBuff[jj*4+2] = TrackBuff[(discard+Tmp)*4+2];
   }

   if ((Title[7][0].Value<2)||(Title[7][0].Value==4)){
     if ((Title[3][0].Value==2)||(Title[3][0].Value==3))Tmp=0;
   }

   for(jj=0; jj<(discard+Tmp); jj++){
    TrackBuff[jj*4+3] = TrackBuff[(discard+Tmp)*4+3];
   }


    for(h=392; h>(392 -Rdiscard); h--){
    TrackBuff[h*4] = TrackBuff[(392 -Rdiscard)*4];
    TrackBuff[h*4+1] = TrackBuff[(392 -Rdiscard)*4+1];
    TrackBuff[h*4+2] = TrackBuff[(392 -Rdiscard)*4+2];
    TrackBuff[h*4+3] = TrackBuff[(392 -Rdiscard)*4+3];
   }



 if ((ShowFFT==1) || (Title[3][0].Value==11) || (Title[3][0].Value==10)) {
    for(i=0; i<512;i++) fi[i] = 0;
    fix_fft(fr, fi, 512);

    for (i=0; i < (512/2); i++)
      {
  X= fr[i];
  Y= fi[i];
                fr[ i ] = Int_sqrt(X*X+Y*Y);
                if(fr[i]>198)fr[i]=198; if(fr[i]<0)fr[i]=0;
                if((Title[3][0].Value==15)||(Title[3][0].Value==13)){
                  if(i>5){
                    if((fr[i-2]>=fr[i-3])&&(fr[i-2]>fr[i-1])&&(fr[i-2]>6)){
                      fr[i-2]=Int_sqrt((fr[i-2]*fr[i-2])+(fr[i-3]*fr[i-3])+(fr[i-1]*fr[i-1]));
                      if(fr[i-2]>198)fr[i-2]=198;
                      fr[i-3]=2+(fr[i-2]>>3);
                      LeftSkirt=i-3;
                    }
                    if((i-5)==LeftSkirt){fr[i-3]=fr[i-5];LeftSkirt=0;}
                  }
                  if(i>7)fr[i-6] = Exp[fr[i-6]];
                }else fr[ i ] = Exp[fr[i]];

       }

             if((Title[3][0].Value==15)||(Title[3][0].Value==13))for(i=250;i<256;i++)fr[i]=Exp[fr[i]];

                fr[0]=0; fr[1]=0;

  FFTflag=1;
  Display_Value(4);
  FFTflag=0;

  PeakFreq = 2;
         imax = 0;
  for (i=2; i < 512/2; i++) {
   if (PeakFreq < fr[i]) {
    PeakFreq= fr[i] ;
    imax = i;
   }
  }

  Int2Str(NFreqStr, NFreq,N_UNIT, 4, 1,ShiftDigits);
  Int2Str(FreqT1Str, ((NFreq / 256) * Title[10][0].Value),N_UNIT, 4, 1,ShiftDigits);
  Int2Str(FreqDivStr, ((NFreq / 256) * 30),N_UNIT, 4, 1,ShiftDigits);
         if (imax>1)Int2Str(PeakFreqStr, ((NFreq / 256) * imax),N_UNIT, 4, 1,ShiftDigits);

 }

}

void Send_Data(s16 Va, s16 Vb, u8 C_D, u16 n)
{
  s32 Tmp = 0, i;

  i = n*4;
  if(Va >= 0 +200) TrackBuff[i + 0] = 0 +200 -1;
  else if(Va <= 0 +1) TrackBuff[i + 0] = 0 +1;
  else TrackBuff[i + 0] = Va;
  if(Vb >= 0 +200) TrackBuff[i + 1] = 0 +200 -1;
  else if(Vb <= 0 +1) TrackBuff[i + 1] = 0 +1;
  else TrackBuff[i + 1] = Vb;

  if(C_D & 1) TrackBuff[i + 2] = c_Max;
  else TrackBuff[i + 2] = Title[2][3].Value;

  switch (Title[3][0].Value){
  case 2:
    Tmp = Posi_412 + Va + Vb;
    break;
  case 3:
    Tmp = Posi_41_2 + Va - Vb;
    break;
  case 4:


    if((~C_D)& 3) Tmp = Title[3][3].Value;
    else Tmp = d_Max;
    break;
  case 5:
    if(C_D & 3) Tmp = d_Max;
    else Tmp = Title[3][3].Value;
    break;
  case 6:
    Tmp = Posi_4F1 + FileBuff[n];
    break;
  case 7:
    Tmp = Posi_4F2 + FileBuff[n+400];
    break;
  case 8:
    Tmp = Posi_4F3 + FileBuff[n+800];
    break;
  case 9:
    Tmp = Posi_4F4 + FileBuff[n+1200];
    break;
  case (10)...(15):
    break;
  default:
    if(C_D & 2) Tmp = d_Max;
    else Tmp = Title[3][3].Value;
  }
  if(Tmp >= 0 +200) TrackBuff[i + 3] = 0 +200 -1;
  else if(Tmp <= 0 +1) TrackBuff[i + 3] = 0 +1;
  else TrackBuff[i + 3] = Tmp;
}



void Synchro(void)
{
freerun=0;
u32 waste=0;


if (BailoutFlag>0) {BailoutFlag=0; goto BailOut;}

if (FrameMode>0)
 {
  switch ((Title[6][0].Value))
  {
     case 5:
     case 1:
        __Set(32+0,(Title[7][0].Value <<3)+Title[7][1].Value);
      if((__Get(2)!=0)||(Title[4][0].Value==2)){
        if (entryflag>0){
          JumpCnt=0;
          entryflag=0;
        }
        Process();
        Wait_Cnt=shortwait[Title[6][1].Value];
        exitflag=1;
      }else if ((Wait_Cnt==1)&&(Title[6][1].Value < 9)){
        if (Title[6][1].Value <6)__Set(6, 1);
      }else if(Wait_Cnt ==0){
        if (Title[6][1].Value > 8){
          freerun=1;
          entryflag=0;
        }else{
          freerun=2;
          entryflag=1;
        }
        if (JumpCnt > (392+Xtend))JumpCnt = 0;
        Process();
      }
      break;
    case 2:
      if(Title[7][0].Value !=4) __Set(32+0,(Title[7][0].Value <<3)+Title[7][1].Value);
      if((__Get(2)!=0)||(Title[4][0].Value==2)){
        Process();
        Wait_Cnt=Wait[Title[6][1].Value];
      }else{
        if(Wait_Cnt==0){
          Wait_Cnt = 1;

        }
      }
      break;
    case 3:
     __Set(32+0,(Title[7][0].Value <<3)+Title[7][1].Value);
      if((__Get(2)!=0)||(Title[4][0].Value==2)){
          Process();
          Wait_Cnt=Wait[Title[6][1].Value];
        } else if(Wait_Cnt==0)
         {
          ResetSum();
          if (Title[6][1].Value < 7) cleardatabuf( (A_Posi+ADCoffset), (B_Posi+ADCoffset),(393+Xtend),2);
          ClearTrackBuff(0);
          Wait_Cnt=Wait[Title[6][1].Value];
      }
      break;
   case 4:
      __Set(32+0,(Title[7][0].Value <<3)+Title[7][1].Value);
      if((__Get(2)!=0)||(Title[4][0].Value==2)) Process();
      break;
    case 0:
      if (Title[6][1].Value>11){
        __Set(32+0, 0x20);
      }else{
       __Set(32+0,3);
       __Set(32+1,255);
      }
      if (Title[6][1].Value>7){
        freerun=1;
        Process();
      }else{
         freerun=2;
         if ((FlagMeter==0) && (JumpCnt> 389)) JumpCnt=0;
         if ((FlagMeter>0) && (JumpCnt> 304)) JumpCnt=0;
         Process();
      }
   }
 }
 else
 {
 switch ((Title[6][0].Value))
   {
   case 5:
   case 1:
       __Set(32+0,(Title[7][0].Value <<3)+Title[7][1].Value);
      if((__Get(2)!=0)||(Title[4][0].Value==2)){
        Process();
        Wait_Cnt = Wait[Title[6][1].Value];
      } else if(Wait_Cnt==0) {
          if(JumpCnt >= 4095) JumpCnt = 0;
          Process();
          Wait_Cnt = Wait[Title[6][1].Value];
      } break;
    case 2:
      if(Title[7][0].Value !=4) __Set(32+0,(Title[7][0].Value <<3)+Title[7][1].Value);
      if((__Get(2)!=0)||(Title[4][0].Value==2)){
        Process();
        Wait_Cnt = Wait[Title[6][1].Value];
      } else if(Wait_Cnt==0) {

       Wait_Cnt = Wait[Title[6][1].Value];
      } break;
     case 3:
      __Set(32+0,(Title[7][0].Value <<3)+Title[7][1].Value);
      if((__Get(2)!=0)||(Title[4][0].Value==2)){
        Process();
        Wait_Cnt = Wait[Title[6][1].Value];
      } else if(Wait_Cnt==0) {
       ResetSum();
       ClearTrackBuff(0);
        Wait_Cnt = Wait[Title[6][1].Value];
      } break;
   case 4:
      __Set(32+0,(Title[7][0].Value <<3)+Title[7][1].Value);
      if((__Get(2)!=0)||(Title[4][0].Value==2)) Process();
 break;
    case 0:
      if (Title[6][1].Value>11){
        __Set(32+0, 0x20);
      }else{
       __Set(32+0,3);
       __Set(32+1,255);
      }
      if (Title[6][1].Value>7){
        freerun=1;
        Process();
      }else{
         freerun=2;
         if(JumpCnt >= 4095) JumpCnt = 0;
         Process();
       }
   }
 }

  if ((Title[6][0].Value)==0) Wait_Cnt = 1;

  if ((FrameMode > 0)&&((Title[6][0].Value)!=4)){
    if ((Title[6][0].Value)==0){
      if ((FlagMeter==0) && (JumpCnt> 389)) JumpCnt=0;
      if ((FlagMeter>0) && (JumpCnt> 304)) JumpCnt=0;
    }
    if (JumpCnt>(392+Xtend)){
      if((__Get(2)!=0)&&(freerun!=2)){
        JumpCnt=0;
        if ((Options&1)&&(Title[6][1].Value < 10)&&((Title[6][0].Value)!=1)&&((Title[6][0].Value)!=5)&&((Title[6][0].Value)!=4)&&((Title[6][0].Value)!=0)){
          CountUnread=0;
BailOut:
          if (Title[7][3].Value>0){

            DelayLoopBreak=50;
            while (CountUnread<Title[7][3].Value){

              if (__Get(1)==0){
                waste =__Read_FIFO();
                CountUnread++;
              }else{
                if(Update>1)break;
                if(DelayLoopBreak==0)break;
              }
              if ((CountUnread>0)&&((CountUnread%(TrigDelayLoop[Title[6][1].Value]))==0)){
                BailoutFlag=1;
                break;
              }
            }

          }
        }

        if (BailoutFlag==0){

     if (Title[7][0].Value==4){AlternateChannel();AltHoldoff=AltDelay[Title[6][1].Value];}
            __Set(6, 1);

        }

        waste++;
      }
    }
  }

   if(HoldOnNext==1) {
    Title[4][0].Value = 1;
    Title[4][0].Flag |= 0x02;
    HoldOnNext=0;
    return;
   }

  if ((Title[4][0].Value == 0)&&(Title[6][1].Value > 10)&&(Title[6][1].Value < 14)&&((Title[6][0].Value) != 4)){
    if ((__Get(2)!=0)&&(FrameMode >0)) {
        if ((Title[7][0].Value==4)&&(Title[4][0].Value == 0)) AlternateChannel();
        __Set(6, 1);
    }
  }

  if ((Title[4][0].Value == 0)&&(__Get(3)!=0)) {

    if((Title[6][0].Value) != 4) {
      if (Title[7][0].Value==4){
        AlternateChannel();
        if(Title[6][1].Value < 10)AltHoldoff=AltDelay[Title[6][1].Value];
      }
      __Set(6, 1);

    }else if(Title[6][1].Value < 11){
      __Set(6, 1);
    }


    if (FrameMode == 0) Wait_Cnt = Wait[Title[6][1].Value];
    JumpCnt =0;
    if((Title[6][0].Value) == 4){
      HoldOnNext=1;
    }
  }

  if (((Title[6][0].Value) != 1)||(Title[6][1].Value > 8)||(exitflag==0)||(entryflag==0)) Draw_Window();



  if ((Title[4][0].Value == 0)&&(__Get(2)==0)&&(Title[7][0].Value==4)){
     if(Title[6][1].Value > 9){

         cleardatabuf((A_Posi+ADCoffset),(B_Posi+ADCoffset), get_bag_max_buf(),TrigSourceEnable);
         AlternateChannel();
         __Set(6, 1);

     }else{
       if(AltHoldoff==0){
         AltHoldoff=AltDelay[Title[6][1].Value];

         cleardatabuf((A_Posi+ADCoffset),(B_Posi+ADCoffset), get_bag_max_buf(),TrigSourceEnable);
         AlternateChannel();
         __Set(6, 1);

       }
       if(AltHoldoff>0)AltHoldoff--;
     }
  }

}

u16 get_bag_max_buf(void) {
u16 out = 4096;

  if ((FrameMode>0)&&((Title[6][0].Value)!=4)){
    if ((Title[6][0].Value)==0){
        if (FlagMeter==0) out = 390;
        if (FlagMeter>0) out = 305;
        if (Title[6][1].Value>9) out=390+150;
    }else if ((Title[6][0].Value)==5){
        out = 393+Title[6][2].Value;
    }else{
        out = (393+Xtend);
    }
  }
  return out;
}

void Beeper(u16 ms){
  if(Beep_mS<20) __Set(3, 5*(Title[12][1].Value-1));
  Beep_mS = ms;
}

void AlternateChannel(void){
             if(TrigSourceEnable==1)TrigSourceEnable=0; else TrigSourceEnable=1;

       if(TrigSourceEnable==0){
                if(Title[0][0].Value==0){
                  TrigSourceEnable=1;
                }else{
                  ReverseBitMask=0xFFFFFF00;
                  BitMask=0xFF;
                }
              }
       if(TrigSourceEnable==1){
                if(Title[1][0].Value==0){
                  TrigSourceEnable=0;
                }else{
                   ReverseBitMask= 0xFFFF00FF;
                  BitMask=0xFF00;
                }
              }

              Update_Trig(0);
}


void cleardatabuf(u8 Afill, u8 Bfill, u16 n, u8 service)
{

 u32 sample=0;
 u16 i;

  sample=Bfill;
  sample <<= 8;

  if(service==0){
    sample=Afill;
    for (i=0; i<n; i++){
      DataBuf[i]&=0xFFFFFF00;
      DataBuf[i]|=sample;
    }
  }

  if(service==1){
    for (i=0; i<n; i++){
      DataBuf[i]&=0xFFFF00FF;
      DataBuf[i]|=sample;
    }
  }

  if(service==2){
    sample|=Afill;
    for (i=0; i<n; i++) DataBuf[i]=sample;
  }
}


void TransferFIFO(s16 i,u8 service){
  u32 swap;
     if(service){
              DataBuf[i] &= ReverseBitMask;
              DataBuf[i] |= (__Read_FIFO() & BitMask);
     } else DataBuf[i] = __Read_FIFO();

            if((TrigSourceEnable==1)||(service==0)){
       swap=0x300;
       swap &= DataBuf[i];
       if ((swap==0x100)||(swap==0x200))DataBuf[i]^=0x300;
            }
}

void SetOffset(u8 channel,u8 range, s16 Ypos) {
s32 temp;
      if(channel==0){
 temp=(1024+Ka3[range])*(Ypos-ScalingOffset);
        if(temp>0)temp+=512; else temp-=512;
        temp=(temp/1024)+ADCoffset+ScalingOffset;
 if (temp<0)temp=0;
        __Set(0, temp);
      }else{
 temp=(1024+Kb3[range])*(Ypos-ScalingOffset);
        if(temp>0)temp+=512; else temp-=512;
        temp=(temp/1024)+ADCoffset+ScalingOffset;
 if (temp<0)temp=0;
        __Set(1, temp);
      }
}

void BatLevelCompensation(void){
u8 i;
 if((LoBatLevel[0]>2800)&&(LoBatLevel[0]<5200)&&(HiBatLevel[0]>2800)&&(HiBatLevel[0]<5200)){
  for(i=0;i<10;i++)Ka1[i]=InterpolateS8(0,LKa1[i],HKa1[i]);
  for(i=0;i<10;i++)Ka2[i]=InterpolateU16(0,LKa2[i],HKa2[i]);
  for(i=0;i<10;i++)Ka3[i]=InterpolateS8(0,LKa3[i],HKa3[i]);
 }
 if((LoBatLevel[1]>2800)&&(LoBatLevel[1]<5200)&&(HiBatLevel[1]>2800)&&(HiBatLevel[1]<5200)){
  for(i=0;i<10;i++)Kb1[i]=InterpolateS8(1,LKb1[i],HKb1[i]);
  for(i=0;i<10;i++)Kb2[i]=InterpolateU16(1,LKb2[i],HKb2[i]);
  for(i=0;i<10;i++)Kb3[i]=InterpolateS8(1,LKb3[i],HKb3[i]);
 }
}

s8 InterpolateS8(u8 Ch, s8 L8,s8 H8){
s32 Tmp;
  Tmp=((__Get(6)-LoBatLevel[Ch])*(H8-L8));
  if(Tmp>0)Tmp+=(VDiff[Ch]/2); else Tmp-=(VDiff[Ch]/2);
  return (Tmp/VDiff[Ch])+L8;
}

u16 InterpolateU16(u8 Ch, u16 L16,u16 H16){
s32 Tmp;
  Tmp=((__Get(6)-LoBatLevel[Ch])*(H16-L16));
  if(Tmp>0)Tmp+=(VDiff[Ch]/2); else Tmp-=(VDiff[Ch]/2);
  return (Tmp/VDiff[Ch])+L16;
}

s32 QError(u8 Ch, u16 Start, u16 End, u32 Utmp){
s32 b,ab,tmp=0;


     b=(QParam(Ch,Start,1)*(QParam(Ch,End,0)+QParam(Ch,End,1)))-(QParam(Ch,End,1)*(QParam(Ch,Start,0)+QParam(Ch,Start,1)));
     ab=(QParam(Ch,Start,0)+QParam(Ch,Start,1))*(QParam(Ch,End,0)+QParam(Ch,End,1));
     tmp=Utmp/ab;
     tmp=tmp*b;
     if(Ch==0)tmp=tmp/TaS; else tmp=tmp/TbS;
     return tmp;

}

s16 QParam(u8 Ch, u16 Position,u8 service){

          if(service){
            if(Ch==0){
              return ((DataBuf[Position]& 0xFF)-ADCoffset)-LastA_Mid;
            }else{
              return (((DataBuf[Position]>>8)&0xFF)-ADCoffset)-LastB_Mid;
            }
          }else{
            if(Ch==0){
       return FirstA_Mid-((DataBuf[Position-1]& 0xFF)-ADCoffset);
            }else{
       return FirstB_Mid-(((DataBuf[Position-1]>>8)&0xFF)-ADCoffset);
            }
          }

}

void Average(u8 Ch){



           if((Title[6][1].Value > 10)||((JumpCnt==get_bag_max_buf())&&(Title[6][1].Value>6)&&(FrameMode>0))){
             RunAvg(Ch);
             if(Ch==0){
               VxAvg[0]=VRunAvg(0,a_Avg,VxAvg[0]);
               VNAvg[0]--;
               VxSsq[0]=VRunAvg(0,a_Ssq,VxSsq[0]);
             }else if(Ch==1){
               VxAvg[1]=VRunAvg(1,b_Avg,VxAvg[1]);
               VNAvg[1]--;
               VxSsq[1]=VRunAvg(1,b_Ssq,VxSsq[1]);
             }

             switch(Ch){
             case 0:
               PxS[Ch]+=PaS;
               TxS[Ch]+=TaS;
               TxN[Ch]+=TaN;
               break;
             case 1:
               PxS[Ch]+=PbS;
               TxS[Ch]+=TbS;
               TxN[Ch]+=TbN;
               break;
             case 2:
               PxS[Ch]+=PcS;
               TxS[Ch]+=TcS;
               TxN[Ch]+=TcN;
               break;
             case 3:
               PxS[Ch]+=PdS;
               TxS[Ch]+=TdS;
               TxN[Ch]+=TdN;
             }
           }else{
             Sum[Ch]=UTmp;

             switch(Ch){
             case 0:
               VxAvg[Ch]=a_Avg;
               VxSsq[Ch]=a_Ssq;
               PxS[Ch]=PaS;
               TxS[Ch]=TaS;
               TxN[Ch]=TaN;
               break;
             case 1:
               VxAvg[Ch]=b_Avg;
               VxSsq[Ch]=b_Ssq;
               PxS[Ch]=PbS;
               TxS[Ch]=TbS;
               TxN[Ch]=TbN;
               break;
             case 2:
               PxS[Ch]=PcS;
               TxS[Ch]=TcS;
               TxN[Ch]=TcN;
               break;
             case 3:
               PxS[Ch]=PdS;
               TxS[Ch]=TdS;
               TxN[Ch]=TdN;
             }
           }
}

s32 VRunAvg(u8 Ch, s32 Value, s32 Sum){
       if(Value>Sum){
         Sum+=((Value-Sum)/++VNAvg[Ch]);
       }else if(Sum>Value){
         Sum-=((Sum-Value)/++VNAvg[Ch]);
       }else VNAvg[Ch]++;
       return Sum;
}

void RunAvg(u8 Ch){
   if(UTmp>Sum[Ch]){
     Sum[Ch]+=((UTmp-Sum[Ch])/++NAvg[Ch]);
   }else if(Sum[Ch]>UTmp){
     Sum[Ch]-=((Sum[Ch]-UTmp)/++NAvg[Ch]);
   }else NAvg[Ch]++;
}


void ResetSum(void){
u8 Ch;
        for(Ch=0;Ch<4;Ch++){
          Sum[Ch]=0;
          NAvg[Ch]=0;
        }

        if(EnablePaS){
          for(Ch=0;Ch<4;Ch++){
            PxS[Ch]=0;
            TxS[Ch]=0;
            TxN[Ch]=0;
          }

        }
        VxAvg[0]=A_Posi*NSamples;
        VxAvg[1]=B_Posi*NSamples;
        for(Ch=0;Ch<2;Ch++){
          VxSsq[Ch]=NSamples/2;
          VNAvg[Ch]=0;
          ClearMinMax(Ch+1);
        }

}

void ClearMinMax(u8 Channels){
  if(Channels&1){Ga_Max=(-0x7FFF);Ga_Min=0x7FFF;}
  if(Channels&2){Gb_Max=(-0x7FFF);Gb_Min=0x7FFF;}
  if((Options&4)==0){
    ClearHold(3);
  }
}

void ClearHold(u8 Channels){
  HoldResetFlag=Channels;
  if(Channels&1){GHa_Max=A_Posi;GHa_Min=A_Posi;}
  if(Channels&2){GHb_Max=B_Posi;GHb_Min=B_Posi;}
}

void ClearTrackBuff(u8 service){
u16 i;
  if(service)ClearLeadingEdge=1; else ClearLeadingEdge=0;
  for(i=0; i<392*4; i++)TrackBuff[i]=0;
}
